# dream

from cshelper import *
from js import *
import event
from ffx import *

trainers = [6,5,7,28,40,12,38,27,46,42,13,41,15,10,20,36,21,22,19,39,23,31,49,18,47]

def OnPreRendererCreate():
	ff.RENDER_WARP = 1

def OnPrecacheObjects():
	print "dream/precache"
	Mission_PrecacheTemplateObj('man_bot', 1, 1)
	Mission_PrecacheTemplateObj('mentor', 1, 0)
	Mission_PrecacheTemplateObj('el_diablo_n', 1, 1)
	Mission_PrecacheTemplateObj('minute_man_n', 1, 1)
	Mission_PrecacheTemplateObj('liberty_lad_n', 1, 1)
	Mission_PrecacheTemplateObj('thug_gun_n', 0, 1)
	Mission_PrecacheTemplateObj('eve_n', 1, 1)
	Mission_PrecacheTemplateObj('bullet_n', 1, 1)
	Mission_PrecacheTemplateObj('man_o_war_n', 1, 1)
	Mission_PrecacheTemplateObj('sea_urchin_n', 1, 1)
	Mission_PrecacheTemplateObj('microwave_n', 1, 1)
	Mission_PrecacheTemplateObj('the_ant_n', 1, 1)
	Mission_PrecacheTemplateObj('ant_soldier_n', 0, 1)

def OnPostInit():
	print "dream/start"
	Campaign_Recruit('alchemiss')
	Campaign_UnlockOrigin('alchemiss')
	setMission(1)
	
	Mission_SetSunlight(-137,57,1.5,0.2,(0.2,0.2,0.6))
	Mission_SetShadows(-137,57,(0.2,0.2,0.4))
	Mission_SetProjShadowBackground((1,1,1))
	Mission_SetProjShadowColor((.6,.6,.6,1))

	print ff.trainers
	addTrainerAttention(ff.trainers)
	#below is part of a hack to let you save during this trainer's speech
	addCustomCommand('get help','trainer_42','SaveTrainer')

	Mission_SetAttr('enemies_down',0)

	Mission_SetAttr('el_diablo_triggered',0)
	Mission_SetAttr('minute_man_triggered',0)
	Mission_SetAttr('liberty_lad_triggered',0)
	Mission_SetAttr('man_bot_freed',0)
	Mission_SetAttr('eve_triggered',0)
	Mission_SetAttr('man_o_war_triggered',0)
	Mission_SetAttr('microwave_triggered',0)
	Mission_SetAttr('the_ant_triggered',0)
	Mission_SetAttr('robots_triggered',0)

	Mission_SetAttr('microwaves_down',0)
	Mission_SetAttr('ants_down',0)
	Mission_SetAttr('robots_down',0)

	Mission_SetAttr('fx_state',0)
	Mission_SetAttr('final_cs_playing',0)

	Mission_SetAttr('repulsion_hint_played',0)
	Mission_SetAttr('ll_hint_played',0)

	regDamage('thug_with_bat1','WakeThug1')
	regDamage('thug_with_bat2','WakeThug2')
	regDamage('thug_with_bat3','WakeThug3')
	regDamage('thug_with_bat4','WakeThug4')
	regDamage('thug_with_bat5','WakeThug56')
	regDamage('thug_with_bat6','WakeThug56')
#	regDanger('thug_with_bat1','WakeThug1')
#	regDanger('thug_with_bat1','WakeThug2')
#	regDanger('thug_with_bat1','WakeThug3')
#	regDanger('thug_with_bat1','WakeThug4')
#	regDanger('thug_with_bat1','WakeThug56')
#	regDanger('thug_with_bat1','WakeThug56')
	Object_SetAttr('thug_with_bat1','pathBudget',1500)
	Object_SetAttr('thug_with_bat2','pathBudget',1500)
	Object_SetAttr('thug_with_bat3','pathBudget',1500)
	Object_SetAttr('thug_with_bat4','pathBudget',1500)
	Object_SetAttr('thug_with_bat5','pathBudget',1500)
	Object_SetAttr('thug_with_bat6','pathBudget',1500)
#	Object_SetAttr('thug_with_bat6','pathBudget',15000)
	Object_SetAttr('thug_with_bat7','pathBudget',1500)
	Object_SetAttr('thug_with_bat8','pathBudget',1500)
	Object_SetAttr('thug_with_bat9','pathBudget',1500)
	Object_SetAttr('thug_with_bat10','pathBudget',1500)
	Object_SetAttr('thug_with_bat11','pathBudget',1500)
	Event_RegisterSink(EVENT_TEMPLATE_OBJ_DIED, 'ThugDown', 'thug_bat_n', '', 0, 0, 1)
	Mission_SetAttr('total_thugs',11)
	Mission_SetAttr('thugs_down',0)

	makeInterrogationFn('thug_with_bat1')

	regDeath('alchemiss','AlchemissDown')
	regDeath('man_bot','ManbotDown')

	Mission_CustomAction('chat', '', 'civilian_female_1', 'ChatF', 3, 0)
	Mission_CustomAction('chat', '', 'civilian_female_2', 'ChatF', 3, 0)
	Mission_CustomAction('chat', '', 'civilian_female_3', 'ChatF', 3, 0)
	Mission_CustomAction('chat', '', 'civilian_female_4', 'ChatF', 3, 0)
	Mission_CustomAction('chat', '', 'civilian_female_5', 'ChatF', 3, 0)
	Mission_CustomAction('chat', '', 'civilian_male_1', 'ChatM', 3, 0)
	Mission_CustomAction('chat', '', 'civilian_male_2', 'ChatM', 3, 0)
	Mission_CustomAction('chat', '', 'civilian_male_3', 'ChatM', 3, 0)
	Mission_CustomAction('chat', '', 'civilian_male_4', 'ChatM', 3, 0)
	Mission_CustomAction('chat', '', 'civilian_male_5', 'ChatM', 3, 0)

	regDialog('DLG_DEBRIEF', 'OnDebrief')
	regDialog('DLG_CHARDEBRIEF', 'OnCharDebrief')
	Mission_SetAttr('mission_won',0)

# to ensure she levels up
	Campaign_AddCP('alchemiss',250)

	ff.RENDER_WARP = 1
	NullAI(event)
	play(start_cs,'start_cs')
	FFX_InitMission()
#	TestEndCS()


def TestEndCS():
	DreamFXIncrement()
	spawn('man_bot','man_bot','mb_marker1')
	play(final_cs,'final_cs')


def NullAI(event):
#	print "detection radius?"
#	dr = Object_GetAttr('thug_with_bat1','detectradius')
#	print dr
#	Object_SetAttr('thug_with_bat1','detectradius',0)
#	Object_SetAttr('thug_with_bat2','detectradius',0)
#	Object_SetAttr('thug_with_bat3','detectradius',0)
#	Object_SetAttr('thug_with_bat4','detectradius',0)
#	Object_SetAttr('thug_with_bat5','detectradius',0)
#	Object_SetAttr('thug_with_bat6','detectradius',0)
	if Object_IsAlive('thug_with_bat1'):
		AI_SetEnabled('thug_with_bat1',0)
	if Object_IsAlive('thug_with_bat2'):
		AI_SetEnabled('thug_with_bat2',0)
	if Object_IsAlive('thug_with_bat3'):
		AI_SetEnabled('thug_with_bat3',0)
	if Object_IsAlive('thug_with_bat4'):
		AI_SetEnabled('thug_with_bat4',0)
	if Object_IsAlive('thug_with_bat5'):
		AI_SetEnabled('thug_with_bat5',0)
	if Object_IsAlive('thug_with_bat6'):
		AI_SetEnabled('thug_with_bat6',0)
	if Mission_GetAttr('man_bot_freed') == 0:
		AI_SetEnabled('thug_with_gun1',0)
	if Mission_GetAttr('eve_triggered') == 0:
		AI_SetEnabled('bullet_nightmare',0)
		AI_SetEnabled('eve_nightmare',0)
	if Mission_GetAttr('man_o_war_triggered') == 0:
		AI_SetEnabled('man_o_war_nightmare',0)
		AI_SetEnabled('sea_urchin_nightmare',0)
	if Mission_GetAttr('microwave_triggered') == 0:
		AI_SetEnabled('microwave_nightmare',0)
	if Mission_GetAttr('minute_man_triggered') == 0:
		AI_SetEnabled('minute_man_nightmare',0)
	if Mission_GetAttr('the_ant_triggered') == 0:
		AI_SetEnabled('the_ant_nightmare',0)
		AI_SetEnabled('ant_soldier1',0)


def ThugDown(event):
	td = Mission_GetAttr('thugs_down') + 1
	Mission_SetAttr('thugs_down',td)
	if td == Mission_GetAttr('total_thugs'):
		Objective_Complete('thugs')


def OnSetupInterrogation(event,hero):
	speakNoCB('narrator', 'MISSPCH_1_NR_34')

def interrogate_thug_with_bat1_fn(char):
	if Mission_GetAttr('man_bot_freed') == 0:
		play(thug_with_bat1_cs,'thug_with_bat1_cs')
	else:
		play(hack_cs,'hack_cs')


def OnTrainer(object, hero, train_number):
	print "Player clicked on trainer " + str(train_number)
	for trainer in ff.trainers:
		removeArrow('trainer_' + str(trainer) + '_arrow')

	if (train_number == 7):
		addArrow('t4_arrow','thug_with_bat4',js.ARROW_YELLOW,1)
	elif (train_number == 28):
		addArrow('t2_arrow','thug_with_bat2',js.ARROW_YELLOW,1)
		flashWidget('WIG_DEFAULT_POWER')
	elif (train_number == 12):
		addArrow('t3_arrow','thug_with_bat3',js.ARROW_YELLOW,1)
		AI_SetEnabled('thug_with_bat3',1)
		addMoveGoal('thug_with_bat3','alchemiss',radius=50,speed=1,priority = ai.goal.PRI_ZERO-1)
	if (train_number == 46):
		addArrow('t5_arrow','thug_with_bat5',js.ARROW_YELLOW,1)
		addArrow('t6_arrow','thug_with_bat6',js.ARROW_YELLOW,1)
		WakeThug56(event)
		HackTrainerForSave()
	elif (train_number == 13):
		NightmareED(event)
	elif (train_number == 10):
		flashWidget('WIG_PORTRAIT_0')
#	elif (train_number == 16):
#		addArrow('mm_arrow','minute_man_nightmare',js.ARROW_YELLOW,1)
	elif (train_number == 39):
		flashWidget('WIG_PORTRAIT_0')
	elif (train_number == 18):
		addArrow('xcan_arrow','sc_powerup_ep1',js.ARROW_YELLOW,1)
	elif (train_number == 20):
		addArrow('t2_arrow','thug_with_gun1',js.ARROW_YELLOW,1)
#	elif (train_number == 19):
#		addArrow('ev_arrow','eve_nightmare',js.ARROW_YELLOW,1)
#		addArrow('bl_arrow','bullet_nightmare',js.ARROW_YELLOW,1)
	elif (train_number == 38):
		addArrow('xcan_arrow','sc_powerup_cp1',js.ARROW_YELLOW,1)
	elif (train_number == 23):
		if Object_IsAlive('tutorial_light'):
			addAttention('tutorial_light')
			regPickup('tutorial_light', 'PickupLight')
			regDeath('tutorial_light','LightDead')
	elif (train_number == 49):
		if Object_IsAlive('pickup_car'):
			addAttention('pickup_car')
			regPickup('pickup_car', 'PickupCar')
			regDeath('pickup_car', 'CarDead')
	elif (train_number == 31):
		addArrow('xcan_arrow','sc_powerup_hp1',js.ARROW_YELLOW,1)
	elif (train_number == 47):
		if Object_IsAlive('disruptable'):
			addAttention('disruptable')
			regDeath('disruptable', 'DisruptableDead')
#	elif (train_number == 27):
#		addArrow('an_arrow','the_ant_nightmare',js.ARROW_YELLOW,1)

	for trainer in ff.trainers:
		next_trainer = 'trainer_' + str(trainer)
		if Object_Exists(next_trainer) and hasAttention(next_trainer):
			js.Mission_AddArrowObject('trainer_' + str(trainer) + '_arrow', next_trainer, ARROW_YELLOW)
			return

def LightDead(event):
	removeAttention('tutorial_light')
def CarDead(event):
	removeAttention('pickup_car')
def DisruptableDead(event):
	removeAttention('disruptable')

def HackTrainerForSave():
	addArrow ('trainer_42_arrow','trainer_42',ARROW_YELLOW)
	regTimer('HackKillArrow',.1)
def HackKillArrow(event):
	removeArrow('trainer_15_arrow')
	print "killing trainer_15_arrow"
def SaveTrainer(event,hero):
	speakNoCB('narrator','MISSPCH_1_NR_42')
	removeAttention('trainer_42')
	removeArrow('trainer_42_arrow')
	for trainer in ff.trainers:
		next_trainer = 'trainer_' + str(trainer)
		if Object_Exists(next_trainer) and hasAttention(next_trainer):
			js.Mission_AddArrowObject('trainer_' + str(trainer) + '_arrow', next_trainer, ARROW_YELLOW)
			return
	print "savetrainer done"


def WakeThug1(event):
	AI_SetEnabled('thug_with_bat1',1)
#	Object_SetAttr('thug_with_bat1','detectradius',40)
def WakeThug2(event):
	AI_SetEnabled('thug_with_bat2',1)
#	Object_SetAttr('thug_with_bat2','detectradius',40)
def WakeThug3(event):
	AI_SetEnabled('thug_with_bat3',1)
#	Object_SetAttr('thug_with_bat3','detectradius',40)
def WakeThug4(event):
	AI_SetEnabled('thug_with_bat4',1)
#	Object_SetAttr('thug_with_bat4','detectradius',40)
def WakeThug56(event):
	AI_SetEnabled('thug_with_bat5',1)
	AI_SetEnabled('thug_with_bat6',1)
#	Object_SetAttr('thug_with_bat5','detectradius',40)
#	Object_SetAttr('thug_with_bat6','detectradius',40)

def EDSetup(event):
#	EnemyDown(event)
	print "setting up El Diablo nightmare interaction"
	playEffectMarker('effect_entropy_spawn', 'ed_spawn', key = 'spawn', keyFn = 'EDSpawned')
	playEffectMarker('effect_entropy_spawn', 'ed_victim_spawn', key = 'spawn', keyFn = 'EDVSpawned')
def EDSpawned(event):
	spawn('el_diablo','el_diablo_n','ed_spawn')
	regDeath('el_diablo','EDDown')
	regDamage('el_diablo','EDAttack')
	regProximityEnter('alchemiss','el_diablo',20,'NightmareED')
	makePeaceful('el_diablo')
	addArrow('ed_arrow','el_diablo',ARROW_RED,1)
def EDVSpawned(event):
	spawn('ed_victim','civilian_female','ed_victim_spawn')
	staygoal=Null()
	addGoalToAI('ed_victim',staygoal,ai.goal.PRI_HI)
	regDeath('ed_victim','EDVictimDead')
	Mission_CustomAction('chat', '', 'ed_victim', 'ChatF', 3, 0)
def NightmareED(event):
	if Object_IsAlive('thug_with_bat1'):
		print "ED not set up yet, not triggering"
	elif Mission_GetAttr('el_diablo_triggered') == 0:
		Mission_SetAttr('el_diablo_triggered',1)
		play(nightmare_el_diablo_ss,'nightmare_el_diablo_ss',priority=2)
	else:
		print "already set off el diablo scene"
def EDAttack(event):
	addMoveGoal('el_diablo',Get_ObjectPos('alchemiss'),ai.goal.PRI_ZERO-1,command='move',radius=50,speed=0)
	addKillGoal('el_diablo','alchemiss',ai.goal.PRI_MED,'',0,1)
	addKillGoal('el_diablo','ed_victim',ai.goal.PRI_ZERO,'',0,1)
def EDVictimDead(event):
	if not Objective_IsComplete('ed_victim'):
		Objective_Fail('ed_victim')
def EDDown(event):
	MMSetup(event)
	EnemyDown(event)
	play(el_diablo_down_ss,'el_diablo_down_ss',interrupt = 1)
	if Object_IsAlive('ed_victim'):
		Objective_Complete('ed_victim')
		clearGoals('ed_victim')


def MMSetup(event):
	playEffectMarker('effect_entropy_spawn', 'mm_spawn', key = 'spawn', keyFn = 'MMSpawned')
	playEffectMarker('effect_entropy_spawn', 'mmv_spawn', key = 'spawn', keyFn = 'MMVSpawned')
def MMSpawned(event):
	spawn('minute_man_nightmare','minute_man_n','mm_spawn')
	regDamage('minute_man_nightmare','MMAttack')
	regHeroMarkerEnter('mm_marker','NightmareMM')
	AI_SetEnabled('minute_man_nightmare',0)
	addArrow('mm_arrow','minute_man_nightmare',ARROW_RED,1)
	regDeath('minute_man_nightmare','MMDown')
def MMVSpawned(event):
	spawn('mm_victim','civilian_male','mmv_spawn')
	staygoal=Null()
	addGoalToAI('mm_victim',staygoal,ai.goal.PRI_HI)
	Mission_CustomAction('chat', '', 'mm_victim', 'ChatM', 3, 0)
def NightmareMM(event):
	if Mission_GetAttr('minute_man_triggered') == 0:
		Mission_SetAttr('minute_man_triggered',1)
		play(nightmare_minuteman_cs,'nightmare_minuteman_cs')
		regTimer('RepulsionHint',1)
#		AI_SetEnabled('minute_man_nightmare',1)
	else:
		print "already set off minute man scene"
def RepulsionHint(event):
	if Mission_GetAttr('repulsion_hint_played') == 0:
		play(repulsion_hint_ss,'repulsion_hint_ss')
	else:
		print "already hinted"
def MMAttack(event):
	play(interrupt_ss,'interrupt_ss',interrupt = 1)
	regTimer('RepulsionHint',.2)
	Mission_SetAttr('minute_man_triggered',1)
	AI_SetEnabled('minute_man_nightmare',1)
#	Goal_AddMove('minute_man',ai.goal.PRI_MED,'move',Get_ObjectPos('alchemiss'),'',50,0)
def MMDown(event):
	EnemyDown(event)
	regTimer('LLSetup',2.25)

def LLSetup(event):
	playEffectMarker('effect_entropy_spawn', 'll_spawn', key = 'spawn', keyFn = 'LLSpawned')
def LLSpawned(event):
	spawn('ll_nightmare','liberty_lad_n','ll_spawn')
	regDeath('ll_nightmare','LLDown')
	Object_SetAttr('ll_nightmare','pathBudget',4000)
	play(nightmare_liberty_lad_ss,'nightmare_liberty_lad_ss')
	regTimer('LLHint',1.2)
def LLHint(event):
	if Mission_GetAttr('ll_hint_played') == 0:
		play(ll_hint_ss,'ll_hint_ss')
	else:
		print "already hinted"
def LLDown(event):
	EnemyDown(event)
	play(ll_down_ss,'ll_down_ss',interrupt=1)
	MBSetup(event)

def MBSetup(event):
	playEffectMarker('effect_entropy_spawn', 'free_mb_marker', key = 'spawn', keyFn = 'MBSpawned')
	playEffectMarker('effect_entropy_spawn', 'cage_guard_spawn1', key = 'spawn', keyFn = 'MBG1Spawned')
	if RPG_GAME_DIFFICULTY > 2:
		playEffectMarker('effect_entropy_spawn', 'cage_guard_spawn2', key = 'spawn', keyFn = 'MBG2Spawned')
	if RPG_GAME_DIFFICULTY > 5:
		playEffectMarker('effect_entropy_spawn', 'cage_guard_spawn3', key = 'spawn', keyFn = 'MBG3Spawned')
def MBSpawned(event):
	spawn('mb_cage','man_bot_cage','free_mb_marker')
	spawn('man_bot_caged','man_bot_caged','free_mb_marker')
	regHeroMarkerEnter('free_mb_marker','FreeManbot')
	regDamage('mb_cage','KillCage')
	regDeath('mb_cage','ManbotJoins')
	addArrow('manbot_arrow','mb_cage',ARROW_RED,1)
def MBG1Spawned(event):
	spawn('thug_with_gun1','thug_gun_n','cage_guard_spawn1')
	AI_SetEnabled('thug_with_gun1',0)
def MBG2Spawned(event):
	spawn('thug_with_gun2','thug_gun_n','cage_guard_spawn2')
	AI_SetEnabled('thug_with_gun2',0)
def MBG3Spawned(event):
	spawn('thug_with_gun3','thug_gun_n','cage_guard_spawn3')
	AI_SetEnabled('thug_with_gun3',0)
def FreeManbot(event):
	AI_SetEnabled('thug_with_gun1',1)
	if RPG_GAME_DIFFICULTY > 2:
		AI_SetEnabled('thug_with_gun2',1)
	if RPG_GAME_DIFFICULTY > 5:
		AI_SetEnabled('thug_with_gun3',1)
	play(free_manbot_ss,'free_manbot_ss')
def KillCage(event):
	kill('mb_cage')
def ManbotJoins(event):
	play(manbot_joins_cs,'manbot_joins_cs',interrupt=1)
	Mission_SetAttr('man_bot_freed',1)
	#moved this here to prevent skipping mission
	if Objective_IsComplete('enemies'):
		regTimer('EnemiesAllDown',1)

def EVSetup(event):
	playEffectMarker('effect_entropy_spawn', 'ev_spawn', key = 'spawn', keyFn = 'EVSpawned')
	playEffectMarker('effect_entropy_spawn', 'bl_spawn', key = 'spawn', keyFn = 'BLSpawned')
	regHeroMarkerEnter('ev_marker','NightmareEV')
def EVSpawned(evemt):
	spawn('eve_nightmare','eve_n','ev_spawn')
	regDamage('eve_nightmare','NightmareEV')
	addArrow('eve_arrow','eve_nightmare',ARROW_RED,1)
	AI_SetEnabled('eve_nightmare',0)
	regDeath('eve_nightmare','EveDown')
def BLSpawned(event):
	spawn('bullet_nightmare','bullet_n','bl_spawn')
	regDamage('bullet_nightmare','NightmareEV')
	addArrow('bullet_arrow','bullet_nightmare',ARROW_RED,1)
	AI_SetEnabled('bullet_nightmare',0)
	regDeath('bullet_nightmare','BulletDown')
def NightmareEV(event):
	if Mission_GetAttr('eve_triggered') == 0:
		Mission_SetAttr('eve_triggered',1)
		AI_SetEnabled('eve_nightmare',1)
		AI_SetEnabled('bullet_nightmare',1)
		regDamage('eve_nightmare','EveAttack')
		regDamage('bullet_nightmare','BulletAttack')
		play(nightmare_eve_ss,'nightmare_eve_ss')
	else:
		print "already set off eve scene"
def EveAttack(event):
	clearGoals('eve_nightmare')
	clearGoals('bullet_nightmare')
def BulletAttack(event):
	clearGoals('bullet_nightmare')
	clearGoals('eve_nightmare')
def EveDown(event):
	EnemyDown(event)
	addAttr('eve_triggered',1)
	if Mission_GetAttr('eve_triggered') == 3:
		EBDown(event)
def BulletDown(event):
	EnemyDown(event)
	addAttr('eve_triggered',1)
	if Mission_GetAttr('eve_triggered') == 3:
		EBDown(event)
def EBDown(event):
	MOSetup(event)
	RobotsSetup(event)

def RobotsSetup(event):
	playEffectMarker('effect_entropy_spawn', 'mech1', key = 'spawn', keyFn = 'Mech1Spawned')
	Mission_SetAttr('total_robots',1)
	if RPG_GAME_DIFFICULTY > 1:
		playEffectMarker('effect_entropy_spawn', 'mech2', key = 'spawn', keyFn = 'Mech2Spawned')
		addAttr('total_robots',1)
	if RPG_GAME_DIFFICULTY > 4:
		playEffectMarker('effect_entropy_spawn', 'mech3', key = 'spawn', keyFn = 'Mech3Spawned')
		addAttr('total_robots',1)
	regHeroMarkerEnter('mech_trigger','RobotsSeen')
def Mech1Spawned(event):
	spawn('mechman1','mech_man','mech1')
	regDetectHero('mechman1','RobotsSeen')
	regDamage('mechman1','RobotsSeen')
	regDeath('mechman1','RobotDown')
	AI_SetEnabled('mechman1',0)
def Mech2Spawned(event):
	spawn('mechman2','mech_man','mech2')
	regDetectHero('mechman2','RobotsSeen')
	regDamage('mechman1','RobotsSeen')
	regDeath('mechman2','RobotDown')
	AI_SetEnabled('mechman2',0)
def Mech3Spawned(event):
	spawn('mechman3','mech_man','mech3')
	regDetectHero('mechman3','RobotsSeen')
	regDamage('mechman1','RobotsSeen')
	regDeath('mechman3','RobotDown')
	AI_SetEnabled('mechman3',0)
def RobotsSeen(event):
	if Mission_GetAttr('robots_triggered') == 0:
		Mission_SetAttr('robots_triggered',1)
		play(robots_ss,'robots_ss')
		Objective_Activate('robots')
		AI_SetEnabled('mechman1',1)
		if RPG_GAME_DIFFICULTY > 1:
			AI_SetEnabled('mechman2',1)
		if RPG_GAME_DIFFICULTY > 4:
			AI_SetEnabled('mechman3',1)
	else:
		print "robots already triggered"
def RobotDown(event):
	rd = Mission_GetAttr('robots_down') + 1
	Mission_SetAttr('robots_down',rd)
	if rd == Mission_GetAttr('total_robots'):
		Objective_Complete('robots')

def MOSetup(event):
	playEffectMarker('effect_entropy_spawn', 'mo_spawn', key = 'spawn', keyFn = 'MOSpawned')
	playEffectMarker('effect_entropy_spawn', 'su_spawn', key = 'spawn', keyFn = 'SUSpawned')
	regHeroMarkerEnter('mo_marker','NightmareMO')
def MOSpawned(evemt):
	spawn('man_o_war_nightmare','man_o_war_n','mo_spawn')
	regDamage('man_o_war_nightmare','NightmareMO')
	addArrow('mo_arrow','man_o_war_nightmare',ARROW_RED,1)
	AI_SetEnabled('man_o_war_nightmare',0)
	regDeath('man_o_war_nightmare','MODown')
def SUSpawned(event):
	spawn('sea_urchin_nightmare','sea_urchin_n','su_spawn')
	regDamage('sea_urchin_nightmare','NightmareMO')
	addArrow('su_arrow','sea_urchin_nightmare',ARROW_RED,1)
	AI_SetEnabled('sea_urchin_nightmare',0)
	regDeath('sea_urchin_nightmare','SUDown')
def PickupLight(event):
	speakNoCB('narrator', 'MISSPCH_1_NR_24')
	removeAttention('tutorial_light')
#	addArrow('mo_arrow','man_o_war_nightmare',js.ARROW_YELLOW,1)
#	addArrow('su_arrow','sea_urchin_nightmare',js.ARROW_YELLOW,1)
	regTimer('NightmareMO',4)
def NightmareMO(event):
	if Mission_GetAttr('man_o_war_triggered') == 0:
		Mission_SetAttr('man_o_war_triggered',1)
		AI_SetEnabled('man_o_war_nightmare',1)
		AI_SetEnabled('sea_urchin_nightmare',1)
		play(nightmare_man_o_war_cs,'nightmare_man_o_war_cs')
	else:
		print "already set off manowar scene"
def MOAttack(event):
	addMoveGoal('man_o_war_nightmare','alchemiss',radius=100,speed=1,priority = ai.goal.PRI_ZERO-1)
	addMoveGoal('sea_urchin_nightmare','alchemiss',radius=100,speed=1,priority = ai.goal.PRI_ZERO-1)
def MODown(event):
	EnemyDown(event)
	addAttr('man_o_war_triggered',1)
	if Mission_GetAttr('man_o_war_triggered') == 3:
		MSDown(event)
def SUDown(event):
	EnemyDown(event)
	play(interrupt_ss,'interrupt_ss',interrupt = 1)
	addAttr('man_o_war_triggered',1)
	if Mission_GetAttr('man_o_war_triggered') == 3:
		MSDown(event)
def MSDown(event):
	MWSetup(event)

def MWSetup(event):
	playEffectMarker('effect_entropy_spawn', 'mw_marker', key = 'spawn', keyFn = 'MWSpawned')
	if RPG_GAME_DIFFICULTY > 5:
		playEffectMarker('effect_entropy_spawn', 'mw_spawn2', key = 'spawn', keyFn = 'MW2Spawned')
def MWSpawned(event):
	spawn('microwave_nightmare','microwave_n','mw_marker')
	regDamage('microwave_nightmare','MWAttack')
	regHeroMarkerEnter('mw_marker','NightmareMW')
	AI_SetEnabled('microwave_nightmare',0)
	addArrow('mw_arrow','microwave_nightmare',ARROW_RED,1)
	regDeath('microwave_nightmare','MWDown')
def MW2Spawned(event):
	spawn('microclone_nightmare','microwave_n','mw_spawn2')
	regDamage('microclone_nightmare','MWAttack')
	AI_SetEnabled('microclone_nightmare',0)
	addArrow('mw2_arrow','microclone_nightmare',ARROW_RED,1)
	regDeath('microwave_nightmare','MWDown')
def PickupCar(event):
	speakNoCB('narrator', 'MISSPCH_1_NR_26')
	removeAttention('pickup_car')
#	addArrow('mw_arrow','microwave_nightmare',js.ARROW_YELLOW,1)
	regTimer('NightmareMW',4)
def NightmareMW(event):
	if Mission_GetAttr('microwave_triggered') == 0:
		Mission_SetAttr('microwave_triggered',1)
		AI_SetEnabled('microwave_nightmare',1)
		if RPG_GAME_DIFFICULTY > 5:
			AI_SetEnabled('microclone_nightmare',1)
		play(nightmare_microwave_ss,'nightmare_microwave_ss')
	else:
		print "already set off microwave scene"
def MWAttack(event):
	NightmareMW(event)
	turnTo('microwave_nightmare','alchemiss')
	addMoveGoal('microwave_nightmare','alchemiss',radius=50,speed=1,priority = ai.goal.PRI_ZERO-1)
	if RPG_GAME_DIFFICULTY > 5:
		turnTo('microclone_nightmare','alchemiss')
		addMoveGoal('microclone_nightmare','alchemiss',radius=50,speed=1,priority = ai.goal.PRI_ZERO-1)
def MWDown(event):
	addAttr('microwaves_down',1)
	mwd = Mission_GetAttr('microwaves_down')
	if ((RPG_GAME_DIFFICULTY < 6) and (mwd == 1)) or ((RPG_GAME_DIFFICULTY > 5) and (mwd == 2)):
		EnemyDown(event)
		ANSetup(event)

def ANSetup(event):
	playEffectMarker('effect_entropy_spawn', 'an_spawn1', key = 'spawn', keyFn = 'ANSpawned')
	if RPG_GAME_DIFFICULTY > 2:
		playEffectMarker('effect_entropy_spawn', 'an_spawn2', key = 'spawn', keyFn = 'AN2Spawned')
	if RPG_GAME_DIFFICULTY > 4:
		playEffectMarker('effect_entropy_spawn', 'an_spawn3', key = 'spawn', keyFn = 'AN3Spawned')
def ANSpawned(event):
	spawn('the_ant_nightmare','the_ant_n','an_spawn1')
	regDamage('the_ant_nightmare','NightmareAN')
	regHeroMarkerEnter('an_marker','NightmareAN')
	AI_SetEnabled('the_ant_nightmare',0)
	addArrow('an_arrow','the_ant_nightmare',ARROW_RED,1)
	regDeath('the_ant_nightmare','AntDown')
def AN2Spawned(event):
	spawn('ant2','ant_soldier_n','an_spawn2')
	regDamage('ant2','NightmareAN')
	AI_SetEnabled('ant2',0)
	addArrow('an2_arrow','ant2',ARROW_RED,1)
	regDeath('ant2','AntDown')
def AN3Spawned(event):
	spawn('ant3','ant_soldier_n','an_spawn3')
	regDamage('ant3','NightmareAN')
	AI_SetEnabled('ant3',0)
	addArrow('an3_arrow','ant3',ARROW_RED,1)
	regDeath('ant3','AntDown')
def NightmareAN(event):
	if Mission_GetAttr('the_ant_triggered') == 0:
		play(nightmare_ant_ss,'nightmare_ant_ss')
		Mission_SetAttr('the_ant_triggered',1)
		AI_SetEnabled('the_ant_nightmare',1)
		if RPG_GAME_DIFFICULTY > 2:
			AI_SetEnabled('ant2',1)
		if RPG_GAME_DIFFICULTY > 4:
			AI_SetEnabled('ant3',1)
		addMoveGoal('the_ant_nightmare','alchemiss',radius=100,speed=1,priority = ai.goal.PRI_ZERO-1)
	else:
		print "already set off the ant scene"
def AntDown(event):
	addAttr('ants_down',1)
	antsd = Mission_GetAttr('ants_down')
	if ((RPG_GAME_DIFFICULTY < 3) and (antsd == 1)) or ((RPG_GAME_DIFFICULTY < 5) and (antsd == 2))or ((RPG_GAME_DIFFICULTY > 4) and (antsd == 3)):
		EnemyDown(event)

def FortressReached(event):
	play(final_cs,'final_cs')


def EnemyDown(event):
	addAttr('enemies_down',1)
	if Mission_GetAttr('enemies_down') == 9:
		Objective_Complete('enemies')
		#moved this here to prevent skipping mission
		if Mission_GetAttr('man_bot_freed') == 1:
			regTimer('EnemiesAllDown',1)
def EnemiesAllDown(event):
	play(enemies_down_ss,'enemies_down_ss')

def AlchemissDown(event):
	if Object_GetAttr('alchemiss','heroPoints')>0:
		speakNoCB('narrator','MISSPCH_1_NR_50')
		regTimer('AlchemissDown2',15)
	else:
		AlchemissDown2(event)
def AlchemissDown2(event):
	if not Object_IsAlive('alchemiss'):
		play(alchemiss_down_ss,'alchemiss_down_ss')
	else:
		print "Whew! Used a hero point in time!"
def ManbotDown(event):
	if Object_GetAttr('man_bot','heroPoints')>0:
		speakNoCB('narrator','MISSPCH_1_NR_50')
		regTimer('ManbotDown2',15)
	else:
		ManbotDown2(event)
def ManbotDown2(event):
	if not Object_IsAlive('man_bot'):
		play(man_bot_down_ss,'man_bot_down_ss')
	else:
		print "Whew! Used a hero point in time!"


def ChatF(event,hero):
	chatline = randint(1,2)
	if chatline == 1:
		forceSpeakNoCB('civilian_female','MISSPCH_1_F1_03',telepathy=0)
	elif chatline == 2:
		forceSpeakNoCB('civilian_female','MISSPCH_1_F2_01',telepathy=0)
def ChatM(event,hero):
	chatline = randint(1,2)
	if chatline == 1:
		forceSpeakNoCB('civilian_male','MISSPCH_1_M1_02',telepathy=0)
	elif chatline == 2:
		forceSpeakNoCB('civilian_male','MISSPCH_1_M3_03',telepathy=0)


def DreamFXIncrement():
	state = Mission_GetAttr('fx_state')+1
	Mission_SetAttr('fx_state',state)
	if state == 1:
		print "state 1"
#		Mission_SetDreamSinParams(1, .015, .25)
#		Mission_StartDreamWave(5,-1,0)
#		DreamFXStartPulsing()
	elif state == 2:
		print "state 2"
#		Mission_FadeDreamSinParams(1, .02, .3, 1)
	elif state == 3:
		print "state 3"
		Mission_StartDreamWave(5,-1,0)
		Mission_FadeDreamSinParams(1, .03, .35, 1)
	else:
		print "problem in DreamFXIncrement?"
def DreamFXStartPulsing():
	regTimer('DreamFXPulse',10)
def DreamFXPulse(event):
	if Mission_GetAttr('final_cs_playing') == 0:
		print "pulsing"
		Mission_FadeDreamSinParams(1., .02, .3, 1)
		regTimer('DreamFXPulseStop',1)
	else:
		print "final CS playing; no pulse"
def DreamFXPulseStop(event):
	regTimer('DreamFXPulse',10)
	state = Mission_GetAttr('fx_state')
	if state == 1:
		print "state 1"
#		Mission_FadeDreamSinParams(1, .015, .25, .75)
		Mission_StartDreamWave(0,0,1)
	elif state == 2:
		print "state 2"
#		Mission_FadeDreamSinParams(1, .02, .3, .75)
		Mission_StartDreamWave(0,0,1)
	elif state == 3:
		print "state 3"
		Mission_FadeDreamSinParams(1, .03, .35, .75)

def OnMissionWon():
	print "dream/won"
	Mission_SetAttr('mission_won',1)

def OnMissionLost():
	print "dream/lost"

def OnDebrief(event):
	print "Debriefing screen reached with script"
	if Mission_GetAttr('mission_won'):
		print "debrief training here"
		play(debrief_dialog_ss,'debrief_dialog_ss',interrupt=1)
	else:
		print "loser training here"
		play(lose_dialog_ss,'lose_dialog_ss',interrupt=1)

def OnCharDebrief(event):
	print "Charcter debriefing screen reached with script"
	play(chardebrief_dialog_ss,'chardebrief_dialog_ss',interrupt=1)



#										 #
# cutscenes and scripted sequences below  #
#										 #



start_cs = [
(
	"Mission_StartDreamWave(0,0,0)",
	"peace()",
	"startCS()",
	"lookAtPos((-730,-1790,0), zoom = -212.0, pitch = 12, heading =  30.3)",
	"AI_Animate('alchemiss', 'land_back', 'onStepCB', 0, 1)",
	"Sound_PlayMusic('music_01dream_cs1',1)",
	"moveTo('intro_civ1', 'alchemiss')",
),
(
	"speak('intro_civ3', 'MISSPCH_1_M3_02', CAPTION_TOP_LEFT)", #Male3 hey fellas! come and look...
	"moveTo('intro_civ2', 'alchemiss')",
),
(
	"speak('intro_civ1', 'MISSPCH_1_M1_01', CAPTION_BOTTOM_RIGHT)", #Male1 Holy Cats! It's the Alche...
	"moveTo('intro_civ3', 'alchemiss')",
),
(
	"lookAtPos((-812,-1754,0), zoom = -204.1, heading = -64.6)",
	"speak('intro_civ2', 'MISSPCH_1_M2_01', CAPTION_TOP_RIGHT)", #Male2 What's she doing here?
),
(
	"speak('alchemiss', 'MISSPCH_1_AL_16', CAPTION_BOTTOM_LEFT)", #Alchemiss peaches and cream! how di...
	"AI_Animate('alchemiss', 'get_up_back', '', 0, 0)",
),
(
	"forceSpeak('minute_man', 'MISSPCH_1_MM_03', CAPTION_TOP_RIGHT)", #Minute Man alchemiss! This is minute...
	"walk('intro_civ1', 'intro_civ_pos1')",
	"walk('intro_civ2', 'intro_civ_pos2')",
),
(
	"speak('alchemiss', 'MISSPCH_1_AL_17', CAPTION_TOP_LEFT)", #Alchemiss manbot? but he's...what d...
	"turn('alchemiss', 'al_pos1')",
),
(
	"forceSpeak('minute_man', 'MISSPCH_1_MM_04', CAPTION_TOP_RIGHT)", #Minute Man there's no time to waste,...
	"walk('intro_civ3', 'intro_civ_pos3')",
	"turn('alchemiss', 'intro_civ_pos3')",
),
(
	"speak('alchemiss', 'MISSPCH_1_AL_18', CAPTION_TOP_LEFT)", #Alchemiss what? minuteman, i don't ...
	"turn('alchemiss', 'al_pos1')",
),
(
	"forceSpeak('minute_man', 'MISSPCH_1_MM_05', CAPTION_TOP_RIGHT)", #Minute Man there's no time for your ...
),
(
	"speak('alchemiss', 'MISSPCH_1_AL_19', CAPTION_TOP_LEFT)", #Alchemiss but he's gone...he sacrif...
	"turn('alchemiss', 'intro_civ_pos1')",
),
(
	"lookAtPos((-770,-1778,0), zoom = -212.0, heading =  24.3)",
	"speak('narrator', 'MISSPCH_1_NR_37', CAPTION_TOP_LEFT)", #Narrator but no one answers the pl...
	"move('alchemiss', 'al_pos1')",
	"Object_Destroy('intro_civ1')",
	"Object_Destroy('intro_civ2')",
	"Object_Destroy('intro_civ3')",
),
(
	"speak('narrator', 'MISSPCH_1_NR_01')", #to get information about the game...
	"look('trainer_6')",
	"newObjective('primary', 1, name='rescue')",
	"registerObjective('primary', 2, name='enemies')",
	"registerObjective('primary', 3, name='survive')",
	"registerObjective('primary', 4, name='return')",
	"registerObjective('secondary', 2, name='ed_victim')",
	"registerObjective('secondary', 3, name='robots')",
	"newObjective('secondary', 1, name='thugs')",
	"addArrow('tb1_arrow','thug_with_bat1',ARROW_RED,1)",
	"addArrow('trainer_6_arrow','trainer_6',ARROW_YELLOW,1)",
),
(
	"war()",
	"regTimer('ff.NullAI',1)",
	"endCS()",
),
]


thug_with_bat1_cs = [
(
	"peace()",
	"startCS()",
	"normalize('thug_with_bat1')",
	"forceSpeak('thug_with_bat1', 'MISSPCH_1_TB_01',telepathy=0)",
),
(
	"kill('thug_with_bat1')",
	"endCS()",
	"war()",
	"regTimer('NullAI',1)",
	"ff.EDSetup(event)"
),
]

hack_cs = [
(
	"peace()",
	"startCS()",
	"normalize('thug_with_bat1')",
	"forceSpeak('thug_with_bat1', 'MISSPCH_1_TB_02',telepathy=0)",
),
(
	"kill('thug_with_bat1')",
	"endCS()",
	"war()",
	"addArrow('ed_arrow','el_diablo',ARROW_RED,1)",
	"regTimer('NullAI',1)",
),
]


nightmare_el_diablo_ss = [
(
	"forceSpeak('ed_victim', 'MISSPCH_1_F1_01',telepathy=0)",
),
(
	"Trigger_Power('el_diablo','ed_victim','eldiablo Flame Projection','')",
	"clearGoals('ed_victim')",
	"forceSpeak('el_diablo_n', 'MISSPCH_1_ED_01',telepathy=0)",
	"Sound_PlayMusic('music_01dream_ed',1)",
),
(
	"forceSpeak('alchemiss', 'MISSPCH_1_AL_01',telepathy=0)",
),
(
	"forceSpeak('el_diablo_n', 'MISSPCH_1_ED_02',telepathy=0)",
),
(
	"clearGoals('el_diablo')",
	"turnTo('el_diablo','alchemiss')",
	"Objective_Activate('ed_victim')",
	"ff.EDAttack(event)",
	"wait(.1)",
),
(
	"blank",
),
]

el_diablo_down_ss = [
(
	"optionalSpeak('ed_victim', 'MISSPCH_1_F1_02')",
),
(
	"forceSpeak('el_diablo_n', 'MISSPCH_1_ED_03',telepathy=0)",
	"ff.DreamFXIncrement()",
),
(
	"blank",
),
]

nightmare_minuteman_cs = [
(
	"peace()",
	"startCS()",
	"look('minute_man_nightmare',time=1)",
	"forceSpeak('minute_man_n', 'MISSPCH_1_MM_01',telepathy=0)",
	"Sound_PlayMusic('music_01dream_mm',1)",
),
(
	"forceSpeak('civilian_male', 'MISSPCH_1_M3_01',telepathy=0)",
),
(
	"forceSpeak('minute_man_n', 'MISSPCH_1_MM_02',telepathy=0)",

),
(
	"addKillGoal('minute_man_nightmare','mm_victim',ai.goal.PRI_ZERO,'',0,1)",
	"forceSpeak('alchemiss', 'MISSPCH_1_AL_02')",
),
(
	"war()",
	"regTimer('ff.NullAI',1)",
	"endCS()",
),
]

repulsion_hint_ss = [
(
	"Mission_SetAttr('repulsion_hint_played',1)",
	"forceSpeak('narrator', 'MISSPCH_1_NR_16',telepathy=0)",
),
(
	"blank",
),
]

ll_hint_ss = [
(
	"Mission_SetAttr('ll_hint_played',1)",
	"forceSpeak('narrator', 'MISSPCH_1_NR_48',telepathy=0)",
),
(
	"blank",
),
]

interrupt_ss = [
(
	"regTimer('ff.NullAI',1)",
	"endCS()",
	"wait(.1)",
),
(
	"blank",
),
]

nightmare_liberty_lad_ss = [
(
	"forceSpeak('liberty_lad_n', 'MISSPCH_1_LL_01',telepathy=0)",
	"Sound_PlayMusic('music_01dream_ll',1)",
),
(
	"addMoveGoal('ll_nightmare','alchemiss',priority = ai.goal.PRI_ZERO-1,radius=5,speed=0)",
	"forceSpeak('alchemiss', 'MISSPCH_1_AL_11')",
),
(
	"addArrow('ll_arrow','ll_nightmare',js.ARROW_RED,1)",
	"forceSpeak('liberty_lad_n', 'MISSPCH_1_LL_02',telepathy=0)",
),
(
	"blank",
),
]


ll_down_ss = [
(
	"forceSpeak('liberty_lad_n', 'MISSPCH_1_LL_03',telepathy=0)",
),
(
	"blank",
),
]

free_manbot_ss = [
(
	"forceSpeak('man_bot', 'MISSPCH_1_MB_01',telepathy=0)",
	"Sound_PlayMusic('music_01dream_ed',1)",
),
(
	"ff.DreamFXIncrement()",
	"forceSpeak('alchemiss', 'MISSPCH_1_AL_12')",
),
(
	"forceSpeak('man_bot', 'MISSPCH_1_MB_05',telepathy=0)",
),
(
	"blank",
),
]

manbot_joins_cs = [
(
	"peace()",
	"startCS()",
	"Object_Destroy('man_bot_caged')",
	"spawn('man_bot','man_bot_dream','free_mb_marker')",
	"look('man_bot', zoom = -100, heading = 0, time = 3)",
	"forceSpeak('man_bot', 'MISSPCH_1_MB_02',telepathy=0)",
),
(
	"turnTo('man_bot','alchemiss')",
	"turnTo('alchemiss','man_bot')",
	"forceSpeak('alchemiss', 'MISSPCH_1_AL_03')",
),
(
	"forceSpeak('man_bot', 'MISSPCH_1_MB_03',telepathy=0)",
),
(
	"forceSpeak('alchemiss', 'MISSPCH_1_AL_04')",
),
(
	"forceSpeak('man_bot', 'MISSPCH_1_MB_06',telepathy=0)",
),
(
	"endCS()",
	"Sound_PlayMusic('music_01dream1')",
	"war()",
	"Objective_Complete('rescue')",
	"Objective_Activate('enemies')",
	"Objective_Activate('survive')",
	"ff.EVSetup(event)",
	"regTimer('NullAI',1)",
),
]



nightmare_eve_ss = [
(
	"forceSpeak('eve_n', 'MISSPCH_1_EV_01',telepathy=0)",
),
(
	"forceSpeak('bullet_n', 'MISSPCH_1_BL_01',telepathy=0)",
),
(
	"addKillGoal('eve_nightmare','_impobj_bldg_attack_1',ai.goal.PRI_MED)",
	"addKillGoal('bullet_nightmare','_impobj_bldg_attack_1',ai.goal.PRI_MED)",
	"forceSpeak('alchemiss', 'MISSPCH_1_AL_14')",
),
(
	"blank",
),
]

nightmare_man_o_war_cs = [
(
	"#peace()",
	"#startCS()",
	"#look('man_o_war_nightmare', zoom = -100, heading = 0, time = 2)",
	"turnTo('man_o_war_nightmare','alchemiss')",
	"turnTo('sea_urchin_nightmare','alchemiss')",
	"forceSpeak('man_o_war_n', 'MISSPCH_1_MO_01',telepathy=0)",
),
(
	"forceSpeak('alchemiss', 'MISSPCH_1_AL_15')",
),
(
	"regTimer('ff.MOAttack',1.5)",
	"forceSpeak('sea_urchin_n', 'MISSPCH_1_SU_01',telepathy=0)",
),
(
	"#endCS()",
	"#war()",
	"wait(.1)",
),
]

robots_ss = [
(
	"forceSpeak('man_bot', 'MISSPCH_1_MB_09',telepathy=0)",
),
(
	"blank",
),
]

nightmare_microwave_ss = [
(
	"regTimer('ff.MWAttack',.1)",
	"forceSpeak('microwave_n', 'MISSPCH_1_MW_01',telepathy=0)",
),
(
	"blank",
),
]

nightmare_ant_ss = [
(
	"turnTo('the_ant_nightmare','alchemiss')",
	"#turnTo('ant2','alchemiss')",
	"#turnTo('ant3','alchemiss')",
	"forceSpeak('the_ant_n', 'MISSPCH_1_AN_01',telepathy=0)",
),
(
	"blank",
),
]

enemies_down_ss = [
(
	"ff.DreamFXIncrement()",
	"forceSpeak('alchemiss', 'MISSPCH_1_AL_13')",
),
(
	"addArrow('ff_arrow','freedom_fortress',ARROW_RED,1)",
	"regHeroMarkerEnter('freedom_fortress','FortressReached')",
	"forceSpeak('man_bot', 'MISSPCH_1_MB_07')",
),
(
	"blank",
),
]

alchemiss_down_ss = [
(
	"forceSpeak('alchemiss', 'MISSPCH_1_AL_20',telepathy=0)",
),
(
	"Objective_Fail('survive')",
	"Mission_Lose()",
),
]

man_bot_down_ss = [
(
	"forceSpeak('man_bot', 'MISSPCH_1_MB_08',telepathy=0)",
),
(
	"Objective_Fail('survive')",
	"Mission_Lose()",
),
]




final_cs = [
(
	"peace()",
	"playTransition()",
	"startCS()",
	"RPG_SetActive(0)",
	"reviveHeroes()",
	"teleport('alchemiss','al_marker1')",
	"teleport('man_bot','mb_marker1')",
	"Mission_SetAttr('final_cs_playing',1)",
	"Mission_FadeDreamSinParams(1., .05, .3, .5)",
),
(
	"look('mb_marker2', zoom = -100, heading = -20, time = 0)",
	"Sound_PlayMusic('music_01dream_end',1)",
	"wait(.2)",
),
(
	"speak('alchemiss', 'MISSPCH_1_AL_05')",
),
(
	"Trigger_Power('man_bot','alchemiss','manbot Energy Focus','')",
	"speak('man_bot', 'MISSPCH_1_MB_04')",
),
(
	"#slow motion effect?",
	"AI_Animate('alchemiss','fall','',0,1)",
	"AI_IssueMove('man_bot','mb_marker2')",
	"forceSpeak('alchemiss', 'MISSPCH_1_AL_06')",
),
(
	"forceSpeak('mentor', 'MISSPCH_1_ME_01')",
),
(
	"forceSpeak('alchemiss', 'MISSPCH_1_AL_07')",
),
(
	"Mission_FadeDreamSinParams(1.85, .14, 1.3, 1.5)",
	"forceSpeak('mentor', 'MISSPCH_1_ME_02')",
),
(
	"#see stage directions",
	"spawn('mentor','mentor','mentor_marker')",
	"AI_Animate('man_bot','pain','',0,1)",
	"AI_Animate('alchemiss','get_up_forward','',0,0)",
	"Mission_StartDreamWave(0,0,1)",
	"forceSpeak('mentor', 'MISSPCH_1_ME_05')",
),
(
	"turnTo('alchemiss','mentor')",
	"forceSpeak('alchemiss', 'MISSPCH_1_AL_08')",
),
(
	"forceSpeak('mentor', 'MISSPCH_1_ME_03')",
),
(
	"forceSpeak('alchemiss', 'MISSPCH_1_AL_09')",
),
(
	"forceSpeak('mentor', 'MISSPCH_1_ME_04')",
),
(
	"Objective_Complete('return')",
	"Objective_Complete('survive')",
	"forceSpeak('alchemiss', 'MISSPCH_1_AL_10')",
),
(
	"endCS()",
	"Mission_Win()",
),
]


debrief_dialog_ss = [
(
	"AI_CancelAllSpeech()",
	"speak('narrator', 'MISSPCH_1_NR_43', forceNonMission = 1)",
),
(
	"blank",
),
]

lose_dialog_ss = [
(
	"AI_CancelAllSpeech()",
	"speak('narrator', 'MISSPCH_1_NR_44', forceNonMission = 1)",
),
(
	"blank",
),
]

chardebrief_dialog_ss = [
(
	"AI_CancelAllSpeech()",
	"speak('narrator', 'MISSPCH_1_NR_45', forceNonMission = 1)",
),
(
	"blank",
),
]

