# to do:


# (DONE) add comment about first regenerating snow-man
# (DONE) Only tree appears at first; once a hero tries to enter, then spawn hands
# (DONE) make snowmen respawn in a non-broken fashion, i.e. without globals.



# red



from cshelper import *
from js import *
import event
# import ai
from ffx import *

trainers = [6,7,3]

def OnPrecacheObjects():
	print "red/precache"
	Mission_PrecacheTemplateObj('red_oktober', 1, 1)
	Mission_PrecacheTemplateObj('shurale', 1, 1)
	Mission_PrecacheTemplateObj('mentor', 1, 0)

def OnPostInit():
	print "red/start"
	print "testing"
	setMission(3)
	addTrainerAttention(ff.trainers)

	ff.CAM_MIN_ZOOM = -100

	Mission_SetSunlight(-130,50,1.2,0.8,(0.1, 0.2, 0.6))
	Mission_SetShadows(-130,50,(0.2,0.1,0.3))
	Mission_SetProjShadowBackground((1,1,1))
	Mission_SetProjShadowColor((.5,.5,.6,1))

	Mission_SetAttr('first_gen_dead', 0)        # we play a scene after the first Gen death; this will block it from playing more than once
	Mission_SetAttr('generator1_dead', 0)       # we also use first_gen_dead to note which Gen it was that died first, so we can train the camera
	Mission_SetAttr('generator2_dead', 0)       # on the right place for the cutscene
	Mission_SetAttr('generator3_dead', 0)
	Mission_SetAttr('generator4_dead', 0)
	Mission_SetAttr('total_gens_dead', 0)
	Mission_SetAttr('spawn_scene_played', 0)
	Mission_SetAttr('talked_to_pablo', 0)
	Mission_SetAttr('spy_koed', 0)
	Mission_SetAttr('snow_approach', 0)
	Mission_SetAttr('spy_squealed', 0)
	Mission_SetAttr('snow_respawn_comment', 0)
	Mission_SetAttr('pablo_arrow_removed', 0)

	Mission_SetAttr('civilians_questioned', 0)
	Mission_SetAttr('civ1questioned', 0)
	Mission_SetAttr('civ2questioned', 0)
	Mission_SetAttr('civ3questioned', 0)
	Mission_SetAttr('civ4questioned', 0)
	Mission_SetAttr('civ5questioned', 0)
	Mission_SetAttr('which_civilian', 0)

	Mission_SetAttr('heroes_still_alive', 0)

	Mission_SetAttr('cutscene_playing', 0)

# this is used for the case when the first two hands are destroyed simultaneously
	Mission_SetAttr('hand_timer', 0)

	Mission_SetAttr('snowman0_marker_count', 0)
	Mission_SetAttr('snowman1_marker_count', 0)
	Mission_SetAttr('snowman2_marker_count', 0)
	Mission_SetAttr('snowman3_marker_count', 0)
	Mission_SetAttr('snowman4_marker_count', 0)
	Mission_SetAttr('snowman5_marker_count', 0)
	Mission_SetAttr('snowman6_marker_count', 0)

	Object_SetAttr('civilian1', 'notspy', 0)
	Object_SetAttr('civilian2', 'notspy', 0)
	Object_SetAttr('civilian3', 'notspy', 0)
	Object_SetAttr('civilian4', 'notspy', 0)
	Object_SetAttr('civilian5', 'notspy', 0)
	Object_SetAttr('pablo', 'notspy', 1)
	Object_SetAttr('pablo', 'minHealth', 1)

	Object_SetAttr('civilian1', 'spy', 0)
	Object_SetAttr('civilian2', 'spy', 0)
	Object_SetAttr('civilian3', 'spy', 0)
	Object_SetAttr('civilian4', 'spy', 0)
	Object_SetAttr('civilian5', 'spy', 0)
	Object_SetAttr('pablo', 'spy', 0)

	Object_Spawn('generator_standin1', 'ro_generator_standin', 'gen1marker')
	Object_Spawn('generator_standin2', 'ro_generator_standin', 'gen2marker')
	Object_Spawn('generator_standin3', 'ro_generator_standin', 'gen3marker')
	Object_Spawn('generator_standin4', 'ro_generator_standin', 'gen4marker')

	regDeath('pablo', 'OnPabloDead')

	regDeath('civilian1', 'OnCivilian1KO')
	regDeath('civilian2', 'OnCivilian2KO')
	regDeath('civilian3', 'OnCivilian3KO')
	regDeath('civilian4', 'OnCivilian4KO')
	regDeath('civilian5', 'OnCivilian5KO')

	regDeath('snow_man5', 'OnSnowman5Destroyed')
	regDeath('snow_man6', 'OnSnowman6Destroyed')

	regHeroMarkerEnter('oktober_spawn', 'OnSnowApproach')

# Talking to Pablo triggers his function "interrogate_pablo_fn"
	makeCustomFn('pablo', attentionMarker = 0) 

	Mission_CustomAction('talk to', '', 'civilian1', 'Civ1Talk1', 3, 0)
	Mission_CustomAction('talk to', '', 'civilian2', 'Civ2Talk1', 3, 0)
	Mission_CustomAction('talk to', '', 'civilian3', 'Civ3Talk1', 3, 0)
	Mission_CustomAction('talk to', '', 'civilian4', 'Civ4Talk1', 3, 0)
	Mission_CustomAction('talk to', '', 'civilian5', 'Civ5Talk1', 3, 0)

	spawn('ice0_standin','fx_standin','ice_hand_spawn0')
	spawn('ice1_standin','fx_standin','ice_hand_spawn1')
	spawn('ice2_standin','fx_standin','ice_serg_spawn')

	addStayGoal('civilian1', priority = ai.goal.PRI_ZERO)
	addStayGoal('civilian2', priority = ai.goal.PRI_ZERO)
	addStayGoal('civilian3', priority = ai.goal.PRI_ZERO)
	addStayGoal('civilian4', priority = ai.goal.PRI_ZERO)
	addStayGoal('civilian5', priority = ai.goal.PRI_ZERO)
	addStayGoal('pablo', priority = ai.goal.PRI_LOW)

	makePeaceful('civilian1')
	makePeaceful('civilian2')
	makePeaceful('civilian3')
	makePeaceful('civilian4')
	makePeaceful('civilian5')

	Mission_SetAttr('mission_won',0)
	regDialog('DLG_DEBRIEF', 'OnDebrief')

	play(start_cs, "start_cs")
	FFX_InitMission()

def OnMissionWon():
	print "red/won"
	Mission_SetAttr('mission_won',1)
#	Campaign_Recruit('bullet')
#	Campaign_UnlockOrigin('bullet')
#	Campaign_Recruit('green_genie')
#	Campaign_UnlockOrigin('green_genie')

def OnMissionLost():
	print "red/lost"

def OnDebrief(event):
	print "Debriefing screen reached with script"
	if Mission_GetAttr('mission_won'):
		print "debrief training here"
	else:
		print "loser training here"
		play(lose_dialog_ss,'lose_dialog_ss',interrupt=1)



##########################################################################################################################################################
## Functions pertaining to Pablo, civilians and spies. ##

# the civilians say one thing if you haven't yet talked to Pablo
def Civ1Talk1(object, hero):
#	speakNoCB('civilian1', 'MISSPCH_3_CC_01')
	Civilian1Speaks()
def Civ2Talk1(object, hero):
#	speakNoCB('civilian2', 'MISSPCH_3_CC_07')
	Civilian2Speaks()
def Civ3Talk1(object, hero):
#	speakNoCB('civilian3', 'MISSPCH_3_CC_08')
	Civilian3Speaks()
def Civ4Talk1(object, hero):
#	speakNoCB('civilian4', 'MISSPCH_3_CC_19')
	Civilian4Speaks()
def Civ5Talk1(object, hero):
#	speakNoCB('civilian5', 'MISSPCH_3_CC_19')
	Civilian5Speaks()


# the civilians say a different thing if you have talked to Pablo
def Civ1Talk2(object, hero):
#	speakNoCB('civilian1', 'MISSPCH_3_CC_20')
	removeAttention('civilian1')
	Civilian1Speaks()
def Civ2Talk2(object, hero):
#	speakNoCB('civilian2', 'MISSPCH_3_CC_21')
	removeAttention('civilian2')
	Civilian2Speaks()
def Civ3Talk2(object, hero):
#	speakNoCB('civilian3', 'MISSPCH_3_CC_21')
	removeAttention('civilian3')
	Civilian3Speaks()
def Civ4Talk2(object, hero):
#	speakNoCB('civilian4', 'MISSPCH_3_CC_22')
	removeAttention('civilian4')
	Civilian4Speaks()
def Civ5Talk2(object, hero):
#	speakNoCB('civilian5', 'MISSPCH_3_CC_22')
	removeAttention('civilian5')
	Civilian5Speaks()


# the civilian who's the spy says yet different things
def SpyTalk(object, hero):
	removeArrow('civspy_arrow')
	if Mission_GetAttr('which_civilian') == 1:
		if Mission_GetAttr('talked_to_pablo') == 0:
			speakNoCB('civilian1', 'MISSPCH_3_CC_14')
		else:
			speakNoCB('civilian1', 'MISSPCH_3_CC_15')
			Mission_RemoveCustomAction('interrogate', '', 'civilian1')
			abortPatrol('civilian1')
			clearGoals('civilian1')
			addKillAllGoal('civilian1', OC_CONTROLLABLE, priority = ai.goal.PRI_MED)
			Object_SetAttr('civilian1', 'defaultToAttack', 1)
			print "spy should be attacking"

	if Mission_GetAttr('which_civilian') == 2:
		if Mission_GetAttr('talked_to_pablo') == 0:
			speakNoCB('civilian2', 'MISSPCH_3_CC_14')
		else:
			speakNoCB('civilian2', 'MISSPCH_3_CC_15')
			Mission_RemoveCustomAction('interrogate', '', 'civilian2')
			abortPatrol('civilian2')
			clearGoals('civilian2')
			addKillAllGoal('civilian2', OC_CONTROLLABLE, priority = ai.goal.PRI_MED)
			Object_SetAttr('civilian2', 'defaultToAttack', 1)
			print "spy should be attacking"

	if Mission_GetAttr('which_civilian') == 3:
		if Mission_GetAttr('talked_to_pablo') == 0:
			speakNoCB('civilian3', 'MISSPCH_3_CC_14')
		else:
			speakNoCB('civilian3', 'MISSPCH_3_CC_15')
			Mission_RemoveCustomAction('interrogate', '', 'civilian3')
			abortPatrol('civilian3')
			clearGoals('civilian3')
			addKillAllGoal('civilian3', OC_CONTROLLABLE, priority = ai.goal.PRI_MED)
			Object_SetAttr('civilian3', 'defaultToAttack', 1)
			print "spy should be attacking"

	if Mission_GetAttr('which_civilian') == 4:
		if Mission_GetAttr('talked_to_pablo') == 0:
			speakNoCB('civilian4', 'MISSPCH_3_CC_14')
		else:
			speakNoCB('civilian4', 'MISSPCH_3_CC_15')
			Mission_RemoveCustomAction('interrogate', '', 'civilian4')
			abortPatrol('civilian4')
			clearGoals('civilian4')
			addKillAllGoal('civilian4', OC_CONTROLLABLE, priority = ai.goal.PRI_MED)
			Object_SetAttr('civilian4', 'defaultToAttack', 1)
			print "spy should be attacking"

	if Mission_GetAttr('which_civilian') == 5:
		if Mission_GetAttr('talked_to_pablo') == 0:
			speakNoCB('civilian5', 'MISSPCH_3_CC_14')
		else:
			speakNoCB('civilian5', 'MISSPCH_3_CC_15')
			Mission_RemoveCustomAction('interrogate', '', 'civilian5')
			abortPatrol('civilian5')
			clearGoals('civilian5')
			addKillAllGoal('civilian5', OC_CONTROLLABLE, priority = ai.goal.PRI_MED)
			Object_SetAttr('civilian5', 'defaultToAttack', 1)
			print "spy should be attacking"

# When the spy is damaged
def OnSpyDamaged(event):
	if Mission_GetAttr('which_civilian') == 1:
		abortPatrol('civilian1')
		clearGoals('civilian1')
		addKillAllGoal('civilian1', OC_CONTROLLABLE, priority = ai.goal.PRI_MED)
		Mission_RemoveCustomAction('interrogate', '', 'civilian1')
		Object_SetAttr('civilian1', 'defaultToAttack', 1)
		print "spy should be attacking"
	if Mission_GetAttr('which_civilian') == 2:
		abortPatrol('civilian2')
		clearGoals('civilian2')
		addKillAllGoal('civilian2', OC_CONTROLLABLE, priority = ai.goal.PRI_MED)
		Mission_RemoveCustomAction('interrogate', '', 'civilian2')
		Object_SetAttr('civilian2', 'defaultToAttack', 1)
		print "spy should be attacking"
	if Mission_GetAttr('which_civilian') == 3:
		abortPatrol('civilian3')
		clearGoals('civilian3')
		addKillAllGoal('civilian3', OC_CONTROLLABLE, priority = ai.goal.PRI_MED)
		Mission_RemoveCustomAction('interrogate', '', 'civilian3')
		Object_SetAttr('civilian3', 'defaultToAttack', 1)
		print "spy should be attacking"
	if Mission_GetAttr('which_civilian') == 4:
		abortPatrol('civilian4')
		clearGoals('civilian4')
		addKillAllGoal('civilian4', OC_CONTROLLABLE, priority = ai.goal.PRI_MED)
		Mission_RemoveCustomAction('interrogate', '', 'civilian4')
		Object_SetAttr('civilian4', 'defaultToAttack', 1)
		print "spy should be attacking"
	if Mission_GetAttr('which_civilian') == 5:
		abortPatrol('civilian5')
		clearGoals('civilian5')
		addKillAllGoal('civilian5', OC_CONTROLLABLE, priority = ai.goal.PRI_MED)
		Mission_RemoveCustomAction('interrogate', '', 'civilian5')
		Object_SetAttr('civilian5', 'defaultToAttack', 1)
		print "spy should be attacking"


# this function is called when the spy is KO-ed (i.e. reduced to one health)
def onSpyKOed(event):
	if Mission_TestAttr('spy_koed'):
		# repeat KO speech
		interrogateMe(event)
	else:
		# set up spy to be interrogated
		Mission_SetAttr('spy_koed', 1)
		if Mission_GetAttr('which_civilian') == 1:
			# remove existing custom actions
			Mission_RemoveCustomAction('CUSTOM_TALKTO', '', 'civilian1')
#			Mission_RemoveCustomAction('CUSTOM_INTERROGATE', '', 'civilian1')
			Mission_RemoveCustomAction('interrogate', '', 'civilian1')
			# go into the real interrogate state
			setInterrogateState('civilian1')
			addInterrogation('civilian1', 'safeInterrogateCS', oneshot = 1)
			# re-trigger interrogation speech if hurt again
			regAlmostDead('civilian1', 'onSpyKOed')
		if Mission_GetAttr('which_civilian') == 2:
			# remove existing custom actions
			Mission_RemoveCustomAction('CUSTOM_TALKTO', '', 'civilian2')
#			Mission_RemoveCustomAction('CUSTOM_INTERROGATE', '', 'civilian2')
			Mission_RemoveCustomAction('interrogate', '', 'civilian2')
			# go into the real interrogate state
			setInterrogateState('civilian2')
			addInterrogation('civilian2', 'safeInterrogateCS', oneshot = 1)
			# re-trigger interrogation speech if hurt again
			regAlmostDead('civilian2', 'onSpyKOed')
		if Mission_GetAttr('which_civilian') == 3:
			# remove existing custom actions
			Mission_RemoveCustomAction('CUSTOM_TALKTO', '', 'civilian3')
#			Mission_RemoveCustomAction('CUSTOM_INTERROGATE', '', 'civilian3')
			Mission_RemoveCustomAction('interrogate', '', 'civilian3')
			# go into the real interrogate state
			setInterrogateState('civilian3')
			addInterrogation('civilian3', 'safeInterrogateCS', oneshot = 1)
			# re-trigger interrogation speech if hurt again
			regAlmostDead('civilian3', 'onSpyKOed')
		if Mission_GetAttr('which_civilian') == 4:
			# remove existing custom actions
			Mission_RemoveCustomAction('CUSTOM_TALKTO', '', 'civilian4')
#			Mission_RemoveCustomAction('CUSTOM_INTERROGATE', '', 'civilian4')
			Mission_RemoveCustomAction('interrogate', '', 'civilian4')
			# go into the real interrogate state
			setInterrogateState('civilian4')
			addInterrogation('civilian4', 'safeInterrogateCS', oneshot = 1)
			# re-trigger interrogation speech if hurt again
			regAlmostDead('civilian4', 'onSpyKOed')
		if Mission_GetAttr('which_civilian') == 5:
			# remove existing custom actions
			Mission_RemoveCustomAction('CUSTOM_TALKTO', '', 'civilian5')
#			Mission_RemoveCustomAction('CUSTOM_INTERROGATE', '', 'civilian5')
			Mission_RemoveCustomAction('interrogate', '', 'civilian5')
			# go into the real interrogate state
			setInterrogateState('civilian5')
			addInterrogation('civilian5', 'safeInterrogateCS', oneshot = 1)
			# re-trigger interrogation speech if hurt again
			regAlmostDead('civilian5', 'onSpyKOed')


# this function is called when the player talks to Pablo
def interrogate_pablo_fn(char):
	if not (Mission_GetAttr('spy_squealed') == 1 and Mission_GetAttr('talked_to_pablo') == 1):
		if Mission_GetAttr('talked_to_pablo') == 1:
			play (interrogate_pablo_again_ss, 'interrogate_pablo_again_ss')
		if Mission_GetAttr('talked_to_pablo') == 0:
			# if this is the first time, set up the villagers to be "interrogated"
			Mission_SetAttr('talked_to_pablo', 1)
			Object_SetAttr('pablo', 'minHealth', 0)
			# remove existing talk to commands
			Mission_RemoveCustomAction('talk to', '', 'civilian1')
			Mission_RemoveCustomAction('talk to', '', 'civilian2')
			Mission_RemoveCustomAction('talk to', '', 'civilian3')
			Mission_RemoveCustomAction('talk to', '', 'civilian4')
			Mission_RemoveCustomAction('talk to', '', 'civilian5')
			# set up 'fake' interrogation commands
			Mission_CustomAction('interrogate', '', 'civilian1', 'Civ1Talk2', 3, 0)
			Mission_CustomAction('interrogate', '', 'civilian2', 'Civ2Talk2', 3, 0)
			Mission_CustomAction('interrogate', '', 'civilian3', 'Civ3Talk2', 3, 0)
			Mission_CustomAction('interrogate', '', 'civilian4', 'Civ4Talk2', 3, 0)
			Mission_CustomAction('interrogate', '', 'civilian5', 'Civ5Talk2', 3, 0)
			addAttention('civilian1')
			addAttention('civilian2')
			addAttention('civilian3')
			addAttention('civilian4')
			addAttention('civilian5')

			Objective_Activate('find_spy')
			Objective_Activate('find_spy_safely')
			play(interrogate_pablo_cs, 'interrogate_pablo_cs')

		removeArrow('pablo_arrow')
		Mission_SetAttr('pablo_arrow_removed', 1)
	if Mission_GetAttr('spy_squealed') == 1:
		Mission_RemoveCustomAction('CUSTOM_TALKTO', '', 'pablo')
	startPatrol('trooper1', 6, priority = ai.goal.PRI_ZERO-1, run = 0)
	startPatrol('trooper2', 6, priority = ai.goal.PRI_ZERO-1, run = 0)
	startPatrol('trooper3', 6, priority = ai.goal.PRI_ZERO-1, run = 0)
	startPatrol('trooper4', 4, priority = ai.goal.PRI_ZERO-1, run = 0)
	startPatrol('trooper5', 4, priority = ai.goal.PRI_ZERO-1, run = 0)
	startPatrol('trooper6', 4, priority = ai.goal.PRI_ZERO-1, run = 0)
	startPatrol('civilian1', 2, priority = ai.goal.PRI_LOW, run = 0)
	startPatrol('civilian2', 2, priority = ai.goal.PRI_LOW, run = 0)
	startPatrol('civilian3', 2, priority = ai.goal.PRI_LOW, run = 0)
	startPatrol('civilian4', 2, priority = ai.goal.PRI_LOW, run = 0)
	startPatrol('civilian5', 2, priority = ai.goal.PRI_LOW, run = 0)

def OnCivilian1KO(event):
#	if Objective_IsFailed('find_spy_safely') != 1:
	if Mission_GetAttr('spy_squealed') == 0:
		Objective_Fail('find_spy_safely')
#	if Mission_GetAttr('spy_koed') != 1:
		speakNoCB('mentor', 'MISSPCH_3_ME_07')
	if Mission_GetAttr('civ1questioned') == 0:
		addAttr('civilians_questioned', 1)
		print Mission_GetAttr('civilians_questioned')
		if Mission_GetAttr('civilians_questioned') == 4:
			SpyRegister()

def OnCivilian2KO(event):
#    if Objective_IsFailed('find_spy_safely') != 1:
	if Mission_GetAttr('spy_squealed') == 0:
		Objective_Fail('find_spy_safely')
#    if Mission_GetAttr('spy_koed') != 1:
		speakNoCB('mentor', 'MISSPCH_3_ME_07')
	if Mission_GetAttr('civ2questioned') == 0:
		addAttr('civilians_questioned', 1)
		print Mission_GetAttr('civilians_questioned')
		if Mission_GetAttr('civilians_questioned') == 4:
			SpyRegister()

def OnCivilian3KO(event):
#    if Objective_IsFailed('find_spy_safely') != 1:
	if Mission_GetAttr('spy_squealed') == 0:
		Objective_Fail('find_spy_safely')
#    if Mission_GetAttr('spy_koed') != 1:
		speakNoCB('mentor', 'MISSPCH_3_ME_07')
	if Mission_GetAttr('civ3questioned') == 0:
		addAttr('civilians_questioned', 1)
		print Mission_GetAttr('civilians_questioned')
		if Mission_GetAttr('civilians_questioned') == 4:
			SpyRegister()

def OnCivilian4KO(event):
#    if Objective_IsFailed('find_spy_safely') != 1:
	if Mission_GetAttr('spy_squealed') == 0:
		Objective_Fail('find_spy_safely')
#    if Mission_GetAttr('spy_koed') != 1:
		speakNoCB('mentor', 'MISSPCH_3_ME_07')
	if Mission_GetAttr('civ4questioned') == 0:
		addAttr('civilians_questioned', 1)
		print Mission_GetAttr('civilians_questioned')
		if Mission_GetAttr('civilians_questioned') == 4:
			SpyRegister()

def OnCivilian5KO(event):
#    if Objective_IsFailed('find_spy_safely') != 1:
	if Mission_GetAttr('spy_squealed') == 0:
		Objective_Fail('find_spy_safely')
#    if Mission_GetAttr('spy_koed') != 1:
		speakNoCB('mentor', 'MISSPCH_3_ME_07')
	if Mission_GetAttr('civ5questioned') == 0:
		addAttr('civilians_questioned', 1)
		print Mission_GetAttr('civilians_questioned')
		if Mission_GetAttr('civilians_questioned') == 4:
			SpyRegister()


def OnPabloDead(event):
	if Mission_GetAttr('talked_to_pablo') == 0:
		if Mission_GetAttr('spy_koed') == 0:
			print "You lose!"
			Objective_Fail('learn_location')
			Mission_Lose()
	if Mission_GetAttr('talked_to_pablo') == 1:
		if not Mission_TestAttr('spy_squealed'):
			Objective_Fail('find_spy_safely')

def SpyInterrogated():
#	Objective_Complete('find_spy')
#	Objective_Complete('find_spy_safely')
	removeAttention('civilian1')
	removeAttention('civilian2')
	removeAttention('civilian3')
	removeAttention('civilian4')
	removeAttention('civilian5')
#	removeAttention('civilian5')
#	removeAttention('civilian6')
#	removeAttention('civilian7')
#	removeAttention('civilian8')
	Mission_SetAttr('spy_squealed', 1)
	removeArrow('spy_arrow')
	if Mission_GetAttr('which_civilian') == 1:
		kill('civilian1')
	if Mission_GetAttr('which_civilian') == 2:
		kill('civilian2')
	if Mission_GetAttr('which_civilian') == 3:
		kill('civilian3')
	if Mission_GetAttr('which_civilian') == 4:
		kill('civilian4')
	if Mission_GetAttr('which_civilian') == 5:
		kill('civilian5')
	if Mission_GetAttr('pablo_arrow_removed') == 0:
		removeArrow('pablo_arrow')
	if Mission_GetAttr('talked_to_pablo') == 1:
		Mission_RemoveCustomAction('CUSTOM_TALKTO', '', 'pablo')


def Civilian1Speaks():
	if Mission_GetAttr('talked_to_pablo') == 0:
		speakNoCB('civilian1', 'MISSPCH_3_CC_01')
	else:
		if Object_GetAttr('civilian1', 'spy'):
			print "Spy stuff goes here"
		elif Object_GetAttr('civilian1', 'notspy'):
			speakNoCB('civilian1', 'MISSPCH_3_CC_20')
			print "I'm being questioned a second time"
		else:
			Object_SetAttr('civilian1', 'notspy', 1)
			speakNoCB('civilian1', 'MISSPCH_3_CC_20')
			addAttr('civilians_questioned', 1)
			Mission_SetAttr('civ1questioned', 1)
			print "Civilians questioned: "
			print Mission_GetAttr('civilians_questioned')
			if Mission_GetAttr('civilians_questioned') == 4:
				SpyRegister()

def Civilian2Speaks():
	if Mission_GetAttr('talked_to_pablo') == 0:
		speakNoCB('civilian2', 'MISSPCH_3_CC_07')
	else:
		if Object_GetAttr('civilian2', 'spy'):
			Mission_SetAttr('which_civilian', 2)
			print "Spy stuff goes here"
		elif Object_GetAttr('civilian2', 'notspy'):
			print "I'm being questioned a second time"
			speakNoCB('civilian2', 'MISSPCH_3_CC_21')
		else:
			Object_SetAttr('civilian2', 'notspy', 1)
			speakNoCB('civilian2', 'MISSPCH_3_CC_21')
			addAttr('civilians_questioned', 1)
			Mission_SetAttr('civ2questioned', 1)
			print "Civilians questioned: "
			print Mission_GetAttr('civilians_questioned')
			if Mission_GetAttr('civilians_questioned') == 4:
				SpyRegister()

def Civilian3Speaks():
	if Mission_GetAttr('talked_to_pablo') == 0:
		speakNoCB('civilian3', 'MISSPCH_3_CC_08')
	else:
		if Object_GetAttr('civilian3', 'spy'):
			Mission_SetAttr('which_civilian', 3)
			print "Spy stuff goes here"
		elif Object_GetAttr('civilian3', 'notspy'):
			print "I'm being questioned a second time"
			speakNoCB('civilian3', 'MISSPCH_3_CC_22')
		else:
			Object_SetAttr('civilian3', 'notspy', 1)
			speakNoCB('civilian3', 'MISSPCH_3_CC_22')
			addAttr('civilians_questioned', 1)
			Mission_SetAttr('civ3questioned', 1)
			print "Civilians questioned: "
			print Mission_GetAttr('civilians_questioned')
			if Mission_GetAttr('civilians_questioned') == 4:
				SpyRegister()

def Civilian4Speaks():
	if Mission_GetAttr('talked_to_pablo') == 0:
		speakNoCB('civilian4', 'MISSPCH_3_CC_19')
	else:
		if Object_GetAttr('civilian4', 'spy'):
			Mission_SetAttr('which_civilian', 4)
			print "Spy stuff goes here"
		elif Object_GetAttr('civilian4', 'notspy'):
			print "I'm being questioned a second time"
			speakNoCB('civilian4', 'MISSPCH_3_CC_22')
		else:
			print "testing"
			Object_SetAttr('civilian4', 'notspy', 1)
			speakNoCB('civilian4', 'MISSPCH_3_CC_22')
			addAttr('civilians_questioned', 1)
			Mission_SetAttr('civ4questioned', 1)
			print "Civilians questioned: "
			print Mission_GetAttr('civilians_questioned')
			if Mission_GetAttr('civilians_questioned') == 4:
				SpyRegister()

def Civilian5Speaks():
	if Mission_GetAttr('talked_to_pablo') == 0:
		speakNoCB('civilian5', 'MISSPCH_3_CC_19')
	else:
		if Object_GetAttr('civilian5', 'spy'):
			Mission_SetAttr('which_civilian', 5)
			print "Spy stuff goes here"
		elif Object_GetAttr('civilian5', 'notspy'):
			print "I'm being questioned a second time"
			speakNoCB('civilian1', 'MISSPCH_3_CC_20')
		else:
			Object_SetAttr('civilian5', 'notspy', 1)
			speakNoCB('civilian1', 'MISSPCH_3_CC_20')
			addAttr('civilians_questioned', 1)
			Mission_SetAttr('civ5questioned', 1)
			print "Civilians questioned: "
			print Mission_GetAttr('civilians_questioned')
			if Mission_GetAttr('civilians_questioned') == 4:
				SpyRegister()


# called when the 5th civilian is talked to, setting him up as the spy
def SpyRegister():
	civlist = getAll('cuban_male_enemy')
	for cuban in civlist:
		if Object_IsAlive(cuban):
			if not Object_GetAttr(cuban, 'notspy'):
				Object_SetAttr(cuban, 'spy', 1)
				print cuban
				print " is now the spy"
				print Object_GetAttr(cuban, 'spy')

	if Object_IsAlive('civilian1'):
		if Object_GetAttr('civilian1', 'spy'):
			Mission_SetAttr('which_civilian', 1)
#			regDamage('civilian1', 'OnSpyDamaged')
			Mission_RemoveCustomAction('interrogate', '', 'civilian1')
			Mission_CustomAction('interrogate', '', 'civilian1', 'SpyTalk', 3, 0)
			regAlmostDead('civilian1', 'onSpyKOed')
			addArrow('civspy_arrow', 'civilian1', js.ARROW_RED, delete=1)

	if Object_IsAlive('civilian2'):
		if Object_GetAttr('civilian2', 'spy'):
			Mission_SetAttr('which_civilian', 2)
#			regDamage('civilian2', 'OnSpyDamaged')
			Mission_RemoveCustomAction('interrogate', '', 'civilian2')
			Mission_CustomAction('interrogate', '', 'civilian2', 'SpyTalk', 3, 0)
			regAlmostDead('civilian2', 'onSpyKOed')
			addArrow('civspy_arrow', 'civilian2', js.ARROW_RED, delete=1)

	if Object_IsAlive('civilian3'):
		if Object_GetAttr('civilian3', 'spy'):
			Mission_SetAttr('which_civilian', 3)
#			regDamage('civilian3', 'OnSpyDamaged')
			Mission_RemoveCustomAction('interrogate', '', 'civilian3')
			Mission_CustomAction('interrogate', '', 'civilian3', 'SpyTalk', 3, 0)
			regAlmostDead('civilian3', 'onSpyKOed')
			addArrow('civspy_arrow', 'civilian3', js.ARROW_RED, delete=1)

	if Object_IsAlive('civilian4'):
		if Object_GetAttr('civilian4', 'spy'):
			Mission_SetAttr('which_civilian', 4)
#			regDamage('civilian4', 'OnSpyDamaged')
			Mission_RemoveCustomAction('interrogate', '', 'civilian4')
			Mission_CustomAction('interrogate', '', 'civilian4', 'SpyTalk', 3, 0)
			regAlmostDead('civilian4', 'onSpyKOed')
			addArrow('civspy_arrow', 'civilian4', js.ARROW_RED, delete=1)

	if Object_IsAlive('civilian5'):
		if Object_GetAttr('civilian5', 'spy'):
			Mission_SetAttr('which_civilian', 5)
#			regDamage('civilian5', 'OnSpyDamaged')
			Mission_RemoveCustomAction('interrogate', '', 'civilian5')
			Mission_CustomAction('interrogate', '', 'civilian5', 'SpyTalk', 3, 0)
			regAlmostDead('civilian5', 'onSpyKOed')
			addArrow('civspy_arrow', 'civilian5', js.ARROW_RED, delete=1)

	print "finding the last civilian and making him the spy"



##########################################################################################################################################################
## Functions pertaining to the Mystical Hands

# These four functions do things when each Generator is destroyed

def OnGen1Destroyed(event):
	print "Generator 1 Destroyed"
	Object_PlayEffect('generator_standin1', 'effect_generator_destroy', '', FX_TRACK_OBJECT_ROT)
	Mission_SetAttr('generator1_dead', 1)           # note that this specific Generator is dead
	addAttr('total_gens_dead', 1)                   # increment the count of how many Generators are currently dead
	print Mission_GetAttr('total_gens_dead')
	if Mission_GetAttr('total_gens_dead') == 4:     # if all four Generators are currently dead...
		AllGensGone()                               # ...play the cutscene where Red emerges.  Otherwise...
	else:
		if Mission_GetAttr('first_gen_dead') == 0:  # if no gen has yet been killed...
			Mission_SetAttr('first_gen_dead', 1)    # mark that gen #1 was the first killed...
			FirstHandDestroyed()                    # ...and play the SS for this event
		if HeroCount() == 4:
			if RPG_GAME_DIFFICULTY == 2:
				regTimer('RespawnGenOne', 60)
			if RPG_GAME_DIFFICULTY == 3:
				regTimer('RespawnGenOne', 30)
			if RPG_GAME_DIFFICULTY == 4:
				regTimer('RespawnGenOne', 30)
			if RPG_GAME_DIFFICULTY == 5:
				regTimer('RespawnGenOne', 20)
			if RPG_GAME_DIFFICULTY == 6:
				regTimer('RespawnGenOne', 5)
		if HeroCount() == 3:
			if RPG_GAME_DIFFICULTY == 2:
				regTimer('RespawnGenOne', 80)
			if RPG_GAME_DIFFICULTY == 3:
				regTimer('RespawnGenOne', 50)
			if RPG_GAME_DIFFICULTY == 4:
				regTimer('RespawnGenOne', 40)
			if RPG_GAME_DIFFICULTY == 5:
				regTimer('RespawnGenOne', 30)
			if RPG_GAME_DIFFICULTY == 6:
				regTimer('RespawnGenOne', 10)
		if HeroCount() == 2:
			if RPG_GAME_DIFFICULTY == 2:
				regTimer('RespawnGenOne', 100)
			if RPG_GAME_DIFFICULTY == 3:
				regTimer('RespawnGenOne', 70)
			if RPG_GAME_DIFFICULTY == 4:
				regTimer('RespawnGenOne', 50)
			if RPG_GAME_DIFFICULTY == 5:
				regTimer('RespawnGenOne', 40)
			if RPG_GAME_DIFFICULTY == 6:
				regTimer('RespawnGenOne', 20)
		if HeroCount() == 1:
			if RPG_GAME_DIFFICULTY == 2:
				regTimer('RespawnGenOne', 120)
			if RPG_GAME_DIFFICULTY == 3:
				regTimer('RespawnGenOne', 90)
			if RPG_GAME_DIFFICULTY == 4:
				regTimer('RespawnGenOne', 60)
			if RPG_GAME_DIFFICULTY == 5:
				regTimer('RespawnGenOne', 50)
			if RPG_GAME_DIFFICULTY == 6:
				regTimer('RespawnGenOne', 30)


def OnGen2Destroyed(event): 
	print "Generator 2 Destroyed"
	Object_PlayEffect('generator_standin2', 'effect_generator_destroy', '', FX_TRACK_OBJECT_ROT)
	Mission_SetAttr('generator2_dead', 1)           # note that this specific Generator is dead
	addAttr('total_gens_dead', 1)                   # increment the count of how many Generators are currently dead
	print Mission_GetAttr('total_gens_dead')
	if Mission_GetAttr('total_gens_dead') == 4:     # if all four Generators are currently dead...
		AllGensGone()                               # ...play the cutscene where Red emerges.  Otherwise...
	else:
		if Mission_GetAttr('first_gen_dead') == 0:  # if no gen has yet been killed...
			Mission_SetAttr('first_gen_dead', 2)    # mark that gen #2 was the first killed...
			FirstHandDestroyed()                    # ...and play the SS for this event
		if HeroCount() == 4:
			if RPG_GAME_DIFFICULTY == 2:
				regTimer('RespawnGenTwo', 60)
			if RPG_GAME_DIFFICULTY == 3:
				regTimer('RespawnGenTwo', 30)
			if RPG_GAME_DIFFICULTY == 4:
				regTimer('RespawnGenTwo', 30)
			if RPG_GAME_DIFFICULTY == 5:
				regTimer('RespawnGenTwo', 20)
			if RPG_GAME_DIFFICULTY == 6:
				regTimer('RespawnGenTwo', 5)
		if HeroCount() == 3:
			if RPG_GAME_DIFFICULTY == 2:
				regTimer('RespawnGenTwo', 80)
			if RPG_GAME_DIFFICULTY == 3:
				regTimer('RespawnGenTwo', 50)
			if RPG_GAME_DIFFICULTY == 4:
				regTimer('RespawnGenTwo', 40)
			if RPG_GAME_DIFFICULTY == 5:
				regTimer('RespawnGenTwo', 30)
			if RPG_GAME_DIFFICULTY == 6:
				regTimer('RespawnGenTwo', 10)
		if HeroCount() == 2:
			if RPG_GAME_DIFFICULTY == 2:
				regTimer('RespawnGenTwo', 100)
			if RPG_GAME_DIFFICULTY == 3:
				regTimer('RespawnGenTwo', 70)
			if RPG_GAME_DIFFICULTY == 4:
				regTimer('RespawnGenTwo', 50)
			if RPG_GAME_DIFFICULTY == 5:
				regTimer('RespawnGenTwo', 40)
			if RPG_GAME_DIFFICULTY == 6:
				regTimer('RespawnGenTwo', 20)
		if HeroCount() == 1:
			if RPG_GAME_DIFFICULTY == 2:
				regTimer('RespawnGenTwo', 120)
			if RPG_GAME_DIFFICULTY == 3:
				regTimer('RespawnGenTwo', 90)
			if RPG_GAME_DIFFICULTY == 4:
				regTimer('RespawnGenTwo', 60)
			if RPG_GAME_DIFFICULTY == 5:
				regTimer('RespawnGenTwo', 50)
			if RPG_GAME_DIFFICULTY == 6:
				regTimer('RespawnGenTwo', 30)


def OnGen3Destroyed(event):
	print "Generator 3 Destroyed"
	Object_PlayEffect('generator_standin3', 'effect_generator_destroy', '', FX_TRACK_OBJECT_ROT)
	Mission_SetAttr('generator3_dead', 1)           # note that this specific Generator is dead
	addAttr('total_gens_dead', 1)                   # increment the count of how many Generators are currently dead
	print Mission_GetAttr('total_gens_dead')
	if Mission_GetAttr('total_gens_dead') == 4:     # if all four Generators are currently dead...
		AllGensGone()                               # ...play the cutscene where Red emerges.  Otherwise...
	else:
		if Mission_GetAttr('first_gen_dead') == 0:  # if no gen has yet been killed...
			Mission_SetAttr('first_gen_dead', 3)    # mark that gen #3 was the first killed...
			FirstHandDestroyed()                    # ...and play the SS for this event
		if HeroCount() == 4:
			if RPG_GAME_DIFFICULTY == 2:
				regTimer('RespawnGenThree', 60)
			if RPG_GAME_DIFFICULTY == 3:
				regTimer('RespawnGenThree', 30)
			if RPG_GAME_DIFFICULTY == 4:
				regTimer('RespawnGenThree', 30)
			if RPG_GAME_DIFFICULTY == 5:
				regTimer('RespawnGenThree', 20)
			if RPG_GAME_DIFFICULTY == 6:
				regTimer('RespawnGenThree', 5)
		if HeroCount() == 3:
			if RPG_GAME_DIFFICULTY == 2:
				regTimer('RespawnGenThree', 80)
			if RPG_GAME_DIFFICULTY == 3:
				regTimer('RespawnGenThree', 50)
			if RPG_GAME_DIFFICULTY == 4:
				regTimer('RespawnGenThree', 40)
			if RPG_GAME_DIFFICULTY == 5:
				regTimer('RespawnGenThree', 30)
			if RPG_GAME_DIFFICULTY == 6:
				regTimer('RespawnGenThree', 10)
		if HeroCount() == 2:
			if RPG_GAME_DIFFICULTY == 2:
				regTimer('RespawnGenThree', 100)
			if RPG_GAME_DIFFICULTY == 3:
				regTimer('RespawnGenThree', 70)
			if RPG_GAME_DIFFICULTY == 4:
				regTimer('RespawnGenThree', 50)
			if RPG_GAME_DIFFICULTY == 5:
				regTimer('RespawnGenThree', 40)
			if RPG_GAME_DIFFICULTY == 6:
				regTimer('RespawnGenThree', 20)
		if HeroCount() == 1:
			if RPG_GAME_DIFFICULTY == 2:
				regTimer('RespawnGenThree', 120)
			if RPG_GAME_DIFFICULTY == 3:
				regTimer('RespawnGenThree', 90)
			if RPG_GAME_DIFFICULTY == 4:
				regTimer('RespawnGenThree', 60)
			if RPG_GAME_DIFFICULTY == 5:
				regTimer('RespawnGenThree', 50)
			if RPG_GAME_DIFFICULTY == 6:
				regTimer('RespawnGenThree', 30)


def OnGen4Destroyed(event):
	print "Generator 4 Destroyed"
	Object_PlayEffect('generator_standin4', 'effect_generator_destroy', '', FX_TRACK_OBJECT_ROT)
	Mission_SetAttr('generator4_dead', 1)           # note that this specific Generator is dead
	addAttr('total_gens_dead', 1)                   # increment the count of how many Generators are currently dead
	print Mission_GetAttr('total_gens_dead')
	if Mission_GetAttr('total_gens_dead') == 4:     # if all four Generators are currently dead...
		AllGensGone()                               # ...play the cutscene where Red emerges.  Otherwise...
	else:
		if Mission_GetAttr('first_gen_dead') == 0:  # if no gen has yet been killed...
			Mission_SetAttr('first_gen_dead', 4)    # mark that gen #4 was the first killed...
			FirstHandDestroyed()                    # ...and play the SS for this event
		if HeroCount() == 4:
			if RPG_GAME_DIFFICULTY == 2:
				regTimer('RespawnGenFour', 60)
			if RPG_GAME_DIFFICULTY == 3:
				regTimer('RespawnGenFour', 30)
			if RPG_GAME_DIFFICULTY == 4:
				regTimer('RespawnGenFour', 30)
			if RPG_GAME_DIFFICULTY == 5:
				regTimer('RespawnGenFour', 20)
			if RPG_GAME_DIFFICULTY == 6:
				regTimer('RespawnGenFour', 5)
		if HeroCount() == 3:
			if RPG_GAME_DIFFICULTY == 2:
				regTimer('RespawnGenFour', 80)
			if RPG_GAME_DIFFICULTY == 3:
				regTimer('RespawnGenFour', 50)
			if RPG_GAME_DIFFICULTY == 4:
				regTimer('RespawnGenFour', 40)
			if RPG_GAME_DIFFICULTY == 5:
				regTimer('RespawnGenFour', 30)
			if RPG_GAME_DIFFICULTY == 6:
				regTimer('RespawnGenFour', 10)
		if HeroCount() == 2:
			if RPG_GAME_DIFFICULTY == 2:
				regTimer('RespawnGenFour', 100)
			if RPG_GAME_DIFFICULTY == 3:
				regTimer('RespawnGenFour', 70)
			if RPG_GAME_DIFFICULTY == 4:
				regTimer('RespawnGenFour', 50)
			if RPG_GAME_DIFFICULTY == 5:
				regTimer('RespawnGenFour', 40)
			if RPG_GAME_DIFFICULTY == 6:
				regTimer('RespawnGenFour', 20)
		if HeroCount() == 1:
			if RPG_GAME_DIFFICULTY == 2:
				regTimer('RespawnGenFour', 120)
			if RPG_GAME_DIFFICULTY == 3:
				regTimer('RespawnGenFour', 90)
			if RPG_GAME_DIFFICULTY == 4:
				regTimer('RespawnGenFour', 60)
			if RPG_GAME_DIFFICULTY == 5:
				regTimer('RespawnGenFour', 50)
			if RPG_GAME_DIFFICULTY == 6:
				regTimer('RespawnGenFour', 30)


# These four functions are triggered by the regTimers above completing, thus respawning the appropriate generator

def RespawnGenOne(event):
	if Mission_GetAttr('total_gens_dead') != 4:                         # we only spawn if this objective hasn't been won already
		print "We should be spawning a new generator now!"
		Object_PlayEffect('generator_standin1', 'effect_generator_spawn', 'OnSpawnEffectFinished1', FX_TRACK_OBJECT_ROT)
#       spawn('generator1', 'ro_generator', 'gen1marker')               # When Generator 1's timer goes off, it respawns an object named generator 1 of template 
#       regDeath('generator1', 'OnGen1Destroyed')
		addAttr('total_gens_dead', -1)                                  # type 'ro_generator', at location of 'gen1marker'.  Then decrement the total count of dead
		print Mission_GetAttr('total_gens_dead')
		if Mission_GetAttr('spawn_scene_played') == 0:                  # generators.  If this is the first such respawn to occur...
			Mission_SetAttr('spawn_scene_played', 1)
			OnFirstGeneratorSpawn()                                     # ...it will trigger a Cutscene.
		else:
			regTimer('HandComeBack', 2)
#			speakNoCB('mentor', 'MISSPCH_3_ME_14')
	if Mission_GetAttr('total_gens_dead') == 4:
		print "No respawn; they're all dead"
	
def RespawnGenTwo(event):
	if Mission_GetAttr('total_gens_dead') != 4:                         # we only spawn if this objective hasn't been won already
		print "We should be spawning a new generator now!"
		Object_PlayEffect('generator_standin2', 'effect_generator_spawn', 'OnSpawnEffectFinished2', FX_TRACK_OBJECT_ROT)
#        spawn('generator2', 'ro_generator', 'gen2marker')               # When Generator 2's timer goes off, it respawns...
#        regDeath('generator2', 'OnGen2Destroyed')
		addAttr('total_gens_dead', -1)                                  # decrement the total count of dead generators
		print Mission_GetAttr('total_gens_dead')
		if Mission_GetAttr('spawn_scene_played') == 0:                  # ...and if this is the first such respawn to occur...
			Mission_SetAttr('spawn_scene_played', 1)
			OnFirstGeneratorSpawn()                                     # ...it will trigger a Cutscene.
		else:
			regTimer('HandComeBack', 2)
#			speakNoCB('mentor', 'MISSPCH_3_ME_14')	if Mission_GetAttr('total_gens_dead') == 4:
	if Mission_GetAttr('total_gens_dead') == 4:
		print "No respawn; they're all dead"
		
def RespawnGenThree(event):
	if Mission_GetAttr('total_gens_dead') != 4:                         # we only spawn if this objective hasn't been won already
		print "We should be spawning a new generator now!"
		Object_PlayEffect('generator_standin3', 'effect_generator_spawn', 'OnSpawnEffectFinished3', FX_TRACK_OBJECT_ROT)
#        spawn('generator3', 'ro_generator', 'gen3marker')               # When Generator 3's timer goes off, it respawns...
#        regDeath('generator3', 'OnGen3Destroyed')
		addAttr('total_gens_dead', -1)                                  # decrement the total count of dead generators
		print Mission_GetAttr('total_gens_dead')
		if Mission_GetAttr('spawn_scene_played') == 0:                  # ...and if this is the first such respawn to occur...
			Mission_SetAttr('spawn_scene_played', 1)
			OnFirstGeneratorSpawn()                                     # ...it will trigger a Cutscene.
		else:
			regTimer('HandComeBack', 2)
#			speakNoCB('mentor', 'MISSPCH_3_ME_14')	if Mission_GetAttr('total_gens_dead') == 4:
	if Mission_GetAttr('total_gens_dead') == 4:
		print "No respawn; they're all dead"
		
def RespawnGenFour(event):
	if Mission_GetAttr('total_gens_dead') != 4:                         # we only spawn if this objective hasn't been won already
		print "We should be spawning a new generator now!"
		Object_PlayEffect('generator_standin4', 'effect_generator_spawn', 'OnSpawnEffectFinished4', FX_TRACK_OBJECT_ROT)
#        spawn('generator4', 'ro_generator', 'gen4marker')               # When Generator 4's timer goes off, it respawns...
#        regDeath('generator4', 'OnGen4Destroyed')
		addAttr('total_gens_dead', -1)                                  # decrement the total count of dead generators
		print Mission_GetAttr('total_gens_dead')
		if Mission_GetAttr('spawn_scene_played') == 0:                  # ...and if this is the first such respawn to occur...
			Mission_SetAttr('spawn_scene_played', 1)
			OnFirstGeneratorSpawn()                                     # ...it will trigger a Cutscene.
		else:
			regTimer('HandComeBack', 2)
#			speakNoCB('mentor', 'MISSPCH_3_ME_14')	if Mission_GetAttr('total_gens_dead') == 4:
	if Mission_GetAttr('total_gens_dead') == 4:
		print "No respawn; they're all dead"


def HandComeBack(event):
	if Mission_GetAttr('hand_timer') == 0:
		speakNoCB('mentor', 'MISSPCH_3_ME_14')


def AllGensGone():
	print "Red October will now appear to fight"
	spawn("red_oktober", "red_oktober", "oktober_spawn")
	spawnGroup("red_shurale_spawn", "shurale", 1) 
	makeInterrogationCS('red_oktober', oneshot = 1)
	play(red_emerges_cs, "red_emerges_cs")


def OnTreeEnter(object, hero):
	Object_PlayEffect('generator_standin1', 'effect_generator_spawn', 'OnSpawnEffectFinished1', FX_TRACK_OBJECT_ROT)
	Object_PlayEffect('generator_standin2', 'effect_generator_spawn', 'OnSpawnEffectFinished2', FX_TRACK_OBJECT_ROT)
	Object_PlayEffect('generator_standin3', 'effect_generator_spawn', 'OnSpawnEffectFinished3', FX_TRACK_OBJECT_ROT)
	Object_PlayEffect('generator_standin4', 'effect_generator_spawn', 'OnSpawnEffectFinished4', FX_TRACK_OBJECT_ROT)
#    spawn("initial_generator1", "ro_generator", "gen1marker")
#    spawn("initial_generator2", "ro_generator", "gen2marker")
#    spawn("initial_generator3", "ro_generator", "gen3marker")
#    spawn("initial_generator4", "ro_generator", "gen4marker")
	removeArrow('tree_arrow')
	play(hands_visible_cs, "hands_visible_cs")

def OnSpawnEffectFinished1(event):
	Object_Spawn('generator1', 'ro_generator', 'gen1marker')
	regDeath('generator1', 'OnGen1Destroyed')

def OnSpawnEffectFinished2(event):
	Object_Spawn('generator2', 'ro_generator', 'gen2marker')
	regDeath('generator2', 'OnGen2Destroyed')

def OnSpawnEffectFinished3(event):
	Object_Spawn('generator3', 'ro_generator', 'gen3marker')
	regDeath('generator3', 'OnGen3Destroyed')

def OnSpawnEffectFinished4(event):
	Object_Spawn('generator4', 'ro_generator', 'gen4marker')
	regDeath('generator4', 'OnGen4Destroyed')

def FirstHandDestroyed():
	Object_PlayEffect('treebase','effect_redtree_spawn','',FX_TRACK_OBJECT_ROT,0.0,'effect_attach_point')
#	Object_PlayEffect('ice1_standin', 'effect_redtree_spawn', '',FX_TRACK_OBJECT_ROT)
#	Object_PlayEffect('ice2_standin', 'effect_redtree_spawn', '',FX_TRACK_OBJECT_ROT)
	spawnGroup("ice_hand_spawn", "ice_trooper_guard", 2)
	spawn('ice_serg', 'ice_sergeant_guard', 'ice_serg_spawn')
	play(save_the_hands_ss, "save_the_hands_ss")
	playEffectMarker('effect_redtree_spawn', 'tree_spawn')

def OnFirstGeneratorSpawn():
	Mission_SetAttr('hand_timer', 1)
	regTimer('SimulTimer', 5)
	if Mission_GetAttr('first_gen_dead') == 1:
		play(hand_1_respawn_cs, "hand_1_respawn_cs")
	if Mission_GetAttr('first_gen_dead') == 2:
		play(hand_2_respawn_cs, "hand_2_respawn_cs")
	if Mission_GetAttr('first_gen_dead') == 3:
		play(hand_3_respawn_cs, "hand_3_respawn_cs")
	if Mission_GetAttr('first_gen_dead') == 4:
		play(hand_4_respawn_cs, "hand_4_respawn_cs")

# This function is part of the effort to solve the "simultaneous hand death" problem
def SimulTimer(event):
	Mission_SetAttr('hand_timer', 0)


##########################################################################################################################################################
## Functions pertaining to Respawning Snowmen

# This spawns three Snowmen, after the CS following the spy being interrogated
def SpawnSnowmen():
	spawn('snow_man0', 'snow_man', 'snowman_spawn0')
	spawn('snow_man1', 'snow_man', 'snowman_spawn1')
	spawn('snow_man2', 'snow_man', 'snowman_spawn2')
#	spawnGroup("snowman_spawn", "snow_man", 3)
	regDeath('snow_man0', 'OnSnowman0Destroyed')
	regDeath('snow_man1', 'OnSnowman1Destroyed')
	regDeath('snow_man2', 'OnSnowman2Destroyed')


# The functions below govern the respawning of snowmen (if they're in snow) at the places of their deaths, with appropriate effects
def OnSnowman0Destroyed(event):
	if (CheckDistance('snow_man0', 'snow_area_marker3') < 1000):
		if Object_Exists('red_oktober'):
			if Object_GetAttr('red_oktober', 'health') != 1:
				print "spawning marker"
				temp = Mission_GetAttr('snowman0_marker_count')
				Marker_Spawn('snowman0_death_'+str(int(temp)), Get_ObjectPos('snow_man0'))
				regTimer('DestroyOldSnowman0', 11)
				regTimer('Snowman0Respawns', 12)
			else:
				print "red's alive with one health, so no snowman regen"
		else:
			print "spawning marker"
			temp = Mission_GetAttr('snowman0_marker_count')
			Marker_Spawn('snowman0_death_'+str(int(temp)), Get_ObjectPos('snow_man0'))
			regTimer('DestroyOldSnowman0', 11)
			regTimer('Snowman0Respawns', 12)

def OnSnowman1Destroyed(event):
	if (CheckDistance('snow_man1', 'snow_area_marker3') < 1000):
		if Object_Exists('red_oktober'):
			if Object_GetAttr('red_oktober', 'health') != 1:
				print "spawning marker"
				temp = Mission_GetAttr('snowman1_marker_count')
				Marker_Spawn('snowman1_death_'+str(int(temp)), Get_ObjectPos('snow_man1'))
				regTimer('DestroyOldSnowman1', 11)
				regTimer('Snowman1Respawns', 12)
			else:
				print "red's alive with one health, so no snowman regen"
		else:
			print "spawning marker"
			temp = Mission_GetAttr('snowman1_marker_count')
			Marker_Spawn('snowman1_death_'+str(int(temp)), Get_ObjectPos('snow_man1'))
			regTimer('DestroyOldSnowman1', 11)
			regTimer('Snowman1Respawns', 12)

def OnSnowman2Destroyed(event):
	if (CheckDistance('snow_man2', 'snow_area_marker3') < 1000):
		if Object_Exists('red_oktober'):
			if Object_GetAttr('red_oktober', 'health') != 1:
				print "spawning marker"
				temp = Mission_GetAttr('snowman2_marker_count')
				Marker_Spawn('snowman2_death_'+str(int(temp)), Get_ObjectPos('snow_man2'))
				regTimer('DestroyOldSnowman2', 11)
				regTimer('Snowman2Respawns', 12)
			else:
				print "red's alive with one health, so no snowman regen"
		else:
			print "spawning marker"
			temp = Mission_GetAttr('snowman2_marker_count')
			Marker_Spawn('snowman2_death_'+str(int(temp)), Get_ObjectPos('snow_man2'))
			regTimer('DestroyOldSnowman2', 11)
			regTimer('Snowman2Respawns', 12)

def OnSnowman3Destroyed(event):
	if (CheckDistance('snow_man3', 'snow_area_marker3') < 1000):
		if Object_Exists('red_oktober'):
			if Object_GetAttr('red_oktober', 'health') != 1:
				print "spawning marker"
				temp = Mission_GetAttr('snowman3_marker_count')
				Marker_Spawn('snowman3_death_'+str(int(temp)), Get_ObjectPos('snow_man3'))
				regTimer('DestroyOldSnowman3', 11)
				regTimer('Snowman3Respawns', 12)
			else:
				print "red's alive with one health, so no snowman regen"
		else:
			print "spawning marker"
			temp = Mission_GetAttr('snowman3_marker_count')
			Marker_Spawn('snowman3_death_'+str(int(temp)), Get_ObjectPos('snow_man3'))
			regTimer('DestroyOldSnowman3', 11)
			regTimer('Snowman3Respawns', 12)

def OnSnowman4Destroyed(event):
	if (CheckDistance('snow_man4', 'snow_area_marker3') < 1000):
		if Object_Exists('red_oktober'):
			if Object_GetAttr('red_oktober', 'health') != 1:
				print "spawning marker"
				temp = Mission_GetAttr('snowman4_marker_count')
				Marker_Spawn('snowman4_death_'+str(int(temp)), Get_ObjectPos('snow_man4'))
				regTimer('DestroyOldSnowman4', 11)
				regTimer('Snowman4Respawns', 12)
			else:
				print "red's alive with one health, so no snowman regen"
		else:
			print "spawning marker"
			temp = Mission_GetAttr('snowman4_marker_count')
			Marker_Spawn('snowman4_death_'+str(int(temp)), Get_ObjectPos('snow_man4'))
			regTimer('DestroyOldSnowman4', 11)
			regTimer('Snowman4Respawns', 12)

def OnSnowman5Destroyed(event):
	if (CheckDistance('snow_man5', 'snow_area_marker3') < 1000):
		if Object_Exists('red_oktober'):
			if Object_GetAttr('red_oktober', 'health') != 1:
				print "spawning marker"
				temp = Mission_GetAttr('snowman5_marker_count')
				Marker_Spawn('snowman5_death_'+str(int(temp)), Get_ObjectPos('snow_man5'))
				regTimer('DestroyOldSnowman5', 11)
				regTimer('Snowman5Respawns', 12)
			else:
				print "red's alive with one health, so no snowman regen"
		else:
			print "spawning marker"
			temp = Mission_GetAttr('snowman5_marker_count')
			Marker_Spawn('snowman5_death_'+str(int(temp)), Get_ObjectPos('snow_man5'))
			regTimer('DestroyOldSnowman5', 11)
			regTimer('Snowman5Respawns', 12)

def OnSnowman6Destroyed(event):
	if (CheckDistance('snow_man6', 'snow_area_marker3') < 1000):
		if Object_Exists('red_oktober'):
			if Object_GetAttr('red_oktober', 'health') != 1:
				print "spawning marker"
				temp = Mission_GetAttr('snowman6_marker_count')
				Marker_Spawn('snowman6_death_'+str(int(temp)), Get_ObjectPos('snow_man6'))
				regTimer('DestroyOldSnowman6', 11)
				regTimer('Snowman6Respawns', 12)
			else:
				print "red's alive with one health, so no snowman regen"
		else:
			print "spawning marker"
			temp = Mission_GetAttr('snowman6_marker_count')
			Marker_Spawn('snowman6_death_'+str(int(temp)), Get_ObjectPos('snow_man6'))
			regTimer('DestroyOldSnowman6', 11)
			regTimer('Snowman6Respawns', 12)

def Snowman0Respawns(event):
	if Object_Exists('red_oktober'):
		if Object_GetAttr('red_oktober', 'health') != 1:
			print "spawning new snowman at marker 0"
			temp2 = Mission_GetAttr('snowman0_marker_count')
			playEffectMarker('effect_snowman_spawn', 'snowman0_death_'+str(int(temp2)), key = 'spawn', keyFn = 'SpawnSnowman0')
	else:
		print "spawning new snowman at marker 0"
		temp2 = Mission_GetAttr('snowman0_marker_count')
		playEffectMarker('effect_snowman_spawn', 'snowman0_death_'+str(int(temp2)), key = 'spawn', keyFn = 'SpawnSnowman0')


def SpawnSnowman0(event):
	temp2 = Mission_GetAttr('snowman0_marker_count')
	Object_Spawn('snow_man0', 'snow_man', 'snowman0_death_'+str(int(temp2)))
	addAttr('snowman0_marker_count', 1)
	regDeath('snow_man0', 'OnSnowman0Destroyed')
	if Mission_GetAttr('snow_respawn_comment') == 0:
		speakNoCB('mentor', 'MISSPCH_3_ME_12')
		Mission_SetAttr('snow_respawn_comment', 1)
	if Mission_GetAttr('cutscene_playing') == 1:
		peace()

def Snowman1Respawns(event):
	if Object_Exists('red_oktober'):
		if Object_GetAttr('red_oktober', 'health') != 1:
			print "spawning new snowman at marker 1"
			temp2 = Mission_GetAttr('snowman1_marker_count')
			playEffectMarker('effect_snowman_spawn', 'snowman1_death_'+str(int(temp2)), key = 'spawn', keyFn = 'SpawnSnowman1')
	else:
		print "spawning new snowman at marker 1"
		temp2 = Mission_GetAttr('snowman1_marker_count')
		playEffectMarker('effect_snowman_spawn', 'snowman1_death_'+str(int(temp2)), key = 'spawn', keyFn = 'SpawnSnowman1')

def SpawnSnowman1(event):
	temp2 = Mission_GetAttr('snowman1_marker_count')
	Object_Spawn('snow_man1', 'snow_man', 'snowman1_death_'+str(int(temp2)))
	addAttr('snowman1_marker_count', 1)
	regDeath('snow_man1', 'OnSnowman1Destroyed')
	if Mission_GetAttr('snow_respawn_comment') == 0:
		speakNoCB('mentor', 'MISSPCH_3_ME_12')
		Mission_SetAttr('snow_respawn_comment', 1)
	if Mission_GetAttr('cutscene_playing') == 1:
		peace()

def Snowman2Respawns(event):
	if Object_Exists('red_oktober'):
		if Object_GetAttr('red_oktober', 'health') != 1:
			print "spawning new snowman at marker 2"
			temp2 = Mission_GetAttr('snowman2_marker_count')
			playEffectMarker('effect_snowman_spawn', 'snowman2_death_'+str(int(temp2)), key = 'spawn', keyFn = 'SpawnSnowman2')
	else:
		print "spawning new snowman at marker 2"
		temp2 = Mission_GetAttr('snowman2_marker_count')
		playEffectMarker('effect_snowman_spawn', 'snowman2_death_'+str(int(temp2)), key = 'spawn', keyFn = 'SpawnSnowman2')


def SpawnSnowman2(event):
	temp2 = Mission_GetAttr('snowman2_marker_count')
	Object_Spawn('snow_man2', 'snow_man', 'snowman2_death_'+str(int(temp2)))
	addAttr('snowman2_marker_count', 1)
	regDeath('snow_man2', 'OnSnowman2Destroyed')
	if Mission_GetAttr('snow_respawn_comment') == 0:
		speakNoCB('mentor', 'MISSPCH_3_ME_12')
		Mission_SetAttr('snow_respawn_comment', 1)
	if Mission_GetAttr('cutscene_playing') == 1:
		peace()

def Snowman3Respawns(event):
	if Object_Exists('red_oktober'):
		if Object_GetAttr('red_oktober', 'health') != 1:
			print "spawning new snowman at marker 3"
			temp2 = Mission_GetAttr('snowman3_marker_count')
			playEffectMarker('effect_snowman_spawn', 'snowman3_death_'+str(int(temp2)), key = 'spawn', keyFn = 'SpawnSnowman3')
	else:
		print "spawning new snowman at marker 3"
		temp2 = Mission_GetAttr('snowman3_marker_count')
		playEffectMarker('effect_snowman_spawn', 'snowman3_death_'+str(int(temp2)), key = 'spawn', keyFn = 'SpawnSnowman3')

def SpawnSnowman3(event):
	temp2 = Mission_GetAttr('snowman3_marker_count')
	Object_Spawn('snow_man3', 'snow_man', 'snowman3_death_'+str(int(temp2)))
	addAttr('snowman3_marker_count', 1)
	regDeath('snow_man3', 'OnSnowman3Destroyed')
	if Mission_GetAttr('snow_respawn_comment') == 0:
		speakNoCB('mentor', 'MISSPCH_3_ME_12')
		Mission_SetAttr('snow_respawn_comment', 1)
	if Mission_GetAttr('cutscene_playing') == 1:
		peace()

def Snowman4Respawns(event):
	if Object_Exists('red_oktober'):
		if Object_GetAttr('red_oktober', 'health') != 1:
			print "spawning new snowman at marker 4"
			temp2 = Mission_GetAttr('snowman4_marker_count')
			playEffectMarker('effect_snowman_spawn', 'snowman4_death_'+str(int(temp2)), key = 'spawn', keyFn = 'SpawnSnowman4')
	else:
		print "spawning new snowman at marker 4"
		temp2 = Mission_GetAttr('snowman4_marker_count')
		playEffectMarker('effect_snowman_spawn', 'snowman4_death_'+str(int(temp2)), key = 'spawn', keyFn = 'SpawnSnowman4')


def SpawnSnowman4(event):
	temp2 = Mission_GetAttr('snowman4_marker_count')
	Object_Spawn('snow_man4', 'snow_man', 'snowman4_death_'+str(int(temp2)))
	addAttr('snowman4_marker_count', 1)
	regDeath('snow_man4', 'OnSnowman4Destroyed')
	if Mission_GetAttr('snow_respawn_comment') == 0:
		speakNoCB('mentor', 'MISSPCH_3_ME_12')
		Mission_SetAttr('snow_respawn_comment', 1)
	if Mission_GetAttr('cutscene_playing') == 1:
		peace()

def Snowman5Respawns(event):
	if Object_Exists('red_oktober'):
		if Object_GetAttr('red_oktober', 'health') != 1:
			print "spawning new snowman at marker 5"
			temp2 = Mission_GetAttr('snowman5_marker_count')
			playEffectMarker('effect_snowman_spawn', 'snowman5_death_'+str(int(temp2)), key = 'spawn', keyFn = 'SpawnSnowman5')
	else:
		print "spawning new snowman at marker 5"
		temp2 = Mission_GetAttr('snowman5_marker_count')
		playEffectMarker('effect_snowman_spawn', 'snowman5_death_'+str(int(temp2)), key = 'spawn', keyFn = 'SpawnSnowman5')


def SpawnSnowman5(event):
	temp2 = Mission_GetAttr('snowman5_marker_count')
	Object_Spawn('snow_man5', 'snow_man', 'snowman5_death_'+str(int(temp2)))
	addAttr('snowman5_marker_count', 1)
	regDeath('snow_man5', 'OnSnowman5Destroyed')
	if Mission_GetAttr('snow_respawn_comment') == 0:
		speakNoCB('mentor', 'MISSPCH_3_ME_12')
		Mission_SetAttr('snow_respawn_comment', 1)
	if Mission_GetAttr('cutscene_playing') == 1:
		peace()

def Snowman6Respawns(event):
	if Object_Exists('red_oktober'):
		if Object_GetAttr('red_oktober', 'health') != 1:
			print "spawning new snowman at marker 6"
			temp2 = Mission_GetAttr('snowman6_marker_count')
			playEffectMarker('effect_snowman_spawn', 'snowman6_death_'+str(int(temp2)), key = 'spawn', keyFn = 'SpawnSnowman6')
	else:
		print "spawning new snowman at marker 6"
		temp2 = Mission_GetAttr('snowman6_marker_count')
		playEffectMarker('effect_snowman_spawn', 'snowman6_death_'+str(int(temp2)), key = 'spawn', keyFn = 'SpawnSnowman6')


def SpawnSnowman6(event):
	temp2 = Mission_GetAttr('snowman6_marker_count')
	Object_Spawn('snow_man6', 'snow_man', 'snowman6_death_'+str(int(temp2)))
	addAttr('snowman6_marker_count', 1)
	regDeath('snow_man6', 'OnSnowman6Destroyed')
	if Mission_GetAttr('snow_respawn_comment') == 0:
		speakNoCB('mentor', 'MISSPCH_3_ME_12')
		Mission_SetAttr('snow_respawn_comment', 1)
	if Mission_GetAttr('cutscene_playing') == 1:
		peace()


def DestroyOldSnowman0(event):
	print "Destroying old snowman 0"
	Object_Destroy('snow_man0', 0)

def DestroyOldSnowman1(event):
	print "Destroying old snowman 1"
	Object_Destroy('snow_man1', 0)

def DestroyOldSnowman2(event):
	print "Destroying old snowman 2"
	Object_Destroy('snow_man2', 0)

def DestroyOldSnowman3(event):
	print "Destroying old snowman 3"
	Object_Destroy('snow_man3', 0)

def DestroyOldSnowman4(event):
	print "Destroying old snowman 4"
	Object_Destroy('snow_man4', 0)

def DestroyOldSnowman5(event):
	print "Destroying old snowman 5"
	Object_Destroy('snow_man5', 0)

def DestroyOldSnowman6(event):
	print "Destroying old snowman 6"
	Object_Destroy('snow_man6', 0)


##########################################################################################################################################################
## Other functions


#This function seems to be using different units than regProximityEnter
def CheckDistance(thing1,thing2):
#	if (not Object_IsAlive(thing1)) or (not Object_IsAlive(thing2)):
#		print "checking distance on a dead object"
#		return 1000
#	else:
	pos1 = Get_ObjectPos(thing1)
	pos2 = Get_MarkerPos(thing2)
	xdelt = abs(pos1[0] - pos2[0])
	ydelt = abs(pos1[1] - pos2[1])
	zdelt = abs(pos1[2] - pos2[2])
	distance = sqrt(xdelt**2 + ydelt**2 + zdelt**2)
	print distance
	return distance


def HeroCount():
	Mission_SetAttr('heroes_still_alive', 0)
	herolist = getAllHeroes()
	herocount = 0
	for hero in herolist:
		if Object_IsAlive(hero):
			addAttr('heroes_still_alive', 1)
	herocount = Mission_GetAttr('heroes_still_alive')
	print "heroes still alive: "
	print herocount
	return herocount



def SpawnShurale():
	spawn('first_shurale', 'shurale', 'shurale_spawn0')
	spawn('shurale_guard0', 'ice_trooper_guard', 'ice_trooper_spawn0')
	spawn('shurale_guard1', 'ice_trooper_guard', 'ice_trooper_spawn1')

def TreeRevealed():
	spawn("treebase", "ro_base_entrance", "tree_spawn")
	Mission_CustomAction('enter', '', 'treebase', 'ff.OnTreeEnter', 10, 1)


def OnSnowApproach(event):
	if Mission_GetAttr('snow_approach') == 0:
		Mission_SetAttr('snow_approach', 1)
		a_hero = getRandomLiveHeroName()
		print a_hero
		if a_hero == 'minute_man':
			speak('minute_man', 'MISSPCH_3_MM_10')
		elif a_hero == 'alchemiss':
			speak('alchemiss', 'MISSPCH_3_AL_05')
		elif a_hero == 'el_diablo':
			speak('el_diablo', 'MISSPCH_3_ED_05')
		elif a_hero == 'liberty_lad':
			speak('liberty_lad', 'MISSPCH_3_LL_05')
		elif a_hero == 'tombstone':
			speak('tombstone', 'MISSPCH_3_TS_05')
		else:
			print "no one's alive?!?"
			wait(0.1)
		print "Look! Snow!"
		


def CheckSecondary():
	if Objective_IsFailed('find_spy_safely') != 1:
		Objective_Complete('find_spy_safely')





def TeleportHeroes1():
	print "teleporting"
	teleport('civilian1', 'spy_spy_marker')
	herolist = getAllHeroes()
	temp = 0
	for hero in herolist:
		if Object_IsAlive(hero):
			if temp == 0:
				teleport(hero, 'spy_hero1_marker')
				temp = 1
			elif temp == 1:
				teleport(hero, 'spy_hero2_marker')
				temp = 2
			elif temp == 2:
				teleport(hero, 'spy_hero3_marker')
				temp = 3
			elif temp == 3:
				teleport(hero, 'spy_hero4_marker')
				temp = 4

def TeleportHeroes2():
	print "teleporting"
	teleport('civilian2', 'spy_spy_marker')
	herolist = getAllHeroes()
	temp = 0
	for hero in herolist:
		if Object_IsAlive(hero):
			if temp == 0:
				teleport(hero, 'spy_hero1_marker')
				temp = 1
			elif temp == 1:
				teleport(hero, 'spy_hero2_marker')
				temp = 2
			elif temp == 2:
				teleport(hero, 'spy_hero3_marker')
				temp = 3
			elif temp == 3:
				teleport(hero, 'spy_hero4_marker')
				temp = 4

def TeleportHeroes3():
	print "teleporting"
	teleport('civilian3', 'spy_spy_marker')
	herolist = getAllHeroes()
	temp = 0
	for hero in herolist:
		if Object_IsAlive(hero):
			if temp == 0:
				teleport(hero, 'spy_hero1_marker')
				temp = 1
			elif temp == 1:
				teleport(hero, 'spy_hero2_marker')
				temp = 2
			elif temp == 2:
				teleport(hero, 'spy_hero3_marker')
				temp = 3
			elif temp == 3:
				teleport(hero, 'spy_hero4_marker')
				temp = 4


def TeleportHeroes4():
	print "teleporting"
	teleport('civilian4', 'spy_spy_marker')
	herolist = getAllHeroes()
	temp = 0
	for hero in herolist:
		if Object_IsAlive(hero):
			if temp == 0:
				teleport(hero, 'spy_hero1_marker')
				temp = 1
			elif temp == 1:
				teleport(hero, 'spy_hero2_marker')
				temp = 2
			elif temp == 2:
				teleport(hero, 'spy_hero3_marker')
				temp = 3
			elif temp == 3:
				teleport(hero, 'spy_hero4_marker')
				temp = 4


def TeleportHeroes5():
	print "teleporting"
	teleport('civilian5', 'spy_spy_marker')
	herolist = getAllHeroes()
	temp = 0
	for hero in herolist:
		if Object_IsAlive(hero):
			if temp == 0:
				teleport(hero, 'spy_hero1_marker')
				temp = 1
			elif temp == 1:
				teleport(hero, 'spy_hero2_marker')
				temp = 2
			elif temp == 2:
				teleport(hero, 'spy_hero3_marker')
				temp = 3
			elif temp == 3:
				teleport(hero, 'spy_hero4_marker')
				temp = 4

###################################
# Fuctions for randomizing speakers
###################################

def PickTellRedSpeech():
	a_hero = getRandomLiveHeroName()
	print a_hero
	if a_hero == 'minute_man':
		speak('minute_man', 'MISSPCH_3_MM_09')
	elif a_hero == 'alchemiss':
		speak('alchemiss', 'MISSPCH_3_AL_02')
	elif a_hero == 'el_diablo':
		speak('el_diablo', 'MISSPCH_3_ED_02')
	elif a_hero == 'liberty_lad':
		speak('liberty_lad', 'MISSPCH_3_LL_02')
	elif a_hero == 'tombstone':
		speak('tombstone', 'MISSPCH_3_TS_02')
	else:
		print "no one's alive?!?"
		wait(0.1) # here just to provide a callback


def PickWhereIsRedSpeech():
	a_hero = getRandomLiveHeroName()
	print a_hero
	if a_hero == 'minute_man':
		speak('minute_man', 'MISSPCH_3_MM_15')
	elif a_hero == 'alchemiss':
		speak('alchemiss', 'MISSPCH_3_AL_03')
	elif a_hero == 'el_diablo':
		speak('el_diablo', 'MISSPCH_3_ED_03')
	elif a_hero == 'liberty_lad':
		speak('liberty_lad', 'MISSPCH_3_LL_03')
	elif a_hero == 'tombstone':
		speak('tombstone', 'MISSPCH_3_TS_03')
	else:
		print "no one's alive?!?"
		wait(0.1) # here just to provide a callback

def PickShurale():
	a_hero = getRandomLiveHeroName()
	print a_hero
	if a_hero == 'minute_man':
		speak('minute_man', 'MISSPCH_3_MM_01')
	elif a_hero == 'alchemiss':
		speak('alchemiss', 'MISSPCH_3_AL_04')
	elif a_hero == 'el_diablo':
		speak('el_diablo', 'MISSPCH_3_ED_04')
	elif a_hero == 'liberty_lad':
		speak('liberty_lad', 'MISSPCH_3_LL_04')
	elif a_hero == 'tombstone':
		speak('tombstone', 'MISSPCH_3_TS_04')
	else:
		print "no one's alive?!?"
		wait(0.1) # here just to provide a callback

def PickMyth():
	a_hero = getRandomLiveHeroName()
	print a_hero
	if a_hero == 'minute_man':
		speak('minute_man', 'MISSPCH_3_MM_19')
	elif a_hero == 'alchemiss':
		speak('alchemiss', 'MISSPCH_3_AL_01')
	elif a_hero == 'el_diablo':
		speak('el_diablo', 'MISSPCH_3_ED_01')
	elif a_hero == 'liberty_lad':
		speak('liberty_lad', 'MISSPCH_3_LL_01')
	elif a_hero == 'tombstone':
		speak('tombstone', 'MISSPCH_3_TS_01')
	else:
		print "no one's alive?!?"
		wait(0.1) # here just to provide a callback

def PickYouMean():
	a_hero = getRandomLiveHeroName()
	print a_hero
	if a_hero == 'minute_man':
		speak('minute_man', 'MISSPCH_3_MM_16')
	elif a_hero == 'alchemiss':
		speak('alchemiss', 'MISSPCH_3_AL_06')
	elif a_hero == 'el_diablo':
		speak('el_diablo', 'MISSPCH_3_ED_06')
	elif a_hero == 'liberty_lad':
		speak('liberty_lad', 'MISSPCH_3_LL_06')
	elif a_hero == 'tombstone':
		speak('tombstone', 'MISSPCH_3_TS_06')
	else:
		print "no one's alive?!?"
		wait(0.1) # here just to provide a callback

###########################################
#                                         #
# cutscenes and scripted sequences below  #
#                                         #
###########################################


start_cs = [
(
	"peace()",
	"startCS()",
	"lookAtPos((-175,-859,43), zoom = -200, pitch = -15, heading = -75)",
	"Sound_PlayMusic('music_03red_cs1',1)",
	"wait(.1)",
),
(
	"speak('minute_man', 'MISSPCH_3_MM_06')",
),
(
	"speak('mentor', 'MISSPCH_3_ME_06')",
),
(
	"endCS()",
	"war()",
	"Sound_PlayMusic('music_03red1')",
	"addArrow('pablo_arrow', 'pablo', js.ARROW_RED, delete=1)",
	"addAttention('pablo')",
	"newObjective('primary', 1, name='learn_location')",
	"registerObjective('primary', 2, name='find_spy')",
	"registerObjective('secondary', 1, name='find_spy_safely')",
	"clearGoals('civilian1')",
	"clearGoals('civilian2')",
	"clearGoals('civilian3')",
	"clearGoals('civilian4')",
	"clearGoals('civilian5')",
),
]

interrogate_pablo_cs = [
(
	"peace()",
	"startCS()",
	"speak('pablo', 'MISSPCH_3_CC_13')",
	"removeAttention('pablo')",
	"Mission_SetAttr('cutscene_playing', 1)",
),
(
	"ff.PickTellRedSpeech()",
),
(
	"speak('pablo', 'MISSPCH_3_CC_12')",
),
(
	"speak('mentor', 'MISSPCH_3_ME_22')",
),
(
	"speak('pablo', 'MISSPCH_3_CC_11')",
),
(
	"endCS()",
	"war()",
	"Mission_SetAttr('cutscene_playing', 0)",
),
]

interrogate_pablo_again_ss = [
(
	"speak('pablo', 'MISSPCH_3_CC_24')",
),
(
	"blank",
),
]

talk_spy_before_pablo_ss = [
(
	"speak('cuban_male', 'MISSPCH_3_CC_14')",
),
(
	"blank",
),
]

talk_spy_after_pablo_ss = [
(
	"speak('cuban_male', 'MISSPCH_3_CC_15')",
),
(
	"blank",
),
]



interrogate_civilian1_cs = [
(
	"Mission_SetAttr('cutscene_playing', 1)",
	"playTransition()",
),
(
	"startCS()",
	"peace()",
	"see()",
	"ff.TeleportHeroes1()",
	"lookAtPos((-575,-818,43), zoom = -94.8, pitch = 0, heading = 44.6)",
	"Sound_PlayMusic('music_03red_cs1',1)",
	"Sound_PlaySound('mission_red')",
	"wait(0.1)",
),
(
	"speak('civilian1', 'MISSPCH_3_CC_16')",
),
(
	"ff.PickWhereIsRedSpeech()",
),
(
	"speak('civilian1', 'MISSPCH_3_CC_23')",
),
(
	"ff.TreeRevealed()",
	"look('oktober_spawn', zoom = 300, heading = 0, time = 1)",
	"wait(3.0)",
),
(
	"speak('mentor', 'MISSPCH_3_ME_18')",
),
(
	"lookAtPos((-575,-818,43), zoom = -94.8, pitch = 0, heading = 44.6)",
	"speak('civilian1', 'MISSPCH_3_CC_18')",
),
(
	"ff.SpawnShurale()",
	"peace()",
	"lookAtPos((-565,-504,24), zoom = -200, pitch = 0, heading = -25, time = 1)",
	"wait(3.0)",
),
(
	"forceSpeak('shurale', 'MISSPCH_3_SR_01', telepathy=0)",
),
(
	"ff.PickShurale()",
),
(
	"speak('mentor', 'MISSPCH_3_ME_08')",
),
(
	"endCS()",
	"war()",
	"Sound_PlayMusic('music_03red2')",
	"blind()",
	"Objective_Complete('find_spy')",
	"Objective_Complete('learn_location')",
	"newObjective('primary', 4, name='enter_tree')",
	"ff.CheckSecondary()",
	"ff.SpawnSnowmen()",
	"removeAttention('civilian1')",
	"ff.addArrow('tree_arrow', 'treebase', js.ARROW_RED, delete=1)",
	"ff.SpyInterrogated()",
	"Mission_SetAttr('cutscene_playing', 0)",
),
]


interrogate_civilian2_cs = [
(
	"Mission_SetAttr('cutscene_playing', 1)",
	"playTransition()",
),
(
	"startCS()",
	"peace()",
	"see()",
	"ff.TeleportHeroes2()",
	"lookAtPos((-575,-818,43), zoom = -94.8, pitch = 0, heading = 44.6)",
	"Sound_PlayMusic('music_03red_cs1',1)",
	"Sound_PlaySound('mission_red')",
	"wait(0.1)",
),
(
	"speak('civilian2', 'MISSPCH_3_CC_16')",
),
(
	"ff.PickWhereIsRedSpeech()",
),
(
	"speak('civilian2', 'MISSPCH_3_CC_23')",
),
(
	"ff.TreeRevealed()",
	"look('oktober_spawn', zoom = 300, heading = 0, time = 1)",
	"wait(3.0)",
),
(
	"speak('mentor', 'MISSPCH_3_ME_18')",
),
(
	"lookAtPos((-575,-818,43), zoom = -94.8, pitch = 0, heading = 44.6)",
	"speak('civilian2', 'MISSPCH_3_CC_18')",
),
(
	"ff.SpawnShurale()",
	"peace()",
	"lookAtPos((-565,-504,24), zoom = -200, pitch = 0, heading = -25, time = 1)",
	"wait(3.0)",
),
(
	"forceSpeak('shurale', 'MISSPCH_3_SR_01', telepathy=0)",
),
(
	"ff.PickShurale()",
),
(
	"speak('mentor', 'MISSPCH_3_ME_08')",
),
(
	"endCS()",
	"war()",
	"Sound_PlayMusic('music_03red2')",
	"blind()",
	"Objective_Complete('find_spy')",
	"Objective_Complete('learn_location')",
	"newObjective('primary', 4, name='enter_tree')",
	"ff.CheckSecondary()",
	"ff.SpawnSnowmen()",
	"removeAttention('civilian2')",
	"ff.addArrow('tree_arrow', 'treebase', js.ARROW_RED, delete=1)",
	"ff.SpyInterrogated()",
	"Mission_SetAttr('cutscene_playing', 0)",
),
]


interrogate_civilian3_cs = [
(
	"Mission_SetAttr('cutscene_playing', 1)",
	"playTransition()",
),
(
	"startCS()",
	"peace()",
	"see()",
	"ff.TeleportHeroes3()",
	"lookAtPos((-575,-818,43), zoom = -94.8, pitch = 0, heading = 44.6)",
	"Sound_PlayMusic('music_03red_cs1',1)",
	"Sound_PlaySound('mission_red')",
	"wait(0.1)",
),
(
	"speak('civilian3', 'MISSPCH_3_CC_16')",
),
(
	"ff.PickWhereIsRedSpeech()",
),
(
	"speak('civilian3', 'MISSPCH_3_CC_23')",
),
(
	"ff.TreeRevealed()",
	"look('oktober_spawn', zoom = 300, heading = 0, time = 1)",
	"wait(3.0)",
),
(
	"speak('mentor', 'MISSPCH_3_ME_18')",
),
(
	"lookAtPos((-575,-818,43), zoom = -94.8, pitch = 0, heading = 44.6)",
	"speak('civilian3', 'MISSPCH_3_CC_18')",
),
(
	"ff.SpawnShurale()",
	"peace()",
	"lookAtPos((-565,-504,24), zoom = -200, pitch = 0, heading = -25, time = 1)",
	"wait(3.0)",
),
(
	"forceSpeak('shurale', 'MISSPCH_3_SR_01', telepathy=0)",
),
(
	"ff.PickShurale()",
),
(
	"speak('mentor', 'MISSPCH_3_ME_08')",
),
(
	"endCS()",
	"war()",
	"Sound_PlayMusic('music_03red2')",
	"blind()",
	"Objective_Complete('find_spy')",
	"Objective_Complete('learn_location')",
	"newObjective('primary', 4, name='enter_tree')",
	"ff.CheckSecondary()",
	"ff.SpawnSnowmen()",
	"removeAttention('civilian3')",
	"ff.addArrow('tree_arrow', 'treebase', js.ARROW_RED, delete=1)",
	"ff.SpyInterrogated()",
	"Mission_SetAttr('cutscene_playing', 0)",
),
]


interrogate_civilian4_cs = [
(
	"Mission_SetAttr('cutscene_playing', 1)",
	"playTransition()",
),
(
	"startCS()",
	"peace()",
	"see()",
	"ff.TeleportHeroes4()",
	"lookAtPos((-575,-818,43), zoom = -94.8, pitch = 0, heading = 44.6)",
	"Sound_PlayMusic('music_03red_cs1',1)",
	"Sound_PlaySound('mission_red')",
	"wait(0.1)",
),
(
	"speak('civilian4', 'MISSPCH_3_CC_16')",
),
(
	"ff.PickWhereIsRedSpeech()",
),
(
	"speak('civilian4', 'MISSPCH_3_CC_23')",
),
(
	"ff.TreeRevealed()",
	"look('oktober_spawn', zoom = 300, heading = 0, time = 1)",
	"wait(3.0)",
),
(
	"speak('mentor', 'MISSPCH_3_ME_18')",
),
(
	"lookAtPos((-575,-818,43), zoom = -94.8, pitch = 0, heading = 44.6)",
	"speak('civilian4', 'MISSPCH_3_CC_18')",
),
(
	"ff.SpawnShurale()",
	"peace()",
	"lookAtPos((-565,-504,24), zoom = -200, pitch = 0, heading = -25, time = 1)",
	"wait(3.0)",
),
(
	"forceSpeak('shurale', 'MISSPCH_3_SR_01', telepathy=0)",
),
(
	"ff.PickShurale()",
),
(
	"speak('mentor', 'MISSPCH_3_ME_08')",
),
(
	"endCS()",
	"war()",
	"blind()",
	"Sound_PlayMusic('music_03red2')",
	"Objective_Complete('find_spy')",
	"Objective_Complete('learn_location')",
	"newObjective('primary', 4, name='enter_tree')",
	"ff.CheckSecondary()",
	"ff.SpawnSnowmen()",
	"removeAttention('civilian4')",
	"ff.addArrow('tree_arrow', 'treebase', js.ARROW_RED, delete=1)",
	"ff.SpyInterrogated()",
	"Mission_SetAttr('cutscene_playing', 0)",
),
]


interrogate_civilian5_cs = [
(
	"Mission_SetAttr('cutscene_playing', 1)",
	"playTransition()",
),
(
	"startCS()",
	"peace()",
	"see()",
	"ff.TeleportHeroes5()",
	"lookAtPos((-575,-818,43), zoom = -94.8, pitch = 0, heading = 44.6)",
	"Sound_PlayMusic('music_03red_cs1',1)",
	"Sound_PlaySound('mission_red')",
	"wait(0.1)",
),
(
	"speak('civilian5', 'MISSPCH_3_CC_16')",
),
(
	"ff.PickWhereIsRedSpeech()",
),
(
	"speak('civilian5', 'MISSPCH_3_CC_23')",
),
(
	"ff.TreeRevealed()",
	"look('oktober_spawn', zoom = 300, heading = 0, time = 1)",
	"wait(3.0)",
),
(
	"speak('mentor', 'MISSPCH_3_ME_18')",
),
(
	"lookAtPos((-575,-818,43), zoom = -94.8, pitch = 0, heading = 44.6)",
	"speak('civilian5', 'MISSPCH_3_CC_18')",
),
(
	"ff.SpawnShurale()",
	"peace()",
	"lookAtPos((-565,-504,24), zoom = -200, pitch = 0, heading = -25, time = 1)",
	"wait(3.0)",
),
(
	"forceSpeak('shurale', 'MISSPCH_3_SR_01', telepathy=0)",
),
(
	"ff.PickShurale()",
),
(
	"speak('mentor', 'MISSPCH_3_ME_08')",
),
(
	"endCS()",
	"war()",
	"Sound_PlayMusic('music_03red2')",
	"blind()",
	"Objective_Complete('find_spy')",
	"Objective_Complete('learn_location')",
	"newObjective('primary', 4, name='enter_tree')",
	"ff.CheckSecondary()",
	"ff.SpawnSnowmen()",
	"removeAttention('civilian5')",
	"ff.addArrow('tree_arrow', 'treebase', js.ARROW_RED, delete=1)",
	"ff.SpyInterrogated()",
	"Mission_SetAttr('cutscene_playing', 0)",
),
]




#interrogate_civilian1_cs = [
#(
#	# plays a one-liner spoken by the civilian -- should really be an SS
#	"ff.Civilian1Speaks()",
#),
#]


#interrogate_civilian2_cs = [
#(
#	# plays a one-liner spoken by the civilian -- should really be an SS
#	"ff.Civilian2Speaks()",
#),
#]

#interrogate_civilian3_cs = [
#(
#	# plays a one-liner spoken by the civilian -- should really be an SS
#	"ff.Civilian3Speaks()",
#),
#]

#interrogate_civilian4_cs = [
#(
#	# plays a one-liner spoken by the civilian -- should really be an SS
#	"ff.Civilian4Speaks()",
#),
#]

#interrogate_civilian5_cs = [
#(
#	# plays a one-liner spoken by the civilian -- should really be an SS
#	"ff.Civilian5Speaks()",
#),
#]

#interrogate_civilian6_cs = [
#(
#	# plays a one-liner spoken by the civilian -- should really be an SS
#	"ff.Civilian6Speaks()",
#),
#]

#interrogate_civilian7_cs = [
#(
#	# plays a one-liner spoken by the civilian -- should really be an SS
#	"ff.Civilian7Speaks()",
#),
#]

#interrogate_civilian8_cs = [
#(
#	# plays a one-liner spoken by the civilian -- should really be an SS
#	"ff.Civilian8Speaks()",
#),
#]






hands_visible_cs = [
(
	"Mission_SetAttr('cutscene_playing', 1)",
	"startCS()",
	"peace()",
	"see()",
	"look('tree_spawn', zoom = 200, heading = 0, time = 0)",
#	"speak('minute_man', 'MISSPCH_3_MM_02')",
	"wait(2.0)",
),
(
	"look('gen1marker', zoom = 200, heading = 0, time = 1)",
	"wait(2.0)",
),
(
	"speakNoCB('mentor', 'MISSPCH_3_ME_02')",
	"wait(0.1)",
),
(
	"look('gen2marker', zoom = 200, heading = 0, time = 1)",
	"wait(2.0)",
),
(
	"look('gen3marker', zoom = 200, heading = 0, time = 1)",
	"wait(2.0)",
),
(
	"look('gen4marker', zoom = 200, heading = 0, time = 1)",
	"wait(7.0)",
),
(
	"endCS()",
	"war()",
	"blind()",
	"newObjective('primary', 5, name='destroy_hands')",
	"Mission_SetAttr('cutscene_playing', 0)",
),
]

#	This line was removed from the above scene



# If the first hand to be respawned is hand #1
hand_1_respawn_cs = [
(
	"Mission_SetAttr('cutscene_playing', 1)",
	"startCS()",
	"peace()",
	"see()",
	"look('gen1marker', zoom = 200, heading = 0, time = 1)",
	"wait(0.2)",
),
(
	"speak('mentor', 'MISSPCH_3_ME_11')",
),
(
	"speak('mentor', 'MISSPCH_3_ME_19')",
),
(
	"ff.PickYouMean()",
),
(
	"speak('mentor', 'MISSPCH_3_ME_20')",
),
(
	"forceSpeak('red_oktober', 'MISSPCH_3_RO_01')",
),
(
	"speak('mentor', 'MISSPCH_3_ME_04')",
),
(
	"endCS()",
	"war()",
	"blind()",
	"Mission_SetAttr('cutscene_playing', 0)",
),
]


# If the first hand to be respawned is hand #2
hand_2_respawn_cs = [
(
	"Mission_SetAttr('cutscene_playing', 1)",
	"startCS()",
	"peace()",
	"see()",
	"look('gen2marker', zoom = 200, heading = 0, time = 1)",
	"wait(0.2)",
),
(
	"speak('mentor', 'MISSPCH_3_ME_11')",
),
(
	"speak('mentor', 'MISSPCH_3_ME_19')",
),
(
	"ff.PickYouMean()",
),
(
	"speak('mentor', 'MISSPCH_3_ME_20')",
),
(
	"forceSpeak('red_oktober', 'MISSPCH_3_RO_01')",
),
(
	"speak('mentor', 'MISSPCH_3_ME_04')",
),
(
	"endCS()",
	"war()",
	"blind()",
	"Mission_SetAttr('cutscene_playing', 0)",
),
]


# If the first hand to be respawned is hand #3
hand_3_respawn_cs = [
(
	"Mission_SetAttr('cutscene_playing', 1)",
	"startCS()",
	"peace()",
	"see()",
	"look('gen3marker', zoom = 200, heading = 0, time = 1)",
	"wait(0.2)",
),
(
	"speak('mentor', 'MISSPCH_3_ME_11')",
),
(
	"speak('mentor', 'MISSPCH_3_ME_19')",
),
(
	"ff.PickYouMean()",
),
(
	"speak('mentor', 'MISSPCH_3_ME_20')",
),
(
	"forceSpeak('red_oktober', 'MISSPCH_3_RO_01')",
),
(
	"speak('mentor', 'MISSPCH_3_ME_04')",
),
(
	"endCS()",
	"war()",
	"blind()",
	"Mission_SetAttr('cutscene_playing', 0)",
),
]

# If the first hand to be respawned is hand #4
hand_4_respawn_cs = [
(
	"Mission_SetAttr('cutscene_playing', 1)",
	"startCS()",
	"peace()",
	"see()",
	"look('gen4marker', zoom = 200, heading = 0, time = 1)",
	"wait(0.2)",
),
(
	"speak('mentor', 'MISSPCH_3_ME_11')",
),
(
	"speak('mentor', 'MISSPCH_3_ME_19')",
),
(
	"ff.PickYouMean()",
),
(
	"speak('mentor', 'MISSPCH_3_ME_20')",
),
(
	"forceSpeak('red_oktober', 'MISSPCH_3_RO_01')",
),
(
	"speak('mentor', 'MISSPCH_3_ME_04')",
),
(
	"endCS()",
	"war()",
	"blind()",
	"Mission_SetAttr('cutscene_playing', 0)",
),
]

	# here's the scene wherein minions come to protect the Hands
save_the_hands_ss = [
(
	"forceSpeak('ice_trooper', 'MISSPCH_3_IT_01')",
),
(
	"speak('mentor', 'MISSPCH_3_ME_23')",
),
(
	"blank",
),
]

# here's the scene where Red October comes to play
red_emerges_cs = [
(
	"Mission_SetAttr('cutscene_playing', 1)",
	"startCS()",
	"peace()",
	"see()",
	"look('oktober_spawn')",
	"Sound_PlayMusic('music_03inside1_cs1',1)",
	"forceSpeak('red_oktober', 'MISSPCH_3_RO_02')",
),
(
	"speak('mentor', 'MISSPCH_3_ME_05')",
),
(
	"endCS()",
	"war()",
	"blind()",
	"Sound_PlayMusic('music_03red2')",
	"Objective_Complete('destroy_hands')",
	"newObjective('primary', 7, name='interrogate_red')",
	"addArrow('red__okt_arrow', 'red_oktober', js.ARROW_RED, delete=1)",
	"Mission_SetAttr('cutscene_playing', 0)",
),
]

interrogate_red_oktober_cs = [
(
	"Mission_SetAttr('cutscene_playing', 1)",
	"startCS()",
	"peace()",
	"see()",
	"look('red_oktober')",
	"Sound_PlayMusic('music_03inside2_end',1)",
	"wait(2.0)",
),
(
	"speak('minute_man', 'MISSPCH_3_MM_08')",
),
(
	"forceSpeak('red_oktober', 'MISSPCH_3_RO_03')",
),
(
	"spawn('red_standin', 'fx_standin', 'red_oktober')",
	"Object_PlayEffect('red_standin', 'effect_entropy_spawn', '',FX_TRACK_OBJECT_ROT)",
	"Object_Destroy('red_oktober')",
	"wait(3.0)",
),
(
	"speak('minute_man', 'MISSPCH_3_MM_18')",
),
(
	"speak('mentor', 'MISSPCH_3_ME_21')",
),
(
	"endCS()",
	"Objective_Complete('interrogate_red')",
	"Objective_Complete('enter_tree')",
	"war()",
	"Mission_Win()",
),
]


lose_dialog_ss = [
(
	"AI_CancelAllSpeech()",
	"speak('narrator', 'MISSPCH_3_NR_04', forceNonMission = 1)",
),
(
	"blank",
),
]
