# winter

from cshelper import *
from js import *
import event

def OnIntermission():
	Mission_PlayOriginStory('quetzalcoatl')

def OnPostInit():
	print 'winter base/start'
	#idle briefing screen stuff
	Mission_SetSunlight(0, 40, 0, 0, (1,1,1))
	lookAtPos((98,115,0), zoom = -252.7, pitch= -8, heading = 8.8)
	Object_PlayEffect('_impobj_main_screen', 'cs_screen_cuba', '', FX_LOOP|FX_TRACK_OBJECT_ROT)
	Event_RegisterSink(EVENT_TIMER, 'MaleWalks', '', '', 15)

	Campaign_Recruit('alchemiss')
	Campaign_UnlockOrigin('alchemiss')
	Campaign_Recruit('el_diablo')
	Campaign_UnlockOrigin('el_diablo')
	Campaign_Recruit('mentor')
	Campaign_UnlockOrigin('mentor')
	Campaign_Recruit('minute_man')
	Campaign_UnlockOrigin('minute_man')
	Campaign_AddHero ('liberty_lad')
	Campaign_UnlockOrigin('liberty_lad')
	Campaign_Recruit('tombstone')
	Campaign_UnlockOrigin('tombstone')
	Campaign_Recruit('bullet')
	Campaign_UnlockOrigin('bullet')
	Campaign_AddHero ('green_genie')
	Campaign_UnlockOrigin('green_genie')
	Campaign_AddHero ('quetzalcoatl')
	Campaign_UnlockOrigin('quetzalcoatl')
	Campaign_Recruit('the_ant')
	Campaign_UnlockOrigin('the_ant')

	Campaign_AddMinion('thug_with_bat')
	Campaign_AddMinion('thug_with_gun')
	Campaign_AddVillain('nuclear_winter')
	Campaign_AddVillain('time_master')
	Campaign_AddMinion('ice_trooper')
	Campaign_AddMinion('ice_sergeant')
	Campaign_AddMinion('snow_man')
	Campaign_AddMinion('shurale')
	Campaign_AddVillain('red_oktober')
	Campaign_AddMinion('dark_shaman')


def MaleWalks(event):
	if isCSPlaying():
		print "too hot to walk"
	else:
		spawn('idle_male', 'cuban_male', 'idle_pos1')
		AI_SetEnabled('idle_male', 0)
		Trigger_Move('idle_male', 'walk', Get_MarkerPos('idle_pos2'), 'MaleKill', 1, 1)
		
def SoldierWalks(event):
	if isCSPlaying():
		print "too tired to walk"
	else:
		spawn('idle_soldier', 'us_soldier', 'idle_pos2')
		AI_SetEnabled('idle_soldier', 0)
		Trigger_Move('idle_soldier', 'walk', Get_MarkerPos('idle_pos1'), 'MaleKill', 1, 1)


def MaleKill(event):
	if Object_Exists('idle_male'):
		Object_Destroy('idle_male')
		print "arrgh! madre de dios!"
		Event_RegisterSink(EVENT_TIMER, 'SoldierWalks', '', '', 23)
	elif Object_Exists('idle_soldier'):
		Object_Destroy('idle_soldier')
		print "you can't handle the truth!"
		Event_RegisterSink(EVENT_TIMER, 'MaleWalks', '', '', 18)


def OnBriefing():
	ff.MaleKill(1)
	play(briefing_cs, 'briefing_cs')
	print 'winter base/briefing'

#-----------
# data
#-----------

briefing_cs = [
(
	"AI_CancelAllSpeech()",
	"startCS()",
	"lookAtPos((26,-61,0), zoom = -223.7, pitch= 0, heading = 46.3)",
	"wait(1)",
),
(
	"speak('red_oktober', 'BRFSPCH_5_RO_01', CAPTION_TOP_LEFT)", #Red Oktober fools! do i have to do ev...  
),
( 
	"lookAtPos((-18,-117,0), zoom = -255.8, pitch= 0, heading = -208.1)",
	"speak('mentor', 'BRFSPCH_5_ME_01', CAPTION_TOP_LEFT)", #Mentor aspersions do not bring u...  
),
( 
	"speak('el_diablo', 'BRFSPCH_5_ED_01', CAPTION_TOP_RIGHT)", #El Diablo and unlike you, your boss...  
),
( 
	"speak('charles_wilson', 'BRFSPCH_5_CH_01', CAPTION_BOTTOM_LEFT)", #Charles Wilson it seems the barriers onl...  
),
( 
	"Object_Spawn('the_ant', 'the_ant', 'hero_pos1')",
	"Sound_PlayMusic('music_04winter_base',1)",
	"speak('the_ant', 'BRFSPCH_5_AN_01', CAPTION_TOP_RIGHT)", #The Ant an entire team of enginee...
),
(
	"lookAtPos((-32,-41,0), zoom = -267.0, pitch= 0, heading = 29.7)",
	"move('the_ant', 'hero_pos2')",
	"turnTo('el_diablo', 'the_ant')",
	"speak('el_diablo', 'BRFSPCH_5_ED_02', CAPTION_TOP_RIGHT)", #El Diablo hey, it's the insect!  
),
( 
	"lookAtPos((-46,-86,0), zoom = -259.6, pitch= 0, heading = -175.2)",
	"turnTo('el_diablo', 'charles_wilson')",
	"speak('the_ant', 'BRFSPCH_5_AN_02', CAPTION_TOP_RIGHT)", #The Ant yep, it's the one and onl...  
),
( 
	"speak('minute_man', 'BRFSPCH_5_MM_01', CAPTION_TOP_LEFT)", #Minute Man welcome back, son. you've...  
),
( 
	"lookAtPos((24,-84,0), zoom = -235.0, pitch= 0, heading = 91.8)",
	"speak('charles_wilson', 'BRFSPCH_5_CH_02', CAPTION_TOP_LEFT)", #Charles Wilson it's vital that we stop n...  
),
(
	"move('the_ant', 'hero_pos3')",
	"move('el_diablo', 'hero_pos3')",
	"move('red_oktober', 'hero_pos3')",
	"move('mentor', 'hero_pos3')",
	"wait(3)",
),
(
	"endBriefingCS()",
),
]

