# -*- coding: cp1252 -*-
# winter

# TO DO:



from cshelper import *
from js import *
import event
from ffx import *

trainers = [1]

def OnPrecacheObjects():
	print "winter/precache"
	Mission_PrecacheTemplateObj('nuclear_winter', 1, 1)
	Mission_PrecacheTemplateObj('dark_shaman_friendly', 1, 1)
	Mission_PrecacheTemplateObj('dark_shaman', 1, 0)
	Mission_PrecacheTemplateObj('frozen_giant', 1, 1)
	Mission_PrecacheTemplateObj('charles_wilson', 1, 0)
	Mission_PrecacheTemplateObj('minute_man', 1, 0)

def OnPostInit():
	print "winter/start"
	setMission(5)
	addTrainerAttention(ff.trainers)

	Mission_SetSunlight(-140,40,1.0,0.8,(0.4,0.3,0.9))
	Mission_SetShadows(-140,40,(0.2,0.1,0.9))
	Mission_SetProjShadowBackground((1,1,1))
	Mission_SetProjShadowColor((.6,.6,.6,1))
	
	Mission_SetAttr('total_gens_dead', 0)
	Mission_SetAttr('tech_1_grilled', 0)
	Mission_SetAttr('tech_2_grilled', 0)
	Mission_SetAttr('tech_3_grilled', 0)

	Mission_SetAttr('transmitter_2_blown', 0)
	Mission_SetAttr('transmitter_4_blown', 0)
	Mission_SetAttr('transmitter_6_blown', 0)

	Mission_SetAttr('building_spawned_1', 0)
	Mission_SetAttr('building_spawned_2', 0)

	Mission_SetAttr('spawned_ice_dead', 0)

	regDeath('_impobj_field_generator_1', 'OnGen1Destroyed')
	regDeath('_impobj_field_generator_2', 'OnGen2Destroyed')
	regDeath('_impobj_field_generator_3', 'OnGen3Destroyed')

	regDeath('_impobj_cuban_missile_3', 'OnMissileDestroyed')
	regDeath('_impobj_cuban_missile_5', 'OnMissileDestroyed')
	regDeath('_impobj_cuban_missile_8', 'OnMissileDestroyed')

	regDeath('_impobj_trans_red', 'OnTransmitter1Destroyed')
	regDeath('_impobj_trans_yellow', 'OnTransmitter2Destroyed')
	regDeath('_impobj_trans_black', 'OnTransmitter3Destroyed')
	regDeath('_impobj_trans_green', 'OnTransmitter4Destroyed')
	regDeath('_impobj_trans_white', 'OnTransmitter5Destroyed')
	regDeath('_impobj_trans_blue', 'OnTransmitter6Destroyed')

	regDeath('_impobj_spawn_hut_2', 'OnBuilding1Destroyed')
	regDeath('_impobj_spawn_hut_3', 'OnBuilding2Destroyed')

	regDamage('_impobj_spawn_hut_2', 'OnBuilding1Damaged')
	regDamage('_impobj_spawn_hut_3', 'OnBuilding2Damaged')

	regDetect('ice_trooper2', 'the_ant', 'OnAntDetected', user = 0)

#	regProximityEnter('the_ant', '_impobj_field_generator_1', 3, 'OnAntDetected')

	regDeath('the_ant', 'OnAntDead')

	startPatrol('trooperpatrol1', 5, priority = ai.goal.PRI_ZERO-1, run = 0)
	startPatrol('trooperpatrol2', 5, priority = ai.goal.PRI_ZERO-1, run = 0)

	Mission_SetAttr('mission_won', 0)
	regDialog('DLG_DEBRIEF', 'OnDebrief')

	play(start_cs, "start_cs")
	FFX_InitMission()

def OnMissionWon():
	print "winter/won"
	Mission_SetAttr('mission_won',1)

def OnMissionLost():
	print "winter/lost"

def OnDebrief(event):
	print "Debriefing screen reached with script"
	if Mission_GetAttr('mission_won'):
		print "debrief training here"
	else:
		print "loser training here"
		play(lose_dialog_ss,'lose_dialog_ss',interrupt=1)


def VictoryCSTest():
	Object_Spawn('nuclear_winter', 'nuclear_winter', 'nuclear_winter_spawn')
	spawn('frozen_giant', 'frozen_giant', Get_ObjectPos('nuclear_winter'))
	Object_Destroy('nuclear_winter')



def OnAntDetected(event):
	print "Ant Detected"
#	moveTo('ice_trooper1', '_impobj_field_generator_1')
#	moveTo('ice_trooper2', '_impobj_field_generator_1')
	forceSpeakNoCB('ice_trooper1', 'MISSPCH_5_IT_08', telepathy=0)

def OnGen1Destroyed(event):
	print "Gen 1 Destroyed"
	addAttr('total_gens_dead', 1)
	if Mission_GetAttr('total_gens_dead') == 1:
		play(gen1_dead_cs, "gen1_dead_cs")
	if Mission_GetAttr('total_gens_dead') == 2:
		play(gen2_dead_ss, "gen2_dead_ss")
	if Mission_GetAttr('total_gens_dead') == 3:
		AllGensDead()
	forcePos = Get_ObjectPos('_impobj_force_field_1')
	Object_Destroy('_impobj_force_field_1')
	playEffect('effect_forceField_destroy', forcePos, orientation = 0)

def OnGen2Destroyed(event):
	print "Gen 2 Destroyed"
	OnBuilding1Destroyed(event)
	addAttr('total_gens_dead', 1)
	if Mission_GetAttr('total_gens_dead') == 1:
		play(gen1_dead_cs, "gen1_dead_cs")
	if Mission_GetAttr('total_gens_dead') == 2:
		play(gen2_dead_ss, "gen2_dead_ss")
	if Mission_GetAttr('total_gens_dead') == 3:
		AllGensDead()
	forcePos = Get_ObjectPos('_impobj_force_field_2')
	Object_Destroy('_impobj_force_field_2')
	playEffect('effect_forceField_destroy', forcePos, orientation = 0)


def OnGen3Destroyed(event):
	print "Gen 3 Destroyed"
	OnBuilding2Destroyed(event)
	addAttr('total_gens_dead', 1)
	if Mission_GetAttr('total_gens_dead') == 1:
		play(gen1_dead_cs, "gen1_dead_cs")
	if Mission_GetAttr('total_gens_dead') == 2:
		play(gen2_dead_ss, "gen2_dead_ss")
	if Mission_GetAttr('total_gens_dead') == 3:
		AllGensDead()
	forcePos = Get_ObjectPos('_impobj_force_field_3')
	Object_Destroy('_impobj_force_field_3')
	playEffect('effect_forceField_destroy', forcePos, orientation = 0)

def OnBuilding1Damaged(event):
	print "Building damaged!"
	if Object_GetAttr('_impobj_spawn_hut_2', 'health') < 51:
		print "should destroy building"
		Mission_SetAttr('building_spawned_1', 1)
		spawnGroup('building1_spawn', 'ice_trooper', 4)
		kill('_impobj_spawn_hut_2')

def OnBuilding1Destroyed(event):
	print "spawn guys!"
	if Mission_GetAttr('building_spawned_1') == 0:
		print "no, really, spawn guys!"
		spawnGroup('building1_spawn', 'ice_trooper', 4)
		Mission_SetAttr('building_spawned_1', 1)

def OnBuilding2Damaged(event):
	print "Building damaged!"
	if Object_GetAttr('_impobj_spawn_hut_3', 'health') < 51:
		print "should destroy building"
		Mission_SetAttr('building_spawned_2', 1)
		spawnGroup('building2_spawn', 'ice_trooper', 4)
		kill('_impobj_spawn_hut_3')


def OnBuilding2Destroyed(event):
	if Mission_GetAttr('building_spawned_2') == 0:
		spawnGroup('building2_spawn', 'ice_trooper', 4)
		Mission_SetAttr('building_spawned_2', 1)


def OnAntDead(event):
	print "The Ant has died!"
	if Mission_GetAttr('total_gens_dead') != 3:
		play(ant_death_cs, "ant_death_cs")
		print "we should be losing the mission now!"
		
def AllGensDead():
	print "All Fields are gone"
	play(all_gens_dead_cs, "all_gens_dead_cs")


def OnTransmitter1Destroyed(event):
	print "red destroyed"
	if Mission_GetAttr('transmitter_2_blown') == 0:
		play(wrong_transmitter_cs, "wrong_transmitter_cs")

def OnTransmitter3Destroyed(event):
	if Mission_GetAttr('transmitter_4_blown') == 0:
		play(wrong_transmitter_cs, "wrong_transmitter_cs")

def OnTransmitter5Destroyed(event):
	if Mission_GetAttr('transmitter_6_blown') == 0:
		play(wrong_transmitter_cs, "wrong_transmitter_cs")

def OnMissileDestroyed(event):
	print "Missile Destroyed!"
	play(missile_destroyed_cs, "missile_destroyed_cs")

def OnTransmitter2Destroyed(event):
	print "yellow destroyed!"
	if Mission_GetAttr('tech_1_grilled') == 0:
		play(wrong_transmitter_cs, "wrong_transmitter_cs")
		print "destroyed transmitter without grilling first tech!  Bad player!"
	if Mission_GetAttr('tech_1_grilled') == 1:
		regTimer('FirstTransBlown', 2)

def FirstTransBlown(event):
	Mission_SetAttr('transmitter_2_blown', 1)
	play(one_down_cs, "one_down_cs")
	Mission_DisplayTimer('missile launch', -1)

def OnTransmitter4Destroyed(event):
	if Mission_GetAttr('tech_2_grilled') == 0:
		play(wrong_transmitter_cs, "wrong_transmitter_cs")
	if Mission_GetAttr('tech_2_grilled') == 1:
		regTimer('SecondTransBlown', 2)

def SecondTransBlown(event):
	Mission_SetAttr('transmitter_4_blown', 1)
	play(two_down_cs, "two_down_cs")
	Mission_DisplayTimer('2nd missile launch', -1)

def OnTransmitter6Destroyed(event):
	if Mission_GetAttr('tech_3_grilled') == 0:
		play(wrong_transmitter_cs, "wrong_transmitter_cs")
	if Mission_GetAttr('tech_3_grilled') == 1:
		regTimer('ThirdTransBlown', 2)

def ThirdTransBlown(event):
		Mission_SetAttr('transmitter_6_blown', 1)
		play(three_down_cs, "three_down_cs")
		Mission_DisplayTimer('3rd missile launch', -1)

def OnWinterDead(event):
	play(not_dead_yet_cs, "not_dead_yet_cs")
	regDeath('frozen_giant', 'OnFrozenGiantKilled')

def OnFrozenGiantKilled(event):
	play(victory_cs, "victory_cs")

def StartFirstTimers():
	regTimer('FirstTimeWarningOne', 270)
	regTimer('FirstTimeWarningTwo', 290)
	regTimer('FirstTooLate', 300)
	Mission_DisplayTimer('missile launch', 300)

def StartSecondTimers():
	regTimer('SecondTimeWarningOne', 210)
	regTimer('SecondTimeWarningTwo', 230)
	regTimer('SecondTooLate', 240)
	Mission_DisplayTimer('2nd missile launch', 240)

def StartThirdTimers():
	regTimer('ThirdTimeWarningOne', 90)
	regTimer('ThirdTimeWarningTwo', 110)
	regTimer('ThirdTooLate', 120)
	Mission_DisplayTimer('3rd missile launch', 120)

def FirstTimeWarningOne(event):
	if Mission_GetAttr('transmitter_2_blown') == 0:
		if not isPlaying():
			play(time_warning_one_ss, "time_warning_one_ss")
			print "First Time Warning One"

def FirstTimeWarningTwo(event):
	if Mission_GetAttr('transmitter_2_blown') == 0:
		if not isPlaying():
			play(time_warning_two_ss, "time_warning_two_ss")
			print "First Time Warning Two"

def FirstTooLate(event):
	if Mission_GetAttr('transmitter_2_blown') == 0:
		play(too_late_cs, "too_late_cs")
		print "First Time Warning Three"

def SecondTimeWarningOne(event):
	if Mission_GetAttr('transmitter_4_blown') == 0:
		if not isPlaying():
			play(time_warning_one_ss, "time_warning_one_ss")
			print "Second Time Warning One"

def SecondTimeWarningTwo(event):
	if Mission_GetAttr('transmitter_4_blown') == 0:
		if not isPlaying():
			play(time_warning_two_ss, "time_warning_two_ss")
			print "Second Time Warning Two"

def SecondTooLate(event):
	if Mission_GetAttr('transmitter_4_blown') == 0:
		play(too_late_cs, "too_late_cs")
		print "Second Time Warning Three"

def ThirdTimeWarningOne(event):
	if Mission_GetAttr('transmitter_6_blown') == 0:
		if not isPlaying():
			play(time_warning_one_ss, "time_warning_one_ss")
			print "Third Time Warning One"

def ThirdTimeWarningTwo(event):
	if Mission_GetAttr('transmitter_6_blown') == 0:
		if not isPlaying():
			play(time_warning_two_ss, "time_warning_two_ss")
			print "Third Time Warning Two"

def ThirdTooLate(event):
	if Mission_GetAttr('transmitter_6_blown') == 0:
		play(too_late_cs, "too_late_cs")
		print "Third Time Warning Three"

def MentorOptional():
	if Object_IsAlive('mentor'):
		play(mentor_optional_ss, "mentor_optional_ss")
	else:
		wait(0.1)

def SpawnMissile1Guards():
	if RPG_GAME_DIFFICULTY == 1:
		spawn('missile1_guard', 'snow_man', 'missile1_guard_spawn')
	if RPG_GAME_DIFFICULTY > 1 and RPG_GAME_DIFFICULTY < 4:
		spawn('missile1_guard', 'snow_man', 'missile1_guard_spawn')
		spawn('missile1_guard2', 'ice_trooper', 'missile1_guard_spawn2')
		spawn('missile1_guard3', 'ice_trooper', 'missile1_guard_spawn3')
	if RPG_GAME_DIFFICULTY > 3:
		spawn('missile1_guard', 'snow_man', 'missile1_guard_spawn')
		spawn('missile1_guard2', 'ice_sergeant', 'missile1_guard_spawn2')
		spawn('missile1_guard3', 'ice_sergeant', 'missile1_guard_spawn3')

def SpawnMissile2Guards():
	if RPG_GAME_DIFFICULTY == 1:
		spawn('missile2_guard', 'snow_man', 'missile2_guard_spawn')
	if RPG_GAME_DIFFICULTY > 1 and RPG_GAME_DIFFICULTY < 4:
		spawn('missile2_guard', 'snow_man', 'missile2_guard_spawn')
		spawn('missile2_guard2', 'ice_trooper', 'missile2_guard_spawn2')
		spawn('missile2_guard3', 'ice_trooper', 'missile2_guard_spawn3')
	if RPG_GAME_DIFFICULTY > 3:
		spawn('missile2_guard', 'snow_man', 'missile1_guard_spawn')
		spawn('missile2_guard2', 'ice_sergeant', 'missile2_guard_spawn2')
		spawn('missile2_guard3', 'ice_sergeant', 'missile2_guard_spawn3')

def SpawnMissile3Guards():
	if RPG_GAME_DIFFICULTY == 1:
		spawn('missile3_guard', 'snow_man', 'missile3_guard_spawn')
	if RPG_GAME_DIFFICULTY > 1 and RPG_GAME_DIFFICULTY < 4:
		spawn('missile3_guard', 'snow_man', 'missile3_guard_spawn')
		spawn('missile3_guard2', 'ice_trooper', 'missile3_guard_spawn2')
		spawn('missile3_guard3', 'ice_trooper', 'missile3_guard_spawn3')
	if RPG_GAME_DIFFICULTY > 3:
		spawn('missile3_guard', 'snow_man', 'missile3_guard_spawn')
		spawn('missile3_guard2', 'ice_sergeant', 'missile3_guard_spawn2')
		spawn('missile3_guard3', 'ice_sergeant', 'missile3_guard_spawn3')

def SpawnedTrooperDie(event):
	addAttr('spawned_ice_dead', 1)
	if Mission_GetAttr('spawned_ice_dead') == 2:
		FollowRed(event)

def FollowRed(event):
	if Object_IsAlive('shaman1'):
		print 'shaman1 following'
		clearGoals('shaman1')
		makePeaceful('shaman1')
		addKillAllGoal('shaman1', OC_MINION | OC_VILLIAN)
		redloc=Get_ObjectPos('red_okt_hero')
		addMoveGoal('shaman1', redloc, priority = ai.goal.PRI_LOW)
	if Object_IsAlive('shaman2'):
		print 'shaman2 following'
		clearGoals('shaman2')
		makePeaceful('shaman2')
		addKillAllGoal('shaman2', OC_MINION | OC_VILLIAN)
		redloc=Get_ObjectPos('red_okt_hero')
		addMoveGoal('shaman2', redloc, priority = ai.goal.PRI_LOW)
	regTimer('FollowRed',5)


def IfRedLives():
	if Object_IsAlive('red_okt_hero'):
		print "red is alive... should be speaking"
		speakNoCB('red_okt_hero', 'MISSPCH_5_RO_05')
		speak('red_okt_hero', 'MISSPCH_5_RO_06')
		spawnGroup('r_shaman', 'dark_shaman_friendly', 3)
	else:
		onStepCB()

def TeleportHeroes():
	herolist = getAllHeroes()
	temp = 0
	for hero in herolist:
		if temp == 0:
			teleport(hero, 'finalcs_hero_marker1')
			temp = 1
		elif temp == 1:
			teleport(hero, 'finalcs_hero_marker2')
			temp = 2
		elif temp == 2:
			teleport(hero, 'finalcs_hero_marker3')
			temp = 3
		elif temp == 3:
			teleport(hero, 'finalcs_hero_marker4')
			temp = 4

def HeroesWalkAway():
	herolist = getAllHeroes()
	temp = 0
	for hero in herolist:
		if temp == 0:
			walk(hero, 'finalcs_hero1target')
			temp = 1
		elif temp == 1:
			walk(hero, 'finalcs_hero2target')
			temp = 2
		elif temp == 2:
			walk(hero, 'finalcs_hero3target')
			temp = 3
		elif temp == 3:
			walk(hero, 'finalcs_hero4target')
			temp = 4

def DestroyAllBaddies():
	baddielist = getAllBaddies()
	for baddie in baddielist:
		Object_Destroy(baddie)
	if Object_IsAlive(spawnGetName('r_shaman', 0)):
		teleport(spawnGetName('r_shaman', 0), 'shaman1_clear')
	if Object_IsAlive(spawnGetName('r_shaman', 1)):
		teleport(spawnGetName('r_shaman', 1), 'shaman2_clear')
	if Object_IsAlive(spawnGetName('r_shaman', 2)):
		teleport(spawnGetName('r_shaman', 2), 'shaman3_clear')

def CheckObjective():
	if Objective_Exists('transmitters_alive') == 0:
		newObjective('primary', 5, name='transmitters_alive')

def DelayFailure():
	regTimer('MissionLoss', 1)

def MissionLoss(event):
	play(real_failure_cs, 'real_failure_cs')

###################################################

def PickMissileLine():
	a_hero = getRandomLiveHeroName()
	print a_hero
	if a_hero == 'alchemiss':
		speak('alchemiss', 'MISSPCH_5_AL_01')
	elif a_hero == 'el_diablo':
		speak('el_diablo', 'MISSPCH_5_ED_01')
	elif a_hero == 'liberty_lad':
		speak('liberty_lad', 'MISSPCH_5_LL_01')
	elif a_hero == 'tombstone':
		speak('tombstone', 'MISSPCH_5_TS_01')
	elif a_hero == 'bullet':
		speak('bullet', 'MISSPCH_5_BL_01')
	elif a_hero == 'green_genie':
		speak('green_genie', 'MISSPCH_5_GG_01')
	elif a_hero == 'quetzalcoatl':
		speak('quetzalcoatl', 'MISSPCH_5_QZ_01')
	elif a_hero == 'red_oktober_hero':
		speak('red_okt_hero', 'MISSPCH_5_RO_10')
	else:
		speak('minute_man', 'MISSPCH_5_MM_20')



def PickTellUs():
	a_hero = getRandomLiveHeroName()
	print a_hero
	if a_hero == 'the_ant':
		speak('the_ant', 'MISSPCH_5_AN_08')
	elif a_hero == 'alchemiss':
		speak('alchemiss', 'MISSPCH_5_AL_02')
	elif a_hero == 'el_diablo':
		speak('el_diablo', 'MISSPCH_5_ED_02')
	elif a_hero == 'liberty_lad':
		speak('liberty_lad', 'MISSPCH_5_LL_02')
	elif a_hero == 'tombstone':
		speak('tombstone', 'MISSPCH_5_TS_02')
	elif a_hero == 'bullet':
		speak('bullet', 'MISSPCH_5_BL_02')
	elif a_hero == 'green_genie':
		speak('green_genie', 'MISSPCH_5_GG_02')
	elif a_hero == 'quetzalcoatl':
		speak('quetzalcoatl', 'MISSPCH_5_QZ_02')
	elif a_hero == 'mentor':
		speak('mentor', 'MISSPCH_5_ME_05')
	elif a_hero == 'red_oktober_hero':
		speak('red_okt_hero', 'MISSPCH_5_RO_11')
	else:
		speak('minute_man', 'MISSPCH_5_MM_32')


def PickTalkMissiles():
	a_hero = getRandomLiveHeroName()
	print a_hero
	if a_hero == 'alchemiss':
		speak('alchemiss', 'MISSPCH_5_AL_04')
	elif a_hero == 'el_diablo':
		speak('el_diablo', 'MISSPCH_5_ED_03')
	elif a_hero == 'liberty_lad':
		speak('liberty_lad', 'MISSPCH_5_LL_03')
	elif a_hero == 'tombstone':
		speak('tombstone', 'MISSPCH_5_TS_03')
	elif a_hero == 'bullet':
		speak('bullet', 'MISSPCH_5_BL_03')
	elif a_hero == 'green_genie':
		speak('green_genie', 'MISSPCH_5_GG_03')
	elif a_hero == 'quetzalcoatl':
		speak('quetzalcoatl', 'MISSPCH_5_QZ_03')
	elif a_hero == 'mentor':
		speak('mentor', 'MISSPCH_5_ME_04')
	elif a_hero == 'red_oktober_hero':
		speak('red_okt_hero', 'MISSPCH_5_RO_12',)
	else:
		speak('minute_man', 'MISSPCH_5_MM_33')


start_cs = [
(
	"peace()",
	"startCS()",
	"look('red_okt_hero', zoom = -150, heading = 0, time = 0)",
	"moveCB('the_ant', 'ant_cs_runtarget')",
),
(
	"forceSpeak('red_okt_hero', 'MISSPCH_5_RO_01', telepathy = 0)",
),
(
	"speak('the_ant', 'MISSPCH_5_AN_01')",
),
(
	"endCS()",
	"war()",
	"Sound_PlayMusic('music_04winter1')",
	"newObjective('primary', 1, name='destroy_generators')",
	"newObjective('primary', 2, name='ant_must_live')",
	"ff.addArrow('gen1_arrow', '_impobj_field_generator_1', js.ARROW_RED, delete=1)",
),
]

ant_death_cs = [
(
	"peace()",
	"startCS()",
	"look('the_ant')",
	"wait(1.0)",
	"speak('the_ant', 'MISSPCH_5_AN_04')",
	"wait(3.0)",
),
(
	"Objective_Fail('ant_must_live')",
	"Mission_Lose()",
),
]
	
gen1_dead_cs = [
(
	"peace()",
	"see()",
	"startCS()",
	"look('the_ant')",
	"speak('the_ant', 'MISSPCH_5_AN_05')",
),
(
	"Object_Spawn('shaman1', 'dark_shaman_friendly', 'shaman_spawn_1')",
	"Object_Spawn('shaman2', 'dark_shaman_friendly', 'shaman_spawn_2')",
	"Object_Spawn('trooper1', 'ice_trooper', 'trooper_spawn_1')",
	"Object_Spawn('trooper2', 'ice_trooper', 'trooper_spawn_2')",
	"peace()",
	"wait(0.1)",
),
(
	"look('shaman_spawn_1', zoom = 0, heading = 0, time = 1)",
	"wait(1.0)",
),
(
	"peace()",
	"forceSpeak('trooper1', 'MISSPCH_5_IT_01')",
),
(
	"forceSpeak('dark_shaman', 'MISSPCH_5_DS_01', telepathy = 0)",
),
(
	"forceSpeak('red_okt_hero', 'MISSPCH_5_RO_04')",
),
(
	"forceSpeak('dark_shaman', 'MISSPCH_5_DS_02', telepathy = 0)",
),
(
	"forceSpeak('trooper1', 'MISSPCH_5_IT_02')",
),
(
	"forceSpeak('dark_shaman', 'MISSPCH_5_DS_03', telepathy = 0)",
),
(
	"forceSpeak('trooper1', 'MISSPCH_5_IT_09')",
),
(
	"forceSpeak('dark_shaman', 'MISSPCH_5_DS_04', telepathy = 0)",
),
(
	"forceSpeak('trooper1', 'MISSPCH_5_IT_10')",
),
(
	"forceSpeak('dark_shaman', 'MISSPCH_5_DS_05', telepathy = 0)",
),
(
	"forceSpeak('trooper1', 'MISSPCH_5_IT_11')",
),
(
	"regDeath('trooper1', 'SpawnedTrooperDie')",
	"regDeath('trooper2', 'SpawnedTrooperDie')",
	"endCS()",
	"war()",
	"blind()",
),
]

gen2_dead_ss = [
(
	"speak('the_ant', 'MISSPCH_5_AN_09')",
),
(
	"blank",
),
]

all_gens_dead_cs = [
(
	"peace()",
	"startCS()",
	"Sound_PlayMusic('music_04winter_hit1',1)",
	"look('the_ant')",
	"speak('the_ant', 'MISSPCH_5_AN_06')",
),
(
	"speak('minute_man', 'MISSPCH_5_MM_19')",
	"Sound_PlayMusic('music_04winter_nw',1)",
),
(
	"peace()",
	"forceSpeak('nuclear_winter', 'MISSPCH_5_NW_01')",
),
(
	"ff.PickMissileLine()",
),
(
	"forceSpeak('nuclear_winter', 'MISSPCH_5_NW_07')",
	"lookAtPos((-764,-35,27), zoom =  51.3, heading =  14.2)",
),
(
	"peace()",
	"Object_Destroy('_impobj_cuban_missile_8')",
	"spawn('missile_object_1', 'invisible_object', 'missile_marker_1')",
	"null()",
),
(
	"Object_PlayEffect( 'missile_object_1', 'effect_missle_launch', 'onStepCB', FX_TRACK_OBJECT_FULL)",
),
(
	"spawn('platform_1', 'cuban_missile_platform', Get_ObjectPos('missile_object_1'))",
#	"Object_PlayEffect('missile_object_1', 'effect_missle_core', '', FX_LOOP|FX_TRACK_OBJECT_FULL)",
	"forceSpeak('nuclear_winter', 'MISSPCH_5_NW_08')",
),
(
	"speak('the_ant', 'MISSPCH_5_AN_07')",
),
(
	"speak('minute_man', 'MISSPCH_5_MM_03')",
),
(
	"speak('minute_man', 'MISSPCH_5_MM_04')",
),
(
	"speak('minute_man', 'MISSPCH_5_MM_22')",
),
(
	"ff.MentorOptional()",
),
(
	"war()",
	"Sound_PlayMusic('music_04winter2')",
	"endCS()",
	"Objective_Complete('destroy_generators')",
	"Objective_Complete('ant_must_live')",
	"newObjective('primary', 3, name='interrogate_technicians')",
	"newObjective('primary', 5, name='transmitters_alive')",
	"Object_Spawn('technician1', 'ice_trooper', 'tech_spawn_1')",
	"spawnGroup('tech_guard1_spawn', 'ice_trooper', 2)",
	"makeInterrogationCS('technician1', oneshot = 1)",
	"ff.addArrow('tech1_arrow', 'technician1', js.ARROW_RED, delete=1)",
	"ff.StartFirstTimers()",
),
]

mentor_optional_ss = [
(
	"speak('mentor', 'MISSPCH_5_ME_01')",
),
(
	"speak('minute_man', 'MISSPCH_5_MM_05')",
),
(
	"blank",
),
]

interrogate_technician1_cs = [
(
	"peace()",
	"startCS()",
	"look('technician1', zoom = -200, heading = 0, time = 0)",
	"wait(1.0)",
),
(
	"forceSpeak('ice_trooper', 'MISSPCH_5_IT_03', telepathy=0)",
),
(
	"ff.PickTellUs()",
),
(
	"forceSpeak('ice_trooper', 'MISSPCH_5_IT_04', telepathy=0)",
),
(
	"ff.PickTalkMissiles()",
),
(
	"forceSpeak('ice_trooper', 'MISSPCH_5_IT_05', telepathy=0)",
),
(
	"war()",
	"endCS()",
	"kill('technician1')",
	"ff.addArrow('transmitter2_arrow', '_impobj_trans_yellow', js.ARROW_RED, delete=1)",
	"ff.removeArrow('tech1_arrow')",
	"ff.addAttr('tech_1_grilled', 1)",
	"ff.SpawnMissile1Guards()",
),
]


time_warning_one_ss = [
(
	"speak('minute_man', 'MISSPCH_5_MM_08')",
),
(
	"blank",
),
]


time_warning_two_ss = [
(
	"speak('minute_man', 'MISSPCH_5_MM_09')",
),
(
	"blank",
),
]


too_late_cs = [
(
	"peace()",
	"startCS()",
	"ff.Objective_Fail('interrogate_technicians')",
	"ff.Mission_Lose()",
),
]


wrong_transmitter_cs = [
(
	"ff.CheckObjective()",
	"peace()",
	"startCS()",
	"ff.DelayFailure()",
),
]

real_failure_cs = [
(
	"peace()",
	"startCS()",
	"ff.Objective_Fail('transmitters_alive')",
	"ff.Mission_Lose()",
),
]


missile_destroyed_cs = [
(
	"peace()",
	"startCS()",
	"ff.Mission_Lose()",
	"ff.Objective_Fail('missiles_alive')",
),
]


one_down_cs = [
(
	"peace()",
	"startCS()",
	"Sound_PlayMusic('music_04winter_hit2',1)",
	"wait(3.0)",
),
(
	"speak('minute_man', 'MISSPCH_5_MM_10')",
),
(
	"forceSpeak('nuclear_winter', 'MISSPCH_5_NW_02')",
),
(
	"lookAtPos((-733,882,70), zoom =  200, heading =  -107)",
	"Object_Destroy('_impobj_cuban_missile_5')",
	"spawn('missile_object_2', 'invisible_object', 'missile_marker_2')",
	"speakNoCB('minute_man', 'MISSPCH_5_MM_11')",
	"null()"
),
(
	"Object_PlayEffect( 'missile_object_2', 'effect_missle_launch', 'onStepCB', FX_TRACK_OBJECT_FULL)",
),
(
	"spawn('platform_2', 'cuban_missile_platform', Get_ObjectPos('missile_object_2'))",
#	"Object_PlayEffect('missile_object_2', 'effect_missle_core', '', FX_LOOP|FX_TRACK_OBJECT_FULL)",
	"null()",
),
(
	"war()",
	"endCS()",
	"Sound_PlayMusic('music_04winter2')",
	"Object_Spawn('technician2', 'ice_trooper', 'tech_spawn_2')",
	"spawnGroup('tech_guard2_spawn', 'ice_trooper', 2)",
	"makeInterrogationCS('technician2', oneshot = 1)",
	"ff.addArrow('tech2_arrow', 'technician2', js.ARROW_RED, delete=1)",
	"ff.removeArrow('transmitter2_arrow')",
	"ff.StartSecondTimers()",
),
]

interrogate_technician2_cs = [
(
	"peace()",
	"startCS()",
	"look('technician2', zoom = -200, heading = 0, time = 0)",
	"wait(1.0)",
),
(
	"forceSpeak('ice_trooper', 'MISSPCH_5_IT_06', telepathy=0)",
),
(
	"speak('minute_man', 'MISSPCH_5_MM_12')",
),
(
	"war()",
	"endCS()",
	"kill('technician2')",
	"ff.addArrow('transmitter4_arrow', '_impobj_trans_green', js.ARROW_RED, delete=1)",
	"ff.removeArrow('tech2_arrow')",
	"ff.addAttr('tech_2_grilled', 1)",
	"ff.SpawnMissile2Guards()",
),
]


two_down_cs = [
(
	"peace()",
	"startCS()",
	"Sound_PlayMusic('music_04winter_hit1',1)",
	"wait(3.0)",
),
(
	"speak('minute_man', 'MISSPCH_5_MM_13')",
),
(
	"forceSpeak('nuclear_winter', 'MISSPCH_5_NW_03')",
),
(
	"lookAtPos((887, 800, 71), zoom =  200, heading =  2)",
	"Object_Destroy('_impobj_cuban_missile_3')",
	"spawn('missile_object_3', 'invisible_object', 'missile_marker_3')",
	"speakNoCB('minute_man', 'MISSPCH_5_MM_14')",
	"null()",
),
(
	"Object_PlayEffect( 'missile_object_3', 'effect_missle_launch', 'onStepCB', FX_TRACK_OBJECT_FULL)",
),
(
#	"Object_PlayEffect( 'missile_object_3', 'effect_missle_core', '', FX_LOOP|FX_TRACK_OBJECT_FULL)",
	"Object_SpawnAt('cuban_missile_platform', Get_ObjectPos('missile_object_3'), 'platform_3', (0, 3.14159, 0))",
	"null()",
),
(
	"war()",
	"endCS()",
	"Sound_PlayMusic('music_04winter2')",
	"Object_Spawn('technician3', 'ice_trooper', 'tech_spawn_3')",
	"spawnGroup('tech_guard3_spawn', 'ice_trooper', 3)",
	"makeInterrogationCS('technician3', oneshot = 1)",
	"ff.addArrow('tech3_arrow', 'technician3', js.ARROW_RED, delete=1)",
	"ff.removeArrow('transmitter3_arrow')",
	"ff.StartThirdTimers()",
),
]


interrogate_technician3_cs = [
(
	"peace()",
	"startCS()",
	"look('technician3', zoom = -200, heading = 0, time = 0)",
	"wait(1.0)",
),
(
	"speak('technician3', 'MISSPCH_5_IT_07')",
),
(
	"war()",
	"endCS()",
	"kill('technician3')",
	"ff.addArrow('transmitter6_arrow', '_impobj_trans_blue', js.ARROW_RED, delete=1)",
	"ff.removeArrow('tech3_arrow')",
	"ff.addAttr('tech_3_grilled', 1)",
	"ff.SpawnMissile3Guards()",
),
]

#	"look('nuclear_winter', zoom = 0, heading = 0, time = 0)",

three_down_cs = [
(
	"peace()",
	"see()",
	"startCS()",
	"Sound_PlayMusic('music_04winter_hit2',1)",
	"wait(3.0)",
),
(
	"speak('minute_man', 'MISSPCH_5_MM_15')",
),
(
	"Object_Spawn('nuclear_winter', 'nuclear_winter', 'nuclear_winter_spawn')",
	"spawnGroup('winter_guard_spawn', 'ice_trooper', 2)",
	"peace()",
	"move('nuclear_winter', 'nuclear_winter_runto')",
	"move('_spwn_winter_guard_spawn0', 'winter_guard_0_runto')",
	"move('_spwn_winter_guard_spawn1', 'winter_guard_1_runto')",
	"wait(0.1)",
),
(
	"lookAtPos((-142, 1049, 0), heading = -44.5, zoom = 0, time = 0)",
	"wait(0.1)",
),
(
	"lookAtPos((-142, 1049, 0), heading = -44.5, zoom = -250, time = 5)",
	"wait(0.1)",
),
(
	"Sound_PlayMusic('music_04winter_nw')",
	"forceSpeak('nuclear_winter', 'MISSPCH_5_NW_04')",
),
(
	"ff.IfRedLives()",
),
(
	"addMoveGoal(spawnGetName('r_shaman', 0), 'nuclear_winter_spawn', fn = '', radius = 5, priority = ai.goal.PRI_LOW)",
	"addMoveGoal(spawnGetName('r_shaman', 1), 'nuclear_winter_spawn', fn = '', radius = 5, priority = ai.goal.PRI_LOW)",
	"addMoveGoal(spawnGetName('r_shaman', 2), 'nuclear_winter_spawn', fn = '', radius = 5, priority = ai.goal.PRI_LOW)",
	"addKillAllGoal(spawnGetName('r_shaman', 0), OC_MINION, priority = ai.goal.PRI_MED)",
	"addKillAllGoal(spawnGetName('r_shaman', 1), OC_MINION, priority = ai.goal.PRI_MED)",
	"addKillAllGoal(spawnGetName('r_shaman', 2), OC_MINION, priority = ai.goal.PRI_MED)",
	"wait(0.1)",
),
(
	"war()",
	"endCS()",
	"ff.removeArrow('transmitter3_arrow')",
	"regDeath('nuclear_winter', 'OnWinterDead')",
	"newObjective('primary', 6, name='defeat_nuclear_winter')",
	"Objective_Complete('interrogate_technicians')",
	"Objective_Complete('transmitters_alive')",
),
]

not_dead_yet_cs = [
(
	"peace()",
	"see()",
	"startCS()",
	"Sound_PlayMusic('music_04winter_hit1',1)",
	"wait(1.0)",
),
(
	"look('nuclear_winter', zoom = 0, heading = 0, time = 0)",
	"wait(5.0)",
),
(
	"speak('minute_man', 'MISSPCH_5_MM_16')",
),
(
	"Mission_Play2DCutscene('cutscene_nuclearWinter', 'cutscene_nuclearWinter_wav', 'onStepCB')",
	"Object_Destroy('nuclear_winter')",
	"spawn('frozen_giant', 'frozen_giant', Get_ObjectPos('nuclear_winter'))",
	"peace()",
),
(
	"Sound_PlayMusic('music_04winter_fg')",
	"speak('frozen_giant', 'MISSPCH_5_FG_01')",
),
(
	"speak('frozen_giant', 'MISSPCH_5_FG_02')",
),
(
	"speak('minute_man', 'MISSPCH_5_MM_21')",
),
(
	"war()",
	"blind()",
	"endCS()",
	"ff.addArrow('frozen_giant_arrow', 'frozen_giant', js.ARROW_RED, delete=1)",
),
]

victory_cs = [
(
	"peace()",
	"see()",
	"startCS()",
	"Sound_PlayMusic('music_04winter_hit2',1)",
	"look('frozen_giant', zoom = 0, heading = 0, time = 1)",
	"look('frozen_giant', zoom = -200, heading = 0, time = 3)",
	"wait(3.0)",
),
(
	"reviveHeroes()",
	"peace()",
	"playTransition()",
	"ff.DestroyAllBaddies()",
),
(
	"ff.TeleportHeroes()",
	"Object_Destroy('frozen_giant')",
	"spawn('nuclear_winter', 'nuclear_winter', Get_ObjectPos('frozen_giant'))",
	"peace()",
	"teleport('nuclear_winter', 'finalcs_nw_marker')",
	"Sound_PlaySound('mission_winter')",
	"wait(0.1)",
),
(
	"look('nuclear_winter', zoom = -200, heading = 0, time = 0)",
	"wait(0.1)",
),
(
	"forceSpeak('nuclear_winter', 'MISSPCH_5_NW_05')",
),
(
	"speak('the_ant', 'MISSPCH_5_AN_10')",
),
(
	"speak('minute_man', 'MISSPCH_5_MM_17')",
),
(
	"speak('red_okt_hero', 'MISSPCH_5_RO_08')",
),
(
	"speak('red_okt_hero', 'MISSPCH_5_RO_09')",
),
(
	"AI_IssueMove('red_okt_hero', 'red_run_target')",
	"wait(2.0)",
),
(
	"spawn('charles_wilson', 'charles_wilson', 'wilson_spawn')",
	"peace()",
	"AI_IssueMove('red_okt_hero', 'red_run_target')",
	"AI_IssueMove('charles_wilson', 'wilson_target')",
	"wait(2.0)",
),
(
	"teleport('red_okt_hero', 'hero_3')",
	"speak('charles_wilson', 'MISSPCH_5_CH_01')",
),
(
	"speak('alchemiss', 'MISSPCH_5_AL_03')",
),
(
	"speak('minute_man', 'MISSPCH_5_MM_18')",
),
(
	"ff.HeroesWalkAway()",
	"AI_IssueMove('nuclear_winter', 'finalcs_nwtarget')",
	"speak('charles_wilson', 'MISSPCH_5_CH_02')",
),
(
	"wait(2.0)",
),
(
	"turnTo('charles_wilson', 'nuclear_winter')",
	"wait(3.0)",
),
(
	"look('charles_wilson', zoom = -250, heading = -90, time = 1)",
	"wait(0.1)",
),
(
	"speak('charles_wilson', 'MISSPCH_5_CH_03')",
),
(
	"Sound_PlayMusic('music_02cuba_enda',1)",
	"speak('charles_wilson', 'MISSPCH_5_CH_04')",
),
(
	"wait(5.0)",
),
(
	"war()",
	"blind()",
	"Objective_Complete('defeat_nuclear_winter')",
	"endCS()",
	"Mission_Win()",
),
]


lose_dialog_ss = [
(
	"AI_CancelAllSpeech()",
	"speak('narrator', 'MISSPCH_5_NR_02', forceNonMission = 1)",
),
(
	"blank",
),
]
