# berlin

from cshelper import *
from js import *
import event
	
def OnIntermission():
	Mission_Play2DCutscene('cutscene_nazi_world', 'cutscene_nazi_world_wav', '')

def OnPostInit():
	print 'berlin base/start'
	
	#idle briefing screen stuff
	lookAtPos((-8,19,3), zoom = -233.4, pitch= -5, heading = 100.9)
	Mission_SetSunlight(0, 40, 0.5, 0, (1,1,1))
	regTimer('SparkItUp', 5)
	Object_PlayEffect('_impobj_main_screen', 'cs_screen_scan', '', FX_LOOP|FX_TRACK_OBJECT_ROT)
	Object_PlayEffect('_impobj_main_screen2', 'cs_screen_scan', '', FX_LOOP|FX_TRACK_OBJECT_ROT)

	Campaign_Recruit('alchemiss')
	Campaign_UnlockOrigin('alchemiss')
	Campaign_Recruit('el_diablo')
	Campaign_UnlockOrigin('el_diablo')
	Campaign_Recruit('mentor')
	Campaign_UnlockOrigin('mentor')
	Campaign_Recruit('minute_man')
	Campaign_UnlockOrigin('minute_man')
	Campaign_AddHero ('liberty_lad')
	Campaign_UnlockOrigin('liberty_lad')
	Campaign_Recruit('tombstone')
	Campaign_UnlockOrigin('tombstone')
	Campaign_Recruit('bullet')
	Campaign_UnlockOrigin('bullet')
	Campaign_AddHero ('green_genie')
	Campaign_UnlockOrigin('green_genie')
	Campaign_AddHero ('quetzalcoatl')
	Campaign_UnlockOrigin('quetzalcoatl')
	Campaign_Recruit('the_ant')
	Campaign_UnlockOrigin('the_ant')
	Campaign_Recruit('eve')
	Campaign_UnlockOrigin('eve')
	Campaign_AddHero ('microwave')
	Campaign_AddHero ('supercollider')
	Campaign_AddHero ('the_bard')

	Campaign_AddMinion('thug_with_bat')
	Campaign_AddMinion('thug_with_gun')
	Campaign_AddVillain('nuclear_winter')
	Campaign_AddVillain('time_master')
	Campaign_AddMinion('ice_trooper')
	Campaign_AddMinion('ice_sergeant')
	Campaign_AddMinion('snow_man')
	Campaign_AddMinion('shurale')
	Campaign_AddVillain('red_oktober')
	Campaign_AddMinion('dark_shaman')
	Campaign_AddVillain('frozen_giant')


def OnBriefing():
	play(briefing_cs, "briefing_cs")
	print 'berlin base/briefing'

def SparkItUp(event):
	if isCSPlaying():
		print "still trying"
	else:
		effectID = Object_PlayEffect('_impobj_time_machine', 'csfx_time_machine', '', FX_TRACK_OBJECT_ROT|FX_LOOP)
		AI_Animate('mentor', 'area', 'StopSparks', float(effectID), 0)
		regTimer('SparkItUp', 7)

def StopSparks(event):
    effectID = event.user
    Object_StopEffect('_impobj_time_machine', int(effectID))

#-----------
# data
#-----------

briefing_cs = [
(
	"startCS()",
	"lookAtPos((-8,14,3), zoom = -252.7, pitch= -5, heading = 105.6)",
	"Sound_PlayMusic('music_05berlin_br1')",
	"wait(2)",
),
(
	"lookAtPos((45,117,0), zoom = -264.2, pitch= -5, heading = -1.1)",
	"speak('el_diablo', 'BRFSPCH_6_ED_01', CAPTION_TOP_RIGHT)", # El Diablo ay maria! what do we do k...
),
(
	"AI_Animate('mentor', 'area', '', 0, 0)",
	"speak('minute_man', 'BRFSPCH_6_MM_01', CAPTION_TOP_LEFT)", # Minute Man the thought of patriot ci...  
),
(
	"lookAtPos((-110,103,0), zoom = -271.1, pitch= 0, heading = -94.0)",
	"speak('the_ant', 'BRFSPCH_6_AN_01', CAPTION_TOP_LEFT)", # The Ant what could be taking ment...  
),
(
	"speak('alchemiss', 'BRFSPCH_6_AL_01', CAPTION_BOTTOM_LEFT)", # Alchemiss relax bug-boy. egghead is...  
),
(
	"lookAtPos((-56,110,0), zoom = -252.0, pitch= 0, heading = -67.6)",
	"speak('tombstone', 'BRFSPCH_6_TS_01', CAPTION_TOP_LEFT)", # Tombstone i smell the stench of evi...
	"move('tombstone', 'hero_pos1')",
),
(
	"turnTo('mentor', 'tombstone')",
	"speak('mentor', 'BRFSPCH_6_ME_01', CAPTION_BOTTOM_RIGHT)", # Mentor tombstone is more right t...  
),
(
	"lookAtPos((24,101,0), zoom = -261.8, pitch= -3, heading = 5.2)",
	"speak('mentor', 'BRFSPCH_6_ME_02', CAPTION_TOP_RIGHT)", # Mentor the time stream is out of...  
),
(
	"speak('minute_man', 'BRFSPCH_6_MM_02', CAPTION_TOP_LEFT)", # Minute Man do you think that wilson ...  
),
(
	"speak('mentor', 'BRFSPCH_6_ME_03', CAPTION_TOP_RIGHT)", # Mentor i would suspect he was so...  
),
(
	"lookAtPos((-89,76,0), zoom = -260.2, pitch= 0, heading = -124.4)",
	"speak('the_ant', 'BRFSPCH_6_AN_02', CAPTION_TOP_RIGHT)", # The Ant that would explain all th...  
),
(
	"speak('mentor', 'BRFSPCH_6_ME_04', CAPTION_TOP_LEFT)", # Mentor using those powers, the g...  
),
(
	"speak('alchemiss', 'BRFSPCH_6_AL_02', CAPTION_TOP_RIGHT)", # Alchemiss and what's that, sugah? t...  
),
(
	"speak('mentor', 'BRFSPCH_6_ME_05', CAPTION_TOP_LEFT)", # Mentor because the changes in th...  
),
(
	"lookAtPos((-56,110,0), zoom = -252.0, pitch= 0, heading = -67.6)",
	"speak('minute_man', 'BRFSPCH_6_MM_03', CAPTION_TOP_RIGHT)", # Minute Man you mean-  
),
(
	"speak('mentor', 'BRFSPCH_6_ME_06', CAPTION_BOTTOM_RIGHT)", # Mentor yes- i can send members o...  
),
(
	"speak('el_diablo', 'BRFSPCH_6_ED_02', CAPTION_TOP_RIGHT)", # El Diablo too late? but it's alread...  
),
(
	"speak('alchemiss', 'BRFSPCH_6_AL_03', CAPTION_BOTTOM_LEFT)", # Alchemiss not 20 years ago it hadn'...  
),
(
	"speak('el_diablo', 'BRFSPCH_6_ED_03', CAPTION_TOP_RIGHT)", # El Diablo ay yay yay! can't we go b...  
),
(
	"endBriefingCS()",
),
]

