# euros

from cshelper import *
from js import *
import event

def OnIntermission():	
	Mission_PlayOriginStory('tricolour')

def OnPostInit():
	print 'euros base/start'
	Mission_SetSunlight(0, 0, 0.5, 0, (1,1,1))
	lookAtPos((14,53,1), zoom = -232.1, pitch= 0, heading = -4.3)
	Object_PlayEffect('_impobj_screen', 'cs_screen_bullet_bw', '', FX_LOOP|FX_TRACK_OBJECT_ROT)
	Object_PlayEffect('_impobj_projector', 'csfx_projector_glare', '', FX_LOOP|FX_TRACK_OBJECT_ROT)
	
	Campaign_Recruit('alchemiss')
	Campaign_UnlockOrigin('alchemiss')
	Campaign_Recruit('el_diablo')
	Campaign_UnlockOrigin('el_diablo')
	Campaign_Recruit('mentor')
	Campaign_UnlockOrigin('mentor')
	Campaign_Recruit('minute_man')
	Campaign_UnlockOrigin('minute_man')
	Campaign_AddHero ('liberty_lad')
	Campaign_UnlockOrigin('liberty_lad')
	Campaign_Recruit('tombstone')
	Campaign_UnlockOrigin('tombstone')
	Campaign_Recruit('bullet')
	Campaign_UnlockOrigin('bullet')
	Campaign_AddHero ('green_genie')
	Campaign_UnlockOrigin('green_genie')
	Campaign_AddHero ('quetzalcoatl')
	Campaign_UnlockOrigin('quetzalcoatl')
	Campaign_Recruit('the_ant')
	Campaign_UnlockOrigin('the_ant')
	Campaign_Recruit('eve')
	Campaign_UnlockOrigin('eve')
	Campaign_AddHero ('microwave')
	Campaign_AddHero ('supercollider')
	Campaign_Recruit('black_jack')
	Campaign_UnlockOrigin('black_jack')
	Campaign_AddHero ('law')
	Campaign_UnlockOrigin('law')
	Campaign_AddHero ('order')
	Campaign_UnlockOrigin('order')
	Campaign_AddHero ('ironox')
	Campaign_AddHero ('man_o_war')
	Campaign_UnlockOrigin('man_o_war')
	Campaign_AddHero ('sea_urchin')
	Campaign_UnlockOrigin('sea_urchin')
	Campaign_Recruit('tricolour')
	Campaign_UnlockOrigin('tricolour')
	Campaign_Recruit('sky_king')
	Campaign_UnlockOrigin('sky_king')
	Campaign_AddHero ('the_bard')

	Campaign_AddMinion('thug_with_bat')
	Campaign_AddMinion('thug_with_gun')
	Campaign_AddVillain('nuclear_winter')
	Campaign_AddVillain('time_master')
	Campaign_AddMinion('ice_trooper')
	Campaign_AddMinion('ice_sergeant')
	Campaign_AddMinion('snow_man')
	Campaign_AddMinion('shurale')
	Campaign_AddVillain('red_oktober')
	Campaign_AddMinion('dark_shaman')
	Campaign_AddVillain('frozen_giant')
	Campaign_AddMinion('nazi_rifleman')
	Campaign_AddMinion('legionnaire')
	Campaign_AddVillain('fortissimo')
	Campaign_AddVillain('red_sun')
	Campaign_AddMinion('nazi_gunner')
	Campaign_AddMinion('nazi_grenadier')

def OnBriefing():
	play(briefing_cs, 'briefing_cs')
	print 'euros base/briefing'

#-----------
# data
#-----------

briefing_cs = [
(
	"startCS()",
	"lookAtPos((14,53,1), zoom = -260.1, pitch= -8, heading = -4.3)",
	"Sound_PlayMusic('music_07euros_br',1)",
	"wait(1)",
),
(
	"speak('black_jack', 'BRFSPCH_10_BJ_01', CAPTION_BOTTOM_RIGHT)", #Black Jack i don't care if you think...
),
(
	"lookAtPos((-43,47,1), zoom = -263.8, pitch= 0, heading = -109.3)",
	"speak('sky_king', 'BRFSPCH_10_SY_01', CAPTION_TOP_RIGHT)", #Sky King i think our chum black ja...  
	"turnTo('black_jack', 'sky_king')",
),
( 
	"turnTo('sky_king', 'black_jack')",
	"AI_Animate('black_jack', 'melee_idle')",
	"speak('black_jack', 'BRFSPCH_10_BJ_02', CAPTION_TOP_LEFT)", #Black Jack right then. for the last ...  
),
( 
	"lookAtPos((-100,26,2), zoom = -261.7, pitch= 0, heading = -135.8)",
	"speak('sky_king', 'BRFSPCH_10_SY_02', CAPTION_TOP_RIGHT)", #Sky King was that a threat, jumpin...  
	"AI_Animate('sky_king', 'melee_idle')",
),
( 
	"speak('black_jack', 'BRFSPCH_10_BJ_03', CAPTION_TOP_LEFT)", #Black Jack that's right rich, coming...  
),
( 
	"lookAtPos((14,53,1), zoom = -265.1, pitch= -5, heading = -4.3)",
	"turnTo('tricolour', 'black_jack')",
	"speak('tricolour', 'BRFSPCH_10_TC_01', CAPTION_TOP_RIGHT)", #Tricolour sacre bleu!  if you fools...  
),
( 
	"AI_Animate('black_jack', 'idle')",
	"AI_Animate('sky_king', 'idle')",
	"speak('sky_king', 'BRFSPCH_10_SY_03', CAPTION_BOTTOM_LEFT)", #Sky King so you're proposing we ru...  
),
( 
	"lookAtPos((-54,-27,1), zoom = -266.3, pitch= 0, heading = -178.6)",
	"speak('tricolour', 'BRFSPCH_10_TC_02', CAPTION_TOP_LEFT)", #Tricolour no, mon ami. i am suggest...  
),
( 
	"speak('sky_king', 'BRFSPCH_10_SY_04', CAPTION_BOTTOM_RIGHT)", #Sky King let's go.  
),
(
	"move('black_jack', 'exit_pos0')",
	"move('sky_king', 'exit_pos0')",
	"move('tricolour', 'exit_pos0')",
	"wait(2)",
),
(
	"endBriefingCS()",
),
]

