# skyking

from cshelper import *
from js import *
import event

def OnIntermission():
	Mission_PlayOriginStory('sky_king')

def OnPostInit():
	print 'skyking base/start'
	#briefing setup stuff
	Mission_SetSunlight(0, 40, 0.5, 0, (1,1,1))
	lookAtPos((69,153,0), zoom = -234.5, pitch= 0, heading = 2.4)
	Object_PlayEffect('_impobj_main_screen2', 'cs_screen_scan', '', FX_LOOP|FX_TRACK_OBJECT_ROT)
	AI_Animate('alchemiss', 'stunned', '', 0, 1)

	Campaign_Recruit('alchemiss')
	Campaign_UnlockOrigin('alchemiss')
	Campaign_Recruit('el_diablo')
	Campaign_UnlockOrigin('el_diablo')
	Campaign_Recruit('mentor')
	Campaign_UnlockOrigin('mentor')
	Campaign_Recruit('minute_man')
	Campaign_UnlockOrigin('minute_man')
	Campaign_AddHero ('liberty_lad')
	Campaign_UnlockOrigin('liberty_lad')
	Campaign_Recruit('tombstone')
	Campaign_UnlockOrigin('tombstone')
	Campaign_Recruit('bullet')
	Campaign_UnlockOrigin('bullet')
	Campaign_AddHero ('green_genie')
	Campaign_UnlockOrigin('green_genie')
	Campaign_AddHero ('quetzalcoatl')
	Campaign_UnlockOrigin('quetzalcoatl')
	Campaign_Recruit('the_ant')
	Campaign_UnlockOrigin('the_ant')
	Campaign_Recruit('eve')
	Campaign_UnlockOrigin('eve')
	Campaign_AddHero ('microwave')
	Campaign_AddHero ('supercollider')
	Campaign_Recruit('black_jack')
	Campaign_UnlockOrigin('black_jack')
	Campaign_AddHero ('law')
	Campaign_UnlockOrigin('law')
	Campaign_AddHero ('order')
	Campaign_UnlockOrigin('order')
	Campaign_AddHero ('ironox')
	Campaign_AddHero ('man_o_war')
	Campaign_UnlockOrigin('man_o_war')
	Campaign_AddHero ('sea_urchin')
	Campaign_UnlockOrigin('sea_urchin')
	Campaign_Recruit('tricolour')
	Campaign_UnlockOrigin('tricolour')
	Campaign_AddHero ('blackbird')
	Campaign_Recruit('sky_king')
	Campaign_UnlockOrigin('sky_king')
	Campaign_AddHero ('the_bard')

	Campaign_AddMinion('thug_with_bat')
	Campaign_AddMinion('thug_with_gun')
	Campaign_AddVillain('nuclear_winter')
	Campaign_AddVillain('time_master')
	Campaign_AddMinion('ice_trooper')
	Campaign_AddMinion('ice_sergeant')
	Campaign_AddMinion('snow_man')
	Campaign_AddMinion('shurale')
	Campaign_AddVillain('red_oktober')
	Campaign_AddMinion('dark_shaman')
	Campaign_AddVillain('frozen_giant')
	Campaign_AddMinion('nazi_rifleman')
	Campaign_AddMinion('legionnaire')
	Campaign_AddVillain('fortissimo')
	Campaign_AddVillain('red_sun')
	Campaign_AddMinion('nazi_gunner')
	Campaign_AddMinion('nazi_grenadier')
	Campaign_AddMinion('killarilla_whip')
	Campaign_AddMinion('killarilla_chaingun')
	Campaign_AddMinion('nazi_general')

def OnBriefing():
	play(briefing_cs)
	AI_Animate('alchemiss', 'stunned', '', 0, 1)
	print 'skyking base/briefing'

#-----------
# data
#-----------

briefing_cs = [
(
	"startCS()",
	"lookAtPos((49,82,0), zoom = -260.7, pitch= -5, heading = 11.4)",
	"wait(1)",
),
(
	"AI_Animate('alchemiss', 'recover_from_stun', '', 0, 0)",
	"Sound_PlayMusic('music_08skyking_base',1)",
	"speak('mentor', 'BRFSPCH_12_ME_01', CAPTION_TOP_RIGHT)", #Mentor are you ready, alchemiss?...
),
(
	"walkCB('alchemiss', 'al_pos1')",
),
(
	"speak('alchemiss', 'BRFSPCH_12_AL_01', CAPTION_BOTTOM_LEFT)", #Alchemiss yes..yes, i'm sorry...i m...  
	"turnTo('alchemiss', 'mentor')",
),
( 
	"lookAtPos((14,30,3), zoom = -266.4, pitch= -3, heading = 98.0)",
	"speak('mentor', 'BRFSPCH_12_ME_02', CAPTION_TOP_RIGHT)", #Mentor you are troubled by our e...  
),
( 
	"speak('alchemiss', 'BRFSPCH_12_AL_02', CAPTION_BOTTOM_LEFT)", #Alchemiss i'm troubled by a lot of ...  
),
( 
	"speak('mentor', 'BRFSPCH_12_ME_03', CAPTION_TOP_RIGHT)", #Mentor there is a saying on eart...  
),
( 
	"lookAtPos((49,82,0), zoom = -260.7, pitch= -5, heading = 11.4)",
	"speak('alchemiss', 'BRFSPCH_12_AL_03', CAPTION_BOTTOM_LEFT)", #Alchemiss thank you, mentor.  
),
( 
	"speak('mentor', 'BRFSPCH_12_ME_04', CAPTION_TOP_RIGHT)", #Mentor are you prepared?  
),
( 
	"speak('alchemiss', 'BRFSPCH_12_AL_04', CAPTION_BOTTOM_LEFT)", #Alchemiss i ahm.  
),
( 
	"lookAtPos((21,57,3), zoom = -258.8, pitch= -5, heading = 54.1)",
	"speak('mentor', 'BRFSPCH_12_ME_05', CAPTION_TOP_RIGHT)", #Mentor we have trained together ...  
),
( 
	"speak('mentor', 'BRFSPCH_12_ME_09', CAPTION_TOP_RIGHT)", #Mentor   
),
( 
	"speak('alchemiss', 'BRFSPCH_12_AL_05', CAPTION_BOTTOM_LEFT)", #Alchemiss sounds like a party.  
	"Object_Spawn('portal_spawn', 'invisible_object', 'bullet_spawn')",
),
(
	"Object_PlayEffect('_impobj_time_machine', 'csfx_time_machine', '', FX_TRACK_OBJECT_ROT|FX_LOOP)",
	"Object_PlayEffect('portal_spawn', 'effect_portal_open', 'onStepCB', FX_TRACK_OBJECT_ROT)",
	"AI_Animate('mentor', 'area', '', 0, 0)",
	"AI_Animate('alchemiss', 'close_portal', '', 0, 1)",
),
(
	"Object_Spawn('bullet', 'bullet', 'bullet_spawn')",
	"Object_PlayEffect('portal_spawn', 'effect_portal_close', '', FX_TRACK_OBJECT_ROT)",
	"AI_Animate('alchemiss', 'land_back', 'onStepCB', 0, 1)",
	"AI_Animate('bullet', 'stunned', '', 0, 1)",
),
(
	"Object_StopEffect('_impobj_time_machine', 1)",
	"speak('mentor', 'BRFSPCH_12_ME_06', CAPTION_TOP_RIGHT)", #Mentor alchemiss!  
),
( 
	"AI_Animate('alchemiss', 'get_up_back', '', 0, 0)",
	"speak('alchemiss', 'BRFSPCH_12_AL_06', CAPTION_BOTTOM_LEFT)", #Alchemiss ah'm all right...just nev...  
),
( 
	"AI_Animate('bullet', 'recover_from_stun', '', 0, 0)",
	"speak('mentor', 'BRFSPCH_12_ME_07', CAPTION_TOP_RIGHT)", #Mentor bullet, are you hurt?  
),
( 
	"lookAtPos((14,30,3), zoom = -266.4, pitch= -3, heading = 98.0)",
	"speak('bullet', 'BRFSPCH_12_BL_01', CAPTION_TOP_LEFT)", #Bullet me? shucks? i'm great! an...  
	"turnTo('bullet', 'mentor')",
),
( 
	"speak('mentor', 'BRFSPCH_12_ME_08', CAPTION_TOP_RIGHT)", #Mentor good...get the others...w...  
),
(
	"move('bullet', 'hero_exit')",
	"move('alchemiss', 'hero_exit')",
	"wait(2)",
),	
( 
	"endBriefingCS()",
),
]

