# disappear

from cshelper import *
from js import *
import event
	
def OnPostInit():
	print 'disappear base/start'
	AI_Animate('man_bot', 'pain', '', 0, 0)
	lookAtPos((-12,190,0), zoom = -210.0, pitch = -8, heading = -43.1)
	Mission_SetSunlight(0, 60, 0.5, 0, (1,1,1))
	Object_PlayEffect('_impobj_main_screen', 'cs_screen_scan', '', FX_LOOP|FX_TRACK_OBJECT_ROT)

	Campaign_UnRecruit('alchemiss')
	Campaign_UnlockOrigin('alchemiss')
	Campaign_UnRecruit('el_diablo')
	Campaign_UnlockOrigin('el_diablo')
	Campaign_Recruit('mentor')
	Campaign_UnlockOrigin('mentor')
	Campaign_Recruit('minute_man')
	Campaign_UnlockOrigin('minute_man')
	Campaign_AddHero ('liberty_lad')
	Campaign_UnlockOrigin('liberty_lad')
	Campaign_Recruit('tombstone')
	Campaign_UnlockOrigin('tombstone')
	Campaign_Recruit('bullet')
	Campaign_UnlockOrigin('bullet')
	Campaign_AddHero ('green_genie')
	Campaign_UnlockOrigin('green_genie')
	Campaign_AddHero ('quetzalcoatl')
	Campaign_UnlockOrigin('quetzalcoatl')
	Campaign_Recruit('the_ant')
	Campaign_UnlockOrigin('the_ant')
	Campaign_UnRecruit('eve')
	Campaign_UnlockOrigin('eve')
	Campaign_UnRecruit('supercollider')
	Campaign_Recruit('microwave')
	Campaign_Recruit('black_jack')
	Campaign_UnlockOrigin('black_jack')
	Campaign_AddHero ('law')
	Campaign_UnlockOrigin('law')
	Campaign_AddHero ('order')
	Campaign_UnlockOrigin('order')
	Campaign_UnRecruit ('ironox')
	Campaign_AddHero ('man_o_war')
	Campaign_UnlockOrigin('man_o_war')
	Campaign_AddHero ('sea_urchin')
	Campaign_UnlockOrigin('sea_urchin')
	Campaign_Recruit('tricolour')
	Campaign_UnlockOrigin('tricolour')
	Campaign_AddHero ('blackbird')
	Campaign_Recruit('sky_king')
	Campaign_UnlockOrigin('sky_king')
	Campaign_Recruit('man_bot')
	Campaign_UnlockOrigin('man_bot')
	Campaign_AddHero ('the_bard')

	Campaign_AddMinion('thug_with_bat')
	Campaign_AddMinion('thug_with_gun')
	Campaign_AddVillain('nuclear_winter')
	Campaign_AddVillain('time_master')
	Campaign_AddMinion('ice_trooper')
	Campaign_AddMinion('ice_sergeant')
	Campaign_AddMinion('snow_man')
	Campaign_AddMinion('shurale')
	Campaign_AddVillain('red_oktober')
	Campaign_AddMinion('dark_shaman')
	Campaign_AddVillain('frozen_giant')
	Campaign_AddMinion('nazi_rifleman')
	Campaign_AddMinion('legionnaire')
	Campaign_AddVillain('fortissimo')
	Campaign_AddVillain('red_sun')
	Campaign_AddMinion('nazi_gunner')
	Campaign_AddMinion('nazi_grenadier')
	Campaign_AddMinion('killarilla_whip')
	Campaign_AddMinion('killarilla_chaingun')
	Campaign_AddMinion('nazi_general')
	Campaign_AddMinion('eye_minor')
	Campaign_AddMinion('centurion')
	Campaign_AddMinion('eye_major')
	Campaign_AddVillain('blitzkrieg')
	Campaign_AddMinion('wraith_warrior')
	Campaign_AddMinion('trex')
	Campaign_AddMinion('fire_elemental')
	Campaign_AddMinion('subterrestrial')
	Campaign_AddMinion('wraith_manta')

def OnBriefing():
	play(briefing_cs)
	print 'disappear base/briefing'

#-----------
# data
#-----------

briefing_cs = [
(
	"startCS()",
	"lookAtPos((-12,187,0), zoom = -250.6, pitch = -5, heading = -31.3)",
	"AI_Animate('man_bot', 'idle', '', 0, 1)",
	"wait(1)",
),
(
	"speak('minute_man', 'BRFSPCH_20_MM_01', CAPTION_TOP_LEFT)", #Minute Man what is it, old friend? e...
),
(
	"lookAtPos((-35,107,0), zoom = -260.0, pitch = -5, heading = -215.0)",
	"speak('man_bot', 'BRFSPCH_20_MB_01', CAPTION_TOP_LEFT)", #Man-Bot this is all my fault. so ...
	"Sound_PlayMusic('music_12dis_base1',1)",
),
(
	"speak('minute_man', 'BRFSPCH_20_MM_02', CAPTION_BOTTOM_RIGHT)", #Minute Man you're wrong, manbot. you...
),
(
	"lookAtPos((-12,220,0), zoom = -260.0, pitch = 0, heading = -35.0)",
	"speak('man_bot', 'BRFSPCH_20_MB_02', CAPTION_TOP_RIGHT)", #Man-Bot for what? for the death o...
	"turnTo('man_bot', 'minute_man')",
),
(
	"speak('minute_man', 'BRFSPCH_20_MM_03', CAPTION_BOTTOM_LEFT)", #Minute Man freedom force doesn't suf...
),
(
	"speak('man_bot', 'BRFSPCH_20_MB_03', CAPTION_TOP_RIGHT)", #Man-Bot how? how can you stop som...
	"spawn('the_ant', 'the_ant', 'ant_spawn')",
),
(
	"lookAtPos((30,157,0), zoom = -260.0, pitch = 0, heading = 25.0, time = 2)",
	"moveCB('the_ant', 'ant_pos1', radius = 0)",
),
(
	"speak('the_ant', 'BRFSPCH_20_AN_01', CAPTION_TOP_RIGHT)", #The Ant actually, i think i know ...
),
(
	"endBriefingCS()",
),
]

