# Time Master
### TODO
### final CS decisions
		# (asset needed: wraith warrior "awaiting blast" animation)
		# (asset needed: Subterrestrial "preparing to blast" animation)
		# (asset needed: Explosion FX for Wraith -> UberWraith conversion (reuse?))
		# (assets needed: power & FX for Subterrestrial zapping Wraith Warrior)

from cshelper import *
from js import *
import event
from random import randint
from ffx import *

def OnPreRendererCreate():
	ff.RENDER_WARP = 1

def OnPrecacheObjects():
	print "timemaster/precache"
	Mission_PrecacheTemplateObj('entropy',1,1)
	Mission_PrecacheTemplateObj('eve_n',0,1)
	Mission_PrecacheTemplateObj('cop_crooked',0,1)
	Mission_PrecacheTemplateObj('el_diablo_n',0,1)
	Mission_PrecacheTemplateObj('eye_minor',0,1)
	Mission_PrecacheTemplateObj('nazi_rifleman',0,1)
	Mission_PrecacheTemplateObj('mafioso',0,1)
	Mission_PrecacheTemplateObj('time_mast_elec_hero',0,1)
	Mission_PrecacheTemplateObj('time_mast_enrg_hero',0,1)
	Mission_PrecacheTemplateObj('time_mast_radn_hero',0,1)

def OnPostInit():
	print "timemaster/start"
	setMission(20)
	
	Mission_SetSunlight(-137,57,1.5,0.2,(0.2,0.2,0.6))
	Mission_SetShadows(-137,57,(0.2,0.2,0.4))
	Mission_SetProjShadowBackground((1,1,1))
	Mission_SetProjShadowColor((.6,.6,.6,1))

	Mission_SetAttr('wave_dead', 0)
	Mission_SetAttr('first_wave_down', 0)
	Mission_SetAttr('second_wave_up', 0)
	Mission_SetAttr('second_wave_down', 0)
	Mission_SetAttr('third_wave_up', 0)
	Mission_SetAttr('third_wave_down', 0)
	Mission_SetAttr('played_first_retreat', 0)

	spawn('entropy','entropy','entrance_marker')

	Mission_SetAttr('distance_check',250)

	Mission_SetAttr('prox_w11_s11', 0)
	Mission_SetAttr('prox_w12_s11', 0)
	Mission_SetAttr('prox_w11_s12', 0)
	Mission_SetAttr('prox_w12_s12', 0)
	Mission_SetAttr('prox_w21_s21', 0)
	Mission_SetAttr('prox_w22_s21', 0)
	Mission_SetAttr('prox_w21_s22', 0)
	Mission_SetAttr('prox_w22_s22', 0)
	Mission_SetAttr('prox_w31_s31', 0)
	Mission_SetAttr('prox_w32_s31', 0)
	Mission_SetAttr('prox_w31_s32', 0)
	Mission_SetAttr('prox_w32_s32', 0)

#	spawn('twin1_standin','fx_standin','twin1_spawn_point')
#	spawn('twin2_standin','fx_standin','twin2_spawn_point')
#	spawn('w11_standin','fx_standin','w11_spawn_point')
#	spawn('w12_standin','fx_standin','w12_spawn_point')
#	spawn('s11_standin','fx_standin','s11_spawn_point')
#	spawn('s12_standin','fx_standin','s12_spawn_point')
#	spawn('w21_standin','fx_standin','w21_spawn_point')
#	spawn('w22_standin','fx_standin','w22_spawn_point')
#	spawn('s21_standin','fx_standin','s21_spawn_point')
#	spawn('s22_standin','fx_standin','s22_spawn_point')
#	spawn('w31_standin','fx_standin','w31_spawn_point')
#	spawn('w32_standin','fx_standin','w32_spawn_point')
#	spawn('s31_standin','fx_standin','s31_spawn_point')
#	spawn('s32_standin','fx_standin','s32_spawn_point')
#	spawn('tm_end_standin','fx_standin','tm_end_marker')
#	spawn('m15_standin','fx_standin','m15')
#	spawn('m16_standin','fx_standin','m16')
#	spawn('m17_standin','fx_standin','m17')
#	spawn('m18_standin','fx_standin','m18')
#	spawn('m25_standin','fx_standin','m25')
#	spawn('m26_standin','fx_standin','m26')
#	spawn('m27_standin','fx_standin','m27')
#	spawn('m28_standin','fx_standin','m28')
#	spawn('m35_standin','fx_standin','m35')
#	spawn('m36_standin','fx_standin','m36')
#	spawn('m37_standin','fx_standin','m37')
#	spawn('m38_standin','fx_standin','m38')

	regDeath('time_master_p','TMDown')

	Mission_SetAttr('entropy_basehp',Object_GetAttr('entropy','health'))
	print Mission_GetAttr('entropy_basehp')

	ff.RENDER_WARP = 1
	Mission_SetAttr('cs_playing', 1)
	play(start_cs,'start_cs')
	FFX_InitMission()

def TestSetup(event):
	print 'testing'
	W11Spawn(event)
	W12Spawn(event)
	S11Spawn(event)
	S12Spawn(event)


def StandardWarpEffect(pos):
	Mission_SetWaveEnvelope(1, 0.35, 3, 0.35, 3, 1)
	Mission_SetWaveSinParams(1, 4, 0.04, 1)
	Mission_StartWave(1, 3, 1, pos)


#def Twin1Start(event):
#	playEffectMarker('effect_entropy_spawn', 'twin1_spawn_point', key = 'spawn', keyFn = 'Twin1Start2')
#	ff.StandardWarpEffect(Get_MarkerPos('twin1_spawn_point'))
#def Twin1Start2(event):
#	teleport('twin_1','twin1_spawn_point')
#	regDeath('twin_1','Twin1Down')
def Twin2Start(event):
	playEffectMarker('effect_entropy_spawn', 'twin2_spawn_point', key = 'spawn', keyFn = 'Twin2Spawn2')
	ff.StandardWarpEffect(Get_MarkerPos('twin2_spawn_point'))
#def Twin2Start2(event):
#	teleport('twin_2','twin2_spawn_point')
#	regDeath('twin_2','Twin2Down')

def Twin1Spawn(event):
	Object_Destroy('twin_1')
	regTimer('Twin1Spawn2',.1)
def Twin1Spawn2(event):
	if Object_IsAlive('twin_2'):
		if Object_GetTemplate('twin_2') == 'time_mast_elec_hero':
			temp = randint(0,1)
			if temp == 0:
				spawn('twin_1','time_mast_radn_hero','twin1_spawn_point')
			elif temp == 1:
				spawn('twin_1','time_mast_enrg_hero','twin1_spawn_point')
		elif Object_GetTemplate('twin_2') == 'time_mast_enrg_hero':
			temp = randint(0,1)
			if temp == 0:
				spawn('twin_1','time_mast_radn_hero','twin1_spawn_point')
			elif temp == 1:
				spawn('twin_1','time_mast_elec_hero','twin1_spawn_point')
		elif Object_GetTemplate('twin_2') == 'time_mast_radn_hero':
			temp = randint(0,1)
			if temp == 0:
				spawn('twin_1','time_mast_elec_hero','twin1_spawn_point')
			elif temp == 1:
				spawn('twin_1','time_mast_enrg_hero','twin1_spawn_point')
	else:
		temp = randint(0,2)
		if temp == 0:
			spawn('twin_1','time_mast_elec_hero','twin1_spawn_point')
		elif temp == 1:
			spawn('twin_1','time_mast_enrg_hero','twin1_spawn_point')
		elif temp == 2:
			spawn('twin_1','time_mast_radn_hero','twin1_spawn_point')
	regDeath('twin_1','Twin1Down')
#	Object_PlayEffect('twin1_standin', 'effect_portal_close', '',FX_TRACK_OBJECT_ROT)
def Twin2Spawn(event):
	Object_Destroy('twin_2')
	regTimer('Twin2Spawn2',.1)
def Twin2Spawn2(event):
	if Object_IsAlive('twin_1'):
		if Object_GetTemplate('twin_1') == 'time_mast_elec_hero':
			temp = randint(0,1)
			if temp == 0:
				spawn('twin_2','time_mast_radn_hero','twin2_spawn_point')
			elif temp == 1:
				spawn('twin_2','time_mast_enrg_hero','twin2_spawn_point')
		elif Object_GetTemplate('twin_1') == 'time_mast_enrg_hero':
			temp = randint(0,1)
			if temp == 0:
				spawn('twin_2','time_mast_radn_hero','twin2_spawn_point')
			elif temp == 1:
				spawn('twin_2','time_mast_elec_hero','twin2_spawn_point')
		elif Object_GetTemplate('twin_1') == 'time_mast_radn_hero':
			temp = randint(0,1)
			if temp == 0:
				spawn('twin_2','time_mast_elec_hero','twin2_spawn_point')
			elif temp == 1:
				spawn('twin_2','time_mast_enrg_hero','twin2_spawn_point')
	else:
		temp = randint(0,2)
		if temp == 0:
			spawn('twin_2','time_mast_elec_hero','twin2_spawn_point')
		elif temp == 1:
			spawn('twin_2','time_mast_enrg_hero','twin2_spawn_point')
		elif temp == 2:
			spawn('twin_2','time_mast_radn_hero','twin2_spawn_point')
	regDeath('twin_2','Twin2Down')
#	Object_PlayEffect('twin2_standin', 'effect_portal_close', '',FX_TRACK_OBJECT_ROT)

def Twin1Down(event):
	regTimer('Twin1Respawn',20)
def Twin2Down(event):
	regTimer('Twin2Respawn',20)
def Twin1Respawn(event):
	# check how late in the mission we are
	if Mission_GetAttr('second_wave_up') == 0:
		StandardWarpEffect(Get_MarkerPos('twin1_spawn_point'))
		playEffectMarker('effect_entropy_spawn', 'twin1_spawn_point', key = 'spawn', keyFn = 'Twin1Spawn')
#		Twin1Spawn(event)
def Twin2Respawn(event):
	# check how late in the mission we are
	if Mission_GetAttr('third_wave_up') == 0:
		StandardWarpEffect(Get_MarkerPos('twin2_spawn_point'))
		playEffectMarker('effect_entropy_spawn', 'twin2_spawn_point', key = 'spawn', keyFn = 'Twin2Spawn')
#		Twin2Spawn(event)



def PickAMonster():
	temp = randint(0,6)
	print temp
	if temp == 0:
		return 'ice_trooper'
	elif temp == 1:
		return 'eye_minor'
	elif temp == 2:
		return 'el_diablo_n'
	elif temp == 3:
		return 'cop_crooked'
	elif temp == 4:
		return 'nazi_rifleman'
	elif temp == 5:
		return 'mafioso'
	elif temp == 6:
		return 'eve_n'
#	elif temp == 7:
#		return 'alien_warrior'


def W11Spawn(event):
	teleport('mon_11','w11_spawn_point')
#	spawn('mon_11','el_diablo_night','w11_spawn_point')
	regDeath('mon_11','AWaveKill')
#	Object_PlayEffect('w11_standin', 'effect_portal_close', '',FX_TRACK_OBJECT_ROT)
	if Mission_GetAttr('cs_playing') == 1:
		AI_SetEnabled('mon_11',0)
def W12Spawn(event):
	teleport('mon_12','w12_spawn_point')
#	spawn('mon_12','eve_nightmare','w12_spawn_point')
	regDeath('mon_12','AWaveKill')
#	Object_PlayEffect('w12_standin', 'effect_portal_close', '',FX_TRACK_OBJECT_ROT)
	if Mission_GetAttr('cs_playing') == 1:
		AI_SetEnabled('mon_12',0)
def S11Spawn(event):
	mon13 = PickAMonster()
	print mon13
	spawn('mon_13',mon13,'s11_spawn_point')
	regDeath('mon_13','AWaveKill')
#	Object_PlayEffect('s11_standin', 'effect_portal_close', '',FX_TRACK_OBJECT_ROT)
	if Mission_GetAttr('cs_playing') == 1:
		AI_SetEnabled('mon_13',0)
def S12Spawn(event):
	mon14 = PickAMonster()
	print mon14
	spawn('mon_14',mon14,'s12_spawn_point')
	regDeath('mon_14','AWaveKill')
#	Object_PlayEffect('s12_standin', 'effect_portal_close', '',FX_TRACK_OBJECT_ROT)
	if Mission_GetAttr('cs_playing') == 1:
		AI_SetEnabled('mon_14',0)

def M15Start(event):
	StandardWarpEffect(Get_MarkerPos('m15'))
	playEffectMarker('effect_entropy_spawn', 'm15', key = 'spawn', keyFn = 'M15Spawn')
#	Object_PlayEffect('m15_standin', 'effect_portal_open', 'M15Spawn',FX_TRACK_OBJECT_ROT)
def M15Spawn(event):
	mon15 = PickAMonster()
	print mon15
	spawn('mon_15',mon15,'m15')
	regDeath('mon_15','AWaveKill')
#	Object_PlayEffect('m15_standin', 'effect_portal_close', '',FX_TRACK_OBJECT_ROT)
	regTimer('M15Attack',.5)
def M15Attack(event):
	targetspot = Get_ObjectPos('time_master_p')
	addMoveGoal('mon_15',targetspot,radius=30)
	regTimer('M16Start',2)
def M16Start(event):
	StandardWarpEffect(Get_MarkerPos('m16'))
	playEffectMarker('effect_entropy_spawn', 'm16', key = 'spawn', keyFn = 'M16Spawn')
#	Object_PlayEffect('m16_standin', 'effect_portal_open', 'M16Spawn',FX_TRACK_OBJECT_ROT)
def M16Spawn(event):
	mon16 = PickAMonster()
	print mon16
	spawn('mon_16',mon16,'m16')
	regDeath('mon_16','AWaveKill')
#	Object_PlayEffect('m16_standin', 'effect_portal_close', '',FX_TRACK_OBJECT_ROT)
	regTimer('M16Attack',.5)
def M16Attack(event):
	targetspot = Get_ObjectPos('time_master_p')
	addMoveGoal('mon_16',targetspot,radius=30)
	regTimer('M17Start',2)
def M17Start(event):
	StandardWarpEffect(Get_MarkerPos('m17'))
	playEffectMarker('effect_entropy_spawn', 'm17', key = 'spawn', keyFn = 'M17Spawn')
#	Object_PlayEffect('m17_standin', 'effect_portal_open', 'M17Spawn',FX_TRACK_OBJECT_ROT)
def M17Spawn(event):
	mon17 = PickAMonster()
	print mon17
	spawn('mon_17',mon17,'m17')
	regDeath('mon_17','AWaveKill')
#	Object_PlayEffect('m17_standin', 'effect_portal_close', '',FX_TRACK_OBJECT_ROT)
	regTimer('M17Attack',.5)
def M17Attack(event):
	targetspot = Get_ObjectPos('time_master_p')
	addMoveGoal('mon_17',targetspot,radius=30)
	regTimer('M18Start',2)
def M18Start(event):
	StandardWarpEffect(Get_MarkerPos('m18'))
	playEffectMarker('effect_entropy_spawn', 'm18', key = 'spawn', keyFn = 'M18Spawn')
#	Object_PlayEffect('m18_standin', 'effect_portal_open', 'M18Spawn',FX_TRACK_OBJECT_ROT)
def M18Spawn(event):
	mon18 = PickAMonster()
	print mon18
	spawn('mon_18',mon18,'m18')
	regDeath('mon_18','AWaveKill')
#	Object_PlayEffect('m18_standin', 'effect_portal_close', '',FX_TRACK_OBJECT_ROT)
	regTimer('M18Attack',.5)
def M18Attack(event):
	targetspot = Get_ObjectPos('time_master_p')
	addMoveGoal('mon_18',targetspot,radius=30)


def W21Spawn(event):
	mon21 = PickAMonster()
	spawn('mon_21',mon21,'w21_spawn_point')
	regDeath('mon_21','AWaveKill')
#	Object_PlayEffect('w21_standin', 'effect_portal_close', '',FX_TRACK_OBJECT_ROT)
	regTimer('W21Attack',.5)
def W21Attack(event):
	targetspot = Get_ObjectPos('time_master_p')
	addMoveGoal('mon_21',targetspot,radius=30)
def W22Spawn(event):
	mon22 = PickAMonster()
	spawn('mon_22',mon22,'w22_spawn_point')
	regDeath('mon_22','AWaveKill')
#	Object_PlayEffect('w22_standin', 'effect_portal_close', '',FX_TRACK_OBJECT_ROT)
	regTimer('W22Attack',.5)
def W22Attack(event):
	targetspot = Get_ObjectPos('time_master_p')
	addMoveGoal('mon_22',targetspot,radius=30)
def S21Spawn(event):
	mon23 = PickAMonster()
	spawn('mon_23',mon23,'s21_spawn_point')
	regDeath('mon_23','AWaveKill')
#	Object_PlayEffect('s21_standin', 'effect_portal_close', '',FX_TRACK_OBJECT_ROT)
	regTimer('S21Attack',.5)
def S21Attack(event):
	targetspot = Get_ObjectPos('time_master_p')
	addMoveGoal('mon_23',targetspot,radius=30)
def S22Spawn(event):
	mon24 = PickAMonster()
	spawn('mon_24',mon24,'s22_spawn_point')
	regDeath('mon_24','AWaveKill')
#	Object_PlayEffect('s22_standin', 'effect_portal_close', '',FX_TRACK_OBJECT_ROT)
	regTimer('S22Attack',.5)
def S22Attack(event):
	targetspot = Get_ObjectPos('time_master_p')
	addMoveGoal('mon_24',targetspot,radius=30)
	regTimer('M25Start',2)

def M25Start(event):
	StandardWarpEffect(Get_MarkerPos('m25'))
	playEffectMarker('effect_entropy_spawn', 'm25', key = 'spawn', keyFn = 'M25Spawn')
#	Object_PlayEffect('m25_standin', 'effect_portal_open', 'M25Spawn',FX_TRACK_OBJECT_ROT)
def M25Spawn(event):
	mon25 = PickAMonster()
	spawn('mon_25',mon25,'m25')
	regDeath('mon_25','AWaveKill')
#	Object_PlayEffect('m22_standin', 'effect_portal_close', '',FX_TRACK_OBJECT_ROT)
	regTimer('M25Attack',.5)
def M25Attack(event):
	targetspot = Get_ObjectPos('time_master_p')
	addMoveGoal('mon_25',targetspot,radius=30)
	regTimer('M26Start',2)
def M26Start(event):
	StandardWarpEffect(Get_MarkerPos('m26'))
	playEffectMarker('effect_entropy_spawn', 'm26', key = 'spawn', keyFn = 'M26Spawn')
#	Object_PlayEffect('m26_standin', 'effect_portal_open', 'M26Spawn',FX_TRACK_OBJECT_ROT)
def M26Spawn(event):
	mon26 = PickAMonster()
	spawn('mon_26',mon26,'m26')
	regDeath('mon_26','AWaveKill')
#	Object_PlayEffect('m26_standin', 'effect_portal_close', '',FX_TRACK_OBJECT_ROT)
	regTimer('M26Attack',.5)
def M26Attack(event):
	targetspot = Get_ObjectPos('time_master_p')
	addMoveGoal('mon_26',targetspot,radius=30)
	regTimer('M27Start',2)
def M27Start(event):
	StandardWarpEffect(Get_MarkerPos('m27'))
	playEffectMarker('effect_entropy_spawn', 'm27', key = 'spawn', keyFn = 'M27Spawn')
#	Object_PlayEffect('m27_standin', 'effect_portal_open', 'M27Spawn',FX_TRACK_OBJECT_ROT)
def M27Spawn(event):
	mon27 = PickAMonster()
	spawn('mon_27',mon27,'m27')
	regDeath('mon_27','AWaveKill')
#	Object_PlayEffect('m27_standin', 'effect_portal_close', '',FX_TRACK_OBJECT_ROT)
	regTimer('M27Attack',.5)
def M27Attack(event):
	targetspot = Get_ObjectPos('time_master_p')
	addMoveGoal('mon_27',targetspot,radius=30)
	regTimer('M28Start',2)
def M28Start(event):
	StandardWarpEffect(Get_MarkerPos('m28'))
	playEffectMarker('effect_entropy_spawn', 'm28', key = 'spawn', keyFn = 'M28Spawn')
#	Object_PlayEffect('m28_standin', 'effect_portal_open', 'M28Spawn',FX_TRACK_OBJECT_ROT)
def M28Spawn(event):
	mon28 = PickAMonster()
	spawn('mon_28',mon28,'m28')
	regDeath('mon_28','AWaveKill')
#	Object_PlayEffect('m28_standin', 'effect_portal_close', '',FX_TRACK_OBJECT_ROT)
	regTimer('M28Attack',.5)
def M28Attack(event):
	targetspot = Get_ObjectPos('time_master_p')
	addMoveGoal('mon_28',targetspot,radius=30)



def W31Spawn(event):
	mon31 = PickAMonster()
	spawn('mon_31',mon31,'w31_spawn_point')
	regDeath('mon_31','AWaveKill')
#	Object_PlayEffect('w31_standin', 'effect_portal_close', '',FX_TRACK_OBJECT_ROT)
	regTimer('W31Attack',.5)
def W31Attack(event):
	targetspot = Get_ObjectPos('time_master_p')
	addMoveGoal('mon_31',targetspot,radius=30)
def W32Spawn(event):
	mon32 = PickAMonster()
	spawn('mon_32',mon32,'w32_spawn_point')
	regDeath('mon_32','AWaveKill')
#	Object_PlayEffect('w32_standin', 'effect_portal_close', '',FX_TRACK_OBJECT_ROT)
	regTimer('W32Attack',.5)
def W32Attack(event):
	targetspot = Get_ObjectPos('time_master_p')
	addMoveGoal('mon_32',targetspot,radius=30)
def S31Spawn(event):
	mon33 = PickAMonster()
	spawn('mon_33',mon33,'s31_spawn_point')
	regDeath('mon_33','AWaveKill')
#	Object_PlayEffect('s31_standin', 'effect_portal_close', '',FX_TRACK_OBJECT_ROT)
	regTimer('S31Attack',.5)
def S31Attack(event):
	targetspot = Get_ObjectPos('time_master_p')
	addMoveGoal('mon_33',targetspot,radius=30)
def S32Spawn(event):
	mon34 = PickAMonster()
	spawn('mon_34',mon34,'s32_spawn_point')
	regDeath('mon_34','AWaveKill')
#	Object_PlayEffect('s32_standin', 'effect_portal_close', '',FX_TRACK_OBJECT_ROT)
	regTimer('S32Attack',.5)
def S32Attack(event):
	targetspot = Get_ObjectPos('time_master_p')
	addMoveGoal('mon_34',targetspot,radius=30)
	regTimer('M35Start',2)

def M35Start(event):
	StandardWarpEffect(Get_MarkerPos('m35'))
	playEffectMarker('effect_entropy_spawn', 'm35', key = 'spawn', keyFn = 'M35Spawn')
#	Object_PlayEffect('m35_standin', 'effect_portal_open', 'M35Spawn',FX_TRACK_OBJECT_ROT)
def M35Spawn(event):
	mon35 = PickAMonster()
	spawn('mon_35',mon35,'m35')
	regDeath('mon_35','AWaveKill')
#	Object_PlayEffect('m32_standin', 'effect_portal_close', '',FX_TRACK_OBJECT_ROT)
	regTimer('M35Attack',.5)
def M35Attack(event):
	targetspot = Get_ObjectPos('time_master_p')
	addMoveGoal('mon_35',targetspot,radius=30)
	regTimer('M36Start',2)
def M36Start(event):
	StandardWarpEffect(Get_MarkerPos('m36'))
	playEffectMarker('effect_entropy_spawn', 'm36', key = 'spawn', keyFn = 'M36Spawn')
#	Object_PlayEffect('m36_standin', 'effect_portal_open', 'M36Spawn',FX_TRACK_OBJECT_ROT)
def M36Spawn(event):
	mon36 = PickAMonster()
	spawn('mon_36',mon36,'m36')
	regDeath('mon_36','AWaveKill')
#	Object_PlayEffect('m36_standin', 'effect_portal_close', '',FX_TRACK_OBJECT_ROT)
	regTimer('M36Attack',.5)
def M36Attack(event):
	targetspot = Get_ObjectPos('time_master_p')
	addMoveGoal('mon_36',targetspot,radius=30)
	regTimer('M37Start',2)
def M37Start(event):
	StandardWarpEffect(Get_MarkerPos('m37'))
	playEffectMarker('effect_entropy_spawn', 'm37', key = 'spawn', keyFn = 'M37Spawn')
#	Object_PlayEffect('m37_standin', 'effect_portal_open', 'M37Spawn',FX_TRACK_OBJECT_ROT)
def M37Spawn(event):
	mon37 = PickAMonster()
	spawn('mon_37',mon37,'m37')
	regDeath('mon_37','AWaveKill')
#	Object_PlayEffect('m37_standin', 'effect_portal_close', '',FX_TRACK_OBJECT_ROT)
	regTimer('M37Attack',.5)
def M37Attack(event):
	targetspot = Get_ObjectPos('time_master_p')
	addMoveGoal('mon_37',targetspot,radius=30)
	regTimer('M38Start',2)
def M38Start(event):
	StandardWarpEffect(Get_MarkerPos('m38'))
	playEffectMarker('effect_entropy_spawn', 'm38', key = 'spawn', keyFn = 'M38Spawn')
#	Object_PlayEffect('m38_standin', 'effect_portal_open', 'M38Spawn',FX_TRACK_OBJECT_ROT)
def M38Spawn(event):
	mon38 = PickAMonster()
	spawn('mon_38',mon38,'m38')
	regDeath('mon_38','AWaveKill')
#	Object_PlayEffect('m38_standin', 'effect_portal_close', '',FX_TRACK_OBJECT_ROT)
	regTimer('M38Attack',.5)
def M38Attack(event):
	targetspot = Get_ObjectPos('time_master_p')
	addMoveGoal('mon_38',targetspot,radius=30)




def AWaveKill(event):
	addAttr('wave_dead',1)
	print "current wave dead: "
	print Mission_GetAttr('wave_dead')
	if Mission_GetAttr('wave_dead') == 5:
		ArrowBaddies()
	if Mission_GetAttr('wave_dead') == Mission_GetAttr('wave_total'):
		Mission_SetAttr('wave_dead', 0)
		if Mission_GetAttr('first_wave_down') == 0:
			FirstWaveDown(event)
		elif Mission_GetAttr('second_wave_down') == 0:
			SecondWaveDown(event)
		elif Mission_GetAttr('third_wave_down') == 0:
			ThirdWaveDown(event)
		else:
			print "problem in AWaveKill?"

def ArrowBaddies():
	arrownum = 1
	baddies = getAllBaddies()
	for bad in baddies:
		if Object_IsAlive(bad) and (not Object_GetTemplate(bad) == 'entropy'):
			addArrow("arrow_"+str(int(arrownum)),bad,ARROW_RED,1)
			arrownum = arrownum + 1



def FirstWaveUp(event):
	addArrow('en_arrow','entropy',ARROW_RED,1)
	r1threshhold = (2.0/3.0)*Mission_GetAttr('entropy_basehp')
	print r1threshhold
	regAlmostDead('entropy','FirstRetreat',r1threshhold)
	Mission_SetAttr('wave_total',8)
	targetspot = Get_ObjectPos('time_master_p')
	addMoveGoal('mon_11',targetspot,radius=30)
	addMoveGoal('mon_12',targetspot,radius=30)
	addMoveGoal('mon_13',targetspot,radius=30)
	addMoveGoal('mon_14',targetspot,radius=30)
	regTimer('M15Start',2)
def FirstRetreat(event):
	if not Mission_GetAttr('third_wave_up') == 1:
		play (first_retreat_ss,'first_retreat_ss')
		Mission_SetAttr('played_first_retreat',1)
		StandardWarpEffect(Get_ObjectPos('entropy'))
		Object_PlayEffect('entropy','effect_entropy_spawn')
		#AI_SetEnabled('entropy',0)
		#teleport('entropy','green_room_marker')
		Object_Destroy('entropy')



def FirstWaveDown(event):
	#teleport('entropy','entrance_marker')
	if not Object_IsAlive('entropy'):
		spawn('entropy','entropy','entrance_marker')
		addArrow('en_arrow','entropy',ARROW_RED,1)
		StandardWarpEffect(Get_ObjectPos('entropy'))
		Object_PlayEffect('entropy','effect_entropy_spawn')
	AI_SetEnabled('entropy',1)
	play(first_wave_down_ss,'first_wave_down_ss')
	newhealth = Mission_GetAttr('entropy_basehp') * (3.0/4.0)
	Object_SetAttr('entropy','health',newhealth)
	r2threshhold = (1.0/3.0)*Mission_GetAttr('entropy_basehp')
	print r2threshhold
	regAlmostDead('entropy','SecondRetreat',r2threshhold)
	Mission_SetAttr('first_wave_down', 1)
	AI_Animate('entropy','active_defence')
	Mission_SetAttr('second_wave_up', 1)
	playEffectMarker('effect_entropy_spawn', 'w21_spawn_point', key = 'spawn', keyFn = 'W21Spawn')
	playEffectMarker('effect_entropy_spawn', 'w22_spawn_point', key = 'spawn', keyFn = 'W22Spawn')
	playEffectMarker('effect_entropy_spawn', 's21_spawn_point', key = 'spawn', keyFn = 'S21Spawn')
	playEffectMarker('effect_entropy_spawn', 's22_spawn_point', key = 'spawn', keyFn = 'S22Spawn')
	StandardWarpEffect(Get_MarkerPos('w21_spawn_point'))
	StandardWarpEffect(Get_MarkerPos('w22_spawn_point'))
	StandardWarpEffect(Get_MarkerPos('s21_spawn_point'))
	StandardWarpEffect(Get_MarkerPos('s22_spawn_point'))
#	Object_PlayEffect('w21_standin', 'effect_portal_open', 'W21Spawn',FX_TRACK_OBJECT_ROT)
#	Object_PlayEffect('w22_standin', 'effect_portal_open', 'W22Spawn',FX_TRACK_OBJECT_ROT)
#	Object_PlayEffect('s21_standin', 'effect_portal_open', 'S21Spawn',FX_TRACK_OBJECT_ROT)
#	Object_PlayEffect('s22_standin', 'effect_portal_open', 'S22Spawn',FX_TRACK_OBJECT_ROT)
	Mission_SetAttr('wave_total',8)
def SecondRetreat(event):
	if not Mission_GetAttr('third_wave_up') == 1:
		StandardWarpEffect(Get_ObjectPos('entropy'))
		Object_PlayEffect('entropy','effect_entropy_spawn')
		#teleport('entropy','green_room_marker')
		#AI_SetEnabled('entropy',0)
		Object_Destroy('entropy')
		if Mission_GetAttr('played_first_retreat') == 1:
			play(second_retreat_ss,'second_retreat_ss')
		else:
			play (first_retreat_ss,'first_retreat_ss')


def SecondWaveDown(event):
	#teleport('entropy','entrance_marker')
	if not Object_IsAlive('entropy'):
		spawn('entropy','entropy','entrance_marker')
		addArrow('en_arrow','entropy',ARROW_RED,1)
		StandardWarpEffect(Get_ObjectPos('entropy'))
		Object_PlayEffect('entropy','effect_entropy_spawn')
	AI_SetEnabled('entropy',1)
	play(second_wave_down_ss,'second_wave_down_ss')
	newhealth = Mission_GetAttr('entropy_basehp') * (1.0/2.0)
	Object_SetAttr('entropy','health',newhealth)
	regAlmostDead('entropy','EntropyDown',1)
	Mission_SetAttr('second_wave_down', 1)
	AI_Animate('entropy','active_defence')
	Mission_SetAttr('third_wave_up', 1)
	playEffectMarker('effect_entropy_spawn', 'w31_spawn_point', key = 'spawn', keyFn = 'W31Spawn')
	playEffectMarker('effect_entropy_spawn', 'w32_spawn_point', key = 'spawn', keyFn = 'W32Spawn')
	playEffectMarker('effect_entropy_spawn', 's31_spawn_point', key = 'spawn', keyFn = 'S31Spawn')
	playEffectMarker('effect_entropy_spawn', 's32_spawn_point', key = 'spawn', keyFn = 'S32Spawn')
	StandardWarpEffect(Get_MarkerPos('w31_spawn_point'))
	StandardWarpEffect(Get_MarkerPos('w32_spawn_point'))
	StandardWarpEffect(Get_MarkerPos('s31_spawn_point'))
	StandardWarpEffect(Get_MarkerPos('s32_spawn_point'))
#	Object_PlayEffect('w31_standin', 'effect_portal_open', 'W31Spawn',FX_TRACK_OBJECT_ROT)
#	Object_PlayEffect('w32_standin', 'effect_portal_open', 'W32Spawn',FX_TRACK_OBJECT_ROT)
#	Object_PlayEffect('s31_standin', 'effect_portal_open', 'S31Spawn',FX_TRACK_OBJECT_ROT)
#	Object_PlayEffect('s32_standin', 'effect_portal_open', 'S32Spawn',FX_TRACK_OBJECT_ROT)
	Mission_SetAttr('wave_total',8)


def ThirdWaveDown(event):
#	teleport('entropy','entrance_marker')
#	play(third_wave_down_ss,'third_wave_down_ss')
	Mission_SetAttr('third_wave_down', 1)

def EntropyDown(event):
	print "Entropy is interrogatable"
	makeSafeCriticalCustomFn('entropy')
	AI_SetEnabled('entropy',0)
def interrogate_entropy_fn(event):
	play(final_cs,'final_cs')


def TMFlee(event):
	teleport('time_master_p','green_room_marker')


def TMDown(event):
	play(tm_down_cs,'tm_down_cs')


def OnMissionWon():
	print "timemaster/won"

def OnMissionLost():
	print "timemaster/lost"


#										 #
# cutscenes and scripted sequences below  #
#										 #


start_cs = [
(
	"peace()",
	"startCS()",
	"look('entrance_marker', zoom = -250, heading = 70, time = 0)",
	"wait(.02)",
),
(
	"Sound_PlayMusic('music_12dis_cs1')",
	"speak('entropy', 'MISSPCH_20_EN_08')",
),
(
	"look('time_master_p', zoom = 0, heading = 0, time = 2)",
	"forceSpeak('time_master', 'MISSPCH_20_TM_04',telepathy=0)",
),
(
	"AI_Animate('time_master_p','area')",
	"playEffectMarker('effect_entropy_spawn', 'twin1_spawn_point', key = 'spawn', keyFn = 'Twin1Spawn2')",
	"ff.StandardWarpEffect(Get_MarkerPos('twin1_spawn_point'))",
	"regTimer('Twin2Start',.2)",
	"#Object_PlayEffect('twin1_standin', 'effect_portal_open', 'Twin1Spawn',FX_TRACK_OBJECT_ROT)",
	"wait(2)",
),
(
	"peace()",
	"look('entropy', zoom = -250, heading = 70, time = 2)",
	"speak('entropy', 'MISSPCH_20_EN_09')",
),
(
	"peace()",
	"AI_Animate('entropy','active_defence')",
	"playEffectMarker('effect_entropy_spawn', 'w11_spawn_point', key = 'spawn', keyFn = 'W11Spawn')",
	"playEffectMarker('effect_entropy_spawn', 'w12_spawn_point', key = 'spawn', keyFn = 'W12Spawn')",
	"playEffectMarker('effect_entropy_spawn', 's11_spawn_point', key = 'spawn', keyFn = 'S11Spawn')",
	"playEffectMarker('effect_entropy_spawn', 's12_spawn_point', key = 'spawn', keyFn = 'S12Spawn')",
	"ff.StandardWarpEffect(Get_MarkerPos('w11_spawn_point'))",
	"ff.StandardWarpEffect(Get_MarkerPos('w12_spawn_point'))",
	"ff.StandardWarpEffect(Get_MarkerPos('s11_spawn_point'))",
	"ff.StandardWarpEffect(Get_MarkerPos('w12_spawn_point'))",
	"#Object_PlayEffect('w11_standin', 'effect_portal_open', 'W11Spawn',FX_TRACK_OBJECT_ROT)",
	"#Object_PlayEffect('w12_standin', 'effect_portal_open', 'W12Spawn',FX_TRACK_OBJECT_ROT)",
	"#Object_PlayEffect('s11_standin', 'effect_portal_open', 'S11Spawn',FX_TRACK_OBJECT_ROT)",
	"#Object_PlayEffect('s12_standin', 'effect_portal_open', 'S12Spawn',FX_TRACK_OBJECT_ROT)",
	"wait(1)",
),
(
	"peace()",
	"speak('entropy', 'MISSPCH_20_EN_10')",
),
(
	"Mission_SetAttr('cs_playing',0)",
	"endCS()",
	"war()",
	"Sound_PlayMusic('music_12tm1')",
	"newObjective('primary', 2, name='entropy')",
	"newObjective('primary', 3, name='tm')",
	"regTimer('FirstWaveUp',.5)",
),
]



first_retreat_ss = [
(
	"speak('mentor', 'MISSPCH_20_ME_08')",
),
(
	"forceSpeak('time_master', 'MISSPCH_20_TM_14',telepathy=0)",
),
(
	"blank",
),
]

first_wave_down_ss = [
(
	"speak('entropy', 'MISSPCH_20_EN_11')",
),
(
	"speak('mentor', 'MISSPCH_20_ME_09')",
),
(
	"blank",
),
]


second_retreat_ss = [
(
	"speak('entropy', 'MISSPCH_20_EN_21')",
),
(
	"blank",
),
]

second_wave_down_ss = [
(
	"speak('entropy', 'MISSPCH_20_EN_14')",
),
(
	"speak('mentor', 'MISSPCH_20_ME_10')",
),
(
	"blank",
),
]



tm_down_cs = [
(
	"peace()",
	"startCS()",
	"look('time_master_p', zoom = 0, heading = 0, time = 0)",
	"forceSpeak('time_master','MISSPCH_20_TM_08',telepathy=0)",
),
(
	"speak('entropy','MISSPCH_20_EN_19')",
),
(
	"Objective_Fail('tm')",
	"endCS()",
	"Mission_Lose()",
),
]


final_cs = [
(
	"playTransition()",
	"peace()",
	"startCS()",
	"see()",
	"normalize('entropy')",
	"removeArrow('en_arrow')",
	"removeArrow('arrow_1')",
	"removeArrow('arrow_2')",
	"removeArrow('arrow_3')",
	"teleport('entropy','entrance_marker')",
	"teleport('time_master_p','tm_end_marker')",
	"Sound_PlayMusic('music_05berlin_cs5a',1)",
),
(
	"look('time_master_p', zoom = 0, heading = 0, time = 0)",
	"forceSpeak('time_master','MISSPCH_20_TM_05',telepathy=0)",
),
(
	"look('entropy', zoom = -250, heading = 70, time = 2)",
	"speak('entropy','MISSPCH_20_EN_16')",
),
(
	"Trigger_Power('entropy','time_master_p','entropy Potential Transfer','')",
	"look('time_master_p', zoom = 0, heading = 0, time = 2)",
	"forceSpeak('time_master','MISSPCH_20_TM_06',telepathy=0)",
),
(
	"Trigger_Power('entropy','time_master_p','entropy Potential Transfer','')",
	"look('entropy', zoom = -250, heading = 70, time = 2)",
	"speak('entropy','MISSPCH_20_EN_17')",
),
(
	"Trigger_Power('entropy','time_master_p','entropy Potential Transfer','')",
	"look('time_master_p', zoom = 0, heading = 0, time = 2)",
	"forceSpeak('time_master','MISSPCH_20_TM_07',telepathy=0)",
),
(
	"playEffectMarker('effect_entropy_spawn', 'tm_end_marker', key = 'spawn', keyFn = 'TMFlee')",
	"ff.StandardWarpEffect(Get_MarkerPos('tm_end_marker'))",
	"look('entropy', zoom = -250, heading = 70, time = 2)",
	"speak('entropy','MISSPCH_20_EN_18')",
),
(
	"Objective_Fail('entropy')",
	"Objective_Complete('tm')",
	"#2D CS here???",
	"blind()",
	"endCS()",
	"Mission_Win()",
),
]
