# manbot

from cshelper import *
from js import *
import event

def OnIntermission():
	Mission_Play2DCutscene('cutscene_manbot_int', 'cutscene_manbot_int_wav1')

def OnPostInit():
	print 'manbot base/start'
	#CS stuff
	lookAtPos((-13,320,-6), zoom = -122.2, heading = -35.7)
	AI_Animate('man_bot', 'get_up_back', '', 0, 1)
	Mission_SetSunlight(-137,57,1.5,0.2,(0.2,0.2,0.6))
	Mission_SetShadows(-137,57,(0.2,0.2,0.4))
	playEffectMarker('building_smoke', 'smoke_pos1', flags = FX_LOOP)
	playEffectMarker('effect_fire', 'smoke_pos2', flags = FX_LOOP)
	playEffectMarker('effect_fire', 'smoke_pos3', flags = FX_LOOP)

	Campaign_UnRecruit('alchemiss')
	Campaign_UnlockOrigin('alchemiss')
	Campaign_UnRecruit('el_diablo')
	Campaign_UnlockOrigin('el_diablo')
	Campaign_UnRecruit('mentor')
	Campaign_UnlockOrigin('mentor')
	Campaign_Recruit('minute_man')
	Campaign_UnlockOrigin('minute_man')
	Campaign_AddHero ('liberty_lad')
	Campaign_UnlockOrigin('liberty_lad')
	Campaign_Recruit('tombstone')
	Campaign_UnlockOrigin('tombstone')
	Campaign_Recruit('bullet')
	Campaign_UnlockOrigin('bullet')
	Campaign_AddHero ('green_genie')
	Campaign_UnlockOrigin('green_genie')
	Campaign_AddHero ('quetzalcoatl')
	Campaign_UnlockOrigin('quetzalcoatl')
	Campaign_Recruit('the_ant')
	Campaign_UnlockOrigin('the_ant')
	Campaign_UnRecruit('eve')
	Campaign_UnlockOrigin('eve')
	Campaign_Recruit('microwave')
	Campaign_UnRecruit('supercollider')
	Campaign_Recruit('black_jack')
	Campaign_UnlockOrigin('black_jack')
	Campaign_AddHero ('law')
	Campaign_UnlockOrigin('law')
	Campaign_AddHero ('order')
	Campaign_UnlockOrigin('order')
	Campaign_UnRecruit ('ironox')
	Campaign_AddHero ('man_o_war')
	Campaign_UnlockOrigin('man_o_war')
	Campaign_AddHero ('sea_urchin')
	Campaign_UnlockOrigin('sea_urchin')
	Campaign_Recruit('tricolour')
	Campaign_UnlockOrigin('tricolour')
	Campaign_AddHero ('blackbird')
	Campaign_Recruit('sky_king')
	Campaign_UnlockOrigin('sky_king')
	Campaign_Recruit('man_bot')
	Campaign_UnlockOrigin('man_bot')
	Campaign_AddHero ('the_bard')

	Campaign_AddMinion('thug_with_bat')
	Campaign_AddMinion('thug_with_gun')
	Campaign_AddVillain('nuclear_winter')
	Campaign_AddVillain('time_master')
	Campaign_AddMinion('ice_trooper')
	Campaign_AddMinion('ice_sergeant')
	Campaign_AddMinion('snow_man')
	Campaign_AddMinion('shurale')
	Campaign_AddVillain('red_oktober')
	Campaign_AddMinion('dark_shaman')
	Campaign_AddVillain('frozen_giant')
	Campaign_AddMinion('nazi_rifleman')
	Campaign_AddMinion('legionnaire')
	Campaign_AddVillain('fortissimo')
	Campaign_AddVillain('red_sun')
	Campaign_AddMinion('nazi_gunner')
	Campaign_AddMinion('nazi_grenadier')
	Campaign_AddMinion('killarilla_whip')
	Campaign_AddMinion('killarilla_chaingun')
	Campaign_AddMinion('nazi_general')
	Campaign_AddMinion('eye_minor')
	Campaign_AddMinion('centurion')
	Campaign_AddMinion('eye_major')
	Campaign_AddVillain('blitzkrieg')
	Campaign_AddMinion('wraith_warrior')
	Campaign_AddMinion('trex')
	Campaign_AddMinion('fire_elemental')
	Campaign_AddMinion('subterrestrial')
	Campaign_AddMinion('wraith_manta')
	Campaign_AddMinion('time_master_elec')
	Campaign_AddMinion('time_master_energy')
	Campaign_AddMinion('time_master_radiation')
	Campaign_AddVillain('entropy')
	Campaign_AddMinion('cop_crooked')
	Campaign_AddMinion('alien_warrior')
	Campaign_AddMinion('mafioso')
	Campaign_AddMinion('bacchite_green')
	Campaign_AddMinion('mech_man')
	Campaign_AddMinion('ice_queen')
	Campaign_AddMinion('cop_crooked')

def OnBriefing():
	play(briefing_cs)
	print 'manbot base/briefing'


#-----------
# data
#-----------

briefing_cs = [
(
	"startCS()",
	"lookAtPos((-13,320,-6), zoom = -222.2, heading = -35.7)",
	"wait(1)",
),
(
	"speak('man_bot', 'BRFSPCH_21_MB_09')", #She's down! this is our...
	"AI_Animate('man_bot', 'melee_idle', '', 0, 1)",
),
(
	"endBriefingCS()",
),
]

