# manbot
### TODO
### start CS staging
### final cs?

from cshelper import *
from js import *
import event
from random import randint
from ffx import *

building_demo_list = [87,64,52,57,41,77,65,63,30,34,16,15,5,11,19,35,25,61,54,40,33,9,23,6,47,36,59,29,24,12]

def OnPreRendererCreate():
	ff.RENDER_WARP = 1

def OnPrecacheObjects():
	print "manbot/precache"
	Mission_PrecacheTemplateObj('entropy',1,1)
	Mission_PrecacheTemplateObj('time_master',1,1)
	Mission_PrecacheTemplateObj('wraith_warrior',0,1)
	Mission_PrecacheTemplateObj('wraith_manta',0,1)
	Mission_PrecacheTemplateObj('subterrestrial',0,1)
	Mission_PrecacheTemplateObj('time_master_elec',0,1)
	Mission_PrecacheTemplateObj('time_master_energy',0,1)
	Mission_PrecacheTemplateObj('time_master_radiation',0,1)

def OnPostInit():
	print "manbot/start"
	setMission(21)
	
	Mission_SetSunlight(-137,57,1.5,0.2,(0.2,0.2,0.6))
	Mission_SetShadows(-137,57,(0.2,0.2,0.4))
	Mission_SetProjShadowBackground((1,1,1))
	Mission_SetProjShadowColor((.6,.6,.6,1))

	Mission_SetAttr('building_index',0)
	Mission_SetAttr('wave_dead',0)
	Mission_SetAttr('wave_total',2)
	Mission_SetAttr('entropy_phase',1)
	Mission_SetAttr('tm_fighting',0)

	spawn('entropy1_standin','fx_standin','entropy_spot1')
	spawn('entropy2_standin','fx_standin','entropy_spot2')
	spawn('entropy3_standin','fx_standin','entropy_spot3')
	spawn('entropy4_standin','fx_standin','entropy_spot4')
	spawn('entropy5_standin','fx_standin','entropy_spot5')
	spawn('entropy6_standin','fx_standin','entropy_spot6')
	spawn('tm_standin','fx_standin','tm_spawn_point')
	spawn('tt1_standin','fx_standin','tt_spawn_point1')
	spawn('tt2_standin','fx_standin','tt_spawn_point2')
	spawn('tt3_standin','fx_standin','tt_spawn_point3')
	spawn('tt4_standin','fx_standin','tt_spawn_point4')
	spawn('tt5_standin','fx_standin','tt_spawn_point5')
	spawn('tt6_standin','fx_standin','tt_spawn_point6')
	spawn('tt7_standin','fx_standin','tt_spawn_point7')
	spawn('tt8_standin','fx_standin','tt_spawn_point8')
	spawn('tt9_standin','fx_standin','tt_spawn_point9')
	spawn('tt10_standin','fx_standin','tt_spawn_point10')
	spawn('tt11_standin','fx_standin','tt_spawn_point11')
	spawn('tt12_standin','fx_standin','tt_spawn_point12')
	spawn('w11_standin','fx_standin','w11_spawn_point')
	spawn('w12_standin','fx_standin','w12_spawn_point')
	spawn('w21_standin','fx_standin','w21_spawn_point')
	spawn('w22_standin','fx_standin','w22_spawn_point')
	spawn('w23_standin','fx_standin','w23_spawn_point')
	spawn('w31_standin','fx_standin','w31_spawn_point')
	spawn('w32_standin','fx_standin','w32_spawn_point')
	spawn('s31_standin','fx_standin','s31_spawn_point')
	spawn('s32_standin','fx_standin','s32_spawn_point')
	spawn('w41_standin','fx_standin','w41_spawn_point')
	spawn('w42_standin','fx_standin','w42_spawn_point')
	spawn('s41_standin','fx_standin','s41_spawn_point')
	spawn('s42_standin','fx_standin','s42_spawn_point')
	spawn('w51_standin','fx_standin','w51_spawn_point')
	spawn('w52_standin','fx_standin','w52_spawn_point')
	spawn('s51_standin','fx_standin','s51_spawn_point')
	spawn('s52_standin','fx_standin','s52_spawn_point')
	spawn('w61_standin','fx_standin','w61_spawn_point')
	spawn('w62_standin','fx_standin','w62_spawn_point')
	spawn('s61_standin','fx_standin','s61_spawn_point')
	spawn('s62_standin','fx_standin','s62_spawn_point')
	spawn('u63_standin','fx_standin','u63_spawn_point')

	Mission_SetAttr('wave_id',1)
	Mission_SetAttr('w11s11_anim_count',0)
	Mission_SetAttr('w11s12_anim_count',0)
	Mission_SetAttr('w12s11_anim_count',0)
	Mission_SetAttr('w12s12_anim_count',0)

	Mission_SetAttr('distance_check',250)
	Mission_SetAttr('prox_w11_s11', 0)
	Mission_SetAttr('prox_w12_s11', 0)
	Mission_SetAttr('prox_w11_s12', 0)
	Mission_SetAttr('prox_w12_s12', 0)

	Mission_SetAttr('prox_warning_delay', 30)

	Mission_SetAttr('entropy_basehp',Object_GetAttr('entropy','health'))

	ff.RENDER_WARP = 1
	regDeath('man_bot','ManbotDown')
	r1threshhold = (4.0/5.0)*Mission_GetAttr('entropy_basehp')
	print r1threshhold
	regAlmostDead('entropy','Retreat2',r1threshhold)
#	regAlmostDead('entropy','Retreat2',400)
	play(start_cs,'start_cs')
	FFX_InitMission()


def StandardWarpEffect(pos):
	Mission_SetWaveEnvelope(1, 0.35, 3, 0.35, 3, 1)
	Mission_SetWaveSinParams(1, 4, 0.04, 1)
	Mission_StartWave(1, 3, 1, pos)



def EntropyToSpot1(event):
	print "entropy goes to spot 1"
	teleport('entropy','entropy_spot1')
	Object_PlayEffect('entropy1_standin', 'effect_portal_close', '',FX_TRACK_OBJECT_ROT)
	StandardWarpEffect(Get_MarkerPos('entropy_spot1'))

def Retreat1(event):
	teleport('entropy','entropy_spot2')
	StandardWarpEffect(Get_MarkerPos('entropy_spot2'))
	AI_SetEnabled('entropy',0)
	regHeroMarkerEnter('entropy_spot2','Wave2Setup')
	regTimer('Buildings1',10)
	regTimer('Retreat1A',3)
def Retreat1A(event):
	regDamage('entropy','Wave2SetupTest')

def Wave2SetupTest(event):
	print "Triggered Entropy Damage Test"
	if event.data < 0:
		Wave2Setup(event)
	else:
		print "just healing"
		regDamage('entropy','Wave2SetupTest')
def Wave2Setup(event):
	regTimer('Wave2Setup2',2)
def Wave2Setup2(event):
	print "starting wave 2"
	if Mission_GetAttr('entropy_phase') == 1:
		CleanWave()
		AI_SetEnabled('entropy',1)
#		regAlmostDead('entropy','Retreat2',400)
		Mission_SetAttr('entropy_phase', 2)
		AI_Animate('entropy','active_defence')
		Object_PlayEffect('w21_standin', 'effect_portal_open', 'W21Spawn',FX_TRACK_OBJECT_ROT)
		StandardWarpEffect(Get_ObjectPos('w21_standin'))
		Object_PlayEffect('w22_standin', 'effect_portal_open', 'W22Spawn',FX_TRACK_OBJECT_ROT)
		StandardWarpEffect(Get_ObjectPos('w22_standin'))
		Object_PlayEffect('w23_standin', 'effect_portal_open', 'W23Spawn',FX_TRACK_OBJECT_ROT)
		StandardWarpEffect(Get_ObjectPos('w23_standin'))
		Mission_SetAttr('wave_total',3)
		regTimer('Buildings2',15)
	else:
		print "already set up phase 2"
def Retreat2(event):
	if Mission_GetAttr('entropy_phase') < 3:
		play(retreat_2_ss,'retreat_2_ss')
		teleport('entropy','entropy_spot4')
		StandardWarpEffect(Get_MarkerPos('entropy_spot4'))
		AI_SetEnabled('entropy',0)
		regHeroMarkerEnter('entropy_spot4','Wave4Setup')
		regTimer('Retreat2A',.1)
	else:
		print "already in phase 4"
def Retreat2A(event):
		regDamage('entropy','Wave4SetupTest')

# wave 3 cut
#def Wave3SetupTest(event):
#	print "Triggered Entropy Damage Test 3"
#	if event.data < 0:
#		Wave3Setup(event)
#	else:
#		print "just healing 3"
#def Wave3Setup(event):
#	regTimer('Wave3Setup2',2)
#def Wave3Setup2(event):
#	print "starting wave 3"
#	if Mission_GetAttr('entropy_phase') == 2:
#		teleport('entropy','entropy_spot3')
#		CleanWave()
#		AI_SetEnabled('entropy',1)
#		regAlmostDead('entropy','Retreat3',300)
#		Mission_SetAttr('entropy_phase', 3)
#		AI_Animate('entropy','active_defence')
#		ff.Buildings3(event)
#		Object_PlayEffect('w31_standin', 'effect_portal_open', 'W31Spawn',FX_TRACK_OBJECT_ROT)
#		Object_PlayEffect('w32_standin', 'effect_portal_open', 'W32Spawn',FX_TRACK_OBJECT_ROT)
#		Object_PlayEffect('s31_standin', 'effect_portal_open', 'S31Spawn',FX_TRACK_OBJECT_ROT)
#		Object_PlayEffect('s32_standin', 'effect_portal_open', 'S32Spawn',FX_TRACK_OBJECT_ROT)
#		Mission_SetAttr('wave_total',4)
#	else:
#		print "already set up phase 3"
#def Retreat3(event):
#	if Mission_GetAttr('entropy_phase') == 3:
#		teleport('entropy','entropy_spot4')
#		AI_SetEnabled('entropy',0)
#		regTimer('Retreat3A',3)
#		regHeroMarkerEnter('entropy_spot4','Wave4Setup')
#	else:
#		print "already in phase 4"
#def Retreat3A(event):
#		regDamage('entropy','Wave4SetupTest')

def Wave4SetupTest(event):
	print "Triggered Entropy Damage Test 4"
	if event.data < 0:
		Wave4Setup(event)
	else:
		print "just healing 4"
		regDamage('entropy','Wave4SetupTest')
def Wave4Setup(event):
	regTimer('Wave4Setup2',2)
def Wave4Setup2(event):
	print "starting wave 4"
#	if Mission_GetAttr('entropy_phase') == 3:
# nope, we come here from phase 2 now
	if Mission_GetAttr('entropy_phase') < 4:
		teleport('entropy','entropy_spot4')
		StandardWarpEffect(Get_MarkerPos('entropy_spot4'))
		CleanWave()
		AI_SetEnabled('entropy',1)
		r2threshhold = (3.0/5.0)*Mission_GetAttr('entropy_basehp')
		print r2threshhold
		regAlmostDead('entropy','Retreat4',r2threshhold)
#		regAlmostDead('entropy','Retreat4',300)
		Mission_SetAttr('entropy_phase', 4)
		AI_Animate('entropy','active_defence')
		Object_PlayEffect('w41_standin', 'effect_portal_open', 'W41Spawn',FX_TRACK_OBJECT_ROT)
		StandardWarpEffect(Get_ObjectPos('w41_standin'))
		Object_PlayEffect('w42_standin', 'effect_portal_open', 'W42Spawn',FX_TRACK_OBJECT_ROT)
		StandardWarpEffect(Get_ObjectPos('w42_standin'))
		Object_PlayEffect('s41_standin', 'effect_portal_open', 'S41Spawn',FX_TRACK_OBJECT_ROT)
		StandardWarpEffect(Get_ObjectPos('s41_standin'))
		Object_PlayEffect('s42_standin', 'effect_portal_open', 'S42Spawn',FX_TRACK_OBJECT_ROT)
		StandardWarpEffect(Get_ObjectPos('s42_standin'))
		Mission_SetAttr('wave_total',4)
	else:
		print "already set up phase 4"
def Retreat4(event):
	if Mission_GetAttr('entropy_phase') < 5:
		play(retreat_4_ss,'retreat_4_ss')
		teleport('entropy','entropy_spot5')
		StandardWarpEffect(Get_MarkerPos('entropy_spot5'))
		AI_SetEnabled('entropy',0)
		regTimer('Retreat4A',3)
		regHeroMarkerEnter('entropy_spot5','Wave5Setup')
	else:
		print "already in phase 5"
def Retreat4A(event):
		regDamage('entropy','Wave5SetupTest')

def Wave5SetupTest(event):
	print "Triggered Entropy Damage Test 5"
	if event.data < 0:
		Wave5Setup(event)
	else:
		print "just healing 5"
		regDamage('entropy','Wave5SetupTest')
def Wave5Setup(event):
	regTimer('Wave5Setup2',2)
def Wave5Setup2(event):
	print "starting wave 5"
	if Mission_GetAttr('entropy_phase') < 5:
		teleport('entropy','entropy_spot5')
		StandardWarpEffect(Get_MarkerPos('entropy_spot5'))
		CleanWave()
		AI_SetEnabled('entropy',1)
		r3threshhold = (2.0/5.0)*Mission_GetAttr('entropy_basehp')
		print r3threshhold
		regAlmostDead('entropy','Retreat5',r3threshhold)
#		regAlmostDead('entropy','Retreat5',200)
		Mission_SetAttr('entropy_phase', 5)
		AI_Animate('entropy','active_defence')
		Object_PlayEffect('w51_standin', 'effect_portal_open', 'W51Spawn',FX_TRACK_OBJECT_ROT)
		StandardWarpEffect(Get_ObjectPos('w51_standin'))
		Object_PlayEffect('w52_standin', 'effect_portal_open', 'W52Spawn',FX_TRACK_OBJECT_ROT)
		StandardWarpEffect(Get_ObjectPos('w52_standin'))
		Object_PlayEffect('s51_standin', 'effect_portal_open', 'S51Spawn',FX_TRACK_OBJECT_ROT)
		StandardWarpEffect(Get_ObjectPos('s51_standin'))
		Object_PlayEffect('s52_standin', 'effect_portal_open', 'S52Spawn',FX_TRACK_OBJECT_ROT)
		StandardWarpEffect(Get_ObjectPos('s52_standin'))
		Mission_SetAttr('wave_total',4)
	else:
		print "already set up phase 5"
def Retreat5(event):
	if Mission_GetAttr('entropy_phase') < 6:
		play(retreat_5_ss,'retreat_5_ss')
		teleport('entropy','entropy_spot6')
		StandardWarpEffect(Get_MarkerPos('entropy_spot6'))
		AI_SetEnabled('entropy',0)
		regTimer('Retreat5A',3)
		regHeroMarkerEnter('entropy_spot6','Wave6Setup')
	else:
		print "already in phase 6"
def Retreat5A(event):
		regDamage('entropy','Wave6Setup')

def Wave6Setup(event):
	regTimer('Wave6Setup2',2)
def Wave6Setup2(event):
	print "starting wave 6"
	if Mission_GetAttr('entropy_phase') < 6:
		teleport('entropy','entropy_spot6')
		StandardWarpEffect(Get_MarkerPos('entropy_spot6'))
		CleanWave()
		AI_SetEnabled('entropy',1)
		regAlmostDead('entropy','InterrEntropySetup',1)
		Mission_SetAttr('entropy_phase', 6)
		AI_Animate('entropy','active_defence')
		Object_PlayEffect('w61_standin', 'effect_portal_open', 'W61Spawn',FX_TRACK_OBJECT_ROT)
		StandardWarpEffect(Get_ObjectPos('w61_standin'))
		Object_PlayEffect('w62_standin', 'effect_portal_open', 'W62Spawn',FX_TRACK_OBJECT_ROT)
		StandardWarpEffect(Get_ObjectPos('w62_standin'))
		Object_PlayEffect('s61_standin', 'effect_portal_open', 'S61Spawn',FX_TRACK_OBJECT_ROT)
		StandardWarpEffect(Get_ObjectPos('s61_standin'))
		Object_PlayEffect('s62_standin', 'effect_portal_open', 'S62Spawn',FX_TRACK_OBJECT_ROT)
		StandardWarpEffect(Get_ObjectPos('s62_standin'))
		Object_PlayEffect('u63_standin', 'effect_portal_open', 'U63Spawn',FX_TRACK_OBJECT_ROT)
		StandardWarpEffect(Get_ObjectPos('u63_standin'))
		Mission_SetAttr('wave_total',5)
	else:
		print "already set up phase 6"
def InterrEntropySetup(event):
	print "Entropy is interrogatable"
	Trigger_Move('entropy','land')
	AI_SetEnabled('entropy',0)
	makeSafeCriticalCustomFn('entropy',oneshot=1)
def interrogate_entropy_fn(event):
	play(entropy_down_cs,'entropy_down_cs')


def W11Spawn(event):
	spawn('wraith_1_1','wraith_warrior','w11_spawn_point')
	regDeath('wraith_1_1','AWaveKill')
	Object_PlayEffect('w11_standin', 'effect_portal_close', '',FX_TRACK_OBJECT_ROT)
	if isPlaying():
		peace()
def W12Spawn(event):
	spawn('wraith_1_2','wraith_warrior','w12_spawn_point')
	regDeath('wraith_1_2','AWaveKill')
	Object_PlayEffect('w12_standin', 'effect_portal_close', '',FX_TRACK_OBJECT_ROT)
	if isPlaying():
		peace()

# NOTE: all waves re-use the names from wave 1 to save on code bloat

def W21Spawn(event):
	spawn('wraith_1_1','wraith_warrior','w21_spawn_point')
	regDeath('wraith_1_1','AWaveKill')
	Object_PlayEffect('w21_standin', 'effect_portal_close', '',FX_TRACK_OBJECT_ROT)
def W22Spawn(event):
	spawn('wraith_1_2','wraith_warrior','w22_spawn_point')
	regDeath('wraith_1_2','AWaveKill')
	Object_PlayEffect('w22_standin', 'effect_portal_close', '',FX_TRACK_OBJECT_ROT)
def W23Spawn(event):
	spawn('wraith_1_3','wraith_warrior','w23_spawn_point')
	regDeath('wraith_1_3','AWaveKill')
	Object_PlayEffect('w23_standin', 'effect_portal_close', '',FX_TRACK_OBJECT_ROT)
	regTimer('Wave2Attack',1)
def Wave2Attack(event):
	targetspot = Get_ObjectPos('man_bot')
	Trigger_Move('wraith_1_1',"move",targetspot,'',20,0)
	Trigger_Move('wraith_1_2',"move",targetspot,'',20,0)
	Trigger_Move('wraith_1_3',"move",targetspot,'',20,0)


# wave 3 actually cut
def W31Spawn(event):
	spawn('wraith_1_1','wraith_warrior','w31_spawn_point')
	regDeath('wraith_1_1','AWaveKill')
	Object_PlayEffect('w31_standin', 'effect_portal_close', '',FX_TRACK_OBJECT_ROT)
def W32Spawn(event):
	spawn('wraith_1_2','wraith_warrior','w32_spawn_point')
	regDeath('wraith_1_2','AWaveKill')
	Object_PlayEffect('w32_standin', 'effect_portal_close', '',FX_TRACK_OBJECT_ROT)
def S31Spawn(event):
	spawn('sub_1_1','subterrestrial','s31_spawn_point')
	regDeath('sub_1_1','AWaveKill')
	Object_PlayEffect('s31_standin', 'effect_portal_close', '',FX_TRACK_OBJECT_ROT)
def S32Spawn(event):
	spawn('sub_1_2','subterrestrial','s32_spawn_point')
	regDeath('sub_1_2','AWaveKill')
	Object_PlayEffect('s32_standin', 'effect_portal_close', '',FX_TRACK_OBJECT_ROT)
	WaveProxChecks()

def W41Spawn(event):
	spawn('wraith_1_1','wraith_warrior','w41_spawn_point')
	regDeath('wraith_1_1','AWaveKill')
	Object_PlayEffect('w41_standin', 'effect_portal_close', '',FX_TRACK_OBJECT_ROT)
def W42Spawn(event):
	spawn('wraith_1_2','wraith_warrior','w42_spawn_point')
	regDeath('wraith_1_2','AWaveKill')
	Object_PlayEffect('w42_standin', 'effect_portal_close', '',FX_TRACK_OBJECT_ROT)
def S41Spawn(event):
	spawn('sub_1_1','subterrestrial','s41_spawn_point')
	regDeath('sub_1_1','AWaveKill')
	Object_PlayEffect('s41_standin', 'effect_portal_close', '',FX_TRACK_OBJECT_ROT)
def S42Spawn(event):
	spawn('sub_1_2','subterrestrial','s42_spawn_point')
	regDeath('sub_1_2','AWaveKill')
	Object_PlayEffect('s42_standin', 'effect_portal_close', '',FX_TRACK_OBJECT_ROT)
	WaveProxChecks()

def W51Spawn(event):
	spawn('wraith_1_1','wraith_warrior','w51_spawn_point')
	regDeath('wraith_1_1','AWaveKill')
	Object_PlayEffect('w51_standin', 'effect_portal_close', '',FX_TRACK_OBJECT_ROT)
def W52Spawn(event):
	spawn('wraith_1_2','wraith_warrior','w52_spawn_point')
	regDeath('wraith_1_2','AWaveKill')
	Object_PlayEffect('w52_standin', 'effect_portal_close', '',FX_TRACK_OBJECT_ROT)
def S51Spawn(event):
	spawn('sub_1_1','subterrestrial','s51_spawn_point')
	regDeath('sub_1_1','AWaveKill')
	Object_PlayEffect('s51_standin', 'effect_portal_close', '',FX_TRACK_OBJECT_ROT)
def S52Spawn(event):
	spawn('sub_1_2','subterrestrial','s52_spawn_point')
	regDeath('sub_1_2','AWaveKill')
	Object_PlayEffect('s52_standin', 'effect_portal_close', '',FX_TRACK_OBJECT_ROT)
	WaveProxChecks()

def W61Spawn(event):
	spawn('wraith_1_1','wraith_warrior','w61_spawn_point')
	regDeath('wraith_1_1','AWaveKill')
	Object_PlayEffect('w61_standin', 'effect_portal_close', '',FX_TRACK_OBJECT_ROT)
def W62Spawn(event):
	spawn('wraith_1_2','wraith_warrior','w62_spawn_point')
	regDeath('wraith_1_2','AWaveKill')
	Object_PlayEffect('w62_standin', 'effect_portal_close', '',FX_TRACK_OBJECT_ROT)
def S61Spawn(event):
	spawn('sub_1_1','subterrestrial','s61_spawn_point')
	regDeath('sub_1_1','AWaveKill')
	Object_PlayEffect('s61_standin', 'effect_portal_close', '',FX_TRACK_OBJECT_ROT)
def S62Spawn(event):
	spawn('sub_1_2','subterrestrial','s62_spawn_point')
	regDeath('sub_1_2','AWaveKill')
	Object_PlayEffect('s62_standin', 'effect_portal_close', '',FX_TRACK_OBJECT_ROT)
def U63Spawn(event):
	spawn('uber_1_3','wraith_manta','u63_spawn_point')
	regDeath('uber_1_3','AWaveKill')
	Object_PlayEffect('u63_standin', 'effect_portal_close', '',FX_TRACK_OBJECT_ROT)
	WaveProxChecks()


def WaveProxChecks():
	regTimer('WaveProxChecks2',.25)
def WaveProxChecks2(event):
	if Object_IsAlive('wraith_1_1') and Object_IsAlive('sub_1_1'):
		regProximityEnter('wraith_1_1','sub_1_1',25,'BoomW11S11',persistent=1)
	if Object_IsAlive('wraith_1_2') and Object_IsAlive('sub_1_1'):
		regProximityEnter('wraith_1_2','sub_1_1',25,'BoomW12S11',persistent=1)
	if Object_IsAlive('wraith_1_1') and Object_IsAlive('sub_1_2'):
		regProximityEnter('wraith_1_1','sub_1_2',25,'BoomW11S12',persistent=1)
	if Object_IsAlive('wraith_1_2') and Object_IsAlive('sub_1_2'):
		regProximityEnter('wraith_1_2','sub_1_2',25,'BoomW12S12',persistent=1)
	# This funtion also sends them back after manbot
	targetspot = Get_ObjectPos('man_bot')
	if Object_IsAlive('wraith_1_1'):
		js.Event_RegisterSink(EVENT_CHARACTER_STATE_CHANGED, 'WaveProxChecks2', 'wraith_1_1')
		js.Event_RegisterSink(EVENT_CHARACTER_SEC_STATE_CHANGED, 'WaveProxChecks2', 'wraith_1_1','',0,SCSTATE_POSSESSED)
		addMoveGoal('wraith_1_1', targetspot, fn = '', radius = 5, priority = ai.goal.PRI_ZERO-1)
	if Object_IsAlive('wraith_1_2'):
		js.Event_RegisterSink(EVENT_CHARACTER_STATE_CHANGED, 'WaveProxChecks2', 'wraith_1_2')
		js.Event_RegisterSink(EVENT_CHARACTER_SEC_STATE_CHANGED, 'WaveProxChecks2', 'wraith_1_2','',0,SCSTATE_POSSESSED)
		addMoveGoal('wraith_1_2', targetspot, fn = '', radius = 5, priority = ai.goal.PRI_ZERO-1)
	if Object_IsAlive('sub_1_1'):
		js.Event_RegisterSink(EVENT_CHARACTER_STATE_CHANGED, 'WaveProxChecks2', 'sub_1_1')
		js.Event_RegisterSink(EVENT_CHARACTER_SEC_STATE_CHANGED, 'WaveProxChecks2', 'sub_1_1','',0,SCSTATE_POSSESSED)
		addMoveGoal('sub_1_1', targetspot, fn = '', radius = 5, priority = ai.goal.PRI_ZERO-1)
	if Object_IsAlive('sub_1_2'):
		js.Event_RegisterSink(EVENT_CHARACTER_STATE_CHANGED, 'WaveProxChecks2', 'sub_1_2')
		js.Event_RegisterSink(EVENT_CHARACTER_SEC_STATE_CHANGED, 'WaveProxChecks2', 'sub_1_2','',0,SCSTATE_POSSESSED)
		addMoveGoal('sub_1_2', targetspot, fn = '', radius = 5, priority = ai.goal.PRI_ZERO-1)


def AWaveKill(event):
	addAttr('wave_dead',1)
	print "AWaveKill"
	print Mission_GetAttr('wave_dead')
	if Mission_GetAttr('wave_dead') == Mission_GetAttr('wave_total'):
		Mission_SetAttr('wave_dead', 0)
		addAttr('wave_id',1)
#		if Mission_GetAttr('entropy_phase') == 1:
#			Wave2Setup(event)
#		elif Mission_GetAttr('entropy_phase') == 2:
##			Wave3Setup(event)
## nope, we cut wave 3
##		elif Mission_GetAttr('entropy_phase') == 3:
#			Wave4Setup(event)
#		elif Mission_GetAttr('entropy_phase') == 4:
#			Wave5Setup(event)
#		elif Mission_GetAttr('entropy_phase') == 5:
#			Wave6Setup(event)
#		elif Mission_GetAttr('entropy_phase') == 6:
#			print "phase 6 done"
#		else:
#			print "problem in AWaveKill?"
def CleanWave():
	print "CleanWave()"
	Object_Destroy('wraith_1_1', 0)
	Object_Destroy('wraith_1_2', 0)
	Object_Destroy('wraith_1_3', 0)
	Object_Destroy('sub_1_1', 0)
	Object_Destroy('sub_1_2', 0)
	Object_Destroy('sub_1_3', 0)
	Object_Destroy('uber_1_1', 0)
#	Object_Destroy('uber_point_1_1')
	Object_Destroy('uber_1_2', 0)
#	Object_Destroy('uber_point_1_2')
	Object_Destroy('uber_1_3', 0)
#	Object_Destroy('uber_point_1_3')
	Mission_SetAttr('w11s11_anim_count',0)
	Mission_SetAttr('w11s12_anim_count',0)
	Mission_SetAttr('w12s11_anim_count',0)
	Mission_SetAttr('w12s12_anim_count',0)
	Mission_SetAttr('prox_w11_s11', 0)
	Mission_SetAttr('prox_w12_s11', 0)
	Mission_SetAttr('prox_w11_s12', 0)
	Mission_SetAttr('prox_w12_s12', 0)



#This function seems to be using different units than regProximityEnter
def CheckDistance(thing1,thing2):
	if (not Object_IsAlive(thing1)) or (not Object_IsAlive(thing2)) or (not normal(thing1)) or (not normal(thing2)) or (isHero(thing1)) or (isHero(thing2)):
		print "checking distance on a dead or warped or possessed object"
		return 10000
	else:
		pos1 = Get_ObjectPos(thing1)
		pos2 = Get_ObjectPos(thing2)
		xdelt = abs(pos1[0] - pos2[0])
		ydelt = abs(pos1[1] - pos2[1])
		zdelt = abs(pos1[2] - pos2[2])
		distance = sqrt(xdelt**2 + ydelt**2 + zdelt**2)
#		print distance
		return distance


def BoomW11S11(event):
	print 'w11 and s11 are close'
	#check to see if either is already doing a boom interaction, and that they're both alive
	if (Mission_GetAttr('prox_w11_s11') == 0) and (Mission_GetAttr('prox_w12_s11') == 0) and (Mission_GetAttr('prox_w11_s12') == 0) and (CheckDistance('wraith_1_1','sub_1_1') < Mission_GetAttr('distance_check')):
		# ensure we don't overlap boom interactions
		Mission_SetAttr('prox_w11_s11',1)
		addArrow('boomer11w','wraith_1_1',js.ARROW_YELLOW,1)
		addArrow('boomer11s','sub_1_1',js.ARROW_YELLOW,1)
		loc = Get_ObjectPos('wraith_1_1')
#		there's a typo in the sound name, so the following is actually correct
		Sound_PlaySound('subt_raith_interaction',loc)
		# Wraith plays an "awaiting blast" anim
		AI_SetEnabled('wraith_1_1',0)
		# Subterrestrial turns towards Wraith, and plays "preparing to blast" anim
		turnTo('sub_1_1','wraith_1_1')
		turnTo('wraith_1_1','sub_1_1')
		AI_SetEnabled('sub_1_1',0)
		AnimW11S11(event)
def AnimW11S11(event):
	print "starting an animation cycle"
	AI_Animate('wraith_1_1', 'absorbing_beam', 'AnimW11S11Finish', 0, 0)
	AI_Animate('sub_1_1','energy_taken')
def AnimW11S11Finish(event):
	status = int(event.data)
	if not status:
		# draining animation was interrupted
		print "stopped interaction"
		UnBoomW11S11(event)
	else:
		print "cycle complete"
		addAttr('w11s11_anim_count',1)
		# tune number below
		if Mission_GetAttr('w11s11_anim_count') > 8:
			ZapBoomW11S11(event)
		else:
			AnimW11S11(event)
def ZapBoomW11S11(event):
	# First, check if they are still close enough
	if CheckDistance('wraith_1_1','sub_1_1') < Mission_GetAttr('distance_check'):
		print 's11 now blasting w11'
		# if so, trigger a power for the FX
		Trigger_Power('sub_1_1','wraith_1_1','subterrestrial Life Suck','')
		regTimer('FinishBoomW11S11',.3)
	else:
		# if player has successfully separated them, reset their checks
		UnBoomW11S11(event)
def UnBoomW11S11(event):
	Mission_SetAttr('prox_w11_s11', 0)
	Mission_SetAttr('w11s11_anim_count',0)
	WaveProxChecks()
	# and their AI
	# and remove arrows
	if Object_IsAlive('wraith_1_1'):
		clearGoals('wraith_1_1')
		AI_SetEnabled('wraith_1_1',1)
		removeArrow('boomer11w')
	if Object_IsAlive('sub_1_1'):
		clearGoals('sub_1_1')
		AI_SetEnabled('sub_1_1',1)
		removeArrow('boomer11s')
def FinishBoomW11S11(event):
	print 'ready to spawn uber 1 1'
	# update wave total for Uber Wraith
	addAttr('wave_total',1)
	# prepare marker for UberWraith
	wraith_loc = Get_ObjectPos('wraith_1_1')
	wraith_rot = Object_GetOrientation('wraith_1_1')
	wave=Mission_GetAttr('wave_id')
	Marker_Spawn('uber_point_1_1_'+str(int(wave)),wraith_loc,wraith_rot[1])
	kill('sub_1_1')
	Trigger_Explosion('wraith_1_1','wraith warrior Explode')
	kill('wraith_1_1')
	# spawn the UberWraith
	regTimer('SpawnUber11',1)

def BoomW11S12(event):
	print 'w11 and s12 are close'
	#check to see if either is already doing a boom interaction, and that they're both alive
	if (Mission_GetAttr('prox_w11_s12') == 0) and (Mission_GetAttr('prox_w11_s11') == 0) and (Mission_GetAttr('prox_w12_s12') == 0) and (CheckDistance('wraith_1_1','sub_1_2') < Mission_GetAttr('distance_check')):
		# ensure we don't overlap boom interactions
		Mission_SetAttr('prox_w11_s12',1)
		addArrow('boomer11w','wraith_1_1',js.ARROW_YELLOW,1)
		addArrow('boomer12s','sub_1_2',js.ARROW_YELLOW,1)
		loc = Get_ObjectPos('wraith_1_1')
#		there's a typo in the sound name, so the following is actually correct
		Sound_PlaySound('subt_raith_interaction',loc)
		# Wraith plays an "awaiting blast" anim
		AI_SetEnabled('wraith_1_1',0)
		# Subterrestrial turns towards Wraith, and plays "preparing to blast" anim
		turnTo('sub_1_2','wraith_1_1')
		turnTo('wraith_1_1','sub_1_2')
		AI_SetEnabled('sub_1_2',0)
		AnimW11S12(event)
def AnimW11S12(event):
	print "starting an animation cycle"
	AI_Animate('wraith_1_1', 'absorbing_beam', 'AnimW11S12Finish', 0, 0)
	AI_Animate('sub_1_2','energy_taken')
def AnimW11S12Finish(event):
	status = int(event.data)
	if not status:
		# draining animation was interrupted
		print "stopped interaction"
		UnBoomW11S12(event)
	else:
		print "cycle complete"
		addAttr('w11s12_anim_count',1)
		# tune number below
		if Mission_GetAttr('w11s12_anim_count') > 8:
			ZapBoomW11S12(event)
		else:
			AnimW11S12(event)
def ZapBoomW11S12(event):
	# First, check if they are still close enough
	if CheckDistance('wraith_1_1','sub_1_2') < Mission_GetAttr('distance_check'):
		print 's12 now blasting w11'
		# if so, trigger a power for the FX
		Trigger_Power('sub_1_2','wraith_1_1','subterrestrial Life Suck','')
		regTimer('FinishBoomW11S12',.3)
	else:
		# if player has successfully separated them, reset their checks
		UnBoomW11S12(event)
def UnBoomW11S12(event):
	Mission_SetAttr('prox_w11_s12', 0)
	Mission_SetAttr('w11s12_anim_count',0)
	WaveProxChecks()
	# and their AI
	# and remove arrows
	if Object_IsAlive('wraith_1_1'):
		clearGoals('wraith_1_1')
		AI_SetEnabled('wraith_1_1',1)
		removeArrow('boomer11w')
	if Object_IsAlive('sub_1_2'):
		clearGoals('sub_1_2')
		AI_SetEnabled('sub_1_2',1)
		removeArrow('boomer12s')
def FinishBoomW11S12(event):
	print 'ready to spawn uber 1 1'
	# update wave total for Uber Wraith
	addAttr('wave_total',1)
	# prepare marker for UberWraith
	wraith_loc = Get_ObjectPos('wraith_1_1')
	wraith_rot = Object_GetOrientation('wraith_1_1')
	wave=Mission_GetAttr('wave_id')
	Marker_Spawn('uber_point_1_1_'+str(int(wave)),wraith_loc,wraith_rot[1])
	kill('sub_1_2')
	Trigger_Explosion('wraith_1_1','wraith warrior Explode')
	kill('wraith_1_1')
	# spawn the UberWraith
	regTimer('SpawnUber11',1)

def BoomW12S11(event):
	print 'w12 and s11 are close'
	#check to see if either is already doing a boom interaction, and that they're both alive
	if (Mission_GetAttr('prox_w12_s11') == 0) and (Mission_GetAttr('prox_w12_s12') == 0) and (Mission_GetAttr('prox_w11_s11') == 0) and (CheckDistance('wraith_1_2','sub_1_1') < Mission_GetAttr('distance_check')):
		# ensure we don't overlap boom interactions
		Mission_SetAttr('prox_w12_s11',1)
		addArrow('boomer12w','wraith_1_2',js.ARROW_YELLOW,1)
		addArrow('boomer11s','sub_1_1',js.ARROW_YELLOW,1)
		loc = Get_ObjectPos('wraith_1_2')
#		there's a typo in the sound name, so the following is actually correct
		Sound_PlaySound('subt_raith_interaction',loc)
		# Wraith plays an "awaiting blast" anim
		AI_SetEnabled('wraith_1_2',0)
		# Subterrestrial turns towards Wraith, and plays "preparing to blast" anim
		turnTo('sub_1_1','wraith_1_2')
		turnTo('wraith_1_2','sub_1_1')
		AI_SetEnabled('sub_1_1',0)
		AnimW12S11(event)
def AnimW12S11(event):
	print "starting an animation cycle"
	AI_Animate('wraith_1_2', 'absorbing_beam', 'AnimW12S11Finish', 0, 0)
	AI_Animate('sub_1_1','energy_taken')
def AnimW12S11Finish(event):
	status = int(event.data)
	if not status:
		# draining animation was interrupted
		print "stopped interaction"
		UnBoomW12S11(event)
	else:
		print "cycle complete"
		addAttr('w12s11_anim_count',1)
		# tune number below
		if Mission_GetAttr('w12s11_anim_count') > 8:
			ZapBoomW12S11(event)
		else:
			AnimW12S11(event)
def ZapBoomW12S11(event):
	# First, check if they are still close enough
	if CheckDistance('wraith_1_2','sub_1_1') < Mission_GetAttr('distance_check'):
		print 's11 now blasting w12'
		# if so, trigger a power for the FX
		Trigger_Power('sub_1_1','wraith_1_2','subterrestrial Life Suck','')
		regTimer('FinishBoomW12S11',.3)
	else:
		# if player has successfully separated them, reset their checks
		UnBoomW12S11(event)
def UnBoomW12S11(event):
	Mission_SetAttr('prox_w12_s11', 0)
	Mission_SetAttr('w12s11_anim_count',0)
	WaveProxChecks()
	# and their AI
	# and remove arrows
	if Object_IsAlive('wraith_1_2'):
		clearGoals('wraith_1_2')
		AI_SetEnabled('wraith_1_2',1)
		removeArrow('boomer12w')
	if Object_IsAlive('sub_1_1'):
		clearGoals('sub_1_1')
		AI_SetEnabled('sub_1_1',1)
		removeArrow('boomer11s')
def FinishBoomW12S11(event):
	print 'ready to spawn uber 1 2'
	# update wave total for Uber Wraith
	addAttr('wave_total',1)
	# prepare marker for UberWraith
	wraith_loc = Get_ObjectPos('wraith_1_2')
	wraith_rot = Object_GetOrientation('wraith_1_2')
	wave=Mission_GetAttr('wave_id')
	Marker_Spawn('uber_point_1_2_'+str(int(wave)),wraith_loc,wraith_rot[1])
	kill('sub_1_1')
	Trigger_Explosion('wraith_1_2','wraith warrior Explode')
	kill('wraith_1_2')
	# spawn the UberWraith
	regTimer('SpawnUber12',1)

def BoomW12S12(event):
	print 'w12 and s12 are close'
	#check to see if either is already doing a boom interaction, and that they're both alive
	if (Mission_GetAttr('prox_w12_s12') == 0) and (Mission_GetAttr('prox_w12_s11') == 0) and (Mission_GetAttr('prox_w11_s12') == 0) and (CheckDistance('wraith_1_2','sub_1_2') < Mission_GetAttr('distance_check')):
		# ensure we don't overlap boom interactions
		Mission_SetAttr('prox_w12_s12',1)
		addArrow('boomer12w','wraith_1_2',js.ARROW_YELLOW,1)
		addArrow('boomer12s','sub_1_2',js.ARROW_YELLOW,1)
		loc = Get_ObjectPos('wraith_1_2')
#		there's a typo in the sound name, so the following is actually correct
		Sound_PlaySound('subt_raith_interaction',loc)
		# Wraith plays an "awaiting blast" anim
		AI_SetEnabled('wraith_1_2',0)
		# Subterrestrial turns towards Wraith, and plays "preparing to blast" anim
		turnTo('sub_1_2','wraith_1_2')
		turnTo('wraith_1_2','sub_1_2')
		AI_SetEnabled('sub_1_2',0)
		AnimW12S12(event)
def AnimW12S12(event):
	print "starting an animation cycle"
	AI_Animate('wraith_1_2', 'absorbing_beam', 'AnimW12S12Finish', 0, 0)
	AI_Animate('sub_1_2','energy_taken')
def AnimW12S12Finish(event):
	status = int(event.data)
	if not status:
		# draining animation was interrupted
		print "stopped interaction"
		UnBoomW12S12(event)
	else:
		print "cycle complete"
		addAttr('w12s12_anim_count',1)
		# tune number below
		if Mission_GetAttr('w12s12_anim_count') > 8:
			ZapBoomW12S12(event)
		else:
			AnimW12S12(event)
def ZapBoomW12S12(event):
	# First, check if they are still close enough
	if CheckDistance('wraith_1_2','sub_1_2') < Mission_GetAttr('distance_check'):
		print 's12 now blasting w12'
		# if so, trigger a power for the FX
		Trigger_Power('sub_1_2','wraith_1_2','subterrestrial Life Suck','')
		regTimer('FinishBoomW12S12',.3)
	else:
		# if player has successfully separated them, reset their checks
		UnBoomW12S12(event)
def UnBoomW12S12(event):
	Mission_SetAttr('prox_w12_s12', 0)
	Mission_SetAttr('w12s12_anim_count',0)
	WaveProxChecks()
	# and their AI
	# and remove arrows
	if Object_IsAlive('wraith_1_2'):
		clearGoals('wraith_1_2')
		AI_SetEnabled('wraith_1_2',1)
		removeArrow('boomer12w')
	if Object_IsAlive('sub_1_2'):
		clearGoals('sub_1_2')
		AI_SetEnabled('sub_1_2',1)
		removeArrow('boomer12s')
def FinishBoomW12S12(event):
	print 'ready to spawn uber 1 2'
	# update wave total for Uber Wraith
	addAttr('wave_total',1)
	# prepare marker for UberWraith
	wraith_loc = Get_ObjectPos('wraith_1_2')
	wraith_rot = Object_GetOrientation('wraith_1_2')
	wave=Mission_GetAttr('wave_id')
	Marker_Spawn('uber_point_1_2_'+str(int(wave)),wraith_loc,wraith_rot[1])
	kill('sub_1_2')
	Trigger_Explosion('wraith_1_2','wraith warrior Explode')
	kill('wraith_1_2')
	# spawn the UberWraith
	regTimer('SpawnUber12',1)

def SpawnUber11(event):
	wave=Mission_GetAttr('wave_id')
	spawn('uber_1_1','wraith_manta','uber_point_1_1_'+str(int(wave)))
	regDeath('uber_1_1','AWaveKill')
def SpawnUber12(event):
	wave=Mission_GetAttr('wave_id')
	spawn('uber_1_2','wraith_manta','uber_point_1_2_'+str(int(wave)))
	regDeath('uber_1_2','AWaveKill')


#less special cases for building check
def CheckDistanceB(thing1,thing2):
	if (not Object_IsAlive(thing1)) or (not Object_IsAlive(thing2)):
		print "checking distance on a dead object"
		return 10000
	else:
		pos1 = Get_ObjectPos(thing1)
		pos2 = Get_ObjectPos(thing2)
		xdelt = abs(pos1[0] - pos2[0])
		ydelt = abs(pos1[1] - pos2[1])
		zdelt = abs(pos1[2] - pos2[2])
		distance = sqrt(xdelt**2 + ydelt**2 + zdelt**2)
#		print distance
		return distance
def ClosestBuildingToE():
	currentclosest = 0
	currentdist = 10000
	for building in range(1,95):
		# the next line is to introduce some uncertainty into the results
		if (randint (0,2) == 0):
			newdist = CheckDistanceB('entropy','_impobj_building_'+str(building))
			if newdist < currentdist:
				currentdist = newdist
				currentclosest = building
	if currentdist == 10000:
		return 10000
	else:
		return currentclosest

def DestroyABuilding(event):
	#old version of this destroyed buildings in a deterministic list
	# this one destroys buildings semi-randomly close to entropy.
	regTimer('DestroyABuilding',7)
	bldg = ClosestBuildingToE()
	print 'now damaging building ' + str(bldg)
	if (bldg != 10000) and (not isPlaying()):
		Trigger_Damage('_impobj_building_' + str(bldg),50)

#def DestroyABuilding(event):
#	index = Mission_GetAttr('building_index')
#	# check to see we haven't run over the end of the list
#	if index < len(building_demo_list):
#		print 'now damaging building ' + str(building_demo_list[int(index)])
#		# damage the building some
#		Trigger_Damage('_impobj_building_' + str(building_demo_list[int(index)]),50)
#		# increment the index to target next building
#		addAttr('building_index',1)
#		regTimer('DestroyABuilding',14)
#		# but do some more damage to the previous building also
#		regTimer('DaB2',21)
#	else:
#		#not clear on why this is needed to work, but it is
#		addAttr('building_index',1)
#		print "building_demo_list used up"
#def DaB2(event):
#	#seems like this out to be -1, but it needs to be -2 to getthe desired interleaving effect.
#	index = Mission_GetAttr('building_index')-2
#	print 'now further damaging building ' + str(building_demo_list[int(index)])
#	Trigger_Damage('_impobj_building_' + str(building_demo_list[int(index)]),50)



def Buildings1(event):
	print "start up generic building destruction sequence"
	DestroyABuilding(event)

def Buildings2(event):
	print "comment on building destruction"
	play(buildings_collapse_ss,'buildings_collapse_ss')

def Buildings3(event):
	print "comment on subterrestrial appearance"
	regTimer('Buildings3B',5)
def Buildings3B(event):
	play(subterrestrials_appear_ss,'subterrestrials_appear_ss')



def BCLine():
#	a_hero = getRandomLiveHeroName()
# Can't use this function, 'cos we need a_hero not to be Man-Bot
	hero_list = getAllHeroes()
	liveheroes = ['nullhero']
	for temp_hero in hero_list:
		if (Object_IsAlive(temp_hero)) and (Object_GetTemplate(temp_hero) != 'man_bot_damaged'):
			liveheroes.append(Object_GetTemplate(temp_hero))
	print len(liveheroes)
	if len(liveheroes) == 1:
		a_hero = 'nobody'
	else:
		temp = randint(1,len(liveheroes)-1)
		a_hero = liveheroes[temp]
	print a_hero
	if a_hero == 'minute_man':
		speak('minute_man', 'MISSPCH_21_MM_02')
	elif a_hero == 'black_jack':
		speak('black_jack', 'MISSPCH_21_BJ_03')
	elif a_hero == 'blackbird':
		speak('blackbird', 'MISSPCH_21_BB_02')
	elif a_hero == 'bullet':
		speak('bullet', 'MISSPCH_21_BL_02')
	elif a_hero == 'green_genie':
		speak('green_genie', 'MISSPCH_21_GG_02')
	elif a_hero == 'law':
		speak('law', 'MISSPCH_21_LW_01')
	elif a_hero == 'liberty_lad':
		speak('liberty_lad', 'MISSPCH_21_LL_02')
	elif a_hero == 'man_o_war':
		speak('man_o_war', 'MISSPCH_21_MO_02')
	elif a_hero == 'microwave':
		speak('microwave', 'MISSPCH_21_MW_02')
	elif a_hero == 'order':
		speak('order', 'MISSPCH_21_OR_02')
	elif a_hero == 'quetzalcoatl':
		speak('quetzalcoatl', 'MISSPCH_21_QZ_02')
	elif a_hero == 'sea_urchin':
		speak('sea_urchin', 'MISSPCH_21_SU_02')
	elif a_hero == 'sky_king':
		speak('sky_king', 'MISSPCH_21_SY_02')
	elif a_hero == 'the_ant':
		speak('the_ant', 'MISSPCH_21_AN_02')
	elif a_hero == 'tombstone':
		speak('tombstone', 'MISSPCH_21_TS_02')
	elif a_hero == 'tricolour':
		speak('tricolour', 'MISSPCH_21_TC_02')
	else:
		print "Custom character?"
		wait(0.1)

def GoingLine():
	if not isPlaying():
		temp = randint(0,4)
		if temp == 0:
			speakNoCB('man_bot', 'MISSPCH_21_MB_10')
		elif temp == 1:
			speakNoCB('man_bot', 'MISSPCH_21_MB_16')
		elif temp == 2:
			speakNoCB('man_bot', 'MISSPCH_21_MB_17')
		elif temp == 3:
			speakNoCB('man_bot', 'MISSPCH_21_MB_18')
		elif temp == 4:
			speakNoCB('man_bot', 'MISSPCH_21_MB_19')
		else:
			print "randint prob?"
	else:
		print "not doing goingline, in a CS"

def ClosingLine(event):
	if not isPlaying():
		temp = randint(0,3)
		if temp == 0:
			speakNoCB('man_bot', 'MISSPCH_21_MB_11')
		elif temp == 1:
			speakNoCB('man_bot', 'MISSPCH_21_MB_20')
		elif temp == 2:
			speakNoCB('man_bot', 'MISSPCH_21_MB_21')
		elif temp == 3:
			speakNoCB('man_bot', 'MISSPCH_21_MB_22')
		else:
			print "randint prob?"
	else:
		print "not doing closingline, in a CS"
	proxtime = Mission_GetAttr('prox_warning_delay')
	regTimer('ResetProxWarning',proxtime)
	Mission_SetAttr('prox_warning_delay',proxtime+15)
def ResetProxWarning(event):
	regProximityEnter('time_master','entropy',150,'ClosingLine')


def FullCure():
	reviveHeroes()
	herolist = getAllHeroes()
	for hero in herolist:
		maxHealth = Object_GetAttr(hero, "maxHealth")
		Object_SetAttr(hero, "health", maxHealth)
		maxEnergy = 100
		Object_SetAttr(hero, "energyPoints", maxEnergy)
		energize(hero)



def TimeMasterSetup(event):
	regDeath('time_master','TimeMasterDown')
	regProximityEnter('time_master','entropy',50,'TimeMasterWins')
	regProximityEnter('time_master','entropy',150,'ClosingLine')
	regDamage('time_master', 'TMFight', persistent = 1)
#	spawn('twin_1','time_master_energy','tt_spawn_point1')
#	regDeath('twin_1','Twin1Down')
#	spawn('twin_2','time_master_radiation','tt_spawn_point2')
#	regDeath('twin_2','Twin2Down')
	Twin1Spawn(event)
	regTimer('Twin2Spawn',5)
#following lines copied from TMToEntropy, so as not to trigger GoingLine()
	Mission_SetAttr('tm_fighting',0)
	enloc = Get_ObjectPos('entropy')
	movegoal = Move(enloc,'walk',30,1)
	addGoalToAI('time_master',movegoal,ai.goal.PRI_HI)

def TMToEntropy(event):
	Mission_SetAttr('tm_fighting',0)
	enloc = Get_ObjectPos('entropy')
	movegoal = Move(enloc,'walk',30,1)
	addGoalToAI('time_master',movegoal,ai.goal.PRI_HI)
	GoingLine()

def TMFight(event):
	if Mission_GetAttr('tm_fighting') == 0:
		Mission_SetAttr('tm_fighting',1)
		clearGoals('time_master')
		regTimer('TMToEntropy',30)


#checking distance to markers, so don't check aliveness
def CheckDistance2(thing1,thing2):
	pos1 = Get_ObjectPos(thing1)
	pos2 = Get_MarkerPos(thing2)
	xdelt = abs(pos1[0] - pos2[0])
	ydelt = abs(pos1[1] - pos2[1])
	zdelt = abs(pos1[2] - pos2[2])
	distance = sqrt(xdelt**2 + ydelt**2 + zdelt**2)
	print distance
	return distance
def GetClosestTwinPoint():
	dist1 = CheckDistance2('time_master','tt_spawn_point1')
	closest = dist1
	point = 1
	dist2 = CheckDistance2('time_master','tt_spawn_point2')
	if dist2 < closest:
		closest = dist2
		point = 2
	dist3 = CheckDistance2('time_master','tt_spawn_point3')
	if dist3 < closest:
		closest = dist3
		point = 3
	dist4 = CheckDistance2('time_master','tt_spawn_point4')
	if dist4 < closest:
		closest = dist4
		point = 4
	dist5 = CheckDistance2('time_master','tt_spawn_point5')
	if dist5 < closest:
		closest = dist5
		point = 5
	dist6 = CheckDistance2('time_master','tt_spawn_point6')
	if dist6 < closest:
		closest = dist6
		point = 6
	dist7 = CheckDistance2('time_master','tt_spawn_point7')
	if dist7 < closest:
		closest = dist7
		point = 7
	dist8 = CheckDistance2('time_master','tt_spawn_point8')
	if dist8 < closest:
		closest = dist8
		point = 8
	dist9 = CheckDistance2('time_master','tt_spawn_point9')
	if dist9 < closest:
		closest = dist9
		point = 9
	dist10 = CheckDistance2('time_master','tt_spawn_point10')
	if dist10 < closest:
		closest = dist10
		point = 10
	dist11 = CheckDistance2('time_master','tt_spawn_point11')
	if dist11 < closest:
		closest = dist11
		point = 11
	dist12 = CheckDistance2('time_master','tt_spawn_point12')
	if dist12 < closest:
		closest = dist12
		point = 12
	return point

def Twin1Spawn(event):
	closest = GetClosestTwinPoint()
	spawnpoint = "tt_spawn_point" + str(closest)
	print spawnpoint
	Object_Destroy('twin_1')
	if Object_IsAlive('twin_2'):
		if Object_GetTemplate('twin_2') == 'time_master_elec':
			temp = randint(0,1)
			if temp == 0:
				spawn('twin_1','time_master_radiation',spawnpoint)
			elif temp == 1:
				spawn('twin_1','time_master_energy',spawnpoint)
		elif Object_GetTemplate('twin_2') == 'time_master_energy':
			temp = randint(0,1)
			if temp == 0:
				spawn('twin_1','time_master_radiation',spawnpoint)
			elif temp == 1:
				spawn('twin_1','time_master_elec',spawnpoint)
		elif Object_GetTemplate('twin_2') == 'time_master_radiation':
			temp = randint(0,1)
			if temp == 0:
				spawn('twin_1','time_master_elec',spawnpoint)
			elif temp == 1:
				spawn('twin_1','time_master_energy',spawnpoint)
	else:
		temp = randint(0,2)
		if temp == 0:
			spawn('twin_1','time_master_elec',spawnpoint)
		elif temp == 1:
			spawn('twin_1','time_master_energy',spawnpoint)
		elif temp == 2:
			spawn('twin_1','time_master_radiation',spawnpoint)
	regDeath('twin_1','Twin1Down')
	playEffectMarker('effect_portal_close', spawnpoint,flags=FX_TRACK_OBJECT_ROT)
	StandardWarpEffect(Get_MarkerPos(spawnpoint))
	regTimer('Twin1Move',1)
def Twin1Move(event):
	mbloc = Get_ObjectPos('man_bot')
	movegoal = Move(mbloc,'walk',30,1)
	addGoalToAI('twin_1',movegoal,ai.goal.PRI_MED)
	addKillAllGoal('twin_1',OC_CONTROLLABLE,ai.goal.PRI_HI)
def Twin2Spawn(event):
	closest = GetClosestTwinPoint()
	spawnpoint = "tt_spawn_point" + str(closest)
	print spawnpoint
	Object_Destroy('twin_2')
	if Object_IsAlive('twin_1'):
		if Object_GetTemplate('twin_1') == 'time_master_elec':
			temp = randint(0,1)
			if temp == 0:
				spawn('twin_2','time_master_radiation',spawnpoint)
			elif temp == 1:
				spawn('twin_2','time_master_energy',spawnpoint)
		elif Object_GetTemplate('twin_1') == 'time_master_energy':
			temp = randint(0,1)
			if temp == 0:
				spawn('twin_2','time_master_radiation',spawnpoint)
			elif temp == 1:
				spawn('twin_2','time_master_elec',spawnpoint)
		elif Object_GetTemplate('twin_1') == 'time_master_radiation':
			temp = randint(0,1)
			if temp == 0:
				spawn('twin_2','time_master_elec',spawnpoint)
			elif temp == 1:
				spawn('twin_2','time_master_energy',spawnpoint)
	else:
		temp = randint(0,2)
		if temp == 0:
			spawn('twin_2','time_master_elec',spawnpoint)
		elif temp == 1:
			spawn('twin_2','time_master_energy',spawnpoint)
		elif temp == 2:
			spawn('twin_2','time_master_radiation',spawnpoint)
	regDeath('twin_2','Twin2Down')
	playEffectMarker('effect_portal_close', spawnpoint,flags=FX_TRACK_OBJECT_ROT)
	StandardWarpEffect(Get_MarkerPos(spawnpoint))
	regTimer('Twin2Move',1)
def Twin2Move(event):
	enloc = Get_ObjectPos('entropy')
	movegoal = Move(enloc,'walk',30,1)
	addGoalToAI('twin_2',movegoal,ai.goal.PRI_MED)
	addKillAllGoal('twin_2',OC_CONTROLLABLE,ai.goal.PRI_HI)

def Twin1Down(event):
	regTimer('Twin1Respawn',45)
def Twin2Down(event):
	regTimer('Twin2Respawn',40)	# timing different to make overlapping spawns less likely
def Twin1Respawn(event):
	if Object_IsAlive('time_master'):
		Twin1Spawn(event)
def Twin2Respawn(event):
	if Object_IsAlive('time_master'):
		Twin2Spawn(event)


def TimeMasterDown(event):
	regTimer('TMD2',3.5)
def TMD2(event):
	play(end_cs, 'end_cs')

def TimeMasterWins(event):
	play(time_master_wins_ss,'time_master_wins_ss')

def ManbotDown(event):
	play(manbot_down_ss,'manbot_down_ss')


def OnMissionWon():
	print "manbot/won"
	Objective_Complete('manbot')
	Objective_Complete('keep_away')
	Objective_Complete('time_master')

def OnMissionLost():
	print "manbot/lost"




#										 #
# cutscenes and scripted sequences below  #
#										 #



start_cs = [
(
	"peace()",
	"startCS()",
	"look('man_bot', zoom = -250, heading = 0, time = 0)",
	"Object_PlayEffect('w11_standin', 'effect_portal_open', 'W11Spawn',FX_TRACK_OBJECT_ROT)",
	"ff.StandardWarpEffect(Get_ObjectPos('w11_standin'))",
	"Object_PlayEffect('w12_standin', 'effect_portal_open', 'W12Spawn',FX_TRACK_OBJECT_ROT)",
	"ff.StandardWarpEffect(Get_ObjectPos('w12_standin'))",
	"speak('man_bot', 'MISSPCH_21_MB_13')",
),
(
	"speak('man_bot', 'MISSPCH_21_MB_05')",
),
(
	"endCS()",
	"war()",
	"regTimer('Retreat1',1)",
	"newObjective('primary', 1, name='entropy')",
	"newObjective('primary', 2, name='manbot')",
	"addArrow('entropy_arrow','entropy')",
),
]


buildings_collapse_ss = [
(
	"ff.BCLine()",
),
(
	"speak('man_bot', 'MISSPCH_21_MB_06')",
),
(
	"blank",
),
]

subterrestrials_appear_ss = [
(
	"speak('man_bot', 'MISSPCH_21_MB_07')",
),
(
	"blank",
),
]


retreat_2_ss = [
(
	"speak('entropy', 'MISSPCH_21_EN_07')",
),
(
	"blank",
),
]

retreat_4_ss = [
(
	"speak('entropy', 'MISSPCH_21_EN_08')",
),
(
	"speak('man_bot', 'MISSPCH_21_MB_15')",
),
(
	"blank",
),
]

retreat_5_ss = [
(
	"speak('entropy', 'MISSPCH_21_EN_09')",
),
(
	"blank",
),
]


entropy_down_cs = [
(
	"peace()",
	"startCS()",
	"ff.CleanWave()",
	"normalize('entropy')",
	"teleport('man_bot','mb_spot_mid')",
	"teleport('hero_2','hero2_spot_mid')",
	"teleport('hero_3','hero3_spot_mid')",
	"teleport('hero_4','hero4_spot_mid')",
	"teleport('entropy','entropy_spot6')",
	"removeArrow('entropy_arrow')",
	"playTransition()",
),
(
	"look('man_bot', zoom = -150, heading = 0, time = 0)",
	"Objective_Complete('entropy')",
	"AI_Animate('entropy','land_back','',0,1)",
	"Object_SetAttr('entropy','minHealth',1)",
	"speak('entropy', 'MISSPCH_21_EN_05')",
	"Sound_PlaySound('mission_manbot')",
),
(
	"speak('man_bot', 'MISSPCH_21_MB_08')",
),
(
	"speak('man_bot', 'MISSPCH_21_MB_14')",
),
(
	"look('tm_spawn_point', zoom = 0, heading = 0, time = 5)",
	"Object_PlayEffect('tm_standin', 'effect_portal_open', '',FX_TRACK_OBJECT_ROT)",
	"ff.StandardWarpEffect(Get_ObjectPos('tm_standin'))",
	"wait(1)",
),
(
	"spawn('time_master','time_master','tm_spawn_point')",
	"speak('time_master', 'MISSPCH_21_TM_01')",
	"Sound_PlayMusic('music_11elem1')",
),
(
	"look('man_bot', zoom = -150, heading = 0, time = 5)",
	"ff.FullCure()",
	"teleport('hero_2','hero2_spot_mid2')",
	"teleport('hero_3','hero3_spot_mid2')",
	"teleport('hero_4','hero4_spot_mid2')",
	"turnTo('man_bot','hero_2')",
	"speak('man_bot', 'MISSPCH_21_MB_09')",
),
(
	"endCS()",
	"#war()",
	"newObjective('primary', 3, name='keep_away')",
	"newObjective('primary', 4, name='time_master')",
	"addArrow('tm_arrow','time_master')",
	"regTimer('TimeMasterSetup',.3)",
	"#AI_SetEnabled('entropy',0)",
	"#teleport('entropy','entropy_spot6')",
	"#AI_Animate('entropy','land_back','',0,1)",
),
]


time_master_wins_ss = [
(
	"AI_Animate('time_master','area')",
	"speak('time_master', 'MISSPCH_21_TM_02')",
),
(
	"Objective_Fail('keep_away')",
	"Mission_Lose()",
),
]

manbot_down_ss = [
(
	"speak('man_bot', 'MISSPCH_21_MB_12')",
),
(
	"Objective_Fail('manbot')",
	"Mission_Lose()",
),
]

end_cs = [ #plays the final cutscene and credits
(
	"Mission_Play2DCutscene('cutscene_end', 'cutscene_end_wav', 'onStepCB')",
),
(
	"Mission_Play2DCutscene('cutscene_credits', 'cutscene_credits_wav', 'onStepCB')",
),
(
	"Mission_Win()",
),
]
