#####################################################################################
#
# Module: m25energy
# Author: m25
# 
# Description: convert string amounts to actual energy numbers
#
#
# Version 3.052
#
#####################################################################################

#print "Loading m25energy.py v.3.2.0 final; branch = m25 branch 1"

import types
from m25config import *
from random import randint

def ConvertEnergy(value,default=0,push=1):
	if type(value) is types.StringType:
		if value == 'none':
			return 0
		if value == 'low':
			#if (M25_AI_PUSH_ENERGY and push) and (randint(1,3)==1): return 0
			return 34
		if value == 'medium':
			#if (M25_AI_PUSH_ENERGY and push) and (randint(1,3)==1): return 34
			return 67
		if value == 'high':
			#if (M25_AI_PUSH_ENERGY and push) and (randint(1,3)==1): return 67
			return 100
		try:
			v = int(value)
			return v
		except:
			return default
	else:
		return value

def CompareEnergy(val1, val2, compare):
	v1 = ConvertEnergy(val1)
	v2 = ConvertEnergy(val2)
	c = 0
	exec 'c = ' + `v1` + compare + `v2`
	return c
