import cshelper
import js

from cshelper import *
from js import *
from ffx import *

from m25ai import *
import m25missionover
import m25event

import sk

def OnPostInit():
    FFX_InitSkirmish()
    StartAI()
    m25event.SetTimer(3, 'CheckHeroesGone')

def StartAI():
	m25ai.InitScripts()
	all = js.Mission_GetDynamicObjects()
	for a in all:
		if js.Object_GetClass(a) & js.OC_CONTROLLABLE:
			m25ai.AIDisableCustom(a)
		m25ai.SetupAI(a)
		m25ai.AddGoal_HuntEnemy(a)

#def OnEnemyKilled(event):
#   sk.OnEnemyKilled(event)
#    total = Mission_GetAttr('total')
#    if (total == 0):
#        m25missionover.SetMissionOver()
#        sk.WinMission()

def OnNoMoreBadGuys():
    if m25missionover.GetMissionOver():
        return
    m25missionover.SetMissionOver()
    sk.WinMission()

def OnReceiveSelectedEnemies(enemies):
    sk.PreSetup()
    markerList = sk.GenerateMarkerList(24)
    for enemy in enemies:
        if len(markerList)>0:
            markerNumber = markerList.pop(0)
        else:
            markerNumber = randint(1,24)
        print 'try to spawn ' + enemy
        sk.SpawnEnemy(enemy, 0, markerNumber)
                   
def OnSelectionRequiredCheck():
    return 1

def OnNumEnemiesCheck():
    return 24

def OnGameTypeCheck():
    return sk.GetStandardMarkerNames()
    
    
def CheckHeroesGone(event):
	all = js.Mission_GetDynamicObjects()
	for a in all:
		if m25ai.GetTeam(a) == m25ai.TEAM_GOODGUYS:
			if Object_Exists(a) and Object_IsAlive(a):
				m25event.SetTimer(3, 'CheckHeroesGone')
				return  # take no action
	m25event.SetTimer(3, 'ReCheckHeroesGone')

def ReCheckHeroesGone(event):
	all = js.Mission_GetDynamicObjects()
	for a in all:
		if m25ai.GetTeam(a) == m25ai.TEAM_GOODGUYS:
			if Object_Exists(a) and Object_IsAlive(a):
				m25event.SetTimer(3, 'CheckHeroesGone')
				return  # take no action
	m25missionover.SetMissionOver()
	Mission_Win()