import cshelper
import js

from cshelper import *
from js import *
from ffx import *
from m25skirmish import *

import sk

waves_data = (
    [('bacchite_green', 1),],
    [('bacchite_green', 2),],
    [('bacchite_green', 1), ('bacchite_silver', 1),],
    [('bacchite_green', 2), ('bacchite_silver', 1),],
    [('bacchite_green', 1), ('bacchite_silver', 1), ('bacchite_red', 1),],
    [('bacchite_green', 2), ('bacchite_silver', 1), ('bacchite_red', 1),],
    [('bacchite_green', 1), ('bacchite_silver', 2), ('bacchite_red', 1),],
    [('pan', 1),],
    [('bacchite_green', 2), ('manbull', 1), ('bacchite_silver', 1),],
    [('bacchite_green', 3), ('manbull', 1), ('bacchite_silver', 1),],
    [('bacchite_green', 1), ('bacchite_silver', 1), ('manbull', 1), ('bacchite_red', 1),],
    [('bacchite_silver', 1), ('bacchite_red', 2), ('manbull', 1),],
    [('bacchite_red', 3), ('bacchite_silver', 2),],
    [('bacchite_red', 2), ('bacchite_silver', 2), ('manbull', 1),],
    [('bacchite_red', 2), ('bacchite_silver', 1), ('manbull', 2),],
    [('bacchite_red', 5),],
    [('manbull', 3),],
    [('manbull', 3), ('bacchite_red', 1), ('bacchite_silver', 1), ],
    [('manbull', 2), ('bacchite_red', 1), ('bacchite_silver', 1), ('pan', 1),],
    [('manbull', 3), ('bacchite_red', 1), ('bacchite_silver', 1), ('pan', 1),],
)

def OnEnemyKilled(event):
    doNothing=0

def OnNoMoreBadGuys():
    wave = int(Mission_GetAttr('wave'))
    if (wave == len(waves_data)):
        sk.WinMission()
    else:
        sk.SpawnNextWaveDelay()
        return 1

def SpawnNextWave(event):
    sk.SpawnNextWave(waves_data, fx = 'effect_entropy_spawn')
    
def OnPostInit():
    sk.SetupInstantAction(waves_data, fx = 'effect_entropy_spawn')
    SetupFFXSkirmish()

def OnSelectionRequiredCheck():
    return 0

def OnGameTypeCheck():
    return sk.GetStandardMarkerNames()