import cshelper
import js

from cshelper import *
from js import *
from ffx import *
from m25skirmish import *

import sk

monsters = [
	'thug_with_bat',
	'thug_with_gun',
	'cop_crooked',
	'thug_with_grenade',
	'sukhov',
	'ice_trooper',
	'darkman_blue',
	'raptor',
	'mafioso',
	'raptor_bezerk',
	'ant_soldier',
	'raptor_boss',
	'ice_sergeant',
	'duplicate_bat_thug',
	'ice_queen',
	'darkman_purple',
	'duplicate_male',
	'duplicate_gun_thug',
	'bacchite_green',
	'duplicate_fem',
	'mech_man',
	'bacchite_red',
	'duplicate_cop',
	'mech_man_flame',
	'bacchite_silver',
	'alien_warrior',
	'nuclear_winter',
	'alien_sergeant',
	'manbull',
	'time_master_elec',
	'time_master_energy',
	'dominion',
	'time_master_radiation',
	'pin_stripe',
	'praetor',
	'shadow',
	'trex',
	'dejavu',
	'mr_mechanical',
	'pan',
	'time_master',
]

def OnEnemyKilled(event):
	sk.OnEnemyKilled(event)
	total = int(Mission_GetAttr('total'))
	if (total == 0):
		wave = int(Mission_GetAttr('wave'))
		if (wave == len(monsters)):
			sk.WinMission()
		else:
			regTimer('SpawnNextWave', 3)

def GenerateWave():
	wave_data = []
	wave = int(Mission_GetAttr('wave'))
	for i in range(0, 5):
		start = min(max(wave, 0), len(monsters)-1)
		end = min(max(wave+5, 0), len(monsters)-1)
		group = [monsters[randint(start, end)], 1]
		wave_data.append(group)
	return wave_data

def SpawnNextWave(event):
	wave = int(Mission_GetAttr('wave'))
	sk.SpawnWave(GenerateWave())
	Mission_SetAttr('wave', wave+1)

def OnPostInit():
	sk.PreSetup()
	sk.Setup()
	SpawnNextWave('')
	SetupFFXSkirmish()

def OnSelectionRequiredCheck():
	return 0

def OnGameTypeCheck():
	return sk.GetStandardMarkerNames()