import cshelper
import js

from cshelper import *
from js import *
from ffx import *
from m25skirmish import *

import sk

monsters = [
	'nazi_rifleman',
	'ice_trooper',
	'nazi_gunner',
	'fire_elemental',
	'nazi_grenadier',
	'snow_man',
	'nazi_general',
	'legionnaire',
	'dark_shaman',
	'shurale',
	'wraith_warrior',
	'red_sun',
	'centurion',
	'subterrestrial',
	'killarilla_whip',
	'killarilla_chaingun',
	'nuclear_winter',
	'frozen_giant',
	'red_oktober',
	'eye_minor',
	'wraith_manta',
	'eye_major',
	'fortissimo',
	'blitzkrieg',
	'entropy',
]

def OnEnemyKilled(event):
	sk.OnEnemyKilled(event)
	total = int(Mission_GetAttr('total'))
	if (total == 0):
		sk.AwardBonus()
		wave = int(Mission_GetAttr('wave'))
		if (wave == len(monsters)):
			sk.WinMission()
		else:
			regTimer('SpawnNextWave', 3)
			sk.StartBonus()
			sk.ReviveHeroes()

def GenerateWave():
	wave_data = []
	wave = int(Mission_GetAttr('wave'))
	for i in range(0, 5):
		start = min(max(wave, 0), len(monsters)-1)
		end = min(max(wave+5, 0), len(monsters)-1)
		group = [monsters[randint(start, end)], 1]
		wave_data.append(group)
	return wave_data

def SpawnNextWave(event):
	wave = int(Mission_GetAttr('wave'))
	sk.SpawnWave(GenerateWave())
	Mission_SetAttr('wave', wave+1)

def OnPostInit():
	sk.PreSetup()
	sk.Setup()
	Mission_SetAttr('bonus_start', 10000)
	Mission_SetAttr('bonus_time', 20)
	Mission_SetAttr('bonus_loss', 2500)
	Mission_SetAttr('ignore_bonus_timer', 0)
	sk.StartBonus()
	SpawnNextWave('')
	SetupFFXSkirmish()

def OnBonusChange(event):
	sk.OnBonusChange(event)
	
def OnSelectionRequiredCheck():
	return 0

def OnGameTypeCheck():
	return sk.GetStandardMarkerNames()