# cuba

from cshelper import *
from js import *
import event

def OnBaseDialog(event):
	print "OnBaseDialog"
	print Mission_GetAttr('visited team')
	if Mission_GetAttr('visited team'):
		if Mission_GetAttr('visited DB'):
			if not Mission_GetAttr('played3'):
				play(base3_dialog_ss, 'base dialog', interrupt = 1)
				Mission_SetAttr('played3', 1)
		else:
			regDialog('DLG_BASE', 'OnBaseDialog')
			if not Mission_GetAttr('played2'):
				play(base2_dialog_ss, 'base dialog', interrupt = 1)
				Mission_SetAttr('played2', 1)
	else:
		regDialog('DLG_BASE', 'OnBaseDialog')
		if not Mission_GetAttr('played1'):
			play(base1_dialog_ss, 'base dialog', interrupt = 1)
			Mission_SetAttr('played1', 1)

def OnTeamDialog(event):
	print 'OnTeamDialog'
	Mission_SetAttr('last', 1)
	print 'last = ' + `Mission_GetAttr('last')`
	regDialog('DLG_TEAM', 'OnTeamDialog')
	if not Mission_GetAttr('visited team'):
		play(team_dialog_ss, 'team dialog', interrupt = 1)
		Mission_SetAttr('visited team', 1)

def OnCharDialog(event):
	if Mission_GetAttr('last'):
		play(char_dialog_ss, 'char dialog', interrupt = 1)
	else:
		regDialog('DLG_CHAR', 'OnCharDialog')

def OnDatabaseDialog(event):
	print 'OnDatabaseDialog'
	Mission_SetAttr('last', 0)
	print 'last = ' + `Mission_GetAttr('last')`
	regDialog('DLG_DATABASE', 'OnDatabaseDialog')
	if not Mission_GetAttr('visited DB'):
		play(database_dialog_ss, 'database dialog', interrupt = 1)
		Mission_SetAttr('visited DB', 1)

def OnPowerDialog(event):
	if Mission_GetAttr('last'):
		play(power_dialog_ss, 'power dialog', interrupt = 1)
	else:
		regDialog('DLG_POWER', 'OnPowerDialog')

def OnSquadDialog(event):
	play(squad_dialog_ss, 'squad dialog', interrupt = 1)


def OnPostInit():
	print 'cuba base/start'
	#cs setup stuff
	lookAtPos((-730,134,0), zoom = -200.0, pitch= 0, heading = -102.3)
	Mission_SetSunlight(0, 40, 0.5, 0, (1,1,1))
	Object_PlayEffect('_impobj_main_screen2', 'cs_screen_manbot', '', FX_LOOP|FX_TRACK_OBJECT_ROT)

#	Mission_Play2DCutscene('cutscene_nazi_world', 'cutscene_nazi_world_wav', 'SparkItUp')
#	play(delay_hack_ss, 'delay hack', interrupt = 1)

	#Campaign stuff
	Campaign_Recruit('alchemiss')
	Campaign_UnlockOrigin('alchemiss')
	Campaign_Recruit('el_diablo')
	Campaign_UnlockOrigin('el_diablo')
	Campaign_Recruit('mentor')
	Campaign_UnlockOrigin('mentor')
	Campaign_Recruit('minute_man')
	Campaign_UnlockOrigin('minute_man')

	Campaign_AddMinion('thug_with_bat')
	Campaign_AddMinion('thug_with_gun')
	Campaign_AddVillain('nuclear_winter')
	Campaign_AddVillain('time_master')
	Campaign_AddMinion('ice_trooper')
	Campaign_AddMinion('ice_sergeant')

	regDialog('DLG_BASE', 'OnBaseDialog')
	regDialog('DLG_TRAINING', 'OnTeamDialog')
	regDialog('DLG_CHAR', 'OnCharDialog')
	regDialog('DLG_DATABASE', 'OnDatabaseDialog')
	regDialog('DLG_SQUADSELECT', 'OnSquadDialog')
	Mission_SetAttr('visited team', 0)
	Mission_SetAttr('visited DB', 0)
	Mission_SetAttr('last', 0)
	Mission_SetAttr('played1', 0)
	Mission_SetAttr('played2', 0)
	Mission_SetAttr('played3', 0)
	OnBaseDialog(event)


def OnBriefing():
	Object_Spawn('el_diablo', 'el_diablo', 'Hero_pos1')
	play(briefing_cs, 'briefing_cs', priority = 2, interrupt = 1)
	print 'cuba base/briefing'

#-----------
# data
#-----------

delay_hack_ss = [
(
	"AI_CancelAllSpeech()",
	"wait(10)",
),
(
	"blank",
),
]

base1_dialog_ss = [
(
	"AI_CancelAllSpeech()",
	"speak('narrator', 'MISSPCH_2_NR_10')",
),
(
	"blank",
),
]

team_dialog_ss = [
(
	"AI_CancelAllSpeech()",
	"speak('narrator', 'MISSPCH_2_NR_11')",
),
(
	"blank",
),
]

char_dialog_ss = [
(
	"AI_CancelAllSpeech()",
	"speak('narrator', 'MISSPCH_2_NR_12')",
),
(
	"blank",
),
]

base2_dialog_ss = [
(
	"AI_CancelAllSpeech()",
	"speak('narrator', 'MISSPCH_2_NR_13')",
),
(
	"blank",
),
]

database_dialog_ss = [
(
	"AI_CancelAllSpeech()",
	"speak('narrator','MISSPCH_2_NR_14')",
),
(
	"blank",
),
]

base3_dialog_ss = [
(
	"AI_CancelAllSpeech()",
	"speak('narrator', 'MISSPCH_2_NR_15')",
),
(
	"blank",
),
]

squad_dialog_ss = [
(
	"AI_CancelAllSpeech()",
	"speak('narrator', 'MISSPCH_2_NR_16')",
),
(
	"blank",
),
]


briefing_cs = [
(
	"AI_CancelAllSpeech()",
	"startCS()",
	"lookAtPos((-660,102,0), zoom = -256.6, pitch= -10, heading = -105.3)",
	"moveTo('el_diablo', 'alchemiss')",
	"Sound_PlayMusic('music_02cuba_base1',1)",
	"wait(3)",
),
(
	"lookAtPos((-594,145,0), zoom = -261.7, pitch= -5, heading = 10.9)",
	"speak('el_diablo', 'BRFSPCH_2_ED_01')", # El Diablo did somebody order mexica...
),
(
	"speak('el_diablo', 'BRFSPCH_2_ED_02')", # El Diablo weird around here, lately...
),
(
	"speak('el_diablo', 'BRFSPCH_2_ED_03')", # El Diablo you know, i was thinking ...
	"turnTo('alchemiss', 'el_diablo')",
),
(
	"lookAtPos((-640,187,0), zoom = -259.5, heading = -57.3)",
	"speak('alchemiss', 'BRFSPCH_2_AL_01')", # Alchemiss i'm not in the mood for j... 
),
(
	"speak('el_diablo', 'BRFSPCH_2_ED_04')", # El Diablo we all miss that big tin ... 
),
(
	"speak('alchemiss', 'BRFSPCH_2_AL_02')", # Alchemiss you don't understand! how... 
	"Object_Spawn('minute_man', 'minute_man', 'Hero_pos3')"
),
(
	"Object_StopEffect('_impobj_main_screen2', 1)",
	"Object_PlayEffect('_impobj_main_screen2', 'cs_screen_alert', '', FX_LOOP|FX_TRACK_OBJECT_ROT)",
	"wait(1)",
),
(
	"lookAtPos((-681,129,0), zoom = -146.0, pitch= 0, heading = -70.8)",
	"forceSpeak('mentor', 'BRFSPCH_2_ME_01', telepathy= 1)", # Mentor attention freedom force! ...
	"moveTo('minute_man', 'el_diablo')",
),
(
	"speak('alchemiss', 'BRFSPCH_2_AL_03')", # Alchemiss duty calls. 
),
(
	"lookAtPos((-594,145,0), zoom = -261.7, pitch= -5, heading = 10.9)",
	"Object_PlayEffect('_impobj_main_screen', 'cs_screen_cuba', '', FX_LOOP|FX_TRACK_OBJECT_ROT)",
	"moveCB('minute_man', 'Hero_pos1')",
	"move('alchemiss', 'Hero_pos1')",
	"move('el_diablo', 'Hero_pos1')",
),
(
	"Mission_Play2DCutscene('transition_mission_nif', 'transition_mission_wav', 'onStepCB')",
	"teleport('minute_man', 'Hero_pos2')",
	"teleport('alchemiss', 'Hero_pos5')",
	"teleport('el_diablo', 'Hero_pos4')",
),
(
	"lookAtPos((-6,191,0), zoom = -246.2, pitch= -5, heading = -64.6)",
	"Sound_PlayMusic('music_02cuba_base2',1)",
	"speak('el_diablo', 'BRFSPCH_2_ED_05')", # El Diablo now let me get this strai... 
	"turnTo('mentor', 'el_diablo')",
	"turnTo('el_diablo', 'mentor')",
	"turnTo('charles_wilson', 'el_diablo')",
),
(
	"speak('minute_man', 'BRFSPCH_2_MM_01')", # Minute Man this "bozo" happens the d... 
	"turnTo('el_diablo', 'minute_man')",
),
(
	"speak('charles_wilson', 'BRFSPCH_2_CH_01')", # Charles Wilson now, now minuteman. i can...    
),
(
	"speak('charles_wilson', 'BRFSPCH_2_CH_02')", # Charles Wilson second halfof line    
),
(
	"speak('minute_man', 'BRFSPCH_2_MM_02')", # Minute Man and for all we know, they...   
),
(
	"lookAtPos((20,108,0), zoom = -244.8, pitch= 0, heading = 85.2)",
	"speak('mentor', 'BRFSPCH_2_ME_02')", # Mentor i've sent out a global ps...  
),
(
	"speak('minute_man', 'BRFSPCH_2_MM_03')", # Minute Man saddle up, freedom force!...  
),
(
	"speak('el_diablo', 'BRFSPCH_2_ED_06')", # El Diablo ay! so much for my dinner...
),
(
	"lookAtPos((-16,138,0), zoom = -201.4, pitch= -10, heading = -78.2)",
	"move('minute_man', 'Hero_pos1')",
	"move('alchemiss', 'Hero_pos1')",
	"move('el_diablo', 'Hero_pos1')",
	"move('mentor', 'Hero_pos1')",
	"wait(3)",
),
(
	"endBriefingCS()",
),
]


