# red

from cshelper import *
from js import *
import event

def OnIntermission():
	Mission_PlayOriginStory('tombstone')

def OnPostInit():
	print 'red base/start'

	#CS setup
	lookAtPos((103,5,0), zoom = -238.7, pitch= -10, heading = 36.1)
	Mission_SetSunlight(0, 40, 0.5, 0, (1,1,1))
	Object_PlayEffect('_impobj_main_screen', 'cs_screen_medical', '', FX_LOOP|FX_TRACK_OBJECT_ROT)

	Campaign_Recruit('alchemiss')
	Campaign_UnlockOrigin('alchemiss')
	Campaign_Recruit('el_diablo')
	Campaign_UnlockOrigin('el_diablo')
	Campaign_Recruit('mentor')
	Campaign_UnlockOrigin('mentor')
	Campaign_Recruit('minute_man')
	Campaign_UnlockOrigin('minute_man')
	Campaign_Recruit('tombstone')
	Campaign_UnlockOrigin('tombstone')
	Campaign_AddHero ('liberty_lad')
	Campaign_UnlockOrigin('liberty_lad')

	Campaign_AddMinion('thug_with_bat')
	Campaign_AddMinion('thug_with_gun')
	Campaign_AddVillain('nuclear_winter')
	Campaign_AddVillain('time_master')
	Campaign_AddMinion('ice_trooper')
	Campaign_AddMinion('ice_sergeant')
	Campaign_AddMinion('snow_man')

	regDialog('DLG_BASE', 'OnBaseDialog')
	regDialog('DLG_RECRUITMENT', 'OnRecruitDialog')
	Mission_SetAttr('played1', 0)
	Mission_SetAttr('visited recruit', 0)

def OnBaseDialog(event):
	print "OnBaseDialog"
	if not Mission_GetAttr('played1'):
		play(base4_dialog_ss, 'base4 dialog', interrupt = 1)
		Mission_SetAttr('played1', 1)

def OnRecruitDialog(event):
	print 'OnTeamDialog'
	if not Mission_GetAttr('visited recruit'):
		play(team_dialog_ss, 'team dialog', interrupt = 1)
		Mission_SetAttr('visited recruit', 1)




def OnBriefing():
	play(briefing_cs, 'briefing_cs', priority = 2, interrupt = 1)
	print 'red base/briefing'

#-----------
# data
#-----------


base4_dialog_ss = [
(
	"AI_CancelAllSpeech()",
	"speak('narrator', 'MISSPCH_3_NR_01')",
),
(
	"blank",
),
]

team_dialog_ss = [
(
	"AI_CancelAllSpeech()",
	"speak('narrator', 'MISSPCH_3_NR_02')",
),
(
	"blank",
),
]


briefing_cs = [
(
	"AI_CancelAllSpeech()",
	"startCS()",
	"lookAtPos((42,-83,32), zoom = -216.8, pitch= 15, heading = 99.4)",
	"wait(1)",
),
(
	"speak('minute_man',  'BRFSPCH_3_MM_01', CAPTION_TOP_LEFT)", #Minute Man mentor! mentor! good grav...  
),
(
	"speak('alchemiss',  'BRFSPCH_3_AL_01', CAPTION_BOTTOM_RIGHT)", #Alchemiss he caint be! we caint los...
),
(
	"Object_Spawn('tombstone', 'tombstone', 'hero_pos1')",
	"lookAtPos((25,-44,14), zoom = -271.3, pitch= 0, heading = 3.6)",
	"null()",
),
(
	"lookAtPos((25,-44,14), zoom = -270.5, pitch= 0, heading = 28.9, time = 4)",
	"moveCB('tombstone', 'hero_pos2')",
),
(
	"speak('tombstone',  'BRFSPCH_3_TS_01', CAPTION_BOTTOM_LEFT)", #Tombstone you fools understand litt...  
),
(
	"turnTo('el_diablo', 'tombstone')",
	"speak('el_diablo',  'BRFSPCH_3_ED_01', CAPTION_TOP_LEFT)", #El Diablo it's tombstone!
),
(
	"speak('tombstone',  'BRFSPCH_3_TS_02', CAPTION_BOTTOM_LEFT)", #Tombstone his spirit has simply bee...  
),
(
	"AI_Animate('tombstone', 'ranged_3', 'onStepCB')",
	"Object_PlayEffect('_impobj_mentor_dead1', 'csfx_tombstone_shadow_shift', '', FX_TRACK_OBJECT_ROT)",
),
(
	"lookAtPos((32,-48,15), zoom = -263.4, pitch= -5, heading = 95)",
	"speak('minute_man',  'BRFSPCH_3_MM_02', CAPTION_TOP_LEFT)", #Minute Man old friend- are you-?
	"Object_Destroy('_impobj_mentor_dead1')",
        "spawn('mentor', 'mentor', 'mentor_pos1')",
	"AI_Animate('mentor', 'get_up_back', '')",
),
(
	"move('mentor', 'hero_pos3')",
	"speak('mentor',  'BRFSPCH_3_ME_01', CAPTION_TOP_RIGHT)", #Mentor just fine, minuteman. tha...  
),
(
	"lookAtPos((-35,0,0), zoom = -252.9, pitch= 0, heading = -112.9)",
	"speak('tombstone',  'BRFSPCH_3_TS_03', CAPTION_BOTTOM_LEFT)", #Tombstone i require neither your th...  
	"turnTo('mentor', 'tombstone')",
),
(
	"turnTo('alchemiss', 'tombstone')",
	"speak('alchemiss',  'BRFSPCH_3_AL_02', CAPTION_BOTTOM_RIGHT)", #Alchemiss so how did you spend your...  
),
(
	"speak('tombstone',  'BRFSPCH_3_TS_04', CAPTION_BOTTOM_LEFT)", #Tombstone small animals wither in m...  
),
(
	"lookAtPos((31,-56,15), zoom = -255.3, pitch= 0, heading = 132.9)", 
	"speak('mentor',  'BRFSPCH_3_ME_02', CAPTION_TOP_RIGHT)", #Mentor we have no time for witti...  
),
(
	"speak('charles_wilson',  'BRFSPCH_3_CH_01', CAPTION_TOP_LEFT)", #Charles Wilson beware, freedom force! nu...  
),
(
	"speak('alchemiss',  'BRFSPCH_3_AL_03', CAPTION_TOP_RIGHT)", #Alchemiss so what else is new?  
),
(
	"endBriefingCS()",
),
]

