# inside

from cshelper import *
from js import *
import event

def OnIntermission():
	Mission_PlayOriginStory('green_genie')
	
def OnPostInit():
	print 'inside base/start'

	Object_PlayEffect('_impobj_main_screen', 'cs_screen_scan', '', FX_LOOP|FX_TRACK_OBJECT_ROT)
	lookAtPos((96,-8,0), zoom = -218.2, pitch = -10, heading = 103.0)
	Mission_SetSunlight(0, 60, 0.5, 0, (1,1,1))
	AI_Animate('charles_wilson', 'idle2', '', 0, 1)
	regTimer('WilsonPoints', 5)

	Campaign_Recruit('alchemiss')
	Campaign_UnlockOrigin('alchemiss')
	Campaign_Recruit('el_diablo')
	Campaign_UnlockOrigin('el_diablo')
	Campaign_Recruit('mentor')
	Campaign_UnlockOrigin('mentor')
	Campaign_Recruit('minute_man')
	Campaign_UnlockOrigin('minute_man')
	Campaign_Recruit('tombstone')
	Campaign_UnlockOrigin('tombstone')
	Campaign_AddHero ('liberty_lad')
	Campaign_UnlockOrigin('liberty_lad')
	Campaign_Recruit('bullet')
	Campaign_UnlockOrigin('bullet')
	Campaign_AddHero ('green_genie')
	Campaign_UnlockOrigin('green_genie')

	Campaign_AddMinion('thug_with_bat')
	Campaign_AddMinion('thug_with_gun')
	Campaign_AddVillain('nuclear_winter')
	Campaign_AddVillain('time_master')
	Campaign_AddMinion('ice_trooper')
	Campaign_AddMinion('ice_sergeant')
	Campaign_AddMinion('snow_man')
	Campaign_AddMinion('shurale')
	Campaign_AddVillain('red_oktober')

	regDialog('DLG_BASE', 'OnBaseDialog')
	Mission_SetAttr('played1', 0)

def OnBaseDialog(event):
	print "OnBaseDialog"
	if not Mission_GetAttr('played1'):
		play(base4_dialog_ss, 'base4 dialog', interrupt = 1)
		Mission_SetAttr('played1', 1)


def OnBriefing():
	play(briefing_cs, 'briefing_cs', priority = 2, interrupt = 1)
	print 'inside base/briefing'

def WilsonPoints(event):
	if isCSPlaying():
		print "they see it"
	else:
		AI_Animate('charles_wilson', 'point', 'WilsonStands', 0, 0)
		
def WilsonStands(event):
	if isCSPlaying():
		print "already at attention"
	else:
		AI_Animate('charles_wilson', 'idle2', '', 0, 1)
		regTimer('WilsonPoints', 5)

#-----------
# data
#-----------

base4_dialog_ss = [
(
	"AI_CancelAllSpeech()",
	"speak('narrator', 'MISSPCH_4_NR_03')",
),
(
	"blank",
),
]


briefing_cs = [
(
	"AI_CancelAllSpeech()",
	"startCS()",
	"lookAtPos((114,12,0), zoom = -234.2, pitch = -10, heading =  25.0)",
	"turnTo('mentor', 'minute_man')",
	"turnTo('charles_wilson', 'minute_man')",
	"wait(0.5)",
),
(
	"speak('mentor', 'BRFSPCH_4_ME_01')", #you must follow RED OKTOB...  
),
(
	"lookAtPos((74,31,0), zoom = -235.2, pitch = -10, heading =  -4.9)",
	"move('minute_man', 'hero_exit')",
	"move('el_diablo', 'hero_exit')",
	"move('tombstone', 'hero_exit')",
	"wait(3)",
),
(        
	"endBriefingCS()",
),
]

