# inside part 2

from cshelper import *
from js import *
from random import randint
import event
from ffx import *

def OnPrecacheObjects():
	print "inside 2/precache"
	Mission_PrecacheTemplateObj('mentor',1,0)
	Mission_PrecacheTemplateObj('red_oktober',1,1)
	Mission_PrecacheTemplateObj('shurale',1,1)
	Mission_PrecacheTemplateObj('ice_trooper_guard',1,1)

def OnPostInit():
	print "inside 2/start"
	setMission(4)

	Mission_SetSunlight(-80,75,0.8,0.4,(0.6,0.3,0.6))
	Mission_SetShadows(-80,75,(0.4,0.2,0.4))
	Mission_SetProjShadowBackground((1,1,1))
	Mission_SetProjShadowColor((.6,.6,.6,1))

	Mission_SetAttr('generator_d1_dead', 0)
	Mission_SetAttr('generator_d2_dead', 0)
	Mission_SetAttr('total_dgens_dead', 0)
	Mission_SetAttr('generator_e1_dead', 0)
	Mission_SetAttr('generator_e2_dead', 0)
	Mission_SetAttr('generator_e3_dead', 0)
	Mission_SetAttr('total_egens_dead', 0)

	Mission_SetAttr('cauldron_d1_dead', 0)
	Mission_SetAttr('cauldron_d2_dead', 0)
	Mission_SetAttr('cauldron_e1_dead', 0)
	Mission_SetAttr('cauldron_e2_dead', 0)
	Mission_SetAttr('cauldron_e3_dead', 0)
	Mission_SetAttr('total_cauldrons_dead', 0)
	Mission_SetAttr('played_minion_spawn_ss', 0)
	Mission_SetAttr('cauldron_ro_dead', 0)
	regDeath('_impobj_cauldron_d1', 'OnCauldronD1Destroyed')
	regDeath('_impobj_cauldron_d2', 'OnCauldronD2Destroyed')
	regDeath('_impobj_cauldron_e1', 'OnCauldronE1Destroyed')
	regDeath('_impobj_cauldron_e2', 'OnCauldronE2Destroyed')
	regDeath('_impobj_cauldron_e3', 'OnCauldronE3Destroyed')

	Object_Spawn('generator_standin_cro1', 'ro_generator_standin', 'cauldron_ro1_fx_point')
	Object_Spawn('generator_standin_cro2', 'ro_generator_standin', 'cauldron_ro2_fx_point')
	Object_Spawn('generator_standin_cro3', 'ro_generator_standin', 'cauldron_ro3_fx_point')
	Object_Spawn('generator_standin_cro4', 'ro_generator_standin', 'ro_respawn_fx')

	Event_RegisterSink(EVENT_TEMPLATE_OBJ_DIED, 'OnCivilianKO', 'cuban_male', '', 0, 0, 1)
	regHeroMarkerEnter('trigger_help_d_ss','HelpD')
	staygoal=Null()
	addGoalToAI('civilian4',staygoal,ai.goal.PRI_HI)
	regHeroMarkerEnter('trigger_help_e_ss','HelpE')
	addGoalToAI('civilian5',staygoal,ai.goal.PRI_HI)

	regDeath('_impobj_cage_d', 'CageDOpen')
	regDeath('_impobj_cage_e', 'CageEOpen')
	Object_Spawn('exit_point', 'ro_generator_standin', 'exit_marker')
	Object_Spawn('waypoint1', 'ro_generator_standin', 'waypoint_marker1')

	Mission_SetAttr('total_civs_freed', 0)

	Mission_CustomAction('enter', '', '_impobj_pumpkin_d', 'OnKnockPumpkinD', 10, 1)
	Mission_CustomAction('enter', '', '_impobj_pumpkin_e', 'OnKnockPumpkinE', 10, 1)

	Object_Spawn('generator_standin_d1', 'ro_generator_standin', 'gen_d1_marker')
	Object_Spawn('generator_standin_d2', 'ro_generator_standin', 'gen_d2_marker')
	Object_Spawn('generator_standin_e1', 'ro_generator_standin', 'gen_e1_marker')
	Object_Spawn('generator_standin_e2', 'ro_generator_standin', 'gen_e2_marker')
	Object_Spawn('generator_standin_e3', 'ro_generator_standin', 'gen_e3_marker')

	regHeroMarkerEnter('trigger_detoad_toads_d', 'DetoadToadsD')
	regHeroMarkerEnter('trigger_toads_e1_arrow', 'ToadsE1Arrow')
	regHeroMarkerEnter('trigger_detoad_toads_e1', 'DetoadToadsE1')
	regHeroMarkerEnter('trigger_detoad_toads_e2', 'DetoadToadsE2')

	regHeroMarkerEnter('trigger_cauldron_d1_setup', 'CauldronD1Setup')
	regHeroMarkerEnter('trigger_cauldron_d2_setup', 'CauldronD2Setup')
	regHeroMarkerEnter('trigger_cauldron_e1_setup', 'CauldronE1Setup')
	regHeroMarkerEnter('trigger_cauldron_e2_setup', 'CauldronE2Setup')
	regHeroMarkerEnter('trigger_cauldron_e3_setup', 'CauldronE3Setup')

# Ken doesn't want this scene in
#	regHeroMarkerEnter('trigger_ss_high_ground', 'PlayHighGroundSS')
	Mission_SetAttr('goo_lines_spoken', 0)
	regHeroMarkerEnter('goo_d1_marker', 'GooD1')
	regHeroMarkerEnter('goo_d2_marker', 'GooD2')
	regHeroMarkerEnter('goo_d3_marker', 'GooD3')
	regHeroMarkerEnter('goo_d4_marker', 'GooD4')
	regHeroMarkerEnter('goo_e1_marker', 'GooE1')
	regHeroMarkerEnter('goo_e2_marker', 'GooE2')
	regHeroMarkerEnter('goo_f1_marker', 'GooF1')
	regHeroMarkerEnter('goo_f2_marker', 'GooF2')
	regHeroMarkerEnter('goo_f3_marker', 'GooF3')

	regHeroMarkerEnter('trigger_boss_fight', 'BossFightSetup')

	Mission_SetAttr('multiple_guards', 1)
	Mission_SetAttr('multiple_cauldrons', 1)

	Mission_SetAttr('mission_won',0)
	regDialog('DLG_DEBRIEF', 'OnDebrief')

#	TestFinale()
	play(start_cs, "start_cs")
	FFX_InitMission()

def TestFinale():
	OpenPumpkinD(event,event)
	OpenPumpkinE(event,event)
	newObjective('primary', 1, name='learn_secrets')
	registerObjective('primary', 2, name='kill_cauldron')
#	FinalROSpawn(event)
#	play(final_cs, "final_cs")




def HelpD(event):
	HelpSpeech(event)
	addArrow('cage_d_arrow', '_impobj_cage_d', js.ARROW_YELLOW, delete=1)

def HelpE(event):
	HelpSpeech(event)
	addArrow('cage_e_arrow', '_impobj_cage_e', js.ARROW_YELLOW, delete=1)

def HelpSpeech(event):
	print "HelpSpeech"
	temp = randint(0,2)
	if temp == 0:
		play(civ_help_ss_1,'civ_help_ss_1')
	elif temp == 1:
		play(civ_help_ss_2,'civ_help_ss_2')
	elif temp == 2:
		play(civ_help_ss_3,'civ_help_ss_3')
	else:
		print "bad random number in Helppeech???"

def CageDOpen(event):
	addAttr('total_civs_freed', 1)
	print Mission_GetAttr('total_civs_freed')
	clearGoals('civilian4')
	Object_SetAttr('civilian4','pathBudget',1500)
	regProximityEnter('civilian4','exit_point',5,'RemoveCiv')
	exitpos=Get_MarkerPos('exit_marker')
	newgoal=Move(exitpos)
	ai.addGoalToAI('civilian4',newgoal,ai.goal.PRI_MED)
	FreeSpeech(event)
	if (Mission_GetAttr('total_civs_freed') == 5) and (Objective_IsFailed('free_civs') != 1):
		Objective_Complete('free_civs')

def RemoveCiv(event):
	print event.object
	Object_Destroy(event.object)
def WaypointCiv1(event):
	clearGoals(event.object)
	exitpos=Get_MarkerPos('exit_marker')
	newgoal=Move(exitpos)
	ai.addGoalToAI(event.object,newgoal,ai.goal.PRI_MED)
	regProximityEnter(event.object,'exit_point',5,'RemoveCiv')

def CageEOpen(event):
	addAttr('total_civs_freed', 1)
	print Mission_GetAttr('total_civs_freed')
	clearGoals('civilian5')
	Object_SetAttr('civilian5','pathBudget',1500)
	regProximityEnter('civilian5','waypoint1',5,'WaypointCiv1')
	exitpos=Get_MarkerPos('waypoint_marker1')
	newgoal=Move(exitpos)
	ai.addGoalToAI('civilian5',newgoal,ai.goal.PRI_MED)
	FreeSpeech(event)
	if (Mission_GetAttr('total_civs_freed') == 5) and (Objective_IsFailed('free_civs') != 1):
		Objective_Complete('free_civs')

def FreeSpeech(event):
	temp = randint(0,2)
	if temp == 0:
		play(civ_thank_ss_1,'civ_thank_ss_1')
	elif temp == 1:
		play(civ_thank_ss_2,'civ_thank_ss_2')
	elif temp == 2:
		play(civ_thank_ss_3,'civ_thank_ss_3')
	else:
		print "bad random number in FreeSpeech???"


def PickAToad():
	difficulty = 10 - RPG_GAME_DIFFICULTY
	temp = randint(0,difficulty)
	print "choosing monster number"
	print temp
	if temp == 0:
		return 'ice_trooper_guard'
	elif temp == 1:
		return 'dark_shaman'
	elif temp == 2:
		return 'shurale'
	else:
		return 'cuban_male'

def DetoadToadsD(event):
	kill("toad_d1")
	kill("toad_d2")
	kill("toad_d3")
	### play detoading FX?
	playEffectMarker('effect_frog_transition','toad_d1_spawn_point')
	playEffectMarker('effect_frog_transition','toad_d2_spawn_point')
	playEffectMarker('effect_frog_transition','toad_d3_spawn_point')
	removeArrow('toads_d_arrow')
	toad_d1 = PickAToad()
	toad_d2 = PickAToad()
	toad_d3 = PickAToad()
	spawn('detoad_toad_d3', toad_d3, 'toad_d3_spawn_point')
	spawn('detoad_toad_d2', toad_d2, 'toad_d2_spawn_point')
	spawn('detoad_toad_d1', toad_d1, 'toad_d1_spawn_point')
	addAttr('total_civs_freed', 1)
	print Mission_GetAttr('total_civs_freed')
	if (Mission_GetAttr('total_civs_freed') == 5) and (Objective_IsFailed('free_civs') != 1):
		Objective_Complete('free_civs')
	exitpos=Get_MarkerPos('exit_marker')
	newgoal=Move(exitpos)
	if toad_d1 == 'cuban_male':
		ai.addGoalToAI('detoad_toad_d1',newgoal,ai.goal.PRI_MED)
		Object_SetAttr('detoad_toad_d1','pathBudget',1500)
		regProximityEnter('detoad_toad_d1','exit_point',5,'RemoveCiv')
	if toad_d2 == 'cuban_male':
		ai.addGoalToAI('detoad_toad_d2',newgoal,ai.goal.PRI_MED)
		Object_SetAttr('detoad_toad_d2','pathBudget',1500)
		regProximityEnter('detoad_toad_d2','exit_point',5,'RemoveCiv')
	if toad_d3 == 'cuban_male':
		ai.addGoalToAI('detoad_toad_d3',newgoal,ai.goal.PRI_MED)
		Object_SetAttr('detoad_toad_d3','pathBudget',1500)
		regProximityEnter('detoad_toad_d3','exit_point',5,'RemoveCiv')

def ToadsE1Arrow(event):
	addArrow('toads_e1_arrow', 'trigger_detoad_toads_e1', js.ARROW_YELLOW, delete=1)

def DetoadToadsE1(event):
	kill("toad_e1")
	kill("toad_e2")
	kill("toad_e3")
	### play detoading FX?
	playEffectMarker('effect_frog_transition','toad_e1_spawn_point')
	playEffectMarker('effect_frog_transition','toad_e2_spawn_point')
	playEffectMarker('effect_frog_transition','toad_e3_spawn_point')
	removeArrow('toads_e1_arrow')
	toad_e1 = PickAToad()
	toad_e2 = PickAToad()
	toad_e3 = PickAToad()
	spawn('detoad_toad_e3', toad_e3, 'toad_e3_spawn_point')
	spawn('detoad_toad_e2', toad_e2, 'toad_e2_spawn_point')
	spawn('detoad_toad_e1', toad_e1, 'toad_e1_spawn_point')
	addAttr('total_civs_freed', 1)
	exitpos=Get_MarkerPos('waypoint_marker1')
	newgoal=Move(exitpos)
	print Mission_GetAttr('total_civs_freed')
	if (Mission_GetAttr('total_civs_freed') == 5) and (Objective_IsFailed('free_civs') != 1):
		Objective_Complete('free_civs')
	if toad_e1 == 'cuban_male':
		ai.addGoalToAI('detoad_toad_e1',newgoal,ai.goal.PRI_MED)
		Object_SetAttr('detoad_toad_e1','pathBudget',1500)
		regProximityEnter('detoad_toad_e1','waypoint1',5,'WaypointCiv1')
	if toad_e2 == 'cuban_male':
		ai.addGoalToAI('detoad_toad_e2',newgoal,ai.goal.PRI_MED)
		Object_SetAttr('detoad_toad_e2','pathBudget',1500)
		regProximityEnter('detoad_toad_e2','waypoint1',5,'WaypointCiv1')
	if toad_e3 == 'cuban_male':
		ai.addGoalToAI('detoad_toad_e3',newgoal,ai.goal.PRI_MED)
		Object_SetAttr('detoad_toad_e3','pathBudget',1500)
		regProximityEnter('detoad_toad_e3','waypoint1',5,'WaypointCiv1')

def DetoadToadsE2(event):
	kill("toad_e4")
	kill("toad_e5")
	kill("toad_e6")
	kill("toad_e7")
	kill("toad_e8")
	### play detoading FX?
	playEffectMarker('effect_frog_transition','toad_e4_spawn_point')
	playEffectMarker('effect_frog_transition','toad_e5_spawn_point')
	playEffectMarker('effect_frog_transition','toad_e6_spawn_point')
	playEffectMarker('effect_frog_transition','toad_e7_spawn_point')
	playEffectMarker('effect_frog_transition','toad_e8_spawn_point')
	removeArrow('toads_e2_arrow')
	toad_e4 = PickAToad()
	toad_e5 = PickAToad()
	toad_e6 = PickAToad()
	toad_e7 = PickAToad()
	toad_e8 = PickAToad()
	spawn('detoad_toad_e4', toad_e4, 'toad_e4_spawn_point')
	spawn('detoad_toad_e5', toad_e5, 'toad_e5_spawn_point')
	spawn('detoad_toad_e6', toad_e6, 'toad_e6_spawn_point')
	spawn('detoad_toad_e7', toad_e7, 'toad_e7_spawn_point')
	spawn('detoad_toad_e8', toad_e8, 'toad_e8_spawn_point')
	addAttr('total_civs_freed', 1)
	exitpos=Get_MarkerPos('waypoint_marker1')
	newgoal=Move(exitpos)
	print Mission_GetAttr('total_civs_freed')
	if (Mission_GetAttr('total_civs_freed') == 5) and (Objective_IsFailed('free_civs') != 1):
		Objective_Complete('free_civs')
	if toad_e4 == 'cuban_male':
		ai.addGoalToAI('detoad_toad_e4',newgoal,ai.goal.PRI_MED)
		Object_SetAttr('detoad_toad_e4','pathBudget',1500)
		regProximityEnter('detoad_toad_e4','waypoint1',5,'WaypointCiv1')
	if toad_e5 == 'cuban_male':
		ai.addGoalToAI('detoad_toad_e5',newgoal,ai.goal.PRI_MED)
		Object_SetAttr('detoad_toad_e5','pathBudget',1500)
		regProximityEnter('detoad_toad_e5','waypoint1',5,'WaypointCiv1')
	if toad_e6 == 'cuban_male':
		ai.addGoalToAI('detoad_toad_e6',newgoal,ai.goal.PRI_MED)
		Object_SetAttr('detoad_toad_e6','pathBudget',1500)
		regProximityEnter('detoad_toad_e6','waypoint1',5,'WaypointCiv1')
	if toad_e7 == 'cuban_male':
		ai.addGoalToAI('detoad_toad_e7',newgoal,ai.goal.PRI_MED)
		Object_SetAttr('detoad_toad_e7','pathBudget',1500)
		regProximityEnter('detoad_toad_e7','waypoint1',5,'WaypointCiv1')
	if toad_e8 == 'cuban_male':
		ai.addGoalToAI('detoad_toad_e8',newgoal,ai.goal.PRI_MED)
		Object_SetAttr('detoad_toad_e8','pathBudget',1500)
		regProximityEnter('detoad_toad_e8','waypoint1',5,'WaypointCiv1')


def PlayHighGroundSS(event):
	play(high_ground_ss, "high_ground_ss")

def MaybePlayStuckLine(event):
# randomly play a "stuck" line, but with steadily decreasing frequency.
	if randint(0,Mission_GetAttr('goo_lines_spoken')) == 0:
		if Mission_GetAttr('goo_lines_spoken') < 3:
			# don't let the speech get less frequent than 1 in 4.
			addAttr('goo_lines_spoken', 1)
			print Mission_GetAttr('goo_lines_spoken')
		PlayStuckLine(event)
# can't do this in a SS, without mojo work to detect who is stuck
#		play(stuck_line_ss,'stuck_line_ss')
	else:
		print "randomly decided not to speak stuck line, 1 in ", Mission_GetAttr('goo_lines_spoken')

def PlayStuckLine(event):
	if Object_GetTemplate(event.object) == 'minute_man':
		forceSpeakNoCB('minute_man', 'MISSPCH_4_MM_19', telepathy = 0)
	elif Object_GetTemplate(event.object) == 'alchemiss':
		forceSpeakNoCB('alchemiss', 'MISSPCH_4_AL_01', telepathy = 0)
	elif Object_GetTemplate(event.object) == 'el_diablo':
		forceSpeakNoCB('el_diablo', 'MISSPCH_4_ED_01', telepathy = 0)
	elif Object_GetTemplate(event.object) == 'tombstone':
		forceSpeakNoCB('tombstone', 'MISSPCH_4_TS_02', telepathy = 0)
	elif Object_GetTemplate(event.object) == 'liberty_lad':
		forceSpeakNoCB('liberty_lad', 'MISSPCH_4_LL_02', telepathy = 0)
	elif Object_GetTemplate(event.object) == 'bullet':
		forceSpeakNoCB('bullet', 'MISSPCH_4_BL_07', telepathy = 0)
	elif Object_GetTemplate(event.object) == 'green_genie':
		forceSpeakNoCB('green_genie', 'MISSPCH_4_GG_08', telepathy = 0)
	else:
		print "custom stuck?!?"

def GooD1(event):
	print "Someone stepped in goo_d1"
	diff = RPG_GAME_DIFFICULTY + 5
	Object_SetSecondaryState(event.object,SCSTATE_SPEED_DECREASED,diff)
	MaybePlayStuckLine(event)
	regTimer('ReGooD1',12)

def ReGooD1(event):
	regHeroMarkerEnter('goo_d1_marker', 'GooD1')

def GooD2(event):
	print "Someone stepped in goo_d2"
	diff = RPG_GAME_DIFFICULTY + 5
	Object_SetSecondaryState(event.object,SCSTATE_SPEED_DECREASED,diff)
	MaybePlayStuckLine(event)
	regTimer('ReGooD2',12)

def ReGooD2(event):
	regHeroMarkerEnter('goo_d2_marker', 'GooD2')

def GooD3(event):
	print "Someone stepped in goo_d3"
	diff = RPG_GAME_DIFFICULTY + 5
	Object_SetSecondaryState(event.object,SCSTATE_SPEED_DECREASED,diff)
	MaybePlayStuckLine(event)
	regTimer('ReGooD3',12)

def ReGooD3(event):
	regHeroMarkerEnter('goo_d3_marker', 'GooD3')

def GooD4(event):
	print "Someone stepped in goo_d4"
	diff = RPG_GAME_DIFFICULTY + 5
	Object_SetSecondaryState(event.object,SCSTATE_SPEED_DECREASED,diff)
	MaybePlayStuckLine(event)
	regTimer('ReGooD4',12)

def ReGooD4(event):
	regHeroMarkerEnter('goo_d4_marker', 'GooD4')

def GooE1(event):
	print "Someone stepped in goo_e1"
	diff = RPG_GAME_DIFFICULTY + 5
	Object_SetSecondaryState(event.object,SCSTATE_SPEED_DECREASED,diff)
	MaybePlayStuckLine(event)
	regTimer('ReGooE1',12)

def ReGooE1(event):
	regHeroMarkerEnter('goo_e1_marker', 'GooE1')

def GooE2(event):
	print "Someone stepped in goo_e2"
	diff = RPG_GAME_DIFFICULTY + 5
	Object_SetSecondaryState(event.object,SCSTATE_SPEED_DECREASED,diff)
	MaybePlayStuckLine(event)
	regTimer('ReGooE2',12)

def ReGooE2(event):
	regHeroMarkerEnter('goo_e2_marker', 'GooE2')

def GooF1(event):
	print "Someone stepped in goo_f1"
	diff = RPG_GAME_DIFFICULTY + 5
	Object_SetSecondaryState(event.object,SCSTATE_SPEED_DECREASED,diff)
# don't play lines here, there's plenty going on already
#	MaybePlayStuckLine(event)
	regTimer('ReGooF1',12)

def ReGooF1(event):
	regHeroMarkerEnter('goo_f1_marker', 'GooF1')

def GooF2(event):
	print "Someone stepped in goo_f2"
	diff = RPG_GAME_DIFFICULTY + 5
	Object_SetSecondaryState(event.object,SCSTATE_SPEED_DECREASED,diff)
# don't play lines here, there's plenty going on already
#	MaybePlayStuckLine(event)
	regTimer('ReGooF2',12)

def ReGooF2(event):
	regHeroMarkerEnter('goo_f2_marker', 'GooF2')

def GooF3(event):
	print "Someone stepped in goo_f3"
	diff = RPG_GAME_DIFFICULTY + 5
	Object_SetSecondaryState(event.object,SCSTATE_SPEED_DECREASED,diff)
# don't play lines here, there's plenty going on already
#	MaybePlayStuckLine(event)
	regTimer('ReGooF3',12)

def ReGooF3(event):
	regHeroMarkerEnter('goo_f3_marker', 'GooF3')



def OnKnockPumpkinD(event, char):
	Object_PlayEffect('generator_standin_d1', 'effect_generator_spawn', 'OnSpawnEffectFinishedD1',FX_TRACK_OBJECT_ROT)
	Object_PlayEffect('generator_standin_d2', 'effect_generator_spawn', 'OnSpawnEffectFinishedD2',FX_TRACK_OBJECT_ROT)
	removeArrow('pumpkin_d_arrow')
	addArrow('gen_d1_arrow', 'gen_d1_marker', js.ARROW_RED, delete=1)
	addArrow('gen_d2_arrow', 'gen_d2_marker', js.ARROW_RED, delete=1)
	Mission_RemoveCustomAction('enter', '', '_impobj_pumpkin_d')
	if RPG_GAME_DIFFICULTY > 1:
		playEffectMarker('effect_redtree_spawn','guard_d1_point1',key='spawn',keyFn='GenD1Guard1Spawn')
	if RPG_GAME_DIFFICULTY > 2:
		playEffectMarker('effect_redtree_spawn','guard_d2_point1',key='spawn',keyFn='GenD2Guard1Spawn')
	if RPG_GAME_DIFFICULTY > 3:
		playEffectMarker('effect_redtree_spawn','guard_d1_point2',key='spawn',keyFn='GenD1Guard2Spawn')
	if RPG_GAME_DIFFICULTY > 4:
		playEffectMarker('effect_redtree_spawn','guard_d1_point3',key='spawn',keyFn='GenD1Guard3Spawn')
	if RPG_GAME_DIFFICULTY > 5:
		playEffectMarker('effect_redtree_spawn','guard_d2_point2',key='spawn',keyFn='GenD2Guard2Spawn')
	PickSpeechGensUp(event)
def GenD1Guard1Spawn(event):
	spawn('guard_d1_1', 'ice_trooper_guard', 'guard_d1_point1')
def GenD1Guard2Spawn(event):
	spawn('guard_d1_2', 'ice_trooper_guard', 'guard_d1_point2')
def GenD1Guard3Spawn(event):
	spawn('guard_d1_3', 'ice_trooper_guard', 'guard_d1_point3')
def GenD2Guard1Spawn(event):
	spawn('guard_d2_1', 'dark_shaman', 'guard_d2_point1')
def GenD2Guard2Spawn(event):
	spawn('guard_d2_2', 'dark_shaman', 'guard_d2_point2')

def OnSpawnEffectFinishedD1(event):
	spawn("generator_d1", "ro_generator", "gen_d1_marker")
	regDeath('generator_d1', 'OnGenD1Destroyed')
	print("Generator D1 is back up")
def OnSpawnEffectFinishedD2(event):
	spawn("generator_d2", "ro_generator", "gen_d2_marker")
	regDeath('generator_d2', 'OnGenD2Destroyed')
	print("Generator D2 is back up")

def OnKnockPumpkinE(event, char):
	Object_PlayEffect('generator_standin_e1', 'effect_generator_spawn', 'OnSpawnEffectFinishedE1',FX_TRACK_OBJECT_ROT)
	Object_PlayEffect('generator_standin_e2', 'effect_generator_spawn', 'OnSpawnEffectFinishedE2',FX_TRACK_OBJECT_ROT)
	Object_PlayEffect('generator_standin_e3', 'effect_generator_spawn', 'OnSpawnEffectFinishedE3',FX_TRACK_OBJECT_ROT)
	removeArrow('pumpkin_e_arrow')
	addArrow('gen_e1_arrow', 'gen_e1_marker', js.ARROW_RED, delete=1)
	addArrow('gen_e2_arrow', 'gen_e2_marker', js.ARROW_RED, delete=1)
	addArrow('gen_e3_arrow', 'gen_e3_marker', js.ARROW_RED, delete=1)
	Mission_RemoveCustomAction('enter', '', '_impobj_pumpkin_e')
	if RPG_GAME_DIFFICULTY > 1:
		playEffectMarker('effect_redtree_spawn','guard_e1_point1',key='spawn',keyFn='GenE1Guard1Spawn')
	if RPG_GAME_DIFFICULTY > 2:
		playEffectMarker('effect_redtree_spawn','guard_e2_point1',key='spawn',keyFn='GenE2Guard1Spawn')
		playEffectMarker('effect_redtree_spawn','guard_e3_point1',key='spawn',keyFn='GenE3Guard1Spawn')
	if RPG_GAME_DIFFICULTY > 3:
		playEffectMarker('effect_redtree_spawn','guard_e1_point2',key='spawn',keyFn='GenE1Guard2Spawn')
		playEffectMarker('effect_redtree_spawn','guard_e2_point2',key='spawn',keyFn='GenE2Guard2Spawn')
	if RPG_GAME_DIFFICULTY > 4:
		playEffectMarker('effect_redtree_spawn','guard_e3_point2',key='spawn',keyFn='GenE3Guard2Spawn')
	if RPG_GAME_DIFFICULTY > 5:
		playEffectMarker('effect_redtree_spawn','guard_e2_point3',key='spawn',keyFn='GenE2Guard3Spawn')
	PickSpeechGensUp(event)
def GenE1Guard1Spawn(event):
	spawn('guard_e1_1', 'ice_trooper_guard', 'guard_e1_point1')
def GenE1Guard2Spawn(event):
	spawn('guard_e1_2', 'ice_trooper_guard', 'guard_e1_point2')
def GenE2Guard1Spawn(event):
	spawn('guard_e2_1', 'dark_shaman', 'guard_e2_point1')
def GenE2Guard2Spawn(event):
	spawn('guard_e2_2', 'dark_shaman', 'guard_e2_point2')
def GenE2Guard3Spawn(event):
	spawn('guard_e2_3', 'dark_shaman', 'guard_e2_point3')
def GenE3Guard1Spawn(event):
	spawn('guard_e3_1', 'ice_trooper_guard', 'guard_e3_point1')
def GenE3Guard2Spawn(event):
	spawn('guard_e3_2', 'ice_trooper_guard', 'guard_e3_point2')

def OnSpawnEffectFinishedE1(event):
	spawn("generator_e1", "ro_generator", "gen_e1_marker")
	regDeath('generator_e1', 'OnGenE1Destroyed')
def OnSpawnEffectFinishedE2(event):
	spawn("generator_e2", "ro_generator", "gen_e2_marker")
	regDeath('generator_e2', 'OnGenE2Destroyed')
def OnSpawnEffectFinishedE3(event):
	spawn("generator_e3", "ro_generator", "gen_e3_marker")
	regDeath('generator_e3', 'OnGenE3Destroyed')



# These functions do things when one of a set of Generators is destroyed

def OnGenD1Destroyed(event):
	Object_PlayEffect('generator_standin_d1', 'effect_generator_destroy','',FX_TRACK_OBJECT_ROT)
	removeArrow('gen_d1_arrow')
	print "Generator D1 Destroyed"
	addAttr('total_dgens_dead', 1)				   # increment the count of how many Generators are currently dead
	print Mission_GetAttr('total_dgens_dead')
	if Mission_GetAttr('total_dgens_dead') == 2:	 # if all Generators of the set are currently dead...
		AllDGensGone(event)							   # ...open the matching Pumpkin Gate.  Otherwise...
	else:
		regTimer('RespawnGenD1', (37 - 3*RPG_GAME_DIFFICULTY))			   # 10 seconds from now, the appropriate RespawnGenXX function will get called

def OnGenD2Destroyed(event):
	Object_PlayEffect('generator_standin_d2', 'effect_generator_destroy','',FX_TRACK_OBJECT_ROT)
	removeArrow('gen_d2_arrow')
	print "Generator D2 Destroyed"
	addAttr('total_dgens_dead', 1)				   # increment the count of how many Generators are currently dead
	print Mission_GetAttr('total_dgens_dead')
	if Mission_GetAttr('total_dgens_dead') == 2:	 # if all Generators of the set are currently dead...
		AllDGensGone(event)							   # ...open the matching Pumpkin Gate.  Otherwise...
	else:
		regTimer('RespawnGenD2', (37 - 3*RPG_GAME_DIFFICULTY))			   # 10 seconds from now, the appropriate RespawnGenXX function will get called

def OnGenE1Destroyed(event):
	Object_PlayEffect('generator_standin_e1', 'effect_generator_destroy','',FX_TRACK_OBJECT_ROT)
	removeArrow('gen_e1_arrow')
	print "Generator E1 Destroyed"
	addAttr('total_egens_dead', 1)				   # increment the count of how many Generators are currently dead
	print Mission_GetAttr('total_egens_dead')
	if Mission_GetAttr('total_egens_dead') == 3:	 # if all Generators of the set are currently dead...
		AllEGensGone(event)							   # ...open the matching Pumpkin Gate.  Otherwise...
	else:
		regTimer('RespawnGenE1', (37 - 3*RPG_GAME_DIFFICULTY))			   # 10 seconds from now, the appropriate RespawnGenXX function will get called

def OnGenE2Destroyed(event):
	Object_PlayEffect('generator_standin_e2', 'effect_generator_destroy','',FX_TRACK_OBJECT_ROT)
	removeArrow('gen_e2_arrow')
	print "Generator E2 Destroyed"
	addAttr('total_egens_dead', 1)				   # increment the count of how many Generators are currently dead
	print Mission_GetAttr('total_egens_dead')
	if Mission_GetAttr('total_egens_dead') == 3:	 # if all Generators of the set are currently dead...
		AllEGensGone(event)							   # ...open the matching Pumpkin Gate.  Otherwise...
	else:
		regTimer('RespawnGenE2', (37 - 3*RPG_GAME_DIFFICULTY))			   # 10 seconds from now, the appropriate RespawnGenXX function will get called

def OnGenE3Destroyed(event):
	Object_PlayEffect('generator_standin_e3', 'effect_generator_destroy','',FX_TRACK_OBJECT_ROT)
	removeArrow('gen_e3_arrow')
	print "Generator E3 Destroyed"
	addAttr('total_egens_dead', 1)				   # increment the count of how many Generators are currently dead
	print Mission_GetAttr('total_egens_dead')
	if Mission_GetAttr('total_egens_dead') == 3:	 # if all Generators of the set are currently dead...
		AllEGensGone(event)							   # ...open the matching Pumpkin Gate.  Otherwise...
	else:
		regTimer('RespawnGenE3', (37 - 3*RPG_GAME_DIFFICULTY))			   # 10 seconds from now, the appropriate RespawnGenXX function will get called



# These functions are triggered by the regTimers above completing, thus repawning the appropriate generator

def RespawnGenD1(event):
	if Mission_GetAttr('total_dgens_dead') != 2:						 # we only spawn if this objective hasn't been won already
		print "We should be spawning a new generator now!"
		Object_PlayEffect('generator_standin_d1', 'effect_generator_spawn', 'OnSpawnEffectFinishedD1',FX_TRACK_OBJECT_ROT)
		PickSpeechGenRespawn(event)
		addAttr('total_dgens_dead', -1)								  # appropriate name ("generatorXX") of template type 'ro_generator',
		print Mission_GetAttr('total_dgens_dead')
		addArrow('gen_d1_arrow', 'gen_d1_marker', js.ARROW_RED, delete=1)
	if Mission_GetAttr('total_dgens_dead') == 2:
		print "No respawn; they're all dead"

def RespawnGenD2(event):
	if Mission_GetAttr('total_dgens_dead') != 2:						 # we only spawn if this objective hasn't been won already
		print "We should be spawning a new generator now!"
		Object_PlayEffect('generator_standin_d2', 'effect_generator_spawn', 'OnSpawnEffectFinishedD2',FX_TRACK_OBJECT_ROT)
		PickSpeechGenRespawn(event)
		addAttr('total_dgens_dead', -1)								  # appropriate name ("generatorXX") of template type 'ro_generator',
		print Mission_GetAttr('total_dgens_dead')
		addArrow('gen_d2_arrow', 'gen_d2_marker', js.ARROW_RED, delete=1)
	if Mission_GetAttr('total_dgens_dead') == 2:
		print "No respawn; they're all dead"

def RespawnGenE1(event):
	if Mission_GetAttr('total_egens_dead') != 3:						 # we only spawn if this objective hasn't been won already
		print "We should be spawning a new generator now!"
		Object_PlayEffect('generator_standin_e1', 'effect_generator_spawn', 'OnSpawnEffectFinishedE1',FX_TRACK_OBJECT_ROT)
		PickSpeechGenRespawn(event)
		addAttr('total_egens_dead', -1)								  # appropriate name ("generatorXX") of template type 'ro_generator',
		print Mission_GetAttr('total_egens_dead')
		addArrow('gen_e1_arrow', 'gen_e1_marker', js.ARROW_RED, delete=1)
	if Mission_GetAttr('total_egens_dead') == 3:
		print "No respawn; they're all dead"

def RespawnGenE2(event):
	if Mission_GetAttr('total_egens_dead') != 3:						 # we only spawn if this objective hasn't been won already
		print "We should be spawning a new generator now!"
		Object_PlayEffect('generator_standin_e2', 'effect_generator_spawn', 'OnSpawnEffectFinishedE2',FX_TRACK_OBJECT_ROT)
		PickSpeechGenRespawn(event)
		addAttr('total_egens_dead', -1)								  # appropriate name ("generatorXX") of template type 'ro_generator',
		print Mission_GetAttr('total_egens_dead')
		addArrow('gen_e2_arrow', 'gen_e2_marker', js.ARROW_RED, delete=1)
	if Mission_GetAttr('total_egens_dead') == 3:
		print "No respawn; they're all dead"

def RespawnGenE3(event):
	if Mission_GetAttr('total_egens_dead') != 3:						 # we only spawn if this objective hasn't been won already
		print "We should be spawning a new generator now!"
		Object_PlayEffect('generator_standin_e3', 'effect_generator_spawn', 'OnSpawnEffectFinishedE3',FX_TRACK_OBJECT_ROT)
		PickSpeechGenRespawn(event)
		addAttr('total_egens_dead', -1)								  # appropriate name ("generatorXX") of template type 'ro_generator',
		print Mission_GetAttr('total_egens_dead')
		addArrow('gen_e3_arrow', 'gen_e3_marker', js.ARROW_RED, delete=1)
	if Mission_GetAttr('total_egens_dead') == 3:
		print "No respawn; they're all dead"



def AllDGensGone(event):
	Mission_CustomAction('enter', '', '_impobj_pumpkin_d', 'OpenPumpkinD', 10, 1)
	print "door D unlocked"
	PickSpeechGensDead(event)
	addArrow('pumpkin_d_arrow', '_impobj_pumpkin_d', js.ARROW_RED, delete=1)
	if RPG_GAME_DIFFICULTY > 2:
		playEffectMarker('effect_redtree_spawn','guard_gate_d_point1',key='spawn',keyFn='DGuard1Spawn')
	if RPG_GAME_DIFFICULTY > 3:
		playEffectMarker('effect_redtree_spawn','guard_gate_d_point2',key='spawn',keyFn='DGuard2Spawn')
	if RPG_GAME_DIFFICULTY > 5:
		playEffectMarker('effect_redtree_spawn','guard_gate_d_point3',key='spawn',keyFn='DGuard3Spawn')
def DGuard1Spawn(event):
	spawn('guard_gate_d1', 'shurale', 'guard_gate_d_point1')
def DGuard2Spawn(event):
	spawn('guard_gate_d2', 'shurale', 'guard_gate_d_point2')
def DGuard3Spawn(event):
	spawn('guard_gate_d3', 'shurale', 'guard_gate_d_point3')
def OpenPumpkinD(event,heroname):
	print "Open Door D"
	pumpkinDPos = Get_ObjectPos('_impobj_pumpkin_d')
	pumpkinDRot = Object_GetOrientation('_impobj_pumpkin_d')
	playEffect('effect_ro_pumpkin_gate', pumpkinDPos, pumpkinDRot[1])
	kill('_impobj_pumpkin_d')
	kill('_impobj_fog3')
	kill('_impobj_physics_stopper_3')
	addArrow('pumpkin_e_arrow', '_impobj_pumpkin_e', js.ARROW_RED, delete=1)
	Mission_CustomAction('enter', '', '_impobj_pumpkin_e', 'OnKnockPumpkinE', 10, 1)
# don't know why I have to do this again, but it seems necessary

def AllEGensGone(event):
	Mission_CustomAction('enter', '', '_impobj_pumpkin_e', 'OpenPumpkinE', 10, 1)
	print "door E unlocked"
	PickSpeechGensDead(event)
	addArrow('pumpkin_e_arrow', '_impobj_pumpkin_e', js.ARROW_RED, delete=1)
	if RPG_GAME_DIFFICULTY > 1:
		playEffectMarker('effect_redtree_spawn','guard_gate_e_point1',key='spawn',keyFn='EGuard1Spawn')
	if RPG_GAME_DIFFICULTY > 3:
		playEffectMarker('effect_redtree_spawn','guard_gate_e_point2',key='spawn',keyFn='EGuard2Spawn')
	if RPG_GAME_DIFFICULTY > 4:
		playEffectMarker('effect_redtree_spawn','guard_gate_e_point3',key='spawn',keyFn='EGuard3Spawn')
def EGuard1Spawn(event):
	spawn('guard_gate_e1', 'shurale', 'guard_gate_e_point1')
def EGuard2Spawn(event):
	spawn('guard_gate_e2', 'shurale', 'guard_gate_e_point2')
def EGuard3Spawn(event):
	spawn('guard_gate_e3', 'shurale', 'guard_gate_e_point3')
def OpenPumpkinE(event,heroname):
	print "Open Door E"
	pumpkinEPos = Get_ObjectPos('_impobj_pumpkin_e')
	pumpkinERot = Object_GetOrientation('_impobj_pumpkin_e')
	playEffect('effect_ro_pumpkin_gate', pumpkinEPos, pumpkinERot[1])
	kill('_impobj_pumpkin_e')
	kill('_impobj_fog4')
	kill('_impobj_physics_stopper_4')

# Cauldron functions

def CauldronD1Setup(event):
	addArrow('cauldron_d1_arrow', '_impobj_cauldron_d1', js.ARROW_YELLOW, delete=1)
	spawn('cauldron_d1_fx1_object','invisible_object','cauldron_d1_fx1')
	spawn('cauldron_d1_fx2_object','invisible_object','cauldron_d1_fx2')
	RespawnCauldronD1_1(event)
	if RPG_GAME_DIFFICULTY > 3:
		regTimer('RespawnCauldronD1_2',8 - RPG_GAME_DIFFICULTY)

def OnSpawnD1_1Destroyed(event):
	regTimer('CleanupCauldronD1_1', 7.5 - RPG_GAME_DIFFICULTY)
	regTimer('RespawnCauldronD1_1', 8 - RPG_GAME_DIFFICULTY)
def OnSpawnD1_2Destroyed(event):
	regTimer('CleanupCauldronD1_2', 7.5 - RPG_GAME_DIFFICULTY)
	regTimer('RespawnCauldronD1_2', 8 - RPG_GAME_DIFFICULTY)

def CleanupCauldronD1_1(event):
	Object_Destroy('ice_trooper_from_d1_1', 0)
def CleanupCauldronD1_2(event):
	Object_Destroy('ice_trooper_from_d1_2', 0)

def RespawnCauldronD1_1(event):
	if Mission_GetAttr('cauldron_d1_dead') == 0:  # check if cauldron is still alive
		Object_PlayEffect('cauldron_d1_fx1_object','effect_cauldron_eject','',FX_TRACK_OBJECT_ROT)
		regTimer('ActualSpawnD1_1',1.75)
def RespawnCauldronD1_2(event):
	if Mission_GetAttr('cauldron_d1_dead') == 0:  # check if cauldron is still alive
		Object_PlayEffect('cauldron_d1_fx2_object','effect_cauldron_eject','',FX_TRACK_OBJECT_ROT)
		regTimer('ActualSpawnD1_2',1.75)

def ActualSpawnD1_1(event):
	spawn('ice_trooper_from_d1_1', 'ice_trooper_guard', 'cauldron_d1_spawn_point1')
	regDeath('ice_trooper_from_d1_1', 'OnSpawnD1_1Destroyed')
	ITRespawnSpeech()
#	play(it_respawn_ss,'it_respawn_ss')
def ActualSpawnD1_2(event):
	spawn('ice_trooper_from_d1_2', 'ice_trooper_guard', 'cauldron_d1_spawn_point2')
	regDeath('ice_trooper_from_d1_2', 'OnSpawnD1_2Destroyed')
	ITRespawnSpeech()
#	play(it_respawn_ss,'it_respawn_ss')

def ITRespawnSpeech():
	temp = randint(0,2)
	if temp == 0:
		forceSpeak('ice_trooper', 'MISSPCH_4_IT_03', telepathy=0)
	elif temp == 1:
		forceSpeak('ice_trooper', 'MISSPCH_4_IT_04', telepathy=0)
	elif temp == 2:
		forceSpeak('ice_trooper', 'MISSPCH_4_IT_05', telepathy=0)
	else:
		print "bad random number in ITRespawnSpeech???"
		wait(.1)

def OnCauldronD1Destroyed(event):
	PickCauldronDeadLine(event)
	Mission_SetAttr('cauldron_d1_dead', 1)
	addAttr('total_cauldrons_destroyed',1)
	if Mission_GetAttr('total_cauldrons_destroyed') == 5:
		Objective_Complete('cauldrons')


def CauldronD2Setup(event):
	addArrow('cauldron_d2_arrow', '_impobj_cauldron_d2', js.ARROW_YELLOW, delete=1)
	spawn('cauldron_d2_fx1_object','invisible_object','cauldron_d2_fx1')
	spawn('cauldron_d2_fx2_object','invisible_object','cauldron_d2_fx2')
	RespawnCauldronD2_1(event)
	if RPG_GAME_DIFFICULTY > 3:
		regTimer('RespawnCauldronD2_2',8 - RPG_GAME_DIFFICULTY)

def OnSpawnD2_1Destroyed(event):
	regTimer('CleanupCauldronD2_1', 7.5 - RPG_GAME_DIFFICULTY)
	regTimer('RespawnCauldronD2_1', 8 - RPG_GAME_DIFFICULTY)
def OnSpawnD2_2Destroyed(event):
	regTimer('CleanupCauldronD2_2', 7.5 - RPG_GAME_DIFFICULTY)
	regTimer('RespawnCauldronD2_2', 8 - RPG_GAME_DIFFICULTY)

def CleanupCauldronD2_1(event):
	Object_Destroy('shurale_from_d2_1', 0)
def CleanupCauldronD2_2(event):
	Object_Destroy('shurale_from_d2_2', 0)

def RespawnCauldronD2_1(event):
	if Mission_GetAttr('cauldron_d2_dead') == 0:  # check if cauldron is still alive
		Object_PlayEffect('cauldron_d2_fx1_object','effect_cauldron_eject','',FX_TRACK_OBJECT_ROT)
		regTimer('ActualSpawnD2_1',1.75)
def RespawnCauldronD2_2(event):
	if Mission_GetAttr('cauldron_d2_dead') == 0:  # check if cauldron is still alive
		Object_PlayEffect('cauldron_d2_fx2_object','effect_cauldron_eject','',FX_TRACK_OBJECT_ROT)
		regTimer('ActualSpawnD2_2',1.75)

def ActualSpawnD2_1(event):
	spawn('shurale_from_d2_1', 'shurale', 'cauldron_d2_spawn_point1')
	regDeath('shurale_from_d2_1', 'OnSpawnD2_1Destroyed')
	SRRespawnSpeech()
#	play(sr_respawn_ss,'sr_respawn_ss')
def ActualSpawnD2_2(event):
	spawn('shurale_from_d2_2', 'shurale', 'cauldron_d2_spawn_point2')
	regDeath('shurale_from_d2_2', 'OnSpawnD2_2Destroyed')
	SRRespawnSpeech()
#	play(sr_respawn_ss,'sr_respawn_ss')

def SRRespawnSpeech():
	temp = randint(0,0)
	if temp == 0:
		forceSpeak('shurale', 'MISSPCH_4_SR_01', telepathy=0)
	else:
		print "bad random number in SRRespawnSpeech???"
		wait(.1)

def OnCauldronD2Destroyed(event):
	PickCauldronDeadLine(event)
	Mission_SetAttr('cauldron_d2_dead', 1)
	addAttr('total_cauldrons_destroyed',1)
	if Mission_GetAttr('total_cauldrons_destroyed') == 5:
		Objective_Complete('cauldrons')


def CauldronE1Setup(event):
	addArrow('cauldron_e1_arrow', '_impobj_cauldron_e1', js.ARROW_YELLOW, delete=1)
	spawn('cauldron_e1_fx1_object','invisible_object','cauldron_e1_fx1')
	spawn('cauldron_e1_fx2_object','invisible_object','cauldron_e1_fx2')
	RespawnCauldronE1_1(event)
	if RPG_GAME_DIFFICULTY > 2:
		regTimer('RespawnCauldronE1_2',8 - RPG_GAME_DIFFICULTY)

def OnSpawnE1_1Destroyed(event):
	regTimer('CleanupCauldronE1_1', 7.5 - RPG_GAME_DIFFICULTY)
	regTimer('RespawnCauldronE1_1', 8 - RPG_GAME_DIFFICULTY)
def OnSpawnE1_2Destroyed(event):
	regTimer('CleanupCauldronE1_2', 7.5 - RPG_GAME_DIFFICULTY)
	regTimer('RespawnCauldronE1_2', 8 - RPG_GAME_DIFFICULTY)

def CleanupCauldronE1_1(event):
	Object_Destroy('ice_trooper_from_e1_1', 0)
def CleanupCauldronE1_2(event):
	Object_Destroy('ice_trooper_from_e1_2', 0)

def RespawnCauldronE1_1(event):
	if Mission_GetAttr('cauldron_e1_dead') == 0:  # check if cauldron is still alive
		Object_PlayEffect('cauldron_e1_fx1_object','effect_cauldron_eject','',FX_TRACK_OBJECT_ROT)
		regTimer('ActualSpawnE1_1',1.75)
def RespawnCauldronE1_2(event):
	if Mission_GetAttr('cauldron_e1_dead') == 0:  # check if cauldron is still alive
		Object_PlayEffect('cauldron_e1_fx2_object','effect_cauldron_eject','',FX_TRACK_OBJECT_ROT)
		regTimer('ActualSpawnE1_2',1.75)

def ActualSpawnE1_1(event):
	spawn('ice_trooper_from_e1_1', 'ice_trooper_guard', 'cauldron_e1_spawn_point1')
	regDeath('ice_trooper_from_e1_1', 'OnSpawnE1_1Destroyed')
	ITRespawnSpeech()
#	play(it_respawn_ss,'it_respawn_ss')
def ActualSpawnE1_2(event):
	spawn('ice_trooper_from_e1_2', 'ice_trooper_guard', 'cauldron_e1_spawn_point2')
	regDeath('ice_trooper_from_e1_2', 'OnSpawnE1_2Destroyed')
	ITRespawnSpeech()
#	play(it_respawn_ss,'it_respawn_ss')

def OnCauldronE1Destroyed(event):
	PickCauldronDeadLine(event)
	Mission_SetAttr('cauldron_e1_dead', 1)
	addAttr('total_cauldrons_destroyed',1)
	if Mission_GetAttr('total_cauldrons_destroyed') == 5:
		Objective_Complete('cauldrons')


def CauldronE2Setup(event):
	addArrow('cauldron_e2_arrow', '_impobj_cauldron_e2', js.ARROW_YELLOW, delete=1)
	spawn('cauldron_e2_fx1_object','invisible_object','cauldron_e2_fx1')
	spawn('cauldron_e2_fx2_object','invisible_object','cauldron_e2_fx2')
	RespawnCauldronE2_1(event)
	if RPG_GAME_DIFFICULTY > 4:
		regTimer('RespawnCauldronE2_2',8 - RPG_GAME_DIFFICULTY)

def OnSpawnE2_1Destroyed(event):
	regTimer('CleanupCauldronE2_1', 7.5 - RPG_GAME_DIFFICULTY)
	regTimer('RespawnCauldronE2_1', 8 - RPG_GAME_DIFFICULTY)
def OnSpawnE2_2Destroyed(event):
	regTimer('CleanupCauldronE2_2', 7.5 - RPG_GAME_DIFFICULTY)
	regTimer('RespawnCauldronE2_2', 8 - RPG_GAME_DIFFICULTY)

def CleanupCauldronE2_1(event):
	Object_Destroy('dark_shaman_from_e2_1', 0)
def CleanupCauldronE2_2(event):
	Object_Destroy('dark_shaman_from_e2_2', 0)

def RespawnCauldronE2_1(event):
	if Mission_GetAttr('cauldron_e2_dead') == 0:  # check if cauldron is still alive
		Object_PlayEffect('cauldron_e2_fx1_object','effect_cauldron_eject','',FX_TRACK_OBJECT_ROT)
		regTimer('ActualSpawnE2_1',1.75)
def RespawnCauldronE2_2(event):
	if Mission_GetAttr('cauldron_e2_dead') == 0:  # check if cauldron is still alive
		Object_PlayEffect('cauldron_e2_fx2_object','effect_cauldron_eject','',FX_TRACK_OBJECT_ROT)
		regTimer('ActualSpawnE2_2',1.75)

def ActualSpawnE2_1(event):
	spawn('dark_shaman_from_e2_1', 'dark_shaman', 'cauldron_e2_spawn_point1')
	regDeath('dark_shaman_from_e2_1', 'OnSpawnE2_1Destroyed')
	DSRespawnSpeech()
#	play(ds_respawn_ss,'ds_respawn_ss')
def ActualSpawnE2_2(event):
	spawn('dark_shaman_from_e2_2', 'dark_shaman', 'cauldron_e2_spawn_point2')
	regDeath('dark_shaman_from_e2_2', 'OnSpawnE2_2Destroyed')
	DSRespawnSpeech()
#	play(ds_respawn_ss,'ds_respawn_ss')

def DSRespawnSpeech():
	temp = randint(0,2)
	if temp == 0:
		forceSpeak('dark_shaman', 'MISSPCH_4_DS_02', telepathy=0)
	elif temp == 1:
		forceSpeak('dark_shaman', 'MISSPCH_4_DS_03', telepathy=0)
	elif temp == 2:
		forceSpeak('dark_shaman', 'MISSPCH_4_DS_04', telepathy=0)
	else:
		print "bad random number in DSRespawnSpeech???"
		wait(.1)

def OnCauldronE2Destroyed(event):
	PickCauldronDeadLine(event)
	Mission_SetAttr('cauldron_e2_dead', 1)
	addAttr('total_cauldrons_destroyed',1)
	if Mission_GetAttr('total_cauldrons_destroyed') == 5:
		Objective_Complete('cauldrons')


def CauldronE3Setup(event):
	addArrow('cauldron_e3_arrow', '_impobj_cauldron_e3', js.ARROW_YELLOW, delete=1)
	addArrow('toads_e2_arrow', 'trigger_detoad_toads_e2', js.ARROW_YELLOW, delete=1)
	spawn('cauldron_e3_fx1_object','invisible_object','cauldron_e3_fx1')
	spawn('cauldron_e3_fx2_object','invisible_object','cauldron_e3_fx2')
	RespawnCauldronE3_1(event)
	if RPG_GAME_DIFFICULTY > 3:
		regTimer('RespawnCauldronE3_2',8 - RPG_GAME_DIFFICULTY)

def OnSpawnE3_1Destroyed(event):
	regTimer('CleanupCauldronE3_1', 7.5 - RPG_GAME_DIFFICULTY)
	regTimer('RespawnCauldronE3_1', 8 - RPG_GAME_DIFFICULTY)
def OnSpawnE3_2Destroyed(event):
	regTimer('CleanupCauldronE3_2', 7.5 - RPG_GAME_DIFFICULTY)
	regTimer('RespawnCauldronE3_2', 8 - RPG_GAME_DIFFICULTY)

def CleanupCauldronE3_1(event):
	Object_Destroy('shurale_from_e3_1', 0)
def CleanupCauldronE3_2(event):
	Object_Destroy('shurale_from_e3_2', 0)

def RespawnCauldronE3_1(event):
	if Mission_GetAttr('cauldron_e3_dead') == 0:  # check if cauldron is still alive
		Object_PlayEffect('cauldron_e3_fx1_object','effect_cauldron_eject','',FX_TRACK_OBJECT_ROT)
		regTimer('ActualSpawnE3_1',1.75)
def RespawnCauldronE3_2(event):
	if Mission_GetAttr('cauldron_e3_dead') == 0:  # check if cauldron is still alive
		Object_PlayEffect('cauldron_e3_fx2_object','effect_cauldron_eject','',FX_TRACK_OBJECT_ROT)
		regTimer('ActualSpawnE3_2',1.75)

def ActualSpawnE3_1(event):
	spawn('shurale_from_e3_1', 'shurale', 'cauldron_e3_spawn_point1')
	regDeath('shurale_from_e3_1', 'OnSpawnE3_1Destroyed')
	SRRespawnSpeech()
#	play(sr_respawn_ss,'sr_respawn_ss')
def ActualSpawnE3_2(event):
	spawn('shurale_from_e3_2', 'shurale', 'cauldron_e3_spawn_point2')
	regDeath('shurale_from_e3_2', 'OnSpawnE3_2Destroyed')
	SRRespawnSpeech()
#	play(sr_respawn_ss,'sr_respawn_ss')

def OnCauldronE3Destroyed(event):
	PickCauldronDeadLine(event)
	Mission_SetAttr('cauldron_e3_dead', 1)
	addAttr('total_cauldrons_destroyed',1)
	if Mission_GetAttr('total_cauldrons_destroyed') == 5:
		Objective_Complete('cauldrons')


def BossFightSetup(event):
	spawn('ice_trooper_from_ro1', 'ice_trooper_guard', 'cauldron_ro1_spawn_point')
	regDeath('ice_trooper_from_ro1', 'OnSpawnRO1Destroyed')
	spawn('dark_shaman_from_ro2', 'dark_shaman', 'cauldron_ro2_spawn_point')
	regDeath('dark_shaman_from_ro2', 'OnSpawnRO2Destroyed')
	spawn('shurale_from_ro3', 'shurale', 'cauldron_ro3_spawn_point')
	regDeath('shurale_from_ro3', 'OnSpawnRO3Destroyed')
	spawn('ro','red_oktober','ro_respawn_marker')
	regDeath('ro', 'RedOktoberKO')
	###tune health number below
	regAlmostDead('_impobj_cauldron_ro', 'PlaySaveCauldronSS', health = 20)
	regDeath('_impobj_cauldron_ro', 'OnCauldronRODestroyed')
	play(red_boss_cs, 'red_boss_cs')

def OnSpawnRO1Destroyed(event):
	regTimer('CleanupCauldronRO1', 7.5 - RPG_GAME_DIFFICULTY)
	regTimer('RespawnCauldronRO1', 8 - RPG_GAME_DIFFICULTY)

def CleanupCauldronRO1(event):
	Object_Destroy('ice_trooper_from_ro1', 0)

def RespawnCauldronRO1(event):
	if Mission_GetAttr('cauldron_ro_dead') == 0:	# check if cauldron is still alive
		Object_PlayEffect('generator_standin_cro1', 'effect_cauldron_eject_long','',FX_TRACK_OBJECT_ROT)
		regTimer('ActualSpawnCRO1',1.75)
		if Mission_GetAttr('played_minion_spawn_ss') == 0:
			play(minion_spawn_ss, 'minion_spawn_ss')
			Mission_SetAttr('played_minion_spawn_ss', 1)

def ActualSpawnCRO1(event):
	spawn('ice_trooper_from_ro1', 'ice_trooper_guard', 'cauldron_ro1_spawn_point')
	regDeath('ice_trooper_from_ro1', 'OnSpawnRO1Destroyed')
	ITRespawnSpeech()
#	play(it_respawn_ss,'it_respawn_ss')

def OnSpawnRO2Destroyed(event):
	regTimer('CleanupCauldronRO2', 7.5 - RPG_GAME_DIFFICULTY)
	regTimer('RespawnCauldronRO2', 8 - RPG_GAME_DIFFICULTY)

def CleanupCauldronRO2(event):
	Object_Destroy('dark_shaman_from_ro2', 0)

def RespawnCauldronRO2(event):
	if Mission_GetAttr('cauldron_ro_dead') == 0:	# check if cauldron is still alive
		Object_PlayEffect('generator_standin_cro2', 'effect_cauldron_eject_long','',FX_TRACK_OBJECT_ROT)
		regTimer('ActualSpawnCRO2',1.75)
		if Mission_GetAttr('played_minion_spawn_ss') == 0:
			play(minion_spawn_ss, 'minion_spawn_ss')
			Mission_SetAttr('played_minion_spawn_ss', 1)

def ActualSpawnCRO2(event):
	spawn('dark_shaman_from_ro2', 'dark_shaman', 'cauldron_ro2_spawn_point')
	regDeath('dark_shaman_from_ro2', 'OnSpawnRO2Destroyed')
	DSRespawnSpeech()
#	play(ds_respawn_ss,'ds_respawn_ss')

def OnSpawnRO3Destroyed(event):
	regTimer('CleanupCauldronRO3', 7.5 - RPG_GAME_DIFFICULTY)
	regTimer('RespawnCauldronRO3', 8 - RPG_GAME_DIFFICULTY)

def CleanupCauldronRO3(event):
	Object_Destroy('shurale_from_ro3', 0)

def RespawnCauldronRO3(event):
	if Mission_GetAttr('cauldron_ro_dead') == 0:	# check if cauldron is still alive
		Object_PlayEffect('generator_standin_cro3', 'effect_cauldron_eject_long','',FX_TRACK_OBJECT_ROT)
		regTimer('ActualSpawnCRO3',1.75)
		if Mission_GetAttr('played_minion_spawn_ss') == 0:
			play(minion_spawn_ss, 'minion_spawn_ss')
			Mission_SetAttr('played_minion_spawn_ss', 1)

def ActualSpawnCRO3(event):
	spawn('shurale_from_ro3', 'shurale', 'cauldron_ro3_spawn_point')
	regDeath('shurale_from_ro3', 'OnSpawnRO3Destroyed')
	SRRespawnSpeech()
#	play(sr_respawn_ss,'sr_respawn_ss')


def OnCauldronRODestroyed(event):
	Objective_Complete('kill_cauldron')
	Mission_SetAttr('cauldron_ro_dead', 1)
	play(cauldron_destroyed_ss, "cauldron_destroyed_ss",interrupt=1)
	if Object_IsAlive('ro') == 0:
		Objective_Complete('kill_ro')
		CleanupRO(event)
		regTimer('FinalROSpawn', 1)
	else:
		addArrow('ro_arrow', 'ro', js.ARROW_RED, delete=1)

def RedOktoberKO(event):
	print "Red Oktober KOd"
	if Objective_IsComplete('kill_cauldron'):
		Objective_Complete('kill_ro')
		kill('ro')
		regTimer('CleanupRO',.1)
#		regTimer('FinalROSpawn', 1)
		play(final_cs, 'final_cs',interrupt=1)
	else:
		regTimer('CleanupRO', 9.5 - RPG_GAME_DIFFICULTY)
		regTimer('RespawnRO', 10 - RPG_GAME_DIFFICULTY)

def CleanupRO(event):
	Object_Destroy('ro', 0)

def RespawnRO(event):
	print "respawn RO"
	if Objective_IsComplete('kill_cauldron'):
		Objective_Complete('kill_ro')
		CleanupRO(event)
		regTimer('FinalROSpawn', 1)
		play(final_cs, 'final_cs')
	else:
		Object_PlayEffect('generator_standin_cro4', 'effect_cauldron_eject_long','',FX_TRACK_OBJECT_ROT)
		regTimer('ActualSpawnCRO4',1.75)

def ActualSpawnCRO4(event):
	print "start RO Respawn SS"
	play(ro_respawn_ss,'ro_respawn_ss')

def RORespawn():
	spawn('ro','red_oktober','ro_respawn_marker')
	regDeath('ro', 'RedOktoberKO')
	forceSpeak('red_oktober', 'MISSPCH_4_RO_03', telepathy = 0)


def PlaySaveCauldronSS(event):
	print "play save cauldron SS"
	play(save_cauldron_ss, "save_cauldron_ss",interrupt=1)
	Object_SetAttr('_impobj_cauldron_ro','minHealth',0)


def OnCivilianKO(event):
	if Objective_IsFailed('live_civs') != 1:
		Objective_Fail('live_civs')

def OnMissionWon():
	print "inside 2/won"
	Mission_SetAttr('mission_won',1)
	if not Objective_IsFailed('live_civs'):
		Objective_Complete('live_civs')

def OnMissionLost():
	print "inside 2/lost"

def OnDebrief(event):
	print "Debriefing screen reached with script"
	if Mission_GetAttr('mission_won'):
		print "debrief training here"
	else:
		print "loser training here"
		play(lose_dialog_ss,'lose_dialog_ss',interrupt=1)



def PickSpeechGensUp(event):
	a_hero = getRandomLiveHeroName()
	print a_hero
	if a_hero == 'minute_man':
		speak('minute_man', 'MISSPCH_4_MM_21')
	elif a_hero == 'alchemiss':
		speak('alchemiss', 'MISSPCH_4_AL_07')
	elif a_hero == 'bullet':
		speak('bullet', 'MISSPCH_4_BL_06')
	elif a_hero == 'el_diablo':
		speak('el_diablo', 'MISSPCH_4_ED_07')
	elif a_hero == 'green_genie':
		speak('green_genie', 'MISSPCH_4_GG_07')
	elif a_hero == 'liberty_lad':
		speak('liberty_lad', 'MISSPCH_4_LL_07')
	elif a_hero == 'tombstone':
		speak('tombstone', 'MISSPCH_4_TS_07')
	else:
		print "custom?!?"
		speak('mentor', 'MISSPCH_4_ME_22')

def PickSpeechGenRespawn(event):
	a_hero = getRandomLiveHeroName()
	print a_hero
	if a_hero == 'minute_man':
		speak('minute_man', 'MISSPCH_4_MM_17')
	elif a_hero == 'alchemiss':
		speak('alchemiss', 'MISSPCH_4_AL_04')
	elif a_hero == 'bullet':
		speak('bullet', 'MISSPCH_4_BL_02')
	elif a_hero == 'el_diablo':
		speak('el_diablo', 'MISSPCH_4_ED_04')
	elif a_hero == 'green_genie':
		speak('green_genie', 'MISSPCH_4_GG_03')
	elif a_hero == 'liberty_lad':
		speak('liberty_lad', 'MISSPCH_4_LL_04')
	elif a_hero == 'tombstone':
		speak('tombstone', 'MISSPCH_4_TS_04')
	else:
		print "custom?!?"
		speak('mentor', 'MISSPCH_4_ME_20')

def PickSpeechGensDead(event):
	a_hero = getRandomLiveHeroName()
	print a_hero
	if a_hero == 'minute_man':
		speak('minute_man', 'MISSPCH_4_MM_18')
	elif a_hero == 'alchemiss':
		speak('alchemiss', 'MISSPCH_4_AL_05')
	elif a_hero == 'bullet':
		speak('bullet', 'MISSPCH_4_BL_03')
	elif a_hero == 'el_diablo':
		speak('el_diablo', 'MISSPCH_4_ED_05')
	elif a_hero == 'green_genie':
		speak('green_genie', 'MISSPCH_4_GG_04')
	elif a_hero == 'liberty_lad':
		speak('liberty_lad', 'MISSPCH_4_LL_05')
	elif a_hero == 'tombstone':
		speak('tombstone', 'MISSPCH_4_TS_05')
	else:
		print "custom?!?"
		speak('mentor', 'MISSPCH_4_ME_21')


def PickCauldronDeadLine(event):
	a_hero = getRandomLiveHeroName()
	print a_hero
	if a_hero == 'minute_man':
		speak('minute_man', 'MISSPCH_4_MM_16')
	elif a_hero == 'alchemiss':
		speak('alchemiss', 'MISSPCH_4_AL_03')
	elif a_hero == 'bullet':
		speak('bullet', 'MISSPCH_4_BL_05')
	elif a_hero == 'el_diablo':
		speak('el_diablo', 'MISSPCH_4_ED_03')
	elif a_hero == 'green_genie':
		speak('green_genie', 'MISSPCH_4_GG_06')
	elif a_hero == 'liberty_lad':
		speak('liberty_lad', 'MISSPCH_4_LL_03')
	elif a_hero == 'tombstone':
		speak('tombstone', 'MISSPCH_4_TS_03')
	else:
		print "custom?!?"
		speak('mentor', 'MISSPCH_4_ME_19')


def PickBossLine(event):
	a_hero = getRandomLiveHeroName()
	print a_hero
	if a_hero == 'minute_man':
		speak('minute_man', 'MISSPCH_4_MM_22')
	elif a_hero == 'alchemiss':
		speak('alchemiss', 'MISSPCH_4_AL_11')
	elif a_hero == 'bullet':
		speak('bullet', 'MISSPCH_4_BL_11')
	elif a_hero == 'el_diablo':
		speak('el_diablo', 'MISSPCH_4_ED_11')
	elif a_hero == 'green_genie':
		speak('green_genie', 'MISSPCH_4_GG_12')
	elif a_hero == 'liberty_lad':
		speak('liberty_lad', 'MISSPCH_4_LL_11')
	elif a_hero == 'tombstone':
		speak('tombstone', 'MISSPCH_4_TS_11')
	else:
		print "custom?!?"
		speak('mentor', 'MISSPCH_4_ME_23')



#										 #
# cutscenes and scripted sequences below  #
#										 #



start_cs = [
(
	"peace()",
	"startCS()",
	"look('minute_man', zoom = -150, heading = 250, time = 0)",
	"wait(.5)",
),
(
	"speak('mentor', 'MISSPCH_4_ME_11')",
),
(
	"endCS()",
	"war()",
	"Sound_PlayMusic('music_03inside2')",
	"newObjective('primary', 1, name='learn_secrets')",
	"newObjective('secondary', 2, name='free_civs')",
	"newObjective('secondary', 3, name='live_civs')",
	"newObjective('secondary', 4, name='cauldrons')",
	"registerObjective('primary', 2, name='kill_cauldron')",
	"registerObjective('primary', 3, name='kill_ro')",
	"addArrow('pumpkin_d_arrow', '_impobj_pumpkin_d', js.ARROW_RED, delete=1)",
	"addArrow('toads_d_arrow', 'trigger_detoad_toads_d', js.ARROW_YELLOW, delete=1)"
),
]

civ_thank_ss_1 = [
(
	"forceSpeak('cuban_male', 'MISSPCH_4_CC_02', telepathy=0)",
),
(
	"blank",
),
]

civ_thank_ss_2 = [
(
	"forceSpeak('cuban_male', 'MISSPCH_4_CC_05', telepathy=0)",
),
(
	"blank",
),
]

civ_thank_ss_3 = [
(
	"forceSpeak('cuban_male', 'MISSPCH_4_CC_06', telepathy=0)",
),
(
	"blank",
),
]

civ_help_ss_1 = [
(
	"forceSpeak('cuban_male', 'MISSPCH_4_CC_07', telepathy=0)",
),
(
	"blank",
),
]

civ_help_ss_2 = [
(
	"forceSpeak('cuban_male', 'MISSPCH_4_CC_08', telepathy=0)",
),
(
	"blank",
),
]

civ_help_ss_3 = [
(
	"forceSpeak('cuban_male', 'MISSPCH_4_CC_09', telepathy=0)",
),
(
	"blank",
),
]


stuck_line_ss = [
(
	"ff.PlayStuckLine()",
),
(
	"blank",
),
]

it_respawn_ss = [
(
	"ff.ITRespawnSpeech()",
),
(
	"blank",
),
]

sr_respawn_ss = [
(
	"ff.SRRespawnSpeech()",
),
(
	"blank",
),
]

ds_respawn_ss = [
(
	"ff.DSRespawnSpeech()",
),
(
	"blank",
),
]

ro_respawn_ss = [
(
	"ff.RORespawn()",
),
(
	"blank",
),
]


high_ground_ss = [
(
	"optionalSpeak('minute_man', 'MISSPCH_4_MM_08')",
),
(
	"speak('mentor', 'MISSPCH_4_ME_05')",
),
(
	"blank",
),
]

red_boss_cs = [
(
	"peace()",
	"see()",
	"startCS()",
	"look('ro', zoom = -250, heading = 300)",
	"Sound_PlayMusic('music_03inside1_cs1',1)",
	"wait(.5)",
),
(
	"forceSpeak('red_oktober', 'MISSPCH_4_RO_01', telepathy=0)",
),
(
	"ff.PickBossLine(event)",
),
(
	"forceSpeak('red_oktober', 'MISSPCH_4_RO_13', telepathy=0)",
),
(
	"endCS()",
	"noLook()",
	"blind()",
	"war()",
	"Sound_PlayMusic('music_03inside2')",
),
]

minion_spawn_ss = [
(
	"speak('mentor', 'MISSPCH_4_ME_06')",
),
(
	"addArrow('cauldron_ro_arrow', '_impobj_cauldron_ro', js.ARROW_RED, delete=1)",
	"Objective_Activate('kill_cauldron')",
	"forceSpeak('red_oktober', 'MISSPCH_4_RO_02', telepathy=0)",
),
(
	"blank",
),
]

save_cauldron_ss = [
(
	"forceSpeak('red_oktober', 'MISSPCH_4_RO_04', telepathy=0)",
),
(
	"blank",
),
]

cauldron_destroyed_ss = [
(
	"forceSpeak('red_oktober', 'MISSPCH_4_RO_05', telepathy=0)",
),
(
	"Objective_Activate('kill_ro')",
	"speak('mentor', 'MISSPCH_4_ME_09')",
),
(
	"blank",
),
]

final_cs = [
(
	"peace()",
	"reviveHeroes()",
	"see()",
	"startCS()",
	"forceSpeak('red_oktober', 'MISSPCH_4_RO_07', telepathy=0)",
),
(
	"peace()",
	"destroyAllByTemplate('dark_shaman')",
	"destroyAllByTemplate('shurale')",
	"destroyAllByTemplate('ice_trooper_guard')",
	"spawn('red_oktober','red_oktober','end_ro')",
	"teleport('minute_man','end_mm')",
	"teleport('hero_2','end_h2')",
	"teleport('hero_3','end_h3')",
	"teleport('hero_4','end_h4')",
	"playTransition()",
),
(
	"peace()",
	"look('red_oktober', zoom = -150, heading = 330)",
	"Sound_PlayMusic('music_03inside2_end',1)",
	"Sound_PlaySound('mission_inside2')",
	"speak('minute_man', 'MISSPCH_4_MM_10')",
),
(
	"forceSpeak('red_oktober', 'MISSPCH_4_RO_08', telepathy=0)",
),
(
	"speak('minute_man', 'MISSPCH_4_MM_23')",
),
(
	"forceSpeak('red_oktober', 'MISSPCH_4_RO_12', telepathy=0)",
),
(
	"speak('minute_man', 'MISSPCH_4_MM_11')",
),
(
	"speak('mentor', 'MISSPCH_4_ME_08')",
),
(
	"forceSpeak('red_oktober', 'MISSPCH_4_RO_09', telepathy=0)",
),
(
	"Objective_Complete('learn_secrets')",
	"speak('minute_man', 'MISSPCH_4_MM_12')",
),
(
	"forceSpeak('red_oktober', 'MISSPCH_4_RO_10', telepathy=0)",
),
(
	"speak('minute_man', 'MISSPCH_4_MM_13')",
),
(
	"speak('mentor', 'MISSPCH_4_ME_16')",
),
(
	"forceSpeak('red_oktober', 'MISSPCH_4_RO_11', telepathy=0)",
),
(
	"speak('mentor', 'MISSPCH_4_ME_17')",
),
(
	"endCS()",
	"noLook()",
	"Mission_Win()",
),
]


lose_dialog_ss = [
(
	"AI_CancelAllSpeech()",
	"speak('narrator', 'MISSPCH_4_NR_01', forceNonMission = 1)",
),
(
	"blank",
),
]
