# redsun

from cshelper import *
from js import *
import event

def OnIntermission():
	Mission_PlayOriginStory('black_jack')
	
def OnPostInit():
	print 'redsun base/start'
	Mission_SetSunlight(0, 40, 0.3, 0, (1,1,1))
	lookAtPos((154,16,6), zoom = -200, pitch= 0, heading = 45.3)
	Object_PlayEffect('_impobj_main_screen2', 'cs_screen_eu_heros', '', FX_LOOP|FX_TRACK_OBJECT_ROT)
	Object_PlayEffect('_impobj_main_screen', 'cs_screen_scan', '', FX_LOOP|FX_TRACK_OBJECT_ROT)

	Campaign_Recruit('alchemiss')
	Campaign_UnlockOrigin('alchemiss')
	Campaign_Recruit('el_diablo')
	Campaign_UnlockOrigin('el_diablo')
	Campaign_Recruit('mentor')
	Campaign_UnlockOrigin('mentor')
	Campaign_Recruit('minute_man')
	Campaign_UnlockOrigin('minute_man')
	Campaign_AddHero ('liberty_lad')
	Campaign_UnlockOrigin('liberty_lad')
	Campaign_Recruit('tombstone')
	Campaign_UnlockOrigin('tombstone')
	Campaign_Recruit('bullet')
	Campaign_UnlockOrigin('bullet')
	Campaign_AddHero ('green_genie')
	Campaign_UnlockOrigin('green_genie')
	Campaign_AddHero ('quetzalcoatl')
	Campaign_UnlockOrigin('quetzalcoatl')
	Campaign_Recruit('the_ant')
	Campaign_UnlockOrigin('the_ant')
	Campaign_Recruit('eve')
	Campaign_UnlockOrigin('eve')
	Campaign_AddHero ('microwave')
	Campaign_AddHero ('supercollider')
	Campaign_Recruit('black_jack')
	Campaign_UnlockOrigin('black_jack')
	Campaign_AddHero ('law')
	Campaign_UnlockOrigin('law')
	Campaign_AddHero ('order')
	Campaign_UnlockOrigin('order')
	Campaign_AddHero ('ironox')
	Campaign_AddHero ('the_bard')

	Campaign_AddMinion('thug_with_bat')
	Campaign_AddMinion('thug_with_gun')
	Campaign_AddVillain('nuclear_winter')
	Campaign_AddVillain('time_master')
	Campaign_AddMinion('ice_trooper')
	Campaign_AddMinion('ice_sergeant')
	Campaign_AddMinion('snow_man')
	Campaign_AddMinion('shurale')
	Campaign_AddVillain('red_oktober')
	Campaign_AddMinion('dark_shaman')
	Campaign_AddVillain('frozen_giant')
	Campaign_AddMinion('nazi_rifleman')
	Campaign_AddMinion('legionnaire')
	Campaign_AddVillain('fortissimo')


def OnBriefing():
	play(briefing_cs, 'briefing_cs')
	print 'redsun base/briefing'

#-----------
# data
#-----------

briefing_cs = [
(
	"startCS()",
	"lookAtPos((154,20,6), zoom = -261.4, pitch= -13, heading = 45.3)",
	"wait(2)",
),
(
	"turnTo('minute_man', 'bullet')",
	"turnTo('mentor', 'bullet')",
	"speak('minute_man', 'BRFSPCH_8_MM_01', CAPTION_TOP_RIGHT)", #Minute Man so it seems that the lege...
),
(
	"lookAtPos((70,-14,0), zoom = -268.3, pitch= -2, heading = -185.3)",	
	"Sound_PlayMusic('music_06redsun_base',1)",
	"speak('bullet', 'BRFSPCH_8_BL_01', CAPTION_TOP_RIGHT)", #Bullet heck, of course they were...  
),
(
	"speak('sea_urchin', 'BRFSPCH_8_SU_01', CAPTION_TOP_LEFT)", #Sea Urchin hey!  
	"AI_Animate('sea_urchin', 'active_defence')",
),
(
	"speak('el_diablo', 'BRFSPCH_8_ED_01', CAPTION_TOP_LEFT)", #El Diablo who the heck is this sky ...  
),
(
	"speak('bullet', 'BRFSPCH_8_BL_02', CAPTION_TOP_RIGHT)", #Bullet some people said it wuz a...  
),
(
	"lookAtPos((151,7,3), zoom = -262.8, pitch= 0, heading = 56.5)",	
	"speak('mentor', 'BRFSPCH_8_ME_01', CAPTION_TOP_LEFT)", #Mentor i am sorry, bullet, but o...  
),
(
	"lookAtPos((65,-14,0), zoom = -268.3, pitch= 0, heading = -185.3)",	
	"speak('bullet', 'BRFSPCH_8_BL_03', CAPTION_TOP_RIGHT)", #Bullet sorry, mentor; you just w...  
),
(
	"turnTo('alchemiss', 'bullet')",
	"speak('alchemiss', 'BRFSPCH_8_AL_01', CAPTION_BOTTOM_RIGHT)", #Alchemiss peaches and cream, bullet...  
),
(
	"speak('bullet', 'BRFSPCH_8_BL_04', CAPTION_TOP_RIGHT)", #Bullet that's a risk i'm willin'...  
),
(
	"speak('mentor', 'BRFSPCH_8_ME_02', CAPTION_TOP_LEFT)", #Mentor perhaps...but i am not. b...  
),
(
	"endBriefingCS()",
),
]

