# euros

import js

from cshelper import *
from js import *
#from ff import *
import event
from ffx import *

def OnPrecacheObjects():
	print "euros/precache"
	Mission_PrecacheTemplateObj('bullet', 1, 0)

def OnPostInit():
	print "euros/start"
	setMission(10)
	
	#Default light settings (TEMPORARY)
	#ff.LIGHT_CULL_RADIUS_FACTOR = 0.1
	#ff.LIGHT_DIM_RADIUS_FACTOR = 0.2
	#ff.LIGHT_CONSTANT_ATTEN = 0.6
	#ff.LIGHT_LINEAR_ATTEN = 0.0
	#ff.LIGHT_QUADRATIC_ATTEN = 3.3

	Mission_SetSunlight(-80,75,0.4,0.4,(0.6,0.4,0.7))
	Mission_SetShadows(-80,75,(0.2,0.2,0.4))
	Mission_SetProjShadowBackground((1,1,1))
	Mission_SetProjShadowColor((.6,.6,.6,1))

	Mission_SetAttr('wave_2', 0)
	Mission_SetAttr('nazis_dead', 0)
	Event_RegisterSink(EVENT_TEMPLATE_OBJ_DIED, 'AnotherOneBitesTheDust', 'nazi_grenadier', '', 0, 0, 1)
	Event_RegisterSink(EVENT_TEMPLATE_OBJ_DIED, 'AnotherOneBitesTheDust', 'nazi_gunner', '', 0, 0, 1)
	Mission_SetAttr('total_nazis',25)
	if RPG_GAME_DIFFICULTY < 6:
		Object_Destroy('nazi_grenadier2')
		Object_Destroy('nazi_grenadier7')
		Mission_SetAttr('total_nazis',23)
	if RPG_GAME_DIFFICULTY < 5:
		# only spawn 4 at end
		Object_Destroy('nazi_gunner13')
		Object_Destroy('nazi_gunner9')
		Object_Destroy('nazi_gunner7')
		Mission_SetAttr('total_nazis',19)
	if RPG_GAME_DIFFICULTY < 4:
		Object_Destroy('nazi_gunner2')
		Object_Destroy('nazi_gunner11')
		Object_Destroy('nazi_gunner10')
		Mission_SetAttr('total_nazis',16)
	if RPG_GAME_DIFFICULTY < 3:
		# only spawn 3 at end
		Object_Destroy('nazi_gunner12')
		Object_Destroy('nazi_gunner8')
		Object_Destroy('nazi_grenadier4')
		Mission_SetAttr('total_nazis',12)
	if RPG_GAME_DIFFICULTY < 2:
		# only spawn 2 at end
		Object_Destroy('nazi_gunner6')
		Object_Destroy('nazi_gunner1')
		Mission_SetAttr('total_nazis',9)

	staygoal=Null()
	addGoalToAI('kar_lab_a_1',staygoal,ai.goal.PRI_HI)
	addGoalToAI('kar_lab_a_2',staygoal,ai.goal.PRI_HI)
	addGoalToAI('kar_lab_a_3',staygoal,ai.goal.PRI_HI)
	addGoalToAI('killarilla_whip1',staygoal,ai.goal.PRI_HI)
	addGoalToAI('killarilla_whip2',staygoal,ai.goal.PRI_HI)
	addGoalToAI('killarilla_whip3',staygoal,ai.goal.PRI_HI)
	addGoalToAI('killarilla_whip4',staygoal,ai.goal.PRI_HI)
	regDamage('lab_a_cage_2','CageA2Bust')
	js.Event_RegisterSink(EVENT_CHARACTER_STATE_CHANGED, 'CageA2Bust', 'kar_lab_a_2')
	regDamage('lab_a_cage_3','CageA3Bust')
	regDamage('kar_lab_a_2','CageA2Bust')
	js.Event_RegisterSink(EVENT_CHARACTER_STATE_CHANGED, 'CageA3Bust', 'kar_lab_a_3')
	regDamage('kar_lab_a_3','CageA3Bust')
	regHeroMarkerEnter('trigger_cage_a2','CageA2Bust')
	regHeroMarkerEnter('trigger_cage_a3','CageA3Bust')
	regDamage('killarilla_whip1','Cage21Bust')
	js.Event_RegisterSink(EVENT_CHARACTER_STATE_CHANGED, 'Cage21Bust', 'killarilla_whip1')
	regDamage('cage1','Cage21Bust')
	regDamage('killarilla_whip2','Cage21Bust')
	js.Event_RegisterSink(EVENT_CHARACTER_STATE_CHANGED, 'Cage21Bust', 'killarilla_whip2')
	regDamage('cage2','Cage21Bust')
	regHeroMarkerEnter('trigger_cage_21','Cage21Bust')
	js.Event_RegisterSink(EVENT_CHARACTER_STATE_CHANGED, 'Cage3Bust', 'killarilla_whip3')
	regDamage('killarilla_whip3','Cage3Bust')
	regDamage('cage3','Cage3Bust')
	regHeroMarkerEnter('trigger_cage_3','Cage3Bust')
	regDamage('killarilla_whip4','Cage4Bust')
	js.Event_RegisterSink(EVENT_CHARACTER_STATE_CHANGED, 'Cage4Bust', 'killarilla_whip4')
	regDamage('cage4','Cage4Bust')
	regHeroMarkerEnter('trigger_cage_4','Cage4Bust')

	Mission_CustomAction('open door', '', '_impobj_wide_door_closed_1', 'OpenLabANorth', 5, 0)
	Mission_CustomAction('open door', '', '_impobj_wide_door_closed_2', 'OpenLabAWest', 5, 1)
	Mission_CustomAction('open door', '', '_impobj_wide_door_closed_5', 'OpenLabASouth', 5, 1)
	Mission_CustomAction('open door', '', '_impobj_door_closed_1', 'OpenLabB', 5, 1)
	Mission_CustomAction('open door', '', '_impobj_door_closed_3', 'OpenLabC', 5, 1)
	Mission_CustomAction('open door', '', '_impobj_door_closed_2', 'OpenLabD', 5, 1)
	Mission_CustomAction('open door', '', '_impobj_wide_door_closed_3', 'OpenPostNW', 5, 1)
	Mission_CustomAction('open door', '', '_impobj_wide_door_closed_4', 'OpenPostSE', 5, 1)
	Mission_CustomAction('open door', '', '_impobj_door_closed_6', 'OpenLabF', 5, 1)
	Mission_CustomAction('open door', '', '_impobj_door_closed_5', 'OpenLabG', 5, 1)
	Mission_CustomAction('open door', '', '_impobj_door_closed_4', 'OpenLabH', 5, 1)
	Mission_CustomAction('open door', '', '_impobj_door_bullets_entry', 'CellFound', 5, 0)

	doorpos1 = Get_ObjectPos('_impobj_wide_door_closed_1')
	doorrot1 = Object_GetOrientation('_impobj_wide_door_closed_1')
	print doorrot1
	Marker_Spawn('door_an_marker',doorpos1,doorrot1[1])
	spawn('door_an_standin','fx_standin','door_an_marker')
	doorpos2 = Get_ObjectPos('_impobj_wide_door_closed_2')
	doorrot2 = Object_GetOrientation('_impobj_wide_door_closed_2')
	print doorrot2
	Marker_Spawn('door_aw_marker',doorpos2,doorrot2[1])
	spawn('door_aw_standin','fx_standin','door_aw_marker')
	doorpos3 = Get_ObjectPos('_impobj_wide_door_closed_3')
	doorrot3 = Object_GetOrientation('_impobj_wide_door_closed_3')
	print doorrot3
	Marker_Spawn('door_nw_marker',doorpos3,doorrot3[1])
	spawn('door_nw_standin','fx_standin','door_nw_marker')
	doorpos4 = Get_ObjectPos('_impobj_wide_door_closed_4')
	doorrot4 = Object_GetOrientation('_impobj_wide_door_closed_4')
	print doorrot4
	Marker_Spawn('door_se_marker',doorpos4,doorrot4[1])
	spawn('door_se_standin','fx_standin','door_se_marker')
	doorpos5 = Get_ObjectPos('_impobj_wide_door_closed_5')
	doorrot5 = Object_GetOrientation('_impobj_wide_door_closed_5')
	print doorrot5
	Marker_Spawn('door_as_marker',doorpos5,doorrot5[1])
	spawn('door_as_standin','fx_standin','door_as_marker')
	doorpos6 = Get_ObjectPos('_impobj_door_closed_1')
	doorrot6 = Object_GetOrientation('_impobj_door_closed_1')
	Marker_Spawn('door_b_marker',doorpos6,doorrot6[1])
	spawn('door_b_standin','fx_standin','door_b_marker')
	doorpos7 = Get_ObjectPos('_impobj_door_closed_2')
	doorrot7 = Object_GetOrientation('_impobj_door_closed_2')
	Marker_Spawn('door_d_marker',doorpos7,doorrot7[1])
	spawn('door_d_standin','fx_standin','door_d_marker')
	doorpos8 = Get_ObjectPos('_impobj_door_closed_3')
	doorrot8 = Object_GetOrientation('_impobj_door_closed_3')
	Marker_Spawn('door_c_marker',doorpos8,doorrot8[1])
	spawn('door_c_standin','fx_standin','door_c_marker')
	doorpos9 = Get_ObjectPos('_impobj_door_closed_4')
	doorrot9 = Object_GetOrientation('_impobj_door_closed_4')
	Marker_Spawn('door_h_marker',doorpos9,doorrot9[1])
	spawn('door_h_standin','fx_standin','door_h_marker')
	doorpos10 = Get_ObjectPos('_impobj_door_closed_5')
	doorrot10 = Object_GetOrientation('_impobj_door_closed_5')
	Marker_Spawn('door_g_marker',doorpos10,doorrot10[1])
	spawn('door_g_standin','fx_standin','door_g_marker')
	doorpos11 = Get_ObjectPos('_impobj_door_closed_6')
	doorrot11 = Object_GetOrientation('_impobj_door_closed_6')
	Marker_Spawn('door_f_marker',doorpos11,doorrot11[1])
	spawn('door_f_standin','fx_standin','door_f_marker')
	doorpos12 = Get_ObjectPos('_impobj_door_bullets_entry')
	doorrot12 = Object_GetOrientation('_impobj_door_bullets_entry')
	Marker_Spawn('door_bullet_marker',doorpos12,doorrot12[1])
	spawn('door_bullet_standin','fx_standin','door_bullet_marker')

	Mission_SetAttr('cell_found_played', 0)
	Mission_SetAttr('north_flipped',0)
	Mission_SetAttr('south_flipped',0)
	switch1 = randint(1,4)
#	switch1 = 3
	if switch1 == 1:
		# NW guard post
		Object_Spawn('switch_north','nazihq_switch','switch_marker_nw')
		regHeroMarkerEnter('s2_nw', 'SeeNSwitch')
	elif switch1 == 2:
		# lab b
		Object_Spawn('switch_north','nazihq_switch','switch_marker_b')
		regHeroMarkerEnter('s2_b', 'SeeNSwitch')
	elif switch1 == 3:
		# lab c
		Object_Spawn('switch_north','nazihq_switch','switch_marker_c')
		regHeroMarkerEnter('s2_c', 'SeeNSwitch')
	elif switch1 == 4:
		# lab d
		Object_Spawn('switch_north','nazihq_switch','switch_marker_d')
		regHeroMarkerEnter('s2_d', 'SeeNSwitch')
	else:
		print "bad random number for switch1?"
		print switch1
	Mission_CustomAction('flip switch', '', 'switch_north', 'NSwitchFlipped', 4, 1)
	Mission_SetAttr('north_switch_loc',switch1)
	switch2 = randint(1,4)
#	switch2 = 4
	if switch2 == 1:
		# SE guard post
		Object_Spawn('switch_south','nazihq_switch','switch_marker_se')
		regHeroMarkerEnter('s2_se', 'SeeSSwitch')
	elif switch2 == 2:
		# lab f
		Object_Spawn('switch_south','nazihq_switch','switch_marker_f')
		regHeroMarkerEnter('s2_f', 'SeeSSwitch')
	elif switch2 == 3:
		# lab g
		Object_Spawn('switch_south','nazihq_switch','switch_marker_g')
		regHeroMarkerEnter('s2_g', 'SeeSSwitch')
	elif switch2 == 4:
		# lab h
		Object_Spawn('switch_south','nazihq_switch','switch_marker_h')
		regHeroMarkerEnter('s2_h', 'SeeSSwitch')
	else:
		print "bad random number for switch2?"
		print switch2
	Mission_CustomAction('flip switch', '', 'switch_south', 'SSwitchFlipped', 4, 1)
	Mission_SetAttr('south_switch_loc',switch2)

	regAlmostDead('_impobj_energy_extractor_1','Tower1Killed',1)
	regAlmostDead('_impobj_energy_extractor_2','Tower2Killed',1)
	Mission_SetAttr('towers_killed', 0)

	regHeroMarkerEnter('death0', 'ChasmKill')
	regHeroMarkerEnter('death1', 'ChasmKill')
	regHeroMarkerEnter('death2', 'ChasmKill')
	regHeroMarkerEnter('death3', 'ChasmKill')
	regHeroMarkerEnter('death4', 'ChasmKill')
	regHeroMarkerEnter('death5', 'ChasmKill')
	regHeroMarkerEnter('death6', 'ChasmKill')
	regHeroMarkerEnter('death7', 'ChasmKill')
	regHeroMarkerEnter('death8', 'ChasmKill')
	regHeroMarkerEnter('death9', 'ChasmKill')

	play(start_cs,'start_cs')
	FFX_InitMission()


def AnotherOneBitesTheDust(event):
	addAttr('nazis_dead',1)
	print Mission_GetAttr('nazis_dead')
	if Mission_GetAttr('nazis_dead') == Mission_GetAttr('total_nazis'):
		Objective_Complete('kill_nazis')


def OpenLabANorth(event,heroname):
	print "open lab A"
	kill('_impobj_fog_lab_a')
	kill('_impobj_wide_door_closed_1')
	Object_PlayEffect('door_an_standin', 'effect_door_wide_opening', 'DoorANOpened',FX_TRACK_OBJECT_ROT)
def DoorANOpened(event):
	spawn('open_an','nazihq_wide_door_open','door_an_marker')
	AI_SetEnabled('kar_lab_a_1',1)
	AI_SetEnabled('kar_lab_a_2',1)
	AI_SetEnabled('kar_lab_a_3',1)
	PlayLabACS(event)

def OpenLabAWest(event,heroname):
	kill('_impobj_fog_corridor')
	kill('_impobj_wide_door_closed_2')
	Object_PlayEffect('door_aw_standin', 'effect_door_wide_opening', 'DoorAWOpened',FX_TRACK_OBJECT_ROT)
def DoorAWOpened(event):
	spawn('open_aw','nazihq_wide_door_open','door_aw_marker')
	AI_SetEnabled('nazi_grenadier6',1)
	AI_SetEnabled('nazi_gunner3',1)

def OpenLabASouth(event,heroname):
	kill('_impobj_fog_corridor')
	kill('_impobj_wide_door_closed_5')
	Object_PlayEffect('door_as_standin', 'effect_door_wide_opening', 'DoorASOpened',FX_TRACK_OBJECT_ROT)
def DoorASOpened(event):
	spawn('open_as','nazihq_wide_door_open','door_as_marker')
	AI_SetEnabled('nazi_grenadier6',1)
	AI_SetEnabled('nazi_gunner3',1)

def OpenLabB(event,heroname):
	kill('_impobj_fog_lab_b')
	kill('_impobj_door_closed_1')
	Object_PlayEffect('door_b_standin', 'effect_door_single_opening', 'DoorBOpened',FX_TRACK_OBJECT_ROT)
def DoorBOpened(event):
	spawn('open_b','nazihq_door_open','door_b_marker')
	AI_SetEnabled('killarilla_whip4',1)
	AI_SetEnabled('nazi_grenadier7',1)
	AI_SetEnabled('nazi_gunner8',1)

def OpenLabC(event,heroname):
	kill('_impobj_fog_lab_c')
	kill('_impobj_door_closed_3')
	Object_PlayEffect('door_c_standin', 'effect_door_single_opening', 'DoorCOpened',FX_TRACK_OBJECT_ROT)
def DoorCOpened(event):
	spawn('open_c','nazihq_door_open','door_c_marker')
	AI_SetEnabled('killarilla_whip1',1)
	AI_SetEnabled('killarilla_whip2',1)
	AI_SetEnabled('nazi_gunner7',1)

def OpenLabD(event,heroname):
	kill('_impobj_fog_lab_d')
	kill('_impobj_door_closed_2')
	Object_PlayEffect('door_d_standin', 'effect_door_single_opening', 'DoorDOpened',FX_TRACK_OBJECT_ROT)
def DoorDOpened(event):
	spawn('open_d','nazihq_door_open','door_d_marker')
	AI_SetEnabled('killarilla_whip3',1)
	AI_SetEnabled('nazi_gunner9',1)

def OpenLabF(event,heroname):
	kill('_impobj_fog_lab_f')
	kill('_impobj_door_closed_6')
	Object_PlayEffect('door_f_standin', 'effect_door_single_opening', 'DoorFOpened',FX_TRACK_OBJECT_ROT)
def DoorFOpened(event):
	spawn('open_f','nazihq_door_open','door_f_marker')
	AI_SetEnabled('nazi_gunner4',1)
	AI_SetEnabled('nazi_gunner10',1)

def OpenLabG(event,heroname):
	kill('_impobj_fog_lab_g')
	kill('_impobj_door_closed_5')
	Object_PlayEffect('door_g_standin', 'effect_door_single_opening', 'DoorGOpened',FX_TRACK_OBJECT_ROT)
def DoorGOpened(event):
	spawn('open_g','nazihq_door_open','door_g_marker')
	AI_SetEnabled('nazi_gunner5',1)
	AI_SetEnabled('nazi_gunner11',1)

def OpenLabH(event,heroname):
	kill('_impobj_fog_lab_h')
	kill('_impobj_door_closed_4')
	Object_PlayEffect('door_h_standin', 'effect_door_single_opening', 'DoorHOpened',FX_TRACK_OBJECT_ROT)
def DoorHOpened(event):
	spawn('open_h','nazihq_door_open','door_h_marker')
	AI_SetEnabled('nazi_grenadier5',1)
	AI_SetEnabled('nazi_gunner12',1)

def OpenPostNW(event,heroname):
	kill('_impobj_fog_guardpost_a')
	kill('_impobj_wide_door_closed_3')
	Object_PlayEffect('door_nw_standin', 'effect_door_wide_opening', 'DoorNWOpened',FX_TRACK_OBJECT_ROT)
def DoorNWOpened(event):
	spawn('open_nw','nazihq_wide_door_open','door_nw_marker')
	AI_SetEnabled('nazi_grenadier1',1)
	AI_SetEnabled('nazi_grenadier2',1)
	AI_SetEnabled('nazi_gunner2',1)
	AI_SetEnabled('nazi_gunner6',1)

def OpenPostSE(event,heroname):
	kill('_impobj_fog_guardpost_b')
	kill('_impobj_wide_door_closed_4')
	Object_PlayEffect('door_se_standin', 'effect_door_wide_opening', 'DoorSEOpened',FX_TRACK_OBJECT_ROT)
def DoorSEOpened(event):
	spawn('open_se','nazihq_wide_door_open','door_se_marker')
	AI_SetEnabled('nazi_gunner1',1)
	AI_SetEnabled('nazi_grenadier3',1)
	AI_SetEnabled('nazi_grenadier4',1)
	AI_SetEnabled('nazi_gunner13',1)



def PlayLabACS(event):
	kill('_impobj_fog_lab_a')
	play(lab_a_cs,'lab_a_cs')
	regDeath('kar_lab_a_1','FirstKARDown')
def LabAFirstAttack():
#	targetspot = Get_ObjectPos('black_jack')
#	print targetspot
#	Trigger_Move('kar_lab_a_1',"move",targetspot,'',20,0)
	regTimer('AIsOff',2)
	# turn off other AIs after CS
def AIsOff(event):
	AI_SetEnabled('killarilla_whip1',0)
	AI_SetEnabled('killarilla_whip2',0)
	AI_SetEnabled('killarilla_whip3',0)
	AI_SetEnabled('killarilla_whip4',0)
	AI_SetEnabled('nazi_grenadier1',0)
	AI_SetEnabled('nazi_grenadier2',0)
	AI_SetEnabled('nazi_grenadier3',0)
	AI_SetEnabled('nazi_grenadier4',0)
	AI_SetEnabled('nazi_grenadier5',0)
	AI_SetEnabled('nazi_grenadier6',0)
	AI_SetEnabled('nazi_grenadier7',0)
	AI_SetEnabled('nazi_gunner1',0)
	AI_SetEnabled('nazi_gunner2',0)
#	AI_SetEnabled('nazi_gunner3',0)
# we don't really want to zero this guy...
	startPatrol('nazi_gunner3',6,priority=ai.goal.PRI_ZERO-1,run=0)
	AI_SetEnabled('nazi_gunner4',0)
	AI_SetEnabled('nazi_gunner5',0)
	AI_SetEnabled('nazi_gunner6',0)
	AI_SetEnabled('nazi_gunner7',0)
	AI_SetEnabled('nazi_gunner8',0)
	AI_SetEnabled('nazi_gunner9',0)
	AI_SetEnabled('nazi_gunner10',0)
	AI_SetEnabled('nazi_gunner11',0)
	AI_SetEnabled('nazi_gunner12',0)
	AI_SetEnabled('nazi_gunner13',0)
def FirstKARDown(event):
	play(first_kar_down_ss,'first_kar_down_ss')


def CageA2Bust(event):
	AI_Animate('kar_lab_a_2','melee')
	kill('lab_a_cage_2')
	clearGoals('kar_lab_a_2')
def CageA3Bust(event):
	AI_Animate('kar_lab_a_3','melee')
	kill('lab_a_cage_3')
	clearGoals('kar_lab_a_3')



def Cage21Bust(event):
	AI_Animate('killarilla_whip2','melee')
	kill('cage2')
	clearGoals('killarilla_whip2')
	regTimer('Cage1Bust',.1)

def Cage1Bust(event):
	AI_Animate('killarilla_whip1','melee')
	kill('cage1')
	clearGoals('killarilla_whip1')

def Cage3Bust(event):
	AI_Animate('killarilla_whip3','melee')
	kill('cage3')
	clearGoals('killarilla_whip3')

def Cage4Bust(event):
	AI_Animate('killarilla_whip4','melee')
	kill('cage4')
	clearGoals('killarilla_whip4')


def NSwitchFlipped(event,heroname):
	Object_NextVersion('switch_north')
	removeArrow('north_arrow')
	Mission_SetAttr('north_flipped',1)
	if Mission_GetAttr('south_flipped') == 0:
		FirstSwitchFlipped()
	elif Mission_GetAttr('south_flipped') == 1:
		BothSwitchesFlipped()
	else:
		print "south switch in weird state"
		print Mission_GetAttr('south_flipped')
def SSwitchFlipped(event,heroname):
	Object_NextVersion('switch_south')
	removeArrow('south_arrow')
	Mission_SetAttr('south_flipped',1)
	if Mission_GetAttr('north_flipped') == 0:
		FirstSwitchFlipped()
	elif Mission_GetAttr('north_flipped') == 1:
		BothSwitchesFlipped()
	else:
		print "north switch in weird state"
		print Mission_GetAttr('north_flipped')
def FirstSwitchFlipped():
	print "flipping first switch"
	a_hero = getRandomLiveHeroName()
	print a_hero
	if a_hero == 'sky_king_ground':
		forceSpeakNoCB('sky_king_ground', 'MISSPCH_10_SY_06',telepathy=0)
	elif a_hero == 'black_jack':
		speakNoCB('black_jack', 'MISSPCH_10_BJ_06')
	elif a_hero == 'tricolour':
		speakNoCB('tricolour', 'MISSPCH_10_TC_06')
	else:
		print "wrong hero on mission?"
	if not Objective_IsComplete('find_controls'):
		Objective_Activate('find_controls')
def SeeNSwitch(event):
	addArrow('north_arrow','switch_north')
	if (Mission_GetAttr('south_flipped') == 0):
		SeeFirstSwitch(event)
	else:
		SeeSecondSwitch(event)
def SeeSSwitch(event):
	addArrow('south_arrow','switch_south')
	if (Mission_GetAttr('north_flipped') == 0):
		SeeFirstSwitch(event)
	else:
		SeeSecondSwitch(event)
def SeeFirstSwitch(event):
	print "approaching first switch"
	a_hero = getRandomLiveHeroName()
	print a_hero
	if a_hero == 'sky_king_ground':
		forceSpeakNoCB('sky_king_ground', 'MISSPCH_10_SY_18',telepathy=0)
	elif a_hero == 'black_jack':
		speakNoCB('black_jack', 'MISSPCH_10_BJ_15')
	elif a_hero == 'tricolour':
		speakNoCB('tricolour', 'MISSPCH_10_TC_14')
	else:
		print "wrong hero on mission?"
def SeeSecondSwitch(event):
	Objective_Complete('find_controls')
	Objective_Activate('use_controls')
	print "approaching second switch"
	a_hero = getRandomLiveHeroName()
	print a_hero
	if a_hero == 'sky_king_ground':
		forceSpeakNoCB('sky_king_ground', 'MISSPCH_10_SY_07',telepathy=0)
	elif a_hero == 'black_jack':
		speakNoCB('black_jack', 'MISSPCH_10_BJ_07')
	elif a_hero == 'tricolour':
		speakNoCB('tricolour', 'MISSPCH_10_TC_07')
	else:
		print "wrong hero on mission?"
def BothSwitchesFlipped():
	Objective_Complete('use_controls')
	Objective_Activate('free_bullet')
	print "open cell now"
	a_hero = getRandomLiveHeroName()
	print a_hero
	if a_hero == 'sky_king_ground':
		forceSpeakNoCB('sky_king_ground', 'MISSPCH_10_SY_14',telepathy=0)
	elif a_hero == 'black_jack':
		speakNoCB('black_jack', 'MISSPCH_10_BJ_11')
	elif a_hero == 'tricolour':
		speakNoCB('tricolour', 'MISSPCH_10_TC_11')
	else:
		print "wrong hero on mission?"
	addArrow('cell_arrow', '_impobj_door_bullets_entry', js.ARROW_RED, delete=1)


def CellFound(event,heroname):
	if (Mission_GetAttr('cell_found_played') == 1) and (not Objective_IsComplete('use_controls')):
		print "retrying cell door"
		a_hero = getRandomLiveHeroName()
		print a_hero
		if a_hero == 'sky_king_ground':
			forceSpeakNoCB('sky_king_ground', 'MISSPCH_10_SY_05',telepathy=0)
		elif a_hero == 'black_jack':
			speakNoCB('black_jack', 'MISSPCH_10_BJ_05')
		elif a_hero == 'tricolour':
			speakNoCB('tricolour', 'MISSPCH_10_TC_05')
		else:
			print "wrong hero on mission?"
	elif (Mission_GetAttr('cell_found_played') == 0) and (not Objective_IsComplete('use_controls')):
#		play(cell_found_ss,'cell_found_ss')
		addAttr('cell_found_played',1)
		Objective_Complete('find_cell')
		if not Objective_IsComplete('find_controls'):
			Objective_Activate('find_controls')
		a_hero = getRandomLiveHeroName()
		print a_hero
		if a_hero == 'sky_king_ground':
			forceSpeakNoCB('sky_king_ground', 'MISSPCH_10_SY_05',telepathy=0)
		elif a_hero == 'black_jack':
			speakNoCB('black_jack', 'MISSPCH_10_BJ_05')
		elif a_hero == 'tricolour':
			speakNoCB('tricolour', 'MISSPCH_10_TC_05')
		else:
			print "wrong hero on mission?"
	else:
		if not Objective_IsComplete('find_cell'):
			Objective_Complete('find_cell')
		print "second time through, fight now"
		CellFight()

def CellFightLine():
	print "first line for cell fight CS"
	a_hero = getRandomLiveHeroName()
	print a_hero
	if a_hero == 'sky_king_ground':
		forceSpeak('sky_king_ground', 'MISSPCH_10_SY_09',telepathy=0)
	elif a_hero == 'black_jack':
		speak('black_jack', 'MISSPCH_10_BJ_09')
	elif a_hero == 'tricolour':
		speak('tricolour', 'MISSPCH_10_TC_09')
	else:
		print "wrong hero on mission?"
def CellFightLine2():
	print "last line for cell fight CS"
	a_hero = getRandomLiveHeroName()
	print a_hero
	if a_hero == 'sky_king_ground':
		forceSpeak('sky_king_ground', 'MISSPCH_10_SY_08',telepathy=0)
	elif a_hero == 'black_jack':
		speak('black_jack', 'MISSPCH_10_BJ_08')
	elif a_hero == 'tricolour':
		speak('tricolour', 'MISSPCH_10_TC_08')
	else:
		print "wrong hero on mission?"

def CellFight():
	kill('_impobj_fog_bullets_lab')
	kill('_impobj_door_bullets_entry')
	spawn('nazi_cell_1', 'nazi_gunner', 'cell_1_spawn_point')
	spawn('nazi_cell_2', 'nazi_gunner', 'cell_2_spawn_point')
	if RPG_GAME_DIFFICULTY > 1:
		spawn('nazi_cell_3', 'nazi_grenadier', 'cell_3_spawn_point')
	if RPG_GAME_DIFFICULTY > 2:
		spawn('nazi_cell_4', 'nazi_gunner', 'cell_4_spawn_point')
	if RPG_GAME_DIFFICULTY > 4:
		spawn('nazi_cell_5', 'nazi_grenadier', 'cell_5_spawn_point')
	removeArrow('cell_arrow')
#def DoorBulletOpened(event):
	spawn('open_bullet','nazihq_door_open','door_bullet_marker')
	play(cell_fight_cs,'cell_fight_cs')

def Tower1Killed(event):
	towerpos1 = Get_ObjectPos('_impobj_energy_extractor_1')
	towerrot1 = Object_GetOrientation('_impobj_energy_extractor_1')
	Marker_Spawn('tower_1_marker',towerpos1,towerrot1[1])
	kill('_impobj_energy_extractor_1')
	spawn('dead_ex_1','nazihq_energy_extractor_dest','tower_1_marker')
	removeArrow('tower_1_arrow')
	addAttr('towers_killed',1)
	if Mission_GetAttr('towers_killed') == 2:
		regTimer('FinalCS',2.5)
def Tower2Killed(event):
	towerpos2 = Get_ObjectPos('_impobj_energy_extractor_2')
	towerrot2 = Object_GetOrientation('_impobj_energy_extractor_2')
	Marker_Spawn('tower_2_marker',towerpos2,towerrot2[1])
	kill('_impobj_energy_extractor_2')
	spawn('dead_ex_2','nazihq_energy_extractor_dest','tower_2_marker')
	removeArrow('tower_2_arrow')
	addAttr('towers_killed',1)
	if Mission_GetAttr('towers_killed') == 2:
		regTimer('FinalCS',2.5)
def FinalCS(event):
	play(final_cs,'final_cs')

def ChasmKill(event):
	kill(event.object)


def OnMissionWon():
	print "euros/won"

def OnMissionLost():
	print "euros/lost"


#										 #
# cutscenes and scripted sequences below  #
#										 #



start_cs = [
(
	"peace()",
	"startCS()",
	"look('sky_king_ground', zoom = -150, heading = 0, time = 0)",
	"wait(.5)",
),
(
	"speak('sky_king_ground', 'MISSPCH_10_SY_01')",
),
(
	"speak('black_jack', 'MISSPCH_10_BJ_01')",
),
(
	"speak('tricolour', 'MISSPCH_10_TC_12')",
),
(
	"endCS()",
	"war()",
	"Sound_PlayMusic('music_07euros1')",
	"newObjective('primary', 1, name='find_cell')",
	"registerObjective('primary', 2, name='find_controls')",
	"registerObjective('primary', 3, name='use_controls')",
	"registerObjective('primary', 4, name='free_bullet')",
	"registerObjective('primary', 5, name='smash_towers')",
	"newObjective('secondary', 1, name='kill_nazis')",
),
]

lab_a_cs = [
(
	"peace()",
	"startCS()",
	"look('lab_a_cs_cam1', zoom = -100, heading = 180, time = 0)",
	"teleport('black_jack','bj_marker_a')",
	"teleport('sky_king_ground','sy_marker_a')",
	"teleport('tricolour','tc_marker_a')",
	"wait(.5)",
),
(
	"optionalSpeak('sky_king_ground', 'MISSPCH_10_SY_03')",
),
(
	"look('lab_a_cs_cam2', zoom = -200, heading = 270, time = 2)",
	"optionalSpeak('black_jack', 'MISSPCH_10_BJ_02')",
),
(
	"optionalSpeak('tricolour', 'MISSPCH_10_TC_02')",
),
(
	"AI_Animate('kar_lab_a_1','melee')",
	"kill('lab_a_cage_1')",
	"forceSpeak('killarilla_whip', 'MISSPCH_10_KR_01', telepathy=0)",
),
(
	"clearGoals('kar_lab_a_1')",
	"ff.LabAFirstAttack()",
	"wait(0)",
),
(
	"endCS()",
	"war()",
),
]

first_kar_down_ss = [
(
	"optionalSpeak('sky_king_ground', 'MISSPCH_10_SY_04')",
),
(
	"optionalSpeak('black_jack', 'MISSPCH_10_BJ_04')",
),
(
	"optionalSpeak('tricolour', 'MISSPCH_10_TC_04')",
),
(
	"blank",
),
]


cell_fight_cs = [
(
	"peace()",
	"startCS()",
	"look('cell_fight_cs_cam1', zoom = -100, heading = 135, time = 0)",
	"teleport('black_jack','bj_marker_cf')",
	"teleport('sky_king_ground','sy_marker_cf')",
	"teleport('tricolour','tc_marker_cf')",
	"wait(.1)",
),
(
	"look('cell_fight_cs_cam1', zoom = -250, heading = 135, time = 2)",
	"ff.CellFightLine()",
),
(
	"look('cell_3_spawn_point', zoom = -250, heading = -30, time = 2)",
	"Sound_PlayMusic('music_04winter_hit1',1)",
	"forceSpeak('nazi_grenadier', 'MISSPCH_10_N1_01',telepathy=0)",
),
(
	"ff.CellFightLine2()",
),
(
	"addArrow('tower_1_arrow', '_impobj_energy_extractor_1', js.ARROW_RED, delete=1)",
	"addArrow('tower_2_arrow', '_impobj_energy_extractor_2', js.ARROW_RED, delete=1)",
	"endCS()",
	"Sound_PlayMusic('music_07euros_jungle')",
	"war()",
),
]

final_cs = [
(
	"peace()",
	"startCS()",
	"reviveHeroes()",
	"Object_SetAttr('_impobj_bullets_restraint','minHealth',0)",
	"playTransition()",
),
(
	"Object_NextVersion('_impobj_bullets_restraint')",
	"Object_Spawn('bullet','bullet','bullet_marker')",
	"look('bullet', zoom = -250, heading = 135, time = 0)",
	"teleport('black_jack','bj_marker1')",
	"teleport('tricolour','tc_marker1')",
	"teleport('sky_king_ground','sy_marker1')",
	"Sound_PlayMusic('music_05berlin_cs5',1)",
	"wait(2)",
),
(
	"Sound_PlaySound('mission_euros')",
	"speak('bullet', 'MISSPCH_10_BL_01')",
),
(
	"speak('tricolour', 'MISSPCH_10_TC_13')",
),
(
	"speak('bullet', 'MISSPCH_10_BL_04')",
),
(
	"speak('sky_king_ground', 'MISSPCH_10_SY_15')",
),
(
	"speak('bullet', 'MISSPCH_10_BL_05')",
),
(
	"speak('black_jack', 'MISSPCH_10_BJ_12')",
),
(
	"look('sky_king_ground', zoom = -150, heading = -45, time = 0)",
	"speak('sky_king_ground', 'MISSPCH_10_SY_10')",
),
(
	"look('bullet', zoom = -250, heading = 135, time = 0)",
	"speak('bullet', 'MISSPCH_10_BL_02')",
),
(
	"look('sky_king_ground', zoom = -150, heading = -45, time = 0)",
	"speakNoCB('sky_king_ground', 'MISSPCH_10_SY_11')",
	"wait(4)",
),
(
	"speak('sky_king_ground', 'MISSPCH_10_SY_16')",
),
(
	"AI_Animate('sky_king_ground','take_flight')",
### replace with actual animation
	"Camera_Fade(2)",
	"wait(1)",
),
(
	"Sound_PlaySound('sy_jets_across_chasm')",
	"Sound_PlayMusic('music_07euros_skyking',1)",
	"wait(1)",
),
(
	"speak('sky_king_ground', 'MISSPCH_10_SY_17')",
),
(
	"#playTransition()",
	"teleport('black_jack','bj_marker2')",
	"teleport('tricolour','tc_marker2')",
	"#teleport('sky_king_ground','sy_marker2')",
	"spawn('sky_king','sky_king','sy_marker2')",
	"teleport('bullet','bullet_marker2')",
	"Camera_UnFade(2)",
	"look('sky_king', zoom = -150, heading = 135, time = 0)",
	"wait(2)",
),
(
	"speak('black_jack', 'MISSPCH_10_BJ_13')",
),
(
	"speak('sky_king', 'MISSPCH_10_SY_12')",
),
(
	"speak('bullet', 'MISSPCH_10_BL_03')",
),
(
	"speak('sky_king', 'MISSPCH_10_SY_13')",
),
(
	"speak('black_jack', 'MISSPCH_10_BJ_14')",
),
(
	"speak('tricolour', 'MISSPCH_10_TC_10')",
),
(
	"Objective_Complete('free_bullet')",
	"Objective_Complete('smash_towers')",
	"endCS()",
	"Mission_Win()",
),
]
