# bullet

from cshelper import *
from js import *
import event
from ffx import *

def OnPrecacheObjects():
	print "bullet/precache"
	Mission_PrecacheTemplateObj('nazi_general', 1, 1)

def OnPostInit():
	print "bullet/start"
	setMission(11)

	Mission_SetSunlight(-80,75,0.4,0.4,(0.6,0.4,0.7))
	Mission_SetShadows(-80,75,(0.2,0.2,0.4))
	Mission_SetProjShadowBackground((1,1,1))
	Mission_SetProjShadowColor((.6,.6,.6,1))

	Mission_AddSquadExtra('bullet')
	Mission_AddSquadExtra('sky_king')

	regDeath('bullet','BulletKO')

	regHeroMarkerEnter('death0', 'ChasmKill')
	regHeroMarkerEnter('death1', 'ChasmKill')
	regHeroMarkerEnter('death2', 'ChasmKill')
	regHeroMarkerEnter('death3', 'ChasmKill')
	regHeroMarkerEnter('death4', 'ChasmKill')
	regHeroMarkerEnter('death5', 'ChasmKill')
	regHeroMarkerEnter('death6', 'ChasmKill')
	regHeroMarkerEnter('death7', 'ChasmKill')
	regHeroMarkerEnter('death8', 'ChasmKill')
	regHeroMarkerEnter('death9', 'ChasmKill')

	Mission_CustomAction('open door', '', '_impobj_door_closed_2', 'OpenLabA', 5, 1)
	Mission_CustomAction('open door', '', '_impobj_door_closed_3', 'OpenLabB', 5, 1)
	Mission_CustomAction('open door', '', '_impobj_door_closed_4', 'OpenLabC', 5, 1)
	Mission_CustomAction('open door', '', '_impobj_wide_door_closed_1', 'OpenPostA', 5, 1)
	Mission_CustomAction('open door', '', '_impobj_wide_door_closed_2', 'GunGoonsCS', 5, 1)
	Mission_CustomAction('open door', '', '_impobj_wide_door_closed_3', 'KillFogEC', 5, 1)
	Mission_CustomAction('open door', '', '_impobj_door_closed_5', 'OpenLabE', 5, 1)
	Mission_CustomAction('open door', '', '_impobj_door_closed_6', 'OpenLabF', 5, 1)
	Mission_CustomAction('open door', '', '_impobj_door_closed_7', 'OpenLabG', 5, 1)
	Mission_CustomAction('open door', '', '_impobj_wide_door_closed_4', 'KillFogExit', 5, 1)
	Mission_CustomAction('open door', '', '_impobj_wide_door_closed_5', 'OpenExit', 3, 0)

	doorpos1 = Get_ObjectPos('_impobj_door_bullets_exit')
	doorrot1 = Object_GetOrientation('_impobj_door_bullets_exit')
	Marker_Spawn('door_bullet_marker',doorpos1,doorrot1[1])
	spawn('door_bullet_standin','fx_standin','door_bullet_marker')
	doorpos2 = Get_ObjectPos('_impobj_door_closed_2')
	doorrot2 = Object_GetOrientation('_impobj_door_closed_2')
	Marker_Spawn('door_a_marker',doorpos2,doorrot2[1])
	spawn('door_a_standin','fx_standin','door_a_marker')
	doorpos3 = Get_ObjectPos('_impobj_door_closed_3')
	doorrot3 = Object_GetOrientation('_impobj_door_closed_3')
	Marker_Spawn('door_b_marker',doorpos3,doorrot3[1])
	spawn('door_b_standin','fx_standin','door_b_marker')
	doorpos4 = Get_ObjectPos('_impobj_door_closed_4')
	doorrot4 = Object_GetOrientation('_impobj_door_closed_4')
	Marker_Spawn('door_c_marker',doorpos4,doorrot4[1])
	spawn('door_c_standin','fx_standin','door_c_marker')
	doorpos5 = Get_ObjectPos('_impobj_wide_door_closed_1')
	doorrot5 = Object_GetOrientation('_impobj_wide_door_closed_1')
	Marker_Spawn('door_pa_marker',doorpos5,doorrot5[1])
	spawn('door_pa_standin','fx_standin','door_pa_marker')
	doorpos6 = Get_ObjectPos('_impobj_wide_door_closed_2')
	doorrot6 = Object_GetOrientation('_impobj_wide_door_closed_2')
	Marker_Spawn('door_dw_marker',doorpos6,doorrot6[1])
	spawn('door_dw_standin','fx_standin','door_dw_marker')
	doorpos7 = Get_ObjectPos('_impobj_wide_door_closed_3')
	doorrot7 = Object_GetOrientation('_impobj_wide_door_closed_3')
	Marker_Spawn('door_dn_marker',doorpos7,doorrot7[1])
	spawn('door_dn_standin','fx_standin','door_dn_marker')
	doorpos8 = Get_ObjectPos('_impobj_door_closed_5')
	doorrot8 = Object_GetOrientation('_impobj_door_closed_5')
	Marker_Spawn('door_e_marker',doorpos8,doorrot8[1])
	spawn('door_e_standin','fx_standin','door_e_marker')
	doorpos9 = Get_ObjectPos('_impobj_door_closed_6')
	doorrot9 = Object_GetOrientation('_impobj_door_closed_6')
	Marker_Spawn('door_f_marker',doorpos9,doorrot9[1])
	spawn('door_f_standin','fx_standin','door_f_marker')
	doorpos10 = Get_ObjectPos('_impobj_door_closed_7')
	doorrot10 = Object_GetOrientation('_impobj_door_closed_7')
	Marker_Spawn('door_g_marker',doorpos10,doorrot10[1])
	spawn('door_g_standin','fx_standin','door_g_marker')
	doorpos11 = Get_ObjectPos('_impobj_wide_door_closed_4')
	doorrot11 = Object_GetOrientation('_impobj_wide_door_closed_4')
	Marker_Spawn('door_exitw_marker',doorpos11,doorrot11[1])
	spawn('door_exitw_standin','fx_standin','door_exitw_marker')
	doorpos12 = Get_ObjectPos('_impobj_wide_door_closed_5')
	doorrot12 = Object_GetOrientation('_impobj_wide_door_closed_5')
	Marker_Spawn('door_exitn_marker',doorpos12,doorrot12[1])
	spawn('door_exitn_standin','fx_standin','door_exitn_marker')

	Mission_SetAttr('lab_a_opened',0)
	Mission_SetAttr('lab_b_opened',0)
	Mission_SetAttr('lab_c_opened',0)
	Mission_SetAttr('lab_d_opened',0)
	Mission_SetAttr('lab_e_opened',0)
	Mission_SetAttr('lab_f_opened',0)
	Mission_SetAttr('lab_g_opened',0)
	Mission_SetAttr('guardpost_opened',0)
	Mission_SetAttr('exit_opened',0)
	Mission_SetAttr('kar_hasCustomGoal',0)


	regDamage('cage1','Cage1Bust')
	regDamage('kar_whip1','Cage1Bust')
	js.Event_RegisterSink(EVENT_CHARACTER_STATE_CHANGED, 'Cage1Bust', 'kar_whip1')
	regHeroMarkerEnter('trigger_cage_1','Cage1Bust')
	regDamage('cage2','Cage2Bust')
	regDamage('kar_whip2','Cage2Bust')
	js.Event_RegisterSink(EVENT_CHARACTER_STATE_CHANGED, 'Cage2Bust', 'kar_whip2')
	regHeroMarkerEnter('trigger_cage_2','Cage2Bust')
	regDamage('cage3','Cage3Bust')
	regDamage('kar_chaingun3','Cage3Bust')
	js.Event_RegisterSink(EVENT_CHARACTER_STATE_CHANGED, 'Cage3Bust', 'kar_chaingun3')
	regHeroMarkerEnter('trigger_cage_3','Cage3Bust')
	Mission_SetAttr('cage1_busted',0)
	Mission_SetAttr('cage2_busted',0)
	Mission_SetAttr('cage3_busted',0)
	Mission_SetAttr('plan_hack',0)


	Mission_CustomAction('pick up', '', 'secret_plans', 'GetPapers', 5, 1)

	regDetectHero('nazi_rifleman4','AmbushBark2')
	regDetectHero('nazi_rifleman2','AmbushBark1')
	regDetectHero('nazi_grenadier5','AmbushBark3')

	regDeath('sc_nazihq_computer_big1','SmashOne')
	regDeath('sc_nazihq_computer_big2','SmashOne')
	regDeath('sc_nazihq_computer_big3','SmashOne')
	regDeath('sc_nazihq_computer_big4','SmashOne')
	regDeath('sc_nazihq_computer_big5','SmashOne')
	regDeath('sc_nazihq_computer_big6','SmashOne')
	regDeath('sc_nazihq_computer_tall1','SmashOne')
	regDeath('sc_nazihq_computer_tall2','SmashOne')
	regDeath('sc_nazihq_computer_tall3','SmashOne')
	regDeath('sc_nazihq_computer_tall4','SmashOne')
	Mission_SetAttr('smash_count', 0)

	regDeath('friendly_cage','SaveGorilla')
	Mission_SetAttr('fg_count', 0)
	Mission_SetAttr('friendly_freed',0)
	Object_SetAttr('friendly_kar','defaultToAttack',0)

	regDeath('nazi_gunner1','FirstWaveDown')
	regDeath('nazi_grenadier1','FirstWaveDown')
	Mission_SetAttr('first_wave_count', 0)

	Mission_SetAttr('keys_found', 0)
	genkey1 = randint(1,3)
	Mission_SetAttr('key1_loc',genkey1)
	if genkey1 == 1:
		# guard post A
		Object_Spawn('general1','nazi_general','general_gp')
	elif genkey1 == 2:
		# lab a
		Object_Spawn('general1','nazi_general','general_a')
	elif genkey1 == 3:
		# lab c
		Object_Spawn('general1','nazi_general','general_c')
	else:
		print "bad random number for genkey1?"
		print genkey1
	regAlmostDead('general1','General1Down',1)
	genkey2 = randint(1,3)
	Mission_SetAttr('key2_loc',genkey2)
	if genkey2 == 1:
		# lab e
		Object_Spawn('general2','nazi_general','general_e')
	elif genkey2 == 2:
		# lab f
		Object_Spawn('general2','nazi_general','general_f')
	elif genkey2 == 3:
		# lab g
		Object_Spawn('general2','nazi_general','general_g')
	else:
		print "bad random number for genkey2?"
		print genkey2
	regAlmostDead('general2','General2Down',1)

	regMarkerEnter('bullet','exit_marker','BulletSafe')
	play(start_cs,'start_cs')
	FFX_InitMission()

def AIsOff(event):
	print "turning off AIs whom War() turned on"
	staygoal=Null()
	if Mission_GetAttr('cage1_busted') == 0:
		addGoalToAI('kar_whip1',staygoal,ai.goal.PRI_HI)
	if Mission_GetAttr('cage2_busted') == 0:
		addGoalToAI('kar_whip2',staygoal,ai.goal.PRI_HI)
	if Mission_GetAttr('cage3_busted') == 0:
		addGoalToAI('kar_chaingun3',staygoal,ai.goal.PRI_HI)
	if Mission_GetAttr('friendly_freed') == 0:
		addGoalToAI('friendly_kar',staygoal,ai.goal.PRI_HI)
	if Mission_GetAttr('lab_a_opened') == 0:
		if Mission_GetAttr('key1_loc') == 2:
			AI_SetEnabled('general1',0)
	if Mission_GetAttr('lab_b_opened') == 0:
		null() # no baddies here
	if Mission_GetAttr('guardpost_opened') == 0:
		AI_SetEnabled('nazi_rifleman4',0)
		AI_SetEnabled('nazi_gunner3',0)
		if Mission_GetAttr('key1_loc') == 1:
			AI_SetEnabled('general1',0)
	if Mission_GetAttr('lab_c_opened') == 0:
		AI_SetEnabled('nazi_grenadier5',0)
		if Mission_GetAttr('key1_loc') == 3:
			AI_SetEnabled('general1',0)
	if Mission_GetAttr('lab_d_opened') == 0:
		AI_SetEnabled('nazi_rifleman1',0)
		AI_SetEnabled('nazi_gunner2',0)
		AI_SetEnabled('nazi_grenadier2',0)
		AI_SetEnabled('kar_chaingun1',0)
		AI_SetEnabled('kar_chaingun2',0)
		# this last is in the NE corridor, but here hould be good enough
		AI_SetEnabled('nazi_rifleman5',0)
	if Mission_GetAttr('lab_e_opened') == 0:
		if Mission_GetAttr('key2_loc') == 1:
			AI_SetEnabled('general2',0)
	if Mission_GetAttr('lab_f_opened') == 0:
		print "Lab F peaceful"
		AI_SetEnabled('nazi_rifleman3',0)
		if Mission_GetAttr('key2_loc') == 2:
			AI_SetEnabled('general2',0)
	if Mission_GetAttr('lab_g_opened') == 0:
		AI_SetEnabled('nazi_grenadier3',0)
		if Mission_GetAttr('key2_loc') == 3:
			AI_SetEnabled('general2',0)
	if Mission_GetAttr('exit_opened') == 0:
		AI_SetEnabled('nazi_rifleman2',0)
		AI_SetEnabled('nazi_gunner4',0)
		AI_SetEnabled('nazi_grenadier4',0)


def BulletKO(event):
	play(final_cs_bl_ko,'final_cs_bl_ko')

def ChasmKill(event):
	kill(event.object)


def FirstWaveDown(event):
	addAttr('first_wave_count',1)
	if Mission_GetAttr('first_wave_count') == 2:
		play(lockdown_ss,'lockdown_ss')


def General1Down(event):
	AI_SetEnabled('general1',0)
	makeCriticalCustomFn('general1')
	# maybe make Safe if Safe gets fixed.
def General2Down(event):
	AI_SetEnabled('general2',0)
	makeCriticalCustomFn('general2')
	# maybe make Safe if Safe gets fixed.
def interrogate_general1_fn(heroname):
	Mission_SetAttr('gen_to_kill',1)
	addAttr('keys_found',1)
	if Mission_GetAttr('keys_found') == 1:
		print "got first key"
		play (general_1_ss,'general_1_ss')
	elif Mission_GetAttr('keys_found') == 2:
		print "got second key"
		play (general_2_ss,'general_2_ss')
		Objective_Complete('find_keys')
def interrogate_general2_fn(heroname):
	Mission_SetAttr('gen_to_kill',2)
	addAttr('keys_found',1)
	if Mission_GetAttr('keys_found') == 1:
		print "got first key"
		play (general_1_ss,'general_1_ss')
	elif Mission_GetAttr('keys_found') == 2:
		print "got second key"
		play (general_2_ss,'general_2_ss')
		Objective_Complete('find_keys')
def KillAGeneral():
	# kills the appropriate general at the end of the SS
	if Mission_GetAttr('gen_to_kill') == 1:
		kill('general1')
	elif Mission_GetAttr('gen_to_kill') == 2:
		kill('general2')
	else:
		print "bad general kill #?"



def KillFogW(event):
	kill('_impobj_fog_corridor_w')
	kill('_impobj_door_bullets_exit')
#def DoorBulletOpened(event):
	spawn('open_bullet','nazihq_door_open','door_bullet_marker')

def OpenLabA(event,heroname):
	kill('_impobj_fog_lab_a')
	kill('_impobj_door_closed_2')
	Object_PlayEffect('door_a_standin', 'effect_door_single_opening', 'DoorAOpened',FX_TRACK_OBJECT_ROT)
def DoorAOpened(event):
	spawn('open_a','nazihq_door_open','door_a_marker')
	Mission_SetAttr('lab_a_opened',1)
	if Mission_GetAttr('key1_loc') == 2:
		AI_SetEnabled('general1',1)

def OpenLabB(event,heroname):
	kill('_impobj_fog_lab_b')
	kill('_impobj_door_closed_3')
	Object_PlayEffect('door_b_standin', 'effect_door_single_opening', 'DoorBOpened',FX_TRACK_OBJECT_ROT)
def DoorBOpened(event):
	spawn('open_b','nazihq_door_open','door_b_marker')
	Mission_SetAttr('lab_b_opened',1)
	FriendlyGorillaCS(event)

def OpenLabC(event,heroname):
	addAttention('secret_plans')
	kill('_impobj_fog_lab_c')
	kill('_impobj_door_closed_4')
	Object_PlayEffect('door_c_standin', 'effect_door_single_opening', 'DoorCOpened',FX_TRACK_OBJECT_ROT)
def DoorCOpened(event):
	spawn('open_c','nazihq_door_open','door_c_marker')
	Mission_SetAttr('lab_c_opened',1)
	if Mission_GetAttr('key1_loc') == 3:
		AI_SetEnabled('general1',1)
	AI_SetEnabled('nazi_grenadier5',1)

def GunGoonsCS(event,heroname):
	kill('_impobj_fog_lab_d')
	kill('_impobj_wide_door_closed_2')
	Object_PlayEffect('door_dw_standin', 'effect_door_wide_opening', 'DoorDWOpened',FX_TRACK_OBJECT_ROT)
def DoorDWOpened(event):
	spawn('open_dw','nazihq_wide_door_open','door_dw_marker')
	Mission_SetAttr('lab_d_opened',1)
	AI_SetEnabled('nazi_rifleman1',1)
	AI_SetEnabled('nazi_gunner2',1)
	AI_SetEnabled('nazi_grenadier2',1)
	AI_SetEnabled('kar_chaingun1',1)
	AI_SetEnabled('kar_chaingun2',1)
	play(gun_goons_cs,'gun_goons_cs')

def OpenLabE(event,heroname):
	kill('_impobj_fog_lab_e')
	kill('_impobj_door_closed_5')
	Object_PlayEffect('door_e_standin', 'effect_door_single_opening', 'DoorEOpened',FX_TRACK_OBJECT_ROT)
def DoorEOpened(event):
	spawn('open_e','nazihq_door_open','door_e_marker')
	Mission_SetAttr('lab_e_opened',1)
	if Mission_GetAttr('key2_loc') == 1:
		AI_SetEnabled('general2',1)

def OpenLabF(event,heroname):
	kill('_impobj_fog_lab_f')
	kill('_impobj_door_closed_6')
	Object_PlayEffect('door_f_standin', 'effect_door_single_opening', 'DoorFOpened',FX_TRACK_OBJECT_ROT)
def DoorFOpened(event):
	spawn('open_f','nazihq_door_open','door_f_marker')
	Mission_SetAttr('lab_f_opened',1)
	if Mission_GetAttr('key2_loc') == 2:
		AI_SetEnabled('general2',1)
	AI_SetEnabled('nazi_rifleman3',1)

def OpenLabG(event,heroname):
	kill('_impobj_fog_lab_g')
	kill('_impobj_door_closed_7')
	Object_PlayEffect('door_g_standin', 'effect_door_single_opening', 'DoorGOpened',FX_TRACK_OBJECT_ROT)
def DoorGOpened(event):
	spawn('open_g','nazihq_door_open','door_g_marker')
	Mission_SetAttr('lab_g_opened',1)
	AI_SetEnabled('nazi_grenadier3',1)
	if Mission_GetAttr('key2_loc') == 3:
		AI_SetEnabled('general2',1)

def OpenPostA(event,heroname):	
	kill('_impobj_wide_door_closed_1')
	kill('_impobj_fog_guardpost_a')
	Object_PlayEffect('door_pa_standin', 'effect_door_wide_opening', 'DoorPAOpened',FX_TRACK_OBJECT_ROT)
def DoorPAOpened(event):
	spawn('open_pa','nazihq_wide_door_open','door_pa_marker')
	Mission_SetAttr('guardpost_opened',1)
	if Mission_GetAttr('key1_loc') == 1:
		AI_SetEnabled('general1',1)
	AI_SetEnabled('nazi_rifleman4',1)
	AI_SetEnabled('nazi_gunner3',1)

def KillFogEC(event,heroname):
	kill('_impobj_wide_door_closed_3')
	kill('_impobj_fog_corridor_e')
	Object_PlayEffect('door_dn_standin', 'effect_door_wide_opening', 'DoorDNOpened',FX_TRACK_OBJECT_ROT)
def DoorDNOpened(event):
	spawn('open_dn','nazihq_wide_door_open','door_dn_marker')
	startPatrol('nazi_rifleman5',2,priority=ai.goal.PRI_ZERO-1,run=0)

def KillFogExit(event,heroname):
	kill('_impobj_wide_door_closed_4')
	kill('_impobj_fog_exit_room')
	Object_PlayEffect('door_exitw_standin', 'effect_door_wide_opening', 'DoorExitWOpened',FX_TRACK_OBJECT_ROT)
def DoorExitWOpened(event):
	spawn('open_exitw','nazihq_wide_door_open','door_exitw_marker')
	Mission_SetAttr('exit_opened',1)
	AI_SetEnabled('nazi_rifleman2',1)
	AI_SetEnabled('nazi_gunner4',1)
	AI_SetEnabled('nazi_grenadier4',1)

def OpenExit(event,heroname):
	if Objective_IsComplete('find_keys'):
		kill('_impobj_wide_door_closed_5')
		Object_PlayEffect('door_exitn_standin', 'effect_door_wide_opening', 'DoorExitNOpened',FX_TRACK_OBJECT_ROT)
		if Object_GetTemplate(heroname) == 'black_jack':
			speakNoCB('black_jack','MISSPCH_11_BJ_10')
		elif Object_GetTemplate(heroname) == 'tricolour':
			speakNoCB('tricolour','MISSPCH_11_TC_10')
		elif Object_GetTemplate(heroname) == 'sky_king':
			speakNoCB('sky_king','MISSPCH_11_SY_10')
		else:
			print "problem in OpenExit?"
	else:
		NeedKeyLine()
def DoorExitNOpened(event):
		spawn('open_exitn','nazihq_wide_door_open','door_exitn_marker')

def NeedKeyLine():
	print "still need at least one key"
	hero_list = getAllHeroes()
	liveheroes = ['nullhero']
	for hero_x in hero_list:
		if Object_IsAlive(hero_x):
			liveheroes.append(Object_GetTemplate(hero_x))
	temp = randint(1,len(liveheroes))-1
	heroname = liveheroes[temp]
	if Object_GetTemplate(heroname) == 'black_jack':
		speakNoCB('black_jack','MISSPCH_11_BJ_11')
	elif Object_GetTemplate(heroname) == 'tricolour':
		speakNoCB('tricolour','MISSPCH_11_TC_11')
	elif Object_GetTemplate(heroname) == 'sky_king':
		speakNoCB('sky_king','MISSPCH_11_SY_11')
	elif Object_GetTemplate(heroname) == 'bullet':
		speakNoCB('bullet','MISSPCH_11_BL_15')
	else:
		print "problem in NeedKeyLine?"
		speakNoCB('bullet', 'MISSPCH_11_BL_15')


def Cage1Bust(event):
	if Mission_GetAttr('plan_hack') == 0:
		AI_Animate('kar_whip1','melee')
		kill('cage1')
		clearGoals('kar_whip1')
		Mission_SetAttr('cage1_busted',1)
	else:
		print "secret plan 'damage'; not busting cage"

def Cage2Bust(event):
	if Mission_GetAttr('plan_hack') == 0:
		AI_Animate('kar_whip2','melee')
		kill('cage2')
		clearGoals('kar_whip2')
		Mission_SetAttr('cage2_busted',1)
	else:
		print "secret plan 'damage'; not busting cage"

def Cage3Bust(event):
	if Mission_GetAttr('plan_hack') == 0:
		AI_Animate('kar_chaingun3','melee')
		kill('cage3')
		clearGoals('kar_chaingun3')
		Mission_SetAttr('cage3_busted',1)
	else:
		print "secret plan 'damage'; not busting cage"


def AmbushBark1(event):
	play(ambush_bark_ss_1,'ambush_bark_ss_1')

def AmbushBark2(event):
	play(ambush_bark_ss_2,'ambush_bark_ss_2')

def AmbushBark3(event):
	play(ambush_bark_ss_3,'ambush_bark_ss_3')

def AmbushBark4(event):
	play(ambush_bark_ss_4,'ambush_bark_ss_4')


def GetPapers(event,heroname):
	kill('secret_plans')
	Objective_Complete('find_plans')
	Mission_SetAttr('plan_hack',1)
	if Object_IsAlive('kar_chaingun1'):
		c1health = Object_GetAttr('kar_chaingun1','health')/2
		Object_SetAttr('kar_chaingun1','health',c1health)
	if Object_IsAlive('kar_chaingun2'):
		c2health = Object_GetAttr('kar_chaingun2','health')/2
		Object_SetAttr('kar_chaingun2','health',c2health)
	if Object_IsAlive('kar_chaingun3'):
		c3health = Object_GetAttr('kar_chaingun3','health')/2
		Object_SetAttr('kar_chaingun3','health',c3health)
	if Object_IsAlive('kar_whip1'):
		w1health = Object_GetAttr('kar_whip1','health')/2
		Object_SetAttr('kar_whip1','health',w1health)
	if Object_IsAlive('kar_whip2'):
		w2health = Object_GetAttr('kar_whip2','health')/2
		Object_SetAttr('kar_whip2','health',w2health)
	play(get_papers_ss, "get_papers_ss")
	regTimer('UndoHack',.5)
def UndoHack(event):
	Mission_SetAttr('plan_hack',0)

def GetPapersLine():
	hero_list = getAllHeroes()
	liveheroes = ['nullhero']
	for hero_x in hero_list:
		if (Object_IsAlive(hero_x) and not (Object_GetTemplate(hero_x) == 'bullet')):
			liveheroes.append(Object_GetTemplate(hero_x))
	if len(liveheroes) == 1:
		a_hero = 'nobody'
	else:
		temp = randint(1,len(liveheroes)-1)
		a_hero = liveheroes[temp]
	print a_hero
	if a_hero == 'sky_king':
		speak('sky_king', 'MISSPCH_11_SY_02')
	elif a_hero == 'black_jack':
		speak('black_jack', 'MISSPCH_11_BJ_13')
	elif a_hero == 'tricolour':
		speak('tricolour', 'MISSPCH_11_TC_03')
	else:
		print "wrong hero on mission?"
		wait(.1)

def SmashOne(event):
	addAttr('smash_count',1)
	print Mission_GetAttr('smash_count')
	### tune various numbers below
	if Mission_GetAttr('smash_count') == 5:
		SmashHalf(event)
	if Mission_GetAttr('smash_count') == 8:
		SmashNear(event)
	if Mission_GetAttr('smash_count') == 10:
		SmashDone(event)
		Objective_Complete('smash')
def SmashHalf(event):
	print("smash half")
	if Object_IsAlive('black_jack'):
		play(smash_half_ss_bj, "smash_half_ss_bj")
	elif Object_IsAlive('sky_king'):
		play(smash_half_ss_sy, "smash_half_ss_sy")
	elif Object_IsAlive('tricolour'):
		play(smash_half_ss_tc, "smash_half_ss_tc")
	else:
		play(smash_half_ss_bl, "smash_half_ss_bl")
def SmashNear(heroname):
	print("smash near")
	if Object_IsAlive('sky_king'):
		play(smash_near_ss_sy, "smash_near_ss_sy")
	elif Object_IsAlive('tricolour'):
		play(smash_near_ss_tc, "smash_near_ss_tc")
	elif Object_IsAlive('black_jack'):
		play(smash_near_ss_bj, "smash_near_ss_bj")
	else:
		play(smash_near_ss_bl, "smash_near_ss_bl")
def SmashDone(heroname):
	print("smash done")
	if Object_IsAlive('tricolour'):
		play(smash_done_ss_tc, "smash_done_ss_tc")
	elif Object_IsAlive('black_jack'):
		play(smash_done_ss_bj, "smash_done_ss_bj")
	elif Object_IsAlive('sky_king'):
		play(smash_done_ss_sy, "smash_done_ss_sy")
	else:
		play(smash_done_ss_bl, "smash_done_ss_bl")


def FriendlyGorillaCS(event):
	play(friendly_gorilla_cs,'friendly_gorilla_cs')

def SaveGorilla(event):
	Mission_SetAttr('friendly_freed',1)
	Object_SetAttr('friendly_kar','pathBudget',1500)
	spawn('fg1','nazi_rifleman','fg1_spawn_point')
	spawn('fg2','nazi_gunner','fg2_spawn_point')
	regDeath('fg1','FGDown')
	regDeath('fg2','FGDown')
	kloc = Get_ObjectPos('friendly_kar')
	addMoveGoal('fg1', kloc, priority = ai.goal.PRI_ZERO-1,radius=10)
	addMoveGoal('fg2', kloc, priority = ai.goal.PRI_ZERO-1,radius=10)
	addKillGoal('fg1','friendly_kar')
	addKillGoal('fg2','friendly_kar')
	FriendlyKAR(event)
	play(save_gorilla_ss,'save_gorilla_ss')

def FriendlyKARLine():
	a_hero = getRandomLiveHeroName()
	print a_hero
	if a_hero == 'sky_king':
		speak('sky_king', 'MISSPCH_11_SY_12')
	elif a_hero == 'black_jack':
		speak('black_jack', 'MISSPCH_11_BJ_12')
	elif a_hero == 'tricolour':
		speak('tricolour', 'MISSPCH_11_TC_12')
	elif a_hero == 'bullet':
		speak('bullet', 'MISSPCH_11_BL_16')
	else:
		print "wrong hero on mission?"

def FGDown(event):
	addAttr('fg_count',1)
	if Mission_GetAttr('fg_count') >= 2:
		if not Objective_IsComplete('free_kar'):
			Objective_Complete('free_kar')
		SetKARCustomAttackCommands()
		Mission_CustomAction('call friendly KAR home', 'bullet', 'bullet', 'AddCallKARHome', 100, 0)
		regDeath('friendly_kar','removeKARCustom')

def removeKARCustom(event):
    if not Object_IsAlive('friendly_kar'):
        print 'removeKARCustom: friendly_kar is dead :-('
        RemoveKARCustomAttackCommands()
        Mission_RemoveCustomAction('call friendly KAR home', 'bullet', 'bullet')

def FriendlyKAR(event):
	if Object_IsAlive('friendly_kar'):
		print 'FriendlyKAR executing'
		js.Event_CancelSinks('FriendlyKAR')
		SetKARCustomAttackCommands()
		if not Mission_GetAttr('kar_hasCustomGoal'):
			clearGoals('friendly_kar')
			makePeaceful('friendly_kar')
			addKillAllGoal('friendly_kar', OC_MINION | OC_VILLIAN)
			bulletloc=Get_ObjectPos('bullet')
			print bulletloc
			addMoveGoal('friendly_kar', bulletloc, priority = ai.goal.PRI_LOW)
		regTimer('FriendlyKAR',5)
	else:
		print 'Friendly KAR is dead; halting homing function'

def AddCustomKARGoal(baddy,hero):
    print 'AddCustomKARGoal: adding kill %s to KAR' % baddy
    addKillGoal('friendly_kar', baddy, ai.goal.PRI_MED+1, fn='', user = 0, permanent = 0, replace = 1)
    Mission_SetAttr('kar_hasCustomGoal',1)
    regDeath(baddy,'ClearKARCustomGoals')

def SetKARCustomAttackCommands():
    RemoveKARCustomAttackCommands()
    for computer in getAllByPrefix('sc_nazihq_computer'):
        Mission_CustomAction('have KAR attack', 'bullet', computer, 'AddCustomKARGoal', 100, 0)
    for baddy in getAllBaddies():
        Mission_CustomAction('have KAR attack', 'bullet', baddy, 'AddCustomKARGoal', 100, 0)

def RemoveKARCustomAttackCommands():
    for computer in getAllByPrefix('sc_nazihq_computer'):
        Mission_RemoveCustomAction('have KAR attack', 'bullet', computer)
    for baddy in getAllBaddies():
        Mission_RemoveCustomAction('have KAR attack', 'bullet', baddy)
        
def ClearKARCustomGoals(event):
    Mission_SetAttr('kar_hasCustomGoal',0)
    FriendlyKAR(event)

def AddCallKARHome(baddy,hero):
    print 'AddCallKARHome: calling KAR home'
    addMoveGoal('friendly_kar', hero, ai.goal.PRI_MED+1, fn='ClearKARCustomGoals', user = 0, permanent = 0, replace = 1)
    Mission_SetAttr('kar_hasCustomGoal',1)

def BulletSafe(event):
	if Objective_IsComplete('find_keys'):
#		kill('_impobj_wide_door_closed_5')
#		spawn('open_exitn','nazihq_wide_door_open','door_exitn_marker')
		play(final_cs,'final_cs')
	else:
		NeedKeyLine()
		regTimer('ResetExit',30)
def ResetExit(event):
	regMarkerEnter('bullet','exit_marker','BulletSafe')

def OnMissionWon():
	print "bullet/won"

def OnMissionLost():
	print "bullet/lost"


#										 #
# cutscenes and scripted sequences below  #
#										 #



start_cs = [
(
	"peace()",
	"startCS()",
	"look('sky_king', zoom = -250, heading = 250, time = 0)",
	"speak('black_jack', 'MISSPCH_11_BJ_01')",
),
(
	"speak('tricolour', 'MISSPCH_11_TC_01')",
),
(
	"ff.KillFogW(event)",
	"speak('sky_king', 'MISSPCH_11_SY_01')",
),
(
	"move('nazi_gunner1','nazirun1')",
	"move('nazi_grenadier1','nazirun2')",
	"look('nazirun1', zoom = -250, heading = 70, time = 2)",
	"turn('black_jack','nazirun1')",
	"turn('bullet','nazirun1')",
	"turn('sky_king','nazirun1')",
	"turn('tricolour','nazirun1')",
	"Sound_PlayMusic('music_04winter_hit2',1)",
	"forceSpeak('nazi_grenadier', 'MISSPCH_11_N1_01', telepathy=0)",
),
(
	"look('bullet', zoom = -250, heading = 70, time = 3)",
	"speak('bullet', 'MISSPCH_11_BL_20')",
),
(
	"endCS()",
	"war()",
	"regTimer('AIsOff',1)",
	"newObjective('primary', 1, name='escape')",
	"newObjective('primary', 2, name='survive')",
	"newObjective('secondary', 1, name='smash')",
	"newObjective('secondary', 2, name='find_plans')",
	"registerObjective('secondary', 3, name='free_kar')",
),
]


lockdown_ss = [
(
	"forceSpeak('nazi_general','MISSPCH_11_NG_01', telepathy=0)",
),
(
	"newObjective('primary', 3, name='find_keys')",
	"speak('bullet','MISSPCH_11_BL_12')",
	"Sound_PlayMusic('music_07euros1')",
),
(
	"blank",
),
]


ambush_bark_ss_1 = [
(
	"forceSpeak('nazi_rifleman', 'MISSPCH_11_N1_02', telepathy=0)",
),
(
	"blank",
),
]

ambush_bark_ss_2 = [
(
	"forceSpeak('nazi_rifleman', 'MISSPCH_11_N1_03', telepathy=0)",
),
(
	"blank",
),
]

ambush_bark_ss_3 = [
(
	"forceSpeak('nazi_rifleman', 'MISSPCH_11_N1_04', telepathy=0)",
),
(
	"blank",
),
]

ambush_bark_ss_4 = [
(
	"forceSpeak('nazi_rifleman', 'MISSPCH_11_N1_05', telepathy=0)",
),
(
	"blank",
),
]


friendly_gorilla_cs = [
(
	"peace()",
	"startCS()",
	"look('friendly_kar', zoom = -200, heading = 180, time = 0)",
	"forceSpeak('killarilla_whip', 'MISSPCH_11_KR_01',telepathy = 0)",
),
(
	"speak('bullet', 'MISSPCH_11_BL_01')",
),
(
	"ff.FriendlyKARLine()",
),
(
	"Objective_Activate('free_kar')",
	"addArrow('fk_arrow', 'friendly_cage', js.ARROW_YELLOW, delete=1)",
	"endCS()",
	"war()",
	"regTimer('AIsOff',1)",
),
]

save_gorilla_ss = [
(
	"speak('fg1', 'MISSPCH_11_N1_06')",
),
(
	"blank",
),
]

get_papers_ss = [
(
	"speak('bullet', 'MISSPCH_11_BL_02')",
),
(
	"ff.GetPapersLine()",
),
(
	"blank",
),
]


gun_goons_cs = [
(
	"peace()",
	"see()",
	"startCS()",
	"look('gg_cam1', zoom = -250, heading = 250, time = 0)",
	"Sound_PlayMusic('music_04winter_hit1',1)",
	"forceSpeak('nazi_rifleman', 'MISSPCH_11_N1_07', telepathy=0)",
),
(
	"look('karg_move1', zoom = -250, heading = 90, time = 0)",
	"move('kar_chaingun1','karg_move1')",
	"move('kar_chaingun2','karg_move2')",
	"move('nazi_rifleman1','escort1')",
	"move('nazi_gunner2','escort2')",
	"Sound_PlayMusic('music_07euros_jungle')",
	"forceSpeak('killarilla_whip', 'MISSPCH_11_KR_02', telepathy=0)",
),
(
	"speak('bullet', 'MISSPCH_11_BL_11')",
),
(
	"blind()",
	"war()",
	"regTimer('AIsOff',1)",
	"endCS()",
),
]

smash_half_ss_bj = [
(
	"speak('black_jack','MISSPCH_11_BJ_04')",
),
(
	"blank",
),
]

smash_half_ss_bl = [
(
	"speak('bullet','MISSPCH_11_BL_03')",
),
(
	"blank",
),
]

smash_half_ss_tc = [
(
	"speak('tricolour','MISSPCH_11_TC_04')",
),
(
	"blank",
),
]

smash_half_ss_sy = [
(
	"speak('sky_king','MISSPCH_11_SY_03')",
),
(
	"blank",
),
]

smash_near_ss_sy = [
(
	"speak('sky_king','MISSPCH_11_SY_04')",
),
(
	"blank",
),
]

smash_near_ss_tc = [
(
	"speak('tricolour','MISSPCH_11_TC_05')",
),
(
	"blank",
),
]

smash_near_ss_bj = [
(
	"speak('black_jack','MISSPCH_11_BJ_05')",
),
(
	"blank",
),
]

smash_near_ss_bl = [
(
	"speak('bullet','MISSPCH_11_BL_04')",
),
(
	"blank",
),
]

smash_done_ss_bl = [
(
	"speak('bullet','MISSPCH_11_BL_05')",
),
(
	"blank",
),
]

smash_done_ss_bj = [
(
	"speak('black_jack','MISSPCH_11_BJ_06')",
),
(
	"blank",
),
]

smash_done_ss_tc = [
(
	"speak('tricolour','MISSPCH_11_TC_06')",
),
(
	"blank",
),
]

smash_done_ss_sy = [
(
	"speak('sky_king','MISSPCH_11_SY_05')",
),
(
	"blank",
),
]


general_1_ss = [
(
	"forceSpeak('nazi_general','MISSPCH_11_NG_02', telepathy=0)",
	"Sound_PlayTransition('music_04winter_hit1')",
),
(
	"ff.KillAGeneral()",
	"speak('bullet','MISSPCH_11_BL_13')",
),
(
	"blank",
),
]

general_2_ss = [
(
	"forceSpeak('nazi_general','MISSPCH_11_NG_04', telepathy=0)",
	"Sound_PlayTransition('music_04winter_hit2')",
),
(
	"ff.KillAGeneral()",
	"speak('bullet','MISSPCH_11_BL_14')",
),
(
	"blank",
),
]



final_cs_bl_ko = [
(
	"peace()",
	"startCS()",
	"look('bullet', zoom = 0)",
	"Objective_Fail('survive')",
	"forceSpeakNoCB('bullet','MISSPCH_11_BL_06', telepathy=0)",
	"wait(1)",
),
(
	"endCS()",
	"Mission_Lose()",
),
]

final_cs = [
(
	"peace()",
	"startCS()",
	"Sound_PlayMusic('music_04winter_hit2',1)",
	"look('exit_marker', zoom = -200, heading = 0, time = 0)",
	"speak('bullet','MISSPCH_11_BL_07')",
),
(
	"Objective_Complete('escape')",
	"Objective_Complete('survive')",
	"endCS()",
	"Mission_Win()",
),
]
