# waiting

# to do:
# - make mission end properly
# - spawn new bad guys after jammer is KO-ed

from cshelper import *
from js import *
import event
from ffx import *

def OnPrecacheObjects():
	print "waiting/precache"
	Mission_PrecacheTemplateObj('killarilla_chaingun', 0, 1)
	Mission_PrecacheTemplateObj('killarilla_whip', 0, 1)
	Mission_PrecacheTemplateObj('nazi_grenadier', 0, 1)
	Mission_PrecacheTemplateObj('nazi_general', 0, 1)
	Mission_PrecacheTemplateObj('nazi_rifleman', 1, 0)
	Mission_PrecacheTemplateObj('eye_minor', 0, 1)

def OnPostInit():
	print "waiting/start"
	setMission(14)

	Mission_SetSunlight(-140,60,1.2,1.0,(0.3,0.2,0.9))
	Mission_SetShadows(-140,60,(0.1,0.1,0.6))
	Mission_SetProjShadowBackground((1,1,1))
	Mission_SetProjShadowColor((.5,.5,.7,1))

	Mission_CustomAction('Adjust_Suit', 'sky_king', 'sky_king', 'OnStartSuitFiddling', 1, 0)
	Mission_SetAttr('testhandle', 0)
	Mission_SetAttr('effect_playing', 0)


	Mission_SetAttr('finished_cycles', 0)
	Mission_SetAttr('number_of_enemies', 6)
	Mission_SetAttr('started_fiddle_cycle', 0)

	Mission_SetAttr('wave_barks_played', 0)	

	Mission_SetAttr('waveA', 0)
	Mission_SetAttr('waveB', 0)

	Mission_SetAttr('mission_over', 0)

	Mission_SetAttr('jammer_in_effect', 0)

	Mission_SetAttr('jammer_1a_dead', 0)
	Mission_SetAttr('jammer_1b_dead', 0)
	Mission_SetAttr('jammer_2a_dead', 0)
	Mission_SetAttr('jammer_2b_dead', 0)
	Mission_SetAttr('jammer_3a_dead', 0)
	Mission_SetAttr('jammer_3b_dead', 0)

	regDeaths('nazi_gunner', 'OnEnemyDied')
	regDeaths('killarilla_whip', 'OnEnemyDied')
	regDeaths('killarilla_chaingun', 'OnEnemyDied')
	regDeaths('nazi_general', 'OnEnemyDied')
	regDeaths('eye_minor', 'OnEnemyDied')

	regDeath('sky_king', 'OnSkyKingDead')

	spawn('gunner1_standin', 'fx_standin', 'nazi_gunner1_marker')
	spawn('gunner2_standin', 'fx_standin', 'nazi_gunner2_marker')
	spawn('gunner3_standin', 'fx_standin', 'nazi_gunner3_marker')
	spawn('swap1_standin', 'fx_standin', 'swap_marker1')
	spawn('swap2_standin', 'fx_standin', 'swap_marker2')
	spawn('swap3_standin', 'fx_standin', 'swap_marker3')
	spawn('swap4_standin', 'fx_standin', 'swap_marker4')
	spawn('swap5_standin', 'fx_standin', 'swap_marker5')
	spawn('swap6_standin', 'fx_standin', 'swap_marker6')

	Object_PlayEffect('_impobj_wall_gate', 'effect_blitz_shield', '', FX_LOOP)

	play(start_cs,'start_cs')
	FFX_InitMission()

def OnMissionWon():
	print "waiting/won"

def OnMissionLost():
	print "waiting/lost"

def OnSkyKingDead(event):
	play(final_sk_dead_cs, "final_sk_dead_cs")

def OnStartSuitFiddling(object, heroname):
	print "fiddling!"
	if Mission_GetAttr('jammer_in_effect') == 0:
		AI_Animate('sky_king', 'fix_suit', 'OnFiddleFinish', 0, 0)
		if Mission_GetAttr('effect_playing') == 0:
			handle = Object_PlayEffect('sky_king', 'effect_skyking_adjustsuit', '', FX_LOOP)
			Mission_SetAttr('testhandle', handle)
			Mission_SetAttr('effect_playing', 1)
		Mission_SetAttr('started_fiddle_cycle', 1)
	if Mission_GetAttr('jammer_in_effect') == 1:
		speakNoCB('sky_king', 'MISSPCH_14_SY_14') 
		print "The Jammer prevents me!"
	if Mission_GetAttr('jammer_in_effect') == 2:
		Mission_SetAttr('jammer_in_effect', 1)

def SkykingIdle(event):
	if Mission_GetAttr('mission_over') == 0:
		if Mission_GetAttr('jammer_in_effect') == 0:
			if Mission_GetAttr('started_fiddle_cycle') == 0:
				play(get_to_work_ss, "get_to_work_ss")
				regTimer('SkykingIdle', 45)

def OnFiddleFinish(event):
	status = int(event.data)
	if not status:
		# fiddling animation was interrupted
		OnFiddleInterrupted()
	else:
		print "cycle complete!"
		addAttr('finished_cycles', 1)
		if Mission_GetAttr('finished_cycles') == 8:
			play(five_eighths_done_ss, "five_eighths_done_ss")
		if Mission_GetAttr('finished_cycles') == 16:
			play(six_eighths_done_ss, "six_eighths_done_ss")
		if Mission_GetAttr('finished_cycles') == 24:
			play(seven_eighths_done_ss, "seven_eighths_done_ss")
		if Mission_GetAttr('finished_cycles') == 32:
			Mission_SetAttr('mission_over', 1)
			play(final_cs, "final_cs")
		OnStartSuitFiddling('sky_king', 'sky_king')

def OnFiddleInterrupted():
	regTimer('SkykingIdle', 20)
	Mission_SetAttr('started_fiddle_cycle', 0)
	Object_StopEffect('sky_king', int(Mission_GetAttr('testhandle')))
	Mission_SetAttr('effect_playing', 0)
	play(interrupted_ss, "interrupted_ss")

def ZeroWaveMoves():
	addMoveGoal('nazi_gunner_swap1', 'sky_king', fn = '', radius = 5, priority = ai.goal.PRI_ZERO-1)
#	addKillAllGoal('nazi_gunner_swap1', OC_CONTROLLABLE, priority = ai.goal.PRI_MED, fn = '', user = 0, permanent = 0, replace = 0)
	addMoveGoal('nazi_general_swap2', 'sky_king', fn = '', radius = 5, priority = ai.goal.PRI_ZERO-1)
#	addKillAllGoal('nazi_general_swap2', OC_CONTROLLABLE, priority = ai.goal.PRI_MED, fn = '', user = 0, permanent = 0, replace = 0)
	addMoveGoal('nazi_gunner_swap3', 'sky_king', fn = '', radius = 5, priority = ai.goal.PRI_ZERO-1)
#	addKillAllGoal('nazi_gunner_swap3', OC_CONTROLLABLE, priority = ai.goal.PRI_MED, fn = '', user = 0, permanent = 0, replace = 0)
	addMoveGoal('nazi_general_swap4', 'sky_king', fn = '', radius = 5, priority = ai.goal.PRI_ZERO-1)
#	addKillAllGoal('nazi_general_swap4', OC_CONTROLLABLE, priority = ai.goal.PRI_MED, fn = '', user = 0, permanent = 0, replace = 0)
	addMoveGoal('killarilla_whip_swap5', 'sky_king', fn = '', radius = 5, priority = ai.goal.PRI_ZERO-1)
#	addKillAllGoal('killarilla_whip_swap5', OC_CONTROLLABLE, priority = ai.goal.PRI_MED, fn = '', user = 0, permanent = 0, replace = 0)
	addMoveGoal('eye_minor_swap6', 'sky_king', fn = '', radius = 5, priority = ai.goal.PRI_ZERO-1)
#	addKillAllGoal('eye_minor_swap6', OC_CONTROLLABLE, priority = ai.goal.PRI_MED, fn = '', user = 0, permanent = 0, replace = 0)

	if RPG_GAME_DIFFICULTY < 3:
		regTimer('EnemyWaveSpawnA', 80)
		regTimer('EnemyWaveSpawnB', 160)
	elif RPG_GAME_DIFFICULTY < 6:
		regTimer('EnemyWaveSpawnA', 60)
		regTimer('EnemyWaveSpawnB', 120)
	else:
		regTimer('EnemyWaveSpawnA', 40)
		regTimer('EnemyWaveSpawnB', 80)
	regTimer('SkykingIdle', 20)
	GoGetKing(event)

# This looping function constantly looks for all bad guys, and sends them to attack Sky King
# It ignores the jammers
# I apologize for the ugliness of these nested loops
def GoGetKing(event):
	print "giving all bad guys their orders!"
	baddielist = getAllBaddies(checkLiving=1)
	for baddie in baddielist:
		if(Mission_GetAttr('jammer_in_effect') == 0):
			addMoveGoal(baddie, 'sky_king', fn = '', radius = 5, priority = ai.goal.PRI_ZERO-1)
#			addKillAllGoal(baddie, OC_CONTROLLABLE, priority = ai.goal.PRI_MED)
		else:
			if not (baddie == 'jammerguy1'):
				if not (baddie == 'jammerguy1a'):
					if not (baddie == 'jammerguy1b'):
						if not (baddie == 'jammerguy2'):
							if not (baddie == 'jammerguy2a'):
								if not (baddie == 'jammerguy2b'):
									if not (baddie == 'jammerguy3'):
										if not (baddie == 'jammerguy3a'):
											if not (baddie == 'jammerguy3b'):
												addMoveGoal(baddie, 'sky_king', fn = '', radius = 5, priority = ai.goal.PRI_ZERO-1)
#												addKillAllGoal(baddie, OC_CONTROLLABLE, priority = ai.goal.PRI_MED)
	regTimer('GoGetKing', 5)


def OnEnemyDied(event):
	addAttr('number_of_enemies', -1)
	print "Enemy has died. Number of enemies now: "
	print Mission_GetAttr('number_of_enemies')

def EnemyWaveSpawnA(event):
	if Mission_GetAttr('mission_over') == 0:
		print "Spawning Wave A"
		wave = int(Mission_GetAttr('waveA'))

		if RPG_GAME_DIFFICULTY < 3:
			regTimer('EnemyWaveSpawnA', 160)
		elif RPG_GAME_DIFFICULTY < 6:
			regTimer('EnemyWaveSpawnA', 120)
		else:
			regTimer('EnemyWaveSpawnA', 80)

		addAttr('waveA', 1)

		if Mission_GetAttr('number_of_enemies') < 6:
			if Mission_GetAttr('wave_barks_played') == 0:
				play(wave_a_bark_ss, "wave_a_bark_ss")
			if Mission_GetAttr('wave_barks_played') == 1:
				play(wave_b_bark_ss, "wave_b_bark_ss")
			if Mission_GetAttr('wave_barks_played') == 2:
				play(wave_c_bark_ss, "wave_c_bark_ss")
			if Mission_GetAttr('wave_barks_played') > 2:
				play(wave_d_bark_ss, "wave_d_bark_ss")
			addAttr('wave_barks_played', 1)

		if Mission_GetAttr('number_of_enemies') < 4:
			spawnGroup('an', 'nazi_gunner', 2, wave)
			spawnGroup('ak', 'killarilla_chaingun', 1, wave)
			addAttr('number_of_enemies', 3)
			print "3 Enemies spawned. Number of enemies now: "
			print Mission_GetAttr('number_of_enemies')

		elif Mission_GetAttr('number_of_enemies') == 4:
			spawnGroup('an', 'nazi_gunner', 1, wave)
			spawnGroup('ak', 'killarilla_chaingun', 1, wave)
			addAttr('number_of_enemies', 2)
			print "2 Enemies spawned. Number of enemies now: "
			print Mission_GetAttr('number_of_enemies')

		elif Mission_GetAttr('number_of_enemies') == 5:
			spawnGroup('ak', 'killarilla_chaingun', 1, wave)
			addAttr('number_of_enemies', 1)
			print "1 Enemy spawned. Number of enemies now: "
			print Mission_GetAttr('number_of_enemies')


def EnemyWaveSpawnB(event):
	if Mission_GetAttr('mission_over') == 0:
		print "Spawning Wave B"
		wave = int(Mission_GetAttr('waveB'))

		if RPG_GAME_DIFFICULTY < 3:
			regTimer('EnemyWaveSpawnB', 160)
		elif RPG_GAME_DIFFICULTY < 6:
			regTimer('EnemyWaveSpawnB', 120)
		else:
			regTimer('EnemyWaveSpawnB', 80)

		addAttr('waveB', 1)

		if Mission_GetAttr('number_of_enemies') < 6:
			if Mission_GetAttr('wave_barks_played') == 0:
				play(wave_a_bark_ss, "wave_a_bark_ss")
			if Mission_GetAttr('wave_barks_played') == 1:
				play(wave_b_bark_ss, "wave_b_bark_ss")
			if Mission_GetAttr('wave_barks_played') == 2:
				play(wave_c_bark_ss, "wave_c_bark_ss")
			if Mission_GetAttr('wave_barks_played') > 2:
				play(wave_d_bark_ss, "wave_d_bark_ss")
			addAttr('wave_barks_played', 1)


			if Mission_GetAttr('number_of_enemies') < 4:
				spawnGroup('bn', 'nazi_gunner', 1, wave)
				spawnGroup('bk', 'killarilla_chaingun', 2, wave)
				addAttr('number_of_enemies', 3)
				print "3 enemies spawned. Number of enemies now: "
				print Mission_GetAttr('number_of_enemies')

			elif Mission_GetAttr('number_of_enemies') == 4:
				spawnGroup('bn', 'nazi_gunner', 1, wave)
				spawnGroup('bk', 'killarilla_chaingun', 1, wave)
				addAttr('number_of_enemies', 2)
				print "2 enemies spawned. Number of enemies now: "
				print Mission_GetAttr('number_of_enemies')

			elif Mission_GetAttr('number_of_enemies') == 5:
				spawnGroup('bk', 'killarilla_chaingun', 1, wave)
				addAttr('number_of_enemies', 1)
				print "1 Enemy spawned. Number of enemies now: "
				print Mission_GetAttr('number_of_enemies')



def JammerArrives():
	Object_StopEffect('sky_king', int(Mission_GetAttr('testhandle')))
	Mission_SetAttr('effect_playing', 0)

	Mission_SetAttr('jammer_in_effect', 2)
	spawn('jammerguy1', 'nazi_grenadier', 'jammer_group1_1')
	spawn('jammerguy1a', 'nazi_gunner', 'jammer_group1_2')
	spawn('jammerguy1b', 'nazi_gunner', 'jammer_group1_3')

	spawn('jammerguy2', 'nazi_grenadier', 'jammer_group2_1')
	spawn('jammerguy2a', 'nazi_gunner', 'jammer_group2_2')
	spawn('jammerguy2b', 'nazi_gunner', 'jammer_group2_3')

	spawn('jammerguy3', 'nazi_grenadier', 'jammer_group3_1')
	spawn('jammerguy3a', 'nazi_gunner', 'jammer_group3_2')
	spawn('jammerguy3b', 'nazi_gunner', 'jammer_group3_3')

	addAttr('number_of_enemies', 9)
	print "Enemy spawned. Number of enemies now: "
	print Mission_GetAttr('number_of_enemies')

	addArrow('jammer_arrow_1', 'jammerguy1', colour = js.ARROW_RED, delete = 1)
	addArrow('jammer_arrow_2', 'jammerguy2', colour = js.ARROW_RED, delete = 1)
	addArrow('jammer_arrow_3', 'jammerguy3', colour = js.ARROW_RED, delete = 1)

	makeInterrogationFn('jammerguy2', oneshot = 1)

	regDeath('jammerguy1', 'OnFakeJammerDead')
	regDeath('jammerguy3', 'OnFakeJammerDead')

	regDeath('jammerguy1a', 'OnJammer1aDead')
	regDeath('jammerguy1b', 'OnJammer1bDead')
	regDeath('jammerguy2a', 'OnJammer2aDead')
	regDeath('jammerguy2b', 'OnJammer2bDead')
	regDeath('jammerguy3a', 'OnJammer3aDead')
	regDeath('jammerguy3b', 'OnJammer3bDead')


	newObjective('primary', 2, name='find_jammer')

def OnJammer1aDead(event):
	Mission_SetAttr('jammer_1a_dead', 1)

def OnJammer1bDead(event):
	Mission_SetAttr('jammer_1b_dead', 1)
	
def OnJammer2aDead(event):
	Mission_SetAttr('jammer_2a_dead', 1)

def OnJammer2bDead(event):
	Mission_SetAttr('jammer_2b_dead', 1)

def OnJammer3aDead(event):
	Mission_SetAttr('jammer_3a_dead', 1)

def OnJammer3bDead(event):
	Mission_SetAttr('jammer_3b_dead', 1)

def interrogate_jammerguy2_fn(char):
	play(jammer_interrogation_ss, "jammer_interrogation_ss")
	print "Jammer Interrogated!"
	Mission_SetAttr('jammer_in_effect', 0)
	if Mission_GetAttr('jammer_1a_dead') == 0:
		addMoveGoal('jammerguy1a', 'sky_king', fn = '', radius = 5, priority = ai.goal.PRI_ZERO-1)
	if Mission_GetAttr('jammer_1b_dead') == 0:
		addMoveGoal('jammerguy1b', 'sky_king', fn = '', radius = 5, priority = ai.goal.PRI_ZERO-1)
	if Mission_GetAttr('jammer_2a_dead') == 0:
		addMoveGoal('jammerguy2a', 'sky_king', fn = '', radius = 5, priority = ai.goal.PRI_ZERO-1)
	if Mission_GetAttr('jammer_2b_dead') == 0:
		addMoveGoal('jammerguy2b', 'sky_king', fn = '', radius = 5, priority = ai.goal.PRI_ZERO-1)
	if Mission_GetAttr('jammer_3a_dead') == 0:
		addMoveGoal('jammerguy3a', 'sky_king', fn = '', radius = 5, priority = ai.goal.PRI_ZERO-1)
	if Mission_GetAttr('jammer_3b_dead') == 0:
		addMoveGoal('jammerguy3b', 'sky_king', fn = '', radius = 5, priority = ai.goal.PRI_ZERO-1)
	if Object_IsAlive('jammerguy1'):
		removeArrow('jammer_arrow_1')
	if Object_IsAlive('jammerguy3'):
		removeArrow('jammer_arrow_3')

def OnFakeJammerDead(event):
	if Mission_GetAttr('jammer_in_effect') != 0:
		speakNoCB('sky_king', 'MISSPCH_14_SY_09')


def PickSkyKingLine():
	temp = randint(0,2)
	if temp == 0:
		speak('sky_king', 'MISSPCH_14_SY_03')
	elif temp == 1:
		speak('sky_king', 'MISSPCH_14_SY_11')
	elif temp == 2:
		speak('sky_king', 'MISSPCH_14_SY_12')
	else:
		print "bad random number in PickSkyKingLine"

def PrintTest1():
	print "test 1"

def PrintTest2():
	print "test 2"

def PrintTest3():
	print "test 3"

#	"look('nazi_gunner2', zoom = -200, heading = -70, time = 2)",
#	"look('nazi_gunner3', zoom = -200, heading = -70, time = 2)",

start_cs = [
(
	"peace()",
	"see()",
	"startCS()",
	"look('sky_king', zoom = 0, heading = 0, time = 0)",
	"Sound_PlayMusic('music_05fort_cs1a',1)",
	"wait(1.0)",
),
(
	"look('sky_king', zoom = -150, heading = 0, time = 4)",
	"wait(4.0)",
),
(
	"look('nazi_gunner1', zoom = -200, heading = -70, time = 2)",
	"wait(5.0)",
),
(
	"Object_PlayEffect('gunner1_standin', 'effect_entropy_spawn', '',FX_TRACK_OBJECT_ROT)",
	"ff.Object_Destroy('nazi_gunner1')",
	"wait(1.0)",
),
(
	"Object_PlayEffect('swap1_standin', 'effect_entropy_spawn', '',FX_TRACK_OBJECT_ROT)",
	"Object_PlayEffect('swap2_standin', 'effect_entropy_spawn', '',FX_TRACK_OBJECT_ROT)",
	"ff.Object_Spawn('nazi_gunner_swap1', 'nazi_gunner', 'swap_marker1')",
	"ff.Object_Spawn('nazi_general_swap2', 'nazi_general', 'swap_marker2')",
	"ff.PrintTest1()",
	"peace()",
	"ff.PrintTest2()",
	"wait(3.0)",
),
(
	"ff.PrintTest3()",
	"lookAtPos((588,966,-48), zoom = -200, pitch = 0, heading = -45.1, time = 2)",
	"wait(3.0)",
),
(
	"Object_PlayEffect('gunner2_standin', 'effect_entropy_spawn', '',FX_TRACK_OBJECT_ROT)",
	"ff.Object_Destroy('nazi_gunner2')",
	"wait(1)",
),
(
	"Object_PlayEffect('swap3_standin', 'effect_entropy_spawn', '',FX_TRACK_OBJECT_ROT)",
	"Object_PlayEffect('swap4_standin', 'effect_entropy_spawn', '',FX_TRACK_OBJECT_ROT)",
	"ff.Object_Spawn('nazi_gunner_swap3', 'nazi_gunner', 'swap_marker3')",
	"ff.Object_Spawn('nazi_general_swap4', 'nazi_general', 'swap_marker4')",
	"peace()",
	"wait(3)",
),
(
	"lookAtPos((-155,985,-48), zoom = -200, pitch = 0, heading = -161, time = 2)",
	"wait(3)",
),
(
	"Object_PlayEffect('gunner3_standin', 'effect_entropy_spawn', '',FX_TRACK_OBJECT_ROT)",
	"ff.Object_Destroy('nazi_gunner3')",
	"wait(1)",
),
(
	"Object_PlayEffect('swap5_standin', 'effect_entropy_spawn', '',FX_TRACK_OBJECT_ROT)",
	"Object_PlayEffect('swap6_standin', 'effect_entropy_spawn', '',FX_TRACK_OBJECT_ROT)",
	"ff.Object_Spawn('killarilla_whip_swap5', 'killarilla_whip', 'swap_marker5')",
	"ff.Object_Spawn('eye_minor_swap6', 'eye_minor', 'swap_marker6')",
	"peace()",
	"wait(3)",
),
(
	"speak('tricolour', 'MISSPCH_14_TC_01')",
),
(
	"speak('bullet', 'MISSPCH_14_BL_01')",
),
(
	"endCS()",
	"blind()",
	"war()",
	"Sound_PlayMusic('music_08skyking1')",
	"newObjective('primary', 1, name='protect_sky_king')",
	"ff.ZeroWaveMoves()",
),
]

get_to_work_ss = [
(
	"speak('sky_king', 'MISSPCH_14_SY_02')",
),
]

#zero_wave_bark_ss = [
#(
#	"forceSpeak('nazi_rifleman', 'MISSPCH_12_N2_01')",
#),
#(
#	"speak('tricolour', 'MISSPCH_12_TC_01')",
#),
#]


wave_a_bark_ss = [
(
	"forceSpeak('nazi_rifleman', 'MISSPCH_14_N1_01', telepathy=0)",
),
]

wave_b_bark_ss = [
(
	"forceSpeak('nazi_rifleman', 'MISSPCH_14_N1_01', telepathy=0)",
),
]

wave_c_bark_ss = [
(
	"forceSpeak('nazi_rifleman', 'MISSPCH_14_N1_01', telepathy=0)",
),
]

wave_d_bark_ss = [
(
	"forceSpeak('nazi_rifleman', 'MISSPCH_14_N1_01', telepathy=0)",
),
]

interrupted_ss = [
(
	"ff.PickSkyKingLine()",
),
]

five_eighths_done_ss = [
(
	"speak('sky_king', 'MISSPCH_14_SY_04')",
),
]

six_eighths_done_ss = [
(
	"speak('sky_king', 'MISSPCH_14_SY_05')",
),
]

seven_eighths_done_ss = [
(
	"speak('sky_king', 'MISSPCH_14_SY_06')",
),
(
	"speak('sky_king', 'MISSPCH_14_SY_13')",
),
(
	"ff.JammerArrives()",
	"wait(0.1)",
),
]

jammer_interrogation_ss = [
(
	"forceSpeak('nazi_rifleman', 'MISSPCH_14_N2_01', telepathy=0)",
),
(
	"speak('sky_king', 'MISSPCH_14_SY_08')",
),
(
	"kill('jammerguy2')",
	"Objective_Complete('find_jammer')",
),
]



final_sk_dead_cs = [
(
	"peace()",
	"startCS()",
	"look('sky_king', zoom = 0)",
	"look('sky_king', zoom = -200, heading = 0, time = 5)",
	"Objective_Fail('protect_sky_king')",
	"wait(5)",
),
(
	"endCS()",
	"Mission_Lose()",
),
]

final_cs = [
(
	"Objective_Complete('protect_sky_king')",
	"peace()",
	"see()",
	"startCS()",
	"Sound_PlayMusic('music_08wait_end',1)",
	"speak('sky_king', 'MISSPCH_14_SY_10')",
),
(
	"speak('mentor', 'MISSPCH_14_ME_02')",
),
(
	"endCS()",
	"blind()",
	"war()",
	"Mission_Win()",
),
]

