# blitzkrieg

from cshelper import *
from js import *
import event
	
def OnPostInit():
	print 'blitzkrieg base/start'
	Mission_SetSunlight(0, 60, 0.5, 0, (1,1,1))
	lookAtPos((3,118,0), zoom= -131.1, pitch= -5, heading= -23.2)
	Object_PlayEffect('_impobj_main_screen', 'cs_screen_scan', '', FX_LOOP|FX_TRACK_OBJECT_ROT)
	Trigger_Move('green_genie', 'fly', Get_MarkerPos('idle_pos1'), 'genieFlysHere', 0, 0)

	Campaign_Recruit('alchemiss')
	Campaign_UnlockOrigin('alchemiss')
	Campaign_Recruit('el_diablo')
	Campaign_UnlockOrigin('el_diablo')
	Campaign_Recruit('mentor')
	Campaign_UnlockOrigin('mentor')
	Campaign_Recruit('minute_man')
	Campaign_UnlockOrigin('minute_man')
	Campaign_AddHero ('liberty_lad')
	Campaign_UnlockOrigin('liberty_lad')
	Campaign_Recruit('tombstone')
	Campaign_UnlockOrigin('tombstone')
	Campaign_Recruit('bullet')
	Campaign_UnlockOrigin('bullet')
	Campaign_AddHero ('green_genie')
	Campaign_UnlockOrigin('green_genie')
	Campaign_AddHero ('quetzalcoatl')
	Campaign_UnlockOrigin('quetzalcoatl')
	Campaign_Recruit('the_ant')
	Campaign_UnlockOrigin('the_ant')
	Campaign_Recruit('eve')	
	Campaign_UnlockOrigin('eve')
	Campaign_AddHero ('supercollider')
	Campaign_AddHero ('microwave')
	Campaign_Recruit('black_jack')
	Campaign_UnlockOrigin('black_jack')
	Campaign_AddHero ('law')
	Campaign_UnlockOrigin('law')
	Campaign_AddHero ('order')
	Campaign_UnlockOrigin('order')
	Campaign_AddHero ('ironox')
	Campaign_AddHero ('man_o_war')
	Campaign_UnlockOrigin('man_o_war')
	Campaign_AddHero ('sea_urchin')
	Campaign_UnlockOrigin('sea_urchin')
	Campaign_Recruit('tricolour')
	Campaign_UnlockOrigin('tricolour')
	Campaign_AddHero ('blackbird')
	Campaign_Recruit('sky_king')
	Campaign_UnlockOrigin('sky_king')
	Campaign_AddHero ('the_bard')

	Campaign_AddMinion('thug_with_bat')
	Campaign_AddMinion('thug_with_gun')
	Campaign_AddVillain('nuclear_winter')
	Campaign_AddVillain('time_master')
	Campaign_AddMinion('ice_trooper')
	Campaign_AddMinion('ice_sergeant')
	Campaign_AddMinion('snow_man')
	Campaign_AddMinion('shurale')
	Campaign_AddVillain('red_oktober')
	Campaign_AddMinion('dark_shaman')
	Campaign_AddVillain('frozen_giant')
	Campaign_AddMinion('nazi_rifleman')
	Campaign_AddMinion('legionnaire')
	Campaign_AddVillain('fortissimo')
	Campaign_AddVillain('red_sun')
	Campaign_AddMinion('nazi_gunner')
	Campaign_AddMinion('nazi_grenadier')
	Campaign_AddMinion('killarilla_whip')
	Campaign_AddMinion('killarilla_chaingun')
	Campaign_AddMinion('nazi_general')
	Campaign_AddMinion('eye_minor')
	Campaign_AddMinion('centurion')



def genieFlysThere(event):
	if isCSPlaying():
		print "can't get there"
	else:
		Trigger_Move('green_genie', 'fly', Get_MarkerPos('idle_pos1'), 'waitThere', 0, 0)

def waitThere(event):
	AI_Animate('green_genie', 'hover_direct_2', '', 0, 1)
	Object_PlayEffect('green_genie', 'csfx_genie_polymorph', 'genieFlysHere', FX_TRACK_OBJECT_FULL)
		
def genieFlysHere(event):
	if isCSPlaying():
		print "can't get here"
	else:
		Trigger_Move('green_genie', 'fly', Get_MarkerPos('idle_pos2'), 'waitHere', 0, 0)

def waitHere(event):
	AI_Animate('green_genie', 'hover_direct', '', 0, 1)
	Object_PlayEffect('green_genie', 'csfx_genie_polymorph', 'genieFlysAway', FX_TRACK_OBJECT_FULL)

def genieFlysAway(event):
	if isCSPlaying():
		print "can't get here"
	else:
		Trigger_Move('green_genie', 'fly', Get_MarkerPos('idle_pos3'), 'waitAway', 0, 0)
	
def waitAway(event):
	regTimer('genieFlysThere', 2)

def OnBriefing():
    teleport('green_genie', 'idle_pos1')
    play(briefing_cs, 'briefing_CS')
    print 'blitzkrieg base/briefing'


#-----------
# data
#-----------

briefing_cs = [
(
	"startCS()",
	"lookAtPos((13,-150,0), zoom= -171.8, pitch= -5, heading= -201.7)",
	"wait(2)",
),
(
	"lookAtPos((-55,-156,0), zoom= -253.6, pitch= -13, heading= -185.2)",
	"Trigger_Move('green_genie', 'fly', Get_MarkerPos('con2_pos'), 'onStepCB', 0, 0)",
),
(
	"Trigger_Move('green_genie', 'land', Get_MarkerPos('con2_pos'), 'onStepCB', 0, 0)",
),	
(
	"AI_Animate('green_genie', 'direct_3', '', 0, 1)",
	"Object_PlayEffect('_impobj_console2', 'csfx_genie_teleport', '', FX_TRACK_OBJECT_ROT)",
	"Sound_PlayMusic('music_09blitz_base1',1)",
	"wait(1)",
),
(
	"spawn('stand', 'cub_fruit_stand1', '_impobj_console2')",
	"null()",
),
(
	"Object_Destroy('_impobj_console2')",
	"wait(2)",
),
(
	"lookAtPos((43,-159,0), zoom= -250.4, pitch= -13, heading= 102.1)",
	"Trigger_Move('green_genie', 'fly', Get_MarkerPos('con1_pos'), 'onStepCB', 0, 0)",
),
(
	"Trigger_Move('green_genie', 'land', Get_MarkerPos('con1_pos'), 'onStepCB', 0, 0)",
),	
(
	"AI_Animate('green_genie', 'direct_3', '', 0, 1)",
	"Object_PlayEffect('_impobj_console1', 'csfx_genie_teleport', '', FX_TRACK_OBJECT_ROT)",
	"wait(1)",
),	
(
	"spawn('tree', 'cub_palm1', '_impobj_console1')",
	"null()",
),
(
	"Object_Destroy('_impobj_console1')",
	"turnTo('green_genie', 'quetzalcoatl')",
	"wait(2)",
),
(
	"Object_PlayEffect('quetzalcoatl', 'csfx_genie_teleport', '', FX_TRACK_OBJECT_ROT)",
	"AI_Animate('green_genie', 'direct_3', 'onStepCB', 0, 1)",
),
(
	"Object_Destroy('quetzalcoatl')",
	"spawn('chicken', 'chicken', 'qz_pos')",
	"wait(1)",
),
(
	"lookAtPos((58,-193,0), zoom= -286.1, pitch= -5, heading= 95.0)",
	"speak('chicken', 'BRFSPCH_16_QZ_01', CAPTION_BOTTOM_RIGHT)", #Quetzalcoatl you dishonor me and my an...
),
(
	#A moment. She sighs and snaps her fingers. 
	"AI_Animate('green_genie', 'direct_2', 'onStepCB', 0, 1)",
),
(
	"Object_PlayEffect('tree', 'csfx_genie_teleport', '', FX_TRACK_OBJECT_ROT)",
	"Object_PlayEffect('stand', 'csfx_genie_teleport', '', FX_TRACK_OBJECT_ROT)",
	"Object_PlayEffect('chicken', 'csfx_genie_teleport', '', FX_TRACK_OBJECT_ROT)",
	"wait(1)",
),
(
	# Everything turns back to they way it was. 
	"Object_Destroy('tree')",
	"Object_Destroy('stand')",
	"Object_Destroy('chicken')",
	"spawn('quetzalcoatl', 'quetzalcoatl', 'qz_pos')",
	"null()",
),
(
	"speak('green_genie', 'BRFSPCH_16_GG_01', CAPTION_TOP_LEFT)", #GreenGenie were ya born this dull, o...
),
(
	"lookAtPos((47,-168,0), zoom= -189.6, pitch= 0, heading= 116.0)",
	#Genie flies off (we just see her feet).
	"move('green_genie', 'hero_spawn1', radius= 2)",
	"wait(1)"
),	
(
	"spawn('mentor', 'mentor', 'hero_spawn1')",
	"spawn('alchemiss', 'alchemiss', 'hero_spawn2')",	
	"spawn('man_o_war', 'man_o_war', 'hero_spawn3')",	
	"spawn('el_diablo', 'el_diablo', 'hero_spawn2')",	
	"spawn('sea_urchin', 'sea_urchin', 'hero_spawn3')",	
	"null()",
),
(
	#The rest of the team comes in.
	"lookAtPos((103,5,0), zoom= -194.9, pitch= 0, heading= 32.7, time= 5)",
	"moveCB('alchemiss', 'hero_pos1', radius= 0)",
	"move('man_o_war', 'hero_pos2', radius= 0)",
),
(
	"Object_Destroy('green_genie')",
	"moveCB('mentor', 'mentor_pos1', radius= 0)",
	"move('el_diablo', 'hero_pos3', radius= 0)",
	"move('sea_urchin', 'hero_pos2', radius= 2)",
	"move('quetzalcoatl', 'hero_pos3', radius= 4)",
),
(
	"lookAtPos((143,1,0), zoom= -252.4, pitch= -5, heading= 30.3)",
	"Sound_PlayMusic('music_09blitz_base2',1)",
	"speak('mentor', 'BRFSPCH_16_ME_01', CAPTION_TOP_LEFT)", #Mentor blitzkrieg has taken our ...
	"turn('mentor', 'hero_pos2')",
	"turnTo('alchemiss', 'mentor')",
	"turnTo('man_o_war', 'mentor')",
	"turnTo('sea_urchin', 'mentor')",
	"turnTo('el_diablo', 'mentor')",
	"turnTo('quetzalcoatl', 'mentor')",
),
(
	"speak('mentor', 'BRFSPCH_16_ME_03', CAPTION_TOP_LEFT)", #Mentor I have grown adept enough...
),	
(
	"speak('alchemiss', 'BRFSPCH_16_AL_01', CAPTION_TOP_RIGHT)", #Alchemiss i wish i shared your conf...
),
(
	"lookAtPos((110,-39,0), zoom= -250.6, pitch= -5, heading= 103.6)",
	"speak('mentor', 'BRFSPCH_16_ME_02', CAPTION_TOP_LEFT)", #Mentor this is the only option, ...
),
(
	"speak('man_o_war', 'BRFSPCH_16_MO_01', CAPTION_TOP_RIGHT)", #Man O' War you'll be fine, lassie. w...
	"turnTo('man_o_war', 'alchemiss')",
),
(
	"speak('sea_urchin', 'BRFSPCH_16_SU_01', CAPTION_BOTTOM_RIGHT)", #Sea Urchin what he said!
),
(
	"speak('el_diablo', 'BRFSPCH_16_ED_01', CAPTION_TOP_LEFT)", #El Diablo does freedom force member...
),
(
	"endBriefingCS()",
),
]

