

# blitzkrieg



# To Do:
# - once Major Eye stops bustin' out of his zone early,
#   have his CS include a camera shot of him, and actually use his beam.

from cshelper import *
from js import *
import event
from ffx import *

def OnPrecacheObjects():
	print "blitzkrieg/precache"
	Mission_PrecacheTemplateObj('alchemiss', 1, 0)
	Mission_PrecacheTemplateObj('black_jack', 1, 0)
	Mission_PrecacheTemplateObj('bullet', 1, 0)
	Mission_PrecacheTemplateObj('blitzkrieg', 1, 0)

def OnPostInit():
	print "blitzkrieg/start"
	setMission(16)

	Mission_SetSunlight(-80,75,0.4,0.4,(0.6,0.4,0.7))
	Mission_SetShadows(-80,75,(0.2,0.2,0.4))
	Mission_SetProjShadowBackground((1,1,1))
	Mission_SetProjShadowColor((.6,.6,.6,1))

	regHeroMarkerEnter('nazi_bark_marker', 'OnBark1Trigger')
	regHeroMarkerEnter('hypnofield1_marker', 'OnFirstHypno')
	regHeroMarkerEnter('hypnofield2_marker', 'OnSecondHypno')
	regHeroMarkerEnter('hypnofield3_marker', 'OnThirdHypno')
	regHeroMarkerEnter('hypnofield4_marker', 'OnFourthHypno')
	regHeroMarkerEnter('hypnofield5_marker', 'OnFifthHypno')
	regHeroMarkerEnter('hypnofield6_marker', 'OnSixthHypno')

	regDeath('nazi_grenadier2', 'OnSniper1Dead')
	regDeath('nazi_general2', 'OnSniper2Dead')
	regDeath('eye_minor3', 'OnEye1Dead')
	regDeath('eye_minor4', 'OnEye2Dead')

	regDeath('nazi_gunner7', 'OnGunner7Dead')

	Mission_SetAttr('FirstNaziBarkPlayed', 0)
	Mission_SetAttr('FirstHypnoTriggeredOnce', 0)
	Mission_SetAttr('FirstHypnoDisabled', 0)
	Mission_SetAttr('WeirdSSPlayed', 0)
	Mission_SetAttr('Control1Destroyed', 0)

	Mission_SetAttr('SecondHypnoDisabled', 0)
	Mission_SetAttr('Control2Destroyed', 0)	
	Mission_SetAttr('SecondHypnoTriggeredOnce', 0)

	Mission_SetAttr('ThirdHypnoDisabled', 0)
	Mission_SetAttr('Control3Destroyed', 0)	
	Mission_SetAttr('ThirdHypnoTriggeredOnce', 0)

	Mission_SetAttr('FourthHypnoDisabled', 0)
	Mission_SetAttr('Control4Destroyed', 0)	
	Mission_SetAttr('FourthHypnoTriggeredOnce', 0)

	Mission_SetAttr('FifthHypnoDisabled', 0)
	Mission_SetAttr('Control5Destroyed', 0)	
	Mission_SetAttr('FifthHypnoTriggeredOnce', 0)

	Mission_SetAttr('SixthHypnoDisabled', 0)
	Mission_SetAttr('Control6Destroyed', 0)	
	Mission_SetAttr('SixthHypnoTriggeredOnce', 0)

	Mission_SetAttr('EnteredLair', 0)
	Mission_SetAttr('HypnofieldLairPrimed', 0)

	Mission_SetAttr('LairHypnoDisabled', 0)

	Mission_SetAttr('WhySphereLineSpoken', 0)

	# this keeps track of the respawns during the boss battle
	Mission_SetAttr('NumberOfSpawns', 0)

	Mission_SetAttr('FinalCSPlaying', 0)

	# used for door-opening
	Mission_CustomAction('open door', '', '_impobj_door1a', 'ff.OpenDoor1a', 5, 1)
	Mission_CustomAction('open door', '', '_impobj_door1b', 'ff.OpenDoor1b', 5, 1)
	Mission_CustomAction('open door', '', '_impobj_door1c', 'ff.OpenDoor1c', 5, 1)
	Mission_CustomAction('open door', '', '_impobj_door1d', 'ff.OpenDoor1d', 5, 1)
	Mission_CustomAction('open door', '', '_impobj_door1e', 'ff.OpenDoor1e', 5, 1)
	Mission_CustomAction('open door', '', '_impobj_door2b', 'ff.OpenDoor2b', 5, 1)
	Mission_CustomAction('open door', '', '_impobj_door2c', 'ff.OpenDoor2c', 5, 1)
	Mission_CustomAction('open door', '', '_impobj_door2d', 'ff.OpenDoor2d', 5, 1)
	Mission_CustomAction('open door', '', '_impobj_door2e', 'ff.OpenDoor2e', 5, 1)
	Mission_CustomAction('open door', '', '_impobj_door2f', 'ff.OpenDoor2f', 5, 1)
	Mission_CustomAction('open door', '', '_impobj_door2g1', 'ff.OpenDoor2g1', 5, 1)
	Mission_CustomAction('open door', '', '_impobj_door2g2', 'ff.OpenDoor2g2', 5, 1)
	Mission_CustomAction('open door', '', '_impobj_door2i', 'ff.OpenDoor2i', 5, 1)
	Mission_CustomAction('open door', '', '_impobj_door2j', 'ff.OpenDoor2j', 5, 1)
	Mission_CustomAction('open door', '', '_impobj_door3a', 'ff.OpenDoor3a', 5, 1)
	Mission_CustomAction('open door', '', '_impobj_door3c', 'ff.OpenDoor3c', 5, 1)
	Mission_CustomAction('open door', '', '_impobj_door3d', 'ff.OpenDoor3d', 5, 1)
	Mission_CustomAction('open door', '', '_impobj_door3e', 'ff.OpenDoor3e', 5, 1)
	Mission_CustomAction('open door', '', '_impobj_door3f', 'ff.OpenDoor3f', 5, 1)

	doorpos1a = Get_ObjectPos('_impobj_door1a')
	doorrot1a = Object_GetOrientation('_impobj_door1a')
	Marker_Spawn('door_1a_marker',doorpos1a,doorrot1a[1])
	spawn('door_1a_standin', 'fx_standin', 'door_1a_marker')

	doorpos1b = Get_ObjectPos('_impobj_door1b')
	doorrot1b = Object_GetOrientation('_impobj_door1b')
	Marker_Spawn('door_1b_marker',doorpos1b,doorrot1b[1])
	spawn('door_1b_standin', 'fx_standin', 'door_1b_marker')

	doorpos1c = Get_ObjectPos('_impobj_door1c')
	doorrot1c = Object_GetOrientation('_impobj_door1c')
	Marker_Spawn('door_1c_marker',doorpos1c,doorrot1c[1])
	spawn('door_1c_standin', 'fx_standin', 'door_1c_marker')

	doorpos1d = Get_ObjectPos('_impobj_door1d')
	doorrot1d = Object_GetOrientation('_impobj_door1d')
	Marker_Spawn('door_1d_marker',doorpos1d,doorrot1d[1])
	spawn('door_1d_standin', 'fx_standin', 'door_1d_marker')

	doorpos1e = Get_ObjectPos('_impobj_door1e')
	doorrot1e = Object_GetOrientation('_impobj_door1e')
	Marker_Spawn('door_1e_marker',doorpos1e,doorrot1e[1])
	spawn('door_1e_standin', 'fx_standin', 'door_1e_marker')

	doorpos2b = Get_ObjectPos('_impobj_door2b')
	doorrot2b = Object_GetOrientation('_impobj_door2b')
	Marker_Spawn('door_2b_marker',doorpos2b,doorrot2b[1])
	spawn('door_2b_standin', 'fx_standin', 'door_2b_marker')

	doorpos2c = Get_ObjectPos('_impobj_door2c')
	doorrot2c = Object_GetOrientation('_impobj_door2c')
	Marker_Spawn('door_2c_marker',doorpos2c,doorrot2c[1])
	spawn('door_2c_standin', 'fx_standin', 'door_2c_marker')

	doorpos2d = Get_ObjectPos('_impobj_door2d')
	doorrot2d = Object_GetOrientation('_impobj_door2d')
	Marker_Spawn('door_2d_marker',doorpos2d,doorrot2d[1])
	spawn('door_2d_standin', 'fx_standin', 'door_2d_marker')

	doorpos2e = Get_ObjectPos('_impobj_door2e')
	doorrot2e = Object_GetOrientation('_impobj_door2e')
	Marker_Spawn('door_2e_marker',doorpos2e,doorrot2e[1])
	spawn('door_2e_standin', 'fx_standin', 'door_2e_marker')

	doorpos2f = Get_ObjectPos('_impobj_door2f')
	doorrot2f = Object_GetOrientation('_impobj_door2f')
	Marker_Spawn('door_2f_marker',doorpos2f,doorrot2f[1])
	spawn('door_2f_standin', 'fx_standin', 'door_2f_marker')

	doorpos2g1 = Get_ObjectPos('_impobj_door2g1')
	doorrot2g1 = Object_GetOrientation('_impobj_door2g1')
	Marker_Spawn('door_2g1_marker',doorpos2g1,doorrot2g1[1])
	spawn('door_2g1_standin', 'fx_standin', 'door_2g1_marker')

	doorpos2g2 = Get_ObjectPos('_impobj_door2g2')
	doorrot2g2 = Object_GetOrientation('_impobj_door2g2')
	Marker_Spawn('door_2g2_marker',doorpos2g2,doorrot2g2[1])
	spawn('door_2g2_standin', 'fx_standin', 'door_2g2_marker')

	doorpos2i = Get_ObjectPos('_impobj_door2i')
	doorrot2i = Object_GetOrientation('_impobj_door2i')
	Marker_Spawn('door_2i_marker',doorpos2i,doorrot2i[1])
	spawn('door_2i_standin', 'fx_standin', 'door_2i_marker')

	doorpos2j = Get_ObjectPos('_impobj_door2j')
	doorrot2j = Object_GetOrientation('_impobj_door2j')
	Marker_Spawn('door_2j_marker',doorpos2j,doorrot2j[1])
	spawn('door_2j_standin', 'fx_standin', 'door_2j_marker')

	doorpos3a = Get_ObjectPos('_impobj_door3a')
	doorrot3a = Object_GetOrientation('_impobj_door3a')
	Marker_Spawn('door_3a_marker',doorpos3a,doorrot3a[1])
	spawn('door_3a_standin', 'fx_standin', 'door_3a_marker')

	doorpos3c = Get_ObjectPos('_impobj_door3c')
	doorrot3c = Object_GetOrientation('_impobj_door3c')
	Marker_Spawn('door_3c_marker',doorpos3c,doorrot3c[1])
	spawn('door_3c_standin', 'fx_standin', 'door_3c_marker')

	doorpos3d = Get_ObjectPos('_impobj_door3d')
	doorrot3d = Object_GetOrientation('_impobj_door3d')
	Marker_Spawn('door_3d_marker',doorpos3d,doorrot3d[1])
	spawn('door_3d_standin', 'fx_standin', 'door_3d_marker')

	doorpos3e = Get_ObjectPos('_impobj_door3e')
	doorrot3e = Object_GetOrientation('_impobj_door3e')
	Marker_Spawn('door_3e_marker',doorpos3e,doorrot3e[1])
	spawn('door_3e_standin', 'fx_standin', 'door_3e_marker')

	doorpos3f = Get_ObjectPos('_impobj_door3f')
	doorrot3f = Object_GetOrientation('_impobj_door3f')
	Marker_Spawn('door_3f_marker',doorpos3f,doorrot3f[1])
	spawn('door_3f_standin', 'fx_standin', 'door_3f_marker')


	# used for the switches that turn off the hypnospheres
	Mission_CustomAction('flip switch', '', '_impobj_controller1', 'ff.OnControl1Destroyed', 5, 1)
	Mission_CustomAction('flip switch', '', '_impobj_controller2', 'ff.OnControl2Destroyed', 5, 1)
	Mission_CustomAction('flip switch', '', '_impobj_controller3', 'ff.OnControl3Destroyed', 5, 1)
	Mission_CustomAction('flip switch', '', '_impobj_controller4', 'ff.OnControl4Destroyed', 5, 1)
	Mission_CustomAction('flip switch', '', '_impobj_controller5', 'ff.OnControl5Destroyed', 5, 1)
	Mission_CustomAction('flip switch', '', '_impobj_controller6', 'ff.OnControl6Destroyed', 5, 1)

	# all AIs turned off at start; they get turned on as their fog is lifted
	AI_SetEnabled('nazi_general1',0)
	AI_SetEnabled('nazi_general2',0)
	AI_SetEnabled('nazi_grenadier1',0)
	AI_SetEnabled('nazi_grenadier2',0)
	AI_SetEnabled('nazi_grenadier3',0)
	AI_SetEnabled('nazi_gunner1',0)
	AI_SetEnabled('nazi_gunner2',0)
	AI_SetEnabled('nazi_gunner3',0)
	AI_SetEnabled('nazi_gunner4',0)
	AI_SetEnabled('nazi_gunner5',0)
	AI_SetEnabled('nazi_gunner6',0)
	AI_SetEnabled('nazi_gunner7',0)
	AI_SetEnabled('nazi_rifleman1',0)
	AI_SetEnabled('eye_major1',0)
	AI_SetEnabled('eye_minor1',0)
	AI_SetEnabled('eye_minor2',0)
	AI_SetEnabled('eye_minor3',0)
	AI_SetEnabled('eye_minor4',0)
	AI_SetEnabled('eye_minor5',0)
	AI_SetEnabled('eye_minor6',0)

	spawn('portal1_standin', 'fx_standin', 'portal_spawn1')
	spawn('portal2_standin', 'fx_standin', 'portal_spawn2')
	spawn('portal3_standin', 'fx_standin', 'portal_spawn3')
	spawn('portal4_standin', 'fx_standin', 'portal_spawn4')

	if RPG_GAME_DIFFICULTY > 2:
		spawn('extra_nazi1', 'nazi_gunner', 'extra_nazi_spawn1')
		spawn('extra_nazi2', 'nazi_gunner', 'extra_nazi_spawn2')
		spawn('extra_nazi3', 'nazi_gunner', 'extra_nazi_spawn3')
		AI_SetEnabled('extra_nazi1',0)
		AI_SetEnabled('extra_nazi2',0)
		AI_SetEnabled('extra_nazi3',0)

	Object_PlayEffect('portal1_standin', 'effect_portal_steady', '', FX_LOOP)
	Object_PlayEffect('portal2_standin', 'effect_portal_steady', '', FX_LOOP)
	Object_PlayEffect('portal3_standin', 'effect_portal_steady', '', FX_LOOP)
	Object_PlayEffect('portal4_standin', 'effect_portal_steady', '', FX_LOOP)

	Object_Spawn('sensor_target', 'invisible_object', 'eye_hero_marker')

#	playEffectMarker('effect_portal_steady', 'portal_spawn1', FX_LOOP)
#	playEffectMarker('effect_portal_steady', 'portal_spawn2', FX_LOOP)
#	playEffectMarker('effect_portal_steady', 'portal_spawn3', FX_LOOP)
#	playEffectMarker('effect_portal_steady', 'portal_spawn4', FX_LOOP)

	play(start_cs, "start_cs")
	FFX_InitMission()



# this function will turn AI's off again who were turned on by a war() in a cutscene
def AITurnOff():
	if Object_IsAlive('_impobj_9_fog1a') == 1:
		AI_SetEnabled('nazi_gunner3',0)
		AI_SetEnabled('nazi_gunner4',0)
	if Object_IsAlive('_impobj_9_fog1b') == 1:
		AI_SetEnabled('nazi_gunner5',0)
		AI_SetEnabled('nazi_gunner6',0)
		AI_SetEnabled('nazi_general1',0)
	if Object_IsAlive('_impobj_9_fog2a') == 1:
		AI_SetEnabled('nazi_gunner7',0)
	if Object_IsAlive('_impobj_9_fog2c') == 1:
		AI_SetEnabled('nazi_grenadier3',0)
	if Object_IsAlive('_impobj_9_fog2d') == 1:
		AI_SetEnabled('eye_minor5',0)
	if Object_IsAlive('_impobj_9_fog2g') == 1:
		AI_SetEnabled('eye_minor6',0)
	if Object_IsAlive('_impobj_9_fog2h') == 1:
		AI_SetEnabled('nazi_rifleman1',0)
	if Object_IsAlive('_impobj_9_fog3a') == 1:
		AI_SetEnabled('nazi_gunner1',0)
		AI_SetEnabled('nazi_gunner2',0)
		AI_SetEnabled('nazi_grenadier1',0)
	if Object_IsAlive('_impobj_9_fog3b') == 1:
		AI_SetEnabled('eye_major1',0)
	if Object_IsAlive('_impobj_9_fog3c') == 1:
		AI_SetEnabled('eye_minor1',0)
	if Object_IsAlive('_impobj_9_fog3d') == 1:
		AI_SetEnabled('eye_minor2',0)
	if Object_IsAlive('_impobj_9_fog3e') == 1:
		AI_SetEnabled('nazi_general2',0)
		AI_SetEnabled('nazi_grenadier2',0)
		AI_SetEnabled('eye_minor3',0)
		AI_SetEnabled('eye_minor4',0)

	if RPG_GAME_DIFFICULTY > 2:
		if Object_IsAlive('_impobj_9_fog1a') == 1:
			AI_SetEnabled('extra_nazi1',0)
			AI_SetEnabled('extra_nazi2',0)
		if Object_IsAlive('_impobj_9_fog3a') == 1:
			AI_SetEnabled('extra_nazi3',0)

def WhySphere():
	if Mission_GetAttr('WhySphereLineSpoken') == 0:
		Mission_SetAttr('WhySphereLineSpoken', 1)
		speakNoCB('bullet', 'MISSPCH_16_BL_11')


def OpenDoor1a(event,heroname):
	kill('_impobj_9_fog1a')
	kill('_impobj_door1a')
	Object_PlayEffect('door_1a_standin', 'effect_door_wide_tall_opening', 'Door1AOpened',FX_TRACK_OBJECT_ROT)
def Door1AOpened(event):
	spawn('open_1a','nazihq_wide_door_tall_open','door_1a_marker')
	AI_SetEnabled('nazi_gunner3',1)
	AI_SetEnabled('nazi_gunner4',1)
	if RPG_GAME_DIFFICULTY > 2:
		AI_SetEnabled('extra_nazi1',1)
		AI_SetEnabled('extra_nazi2',1)

def OpenDoor1b(event,heroname):
	kill('_impobj_9_fog1b')
	kill('_impobj_door1b')
	Object_PlayEffect('door_1b_standin', 'effect_door_tall_opening', 'Door1BOpened',FX_TRACK_OBJECT_ROT)
def Door1BOpened(event):
	spawn('open_1b','nazihq_door_tall_open','door_1b_marker')
	AI_SetEnabled('nazi_gunner5',1)
	AI_SetEnabled('nazi_gunner6',1)
	AI_SetEnabled('nazi_general1',1)


def OpenDoor1c(event,heroname):
	kill('_impobj_9_fog1c')
	kill('_impobj_door1c')
	Object_PlayEffect('door_1c_standin', 'effect_door_tall_opening', 'Door1COpened',FX_TRACK_OBJECT_ROT)
def Door1COpened(event):
	spawn('open_1c','nazihq_door_tall_open','door_1c_marker')


def OpenDoor1d(event,heroname):
	print "opening door 1d"
	kill('_impobj_9_fog1d')
	kill('_impobj_door1d')
	Object_PlayEffect('door_1d_standin', 'effect_door_wide_tall_opening', 'Door1DOpened',FX_TRACK_OBJECT_ROT)
def Door1DOpened(event):
	print "spawning door 1D"
	spawn('open_1d','nazihq_wide_door_tall_open','door_1d_marker')


def OpenDoor1e(event,heroname):
	kill('_impobj_9_fog2a')
	kill('_impobj_door1e')
	Object_PlayEffect('door_1e_standin', 'effect_door_tall_opening', 'Door1EOpened',FX_TRACK_OBJECT_ROT)
def Door1EOpened(event):
	spawn('open_1e','nazihq_door_tall_open','door_1e_marker')
	AI_SetEnabled('nazi_gunner7',1)
	OnPreFirstHypno(event)


def OpenDoor2b(event,heroname):
	kill('_impobj_9_fog2b')
	kill('_impobj_door2b')
	Object_PlayEffect('door_2b_standin', 'effect_door_tall_opening', 'Door2BOpened',FX_TRACK_OBJECT_ROT)
def Door2BOpened(event):
	spawn('open_2b','nazihq_door_tall_open','door_2b_marker')


def OpenDoor2c(event,heroname):
	kill('_impobj_9_fog2c')
	kill('_impobj_door2c')
	Object_PlayEffect('door_2c_standin', 'effect_door_tall_opening', 'Door2COpened',FX_TRACK_OBJECT_ROT)
def Door2COpened(event):
	spawn('open_2c','nazihq_door_tall_open','door_2c_marker')
	AI_SetEnabled('nazi_grenadier3',1)

def OpenDoor2d(event,heroname):
	kill('_impobj_9_fog2d')
	kill('_impobj_door2d')
	Object_PlayEffect('door_2d_standin', 'effect_door_wide_tall_opening', 'Door2DOpened',FX_TRACK_OBJECT_ROT)
def Door2DOpened(event):
	spawn('open_2d','nazihq_wide_door_tall_open','door_2d_marker')
	AI_SetEnabled('eye_minor5',1)


def OpenDoor2e(event,heroname):
	kill('_impobj_9_fog2e')
	kill('_impobj_door2e')
	Object_PlayEffect('door_2e_standin', 'effect_door_wide_tall_opening', 'Door2EOpened',FX_TRACK_OBJECT_ROT)
def Door2EOpened(event):
	spawn('open_2e','nazihq_wide_door_tall_open','door_2e_marker')


def OpenDoor2f(event,heroname):
	kill('_impobj_9_fog2f')
	kill('_impobj_door2f')
	Object_PlayEffect('door_2f_standin', 'effect_door_wide_tall_opening', 'Door2FOpened',FX_TRACK_OBJECT_ROT)
def Door2FOpened(event):
	spawn('open_2f','nazihq_wide_door_tall_open','door_2f_marker')


def OpenDoor2g1(event,heroname):
	kill('_impobj_9_fog2g')
	kill('_impobj_door2g1')
	Object_PlayEffect('door_2g1_standin', 'effect_door_wide_tall_opening', 'Door2G1Opened',FX_TRACK_OBJECT_ROT)
def Door2G1Opened(event):
	spawn('open_2g1','nazihq_wide_door_tall_open','door_2g1_marker')
	AI_SetEnabled('eye_minor6',1)


def OpenDoor2g2(event,heroname):
	kill('_impobj_9_fog2g')
	kill('_impobj_door2g2')
	Object_PlayEffect('door_2g2_standin', 'effect_door_tall_opening', 'Door2G2Opened',FX_TRACK_OBJECT_ROT)
def Door2G2Opened(event):
	spawn('open_2g2','nazihq_door_tall_open','door_2g2_marker')
	AI_SetEnabled('eye_minor6',1)

def OpenDoor2i(event,heroname):
	kill('_impobj_9_fog2i')
	kill('_impobj_door2i')
	Object_PlayEffect('door_2i_standin', 'effect_door_wide_tall_opening', 'Door2IOpened',FX_TRACK_OBJECT_ROT)
def Door2IOpened(event):
	spawn('open_2i','nazihq_wide_door_tall_open','door_2i_marker')


def OpenDoor2j(event,heroname):
	kill('_impobj_9_fog2h')
	kill('_impobj_door2j')
	Object_PlayEffect('door_2j_standin', 'effect_door_tall_opening', 'Door2JOpened',FX_TRACK_OBJECT_ROT)
def Door2JOpened(event):
	spawn('open_2j','nazihq_door_tall_open','door_2j_marker')
	AI_SetEnabled('nazi_rifleman1',1)




def OpenDoor3a(event,heroname):
	kill('_impobj_9_fog3a')
	kill('_impobj_door3a')
	Object_PlayEffect('door_3a_standin', 'effect_door_wide_tall_opening', 'Door3AOpened',FX_TRACK_OBJECT_ROT)
def Door3AOpened(event):
	spawn('open_3a','nazihq_wide_door_tall_open','door_3a_marker')
	AI_SetEnabled('nazi_gunner1',1)
	AI_SetEnabled('nazi_gunner2',1)
	AI_SetEnabled('nazi_grenadier1',1)
	if RPG_GAME_DIFFICULTY > 2:
		AI_SetEnabled('extra_nazi3',1)

def OpenDoor3c(event,heroname):
	kill('_impobj_9_fog3c')
	kill('_impobj_door3c')
	Object_PlayEffect('door_3c_standin', 'effect_door_wide_tall_opening', 'Door3COpened',FX_TRACK_OBJECT_ROT)
def Door3COpened(event):
	spawn('open_3c','nazihq_wide_door_tall_open','door_3c_marker')
	AI_SetEnabled('eye_minor1',1)


def OpenDoor3d(event,heroname):
	kill('_impobj_9_fog3d')
	kill('_impobj_door3d')
	Object_PlayEffect('door_3d_standin', 'effect_door_tall_opening', 'Door3DOpened',FX_TRACK_OBJECT_ROT)
def Door3DOpened(event):
	spawn('open_3d','nazihq_door_tall_open','door_3d_marker')
	AI_SetEnabled('eye_minor2',1)

def OpenDoor3e(event,heroname):
	kill('_impobj_9_fog3e')
#	Object_PlayEffect('door_3e_standin', 'effect_door_wide_tall_opening', 'Door3EOpened',FX_TRACK_OBJECT_ROT)
	AI_SetEnabled('nazi_general2',1)
	AI_SetEnabled('nazi_grenadier2',1)
	AI_SetEnabled('eye_minor3',1)
	AI_SetEnabled('eye_minor4',1)
	play(entered_lair_cs, "entered_lair_cs")

def OpenDoor3f(event,heroname):
	kill('_impobj_9_fog3b')
	kill('_impobj_door3f')
	teleport(heroname, 'eye_hero_marker')
	Object_SetSecondaryState(heroname, SCSTATE_DEEP_SENSORED, 10)
	Object_PlayEffect('door_3f_standin', 'effect_door_wide_tall_opening', 'Door3FOpened',FX_TRACK_OBJECT_ROT)
def Door3FOpened(event):
	spawn('open_3f','nazihq_wide_door_tall_open','door_3f_marker')
	AI_SetEnabled('eye_minor1',1)
	AI_SetEnabled('eye_major1',1)
	play(major_eye_cs, "major_eye_cs")


def EyeZap():
	Trigger_Power('eye_major1', 'sensor_target', 'eye of the reich Deep Sensor','')
	null()

# stumpy: Try to make the hypnosis respect characters' defences and
# resistances.  Requires 'ffx_tiggot_minion' be defined (an ffx_tiggot
# with GAME_OBJ_MINION class) and 'hypnosphere hypnosis' power (very
# high magnitude, small area hypnosis, ffq_direct_invisible FX).
def TriggerHypnotize(char,sphere):
    hypnotiggot = sphere+'tig'
    powerlevel = 0
    if RPG_GAME_DIFFICULTY > 3:
        powerlevel = 1
    if RPG_GAME_DIFFICULTY > 5:
        powerlevel = 2
    if not Object_Exists(hypnotiggot):
        spawn(hypnotiggot,'ffx_tiggot_minion',sphere)  # check that this works, because toggot is of class police and hypnosis might not choose sides properly
    print 'TriggerHypnotize(%s,%s) trying with tiggot=%s, powerlevel=%d' % (repr(char),repr(sphere),hypnotiggot,powerlevel)
    Trigger_Explosion(hypnotiggot,'hypnosphere hypnosis',powerlevel)

def RemoveHypnotig(control):    # control will be '_impobj_controller1', etc
    hypnotiggot = '_impobj_hypno_s' + control[-1] + 'tig'
    Object_Destroy(hypnotiggot)
    
def OnBark1Trigger(event):
	if Mission_GetAttr('FirstNaziBarkPlayed') == 0:
		Mission_SetAttr('FirstNaziBarkPlayed', 1)
		play(stop_them_ss, "stop_them_ss")

# When any hero sets off the first hypno-field
def OnFirstHypno(event):
	if Mission_GetAttr('Control1Destroyed') == 0:
		if Mission_GetAttr('FirstHypnoTriggeredOnce') == 0:
			Mission_SetAttr('FirstHypnoTriggeredOnce', 1)
			play(field_hypnosis_cs, "field_hypnosis_cs")
			print "entering"
		if Mission_GetAttr('FirstHypnoDisabled') == 0:
			Mission_SetAttr('FirstHypnoDisabled', 1)
##			Object_SetPrimaryState(event.object,PCSTATE_HYPNOTISED,15)
			TriggerHypnotize(event.object,'_impobj_hypno_s1')
			Object_NextVersion('_impobj_hypno_s1')
			Object_PlayEffect('_impobj_hypno_s1', 'effect_hypno_end')
			if RPG_GAME_DIFFICULTY < 3:
				regTimer('OnHypno1Expired', 20)
			elif RPG_GAME_DIFFICULTY < 6:
				regTimer('OnHypno1Expired', 18)
			else:
				regTimer('OnHypno1Expired', 15)
			regTimer('DestroyHypno1', 14.8)

def OnPreFirstHypno(event):
	if Mission_GetAttr('WeirdSSPlayed') == 0:
		Mission_SetAttr('WeirdSSPlayed', 1)
		play(weird_field_ss, "weird_field_ss")

def DestroyHypno1(event):
		Object_Destroy('_impobj_hypno_s1')
		print "impobj_hypno_s1 destroyed"

def OnHypno1Expired(event):
	if Mission_GetAttr('Control1Destroyed') == 0:
		if not Object_Exists('_impobj_hypno_s1'):
			spawn('_impobj_hypno_s1', 'nazihq_hypno_sphere', 'hypnofield1_marker')
		Object_PlayEffect('_impobj_hypno_s1', 'hypnofield_start')
		regHeroMarkerEnter('hypnofield1_marker', 'OnFirstHypno')
		Mission_SetAttr('FirstHypnoDisabled', 0)

def OnControl1Destroyed(event,heroname):
	Mission_SetAttr('Control1Destroyed', 1)
	RemoveHypnotig(event)
	Object_NextVersion('_impobj_controller1')
	if ( Mission_GetAttr('FirstHypnoDisabled') == 0 ) and ( Object_Exists('_impobj_hypno_s1') ):
		Object_NextVersion('_impobj_hypno_s1')
		Object_PlayEffect('_impobj_hypno_s1', 'effect_hypno_end')

def OnSecondHypno(event):
	if Mission_GetAttr('Control2Destroyed') == 0:
		if Mission_GetAttr('SecondHypnoTriggeredOnce') == 0:
			Mission_SetAttr('SecondHypnoTriggeredOnce', 1)
			if Object_IsAlive('nazi_rifleman1') or Object_IsAlive('nazi_gunner7'):
				play(second_field_hypnosis_ss, "second_field_hypnosis_ss")
		print "entering"
		if Mission_GetAttr('SecondHypnoDisabled') == 0:
			Mission_SetAttr('SecondHypnoDisabled', 1)
##			Object_SetPrimaryState(event.object,PCSTATE_HYPNOTISED,15)
			TriggerHypnotize(event.object,'_impobj_hypno_s2')
			Object_NextVersion('_impobj_hypno_s2')
			Object_PlayEffect('_impobj_hypno_s2', 'effect_hypno_end')
			if RPG_GAME_DIFFICULTY < 3:
				regTimer('OnHypno2Expired', 20)
			elif RPG_GAME_DIFFICULTY < 6:
				regTimer('OnHypno2Expired', 18)
			else:
				regTimer('OnHypno2Expired', 15)
			regTimer('DestroyHypno2', 14.8)

def DestroyHypno2(event):
		Object_Destroy('_impobj_hypno_s2')
		print "impobj_hypno_s2 destroyed"

def OnHypno2Expired(event):
	if Mission_GetAttr('Control2Destroyed') == 0:
		if not Object_Exists('_impobj_hypno_s2'):
			spawn('_impobj_hypno_s2', 'nazihq_hypno_sphere', 'hypnofield2_marker')
		Object_PlayEffect('_impobj_hypno_s2', 'hypnofield_start')
		regHeroMarkerEnter('hypnofield2_marker', 'OnSecondHypno')
		Mission_SetAttr('SecondHypnoDisabled', 0)

def OnControl2Destroyed(event,heroname):
	Mission_SetAttr('Control2Destroyed', 1)
	RemoveHypnotig(event)
	Object_NextVersion('_impobj_controller2')
	if ( Mission_GetAttr('SecondHypnoDisabled') == 0 ) and ( Object_Exists('_impobj_hypno_s2') ):
		Object_NextVersion('_impobj_hypno_s2')
		Object_PlayEffect('_impobj_hypno_s2', 'effect_hypno_end')

def OnGunner7Dead(event):
	speakNoCB('bullet', 'MISSPCH_16_BL_10')


def OnThirdHypno(event):
	if Mission_GetAttr('Control3Destroyed') == 0:
		print "entering"
		if Mission_GetAttr('ThirdHypnoDisabled') == 0:
			Mission_SetAttr('ThirdHypnoDisabled', 1)
##			Object_SetPrimaryState(event.object,PCSTATE_HYPNOTISED,15)
			TriggerHypnotize(event.object,'_impobj_hypno_s3')
			Object_NextVersion('_impobj_hypno_s3')
			Object_PlayEffect('_impobj_hypno_s3', 'effect_hypno_end')
			if RPG_GAME_DIFFICULTY < 3:
				regTimer('OnHypno3Expired', 20)
			elif RPG_GAME_DIFFICULTY < 6:
				regTimer('OnHypno3Expired', 18)
			else:
				regTimer('OnHypno3Expired', 15)
			regTimer('DestroyHypno3', 14.8)

def DestroyHypno3(event):
		Object_Destroy('_impobj_hypno_s3')
		print "impobj_hypno_s3 destroyed"

def OnHypno3Expired(event):
	if Mission_GetAttr('Control3Destroyed') == 0:
		if not Object_Exists('_impobj_hypno_s3'):
			spawn('_impobj_hypno_s3', 'nazihq_hypno_sphere', 'hypnofield3_marker')
		Object_PlayEffect('_impobj_hypno_s3', 'hypnofield_start')
		regHeroMarkerEnter('hypnofield3_marker', 'OnThirdHypno')
		Mission_SetAttr('ThirdHypnoDisabled', 0)

def OnControl3Destroyed(event,heroname):
	Mission_SetAttr('Control3Destroyed', 1)
	RemoveHypnotig(event)
	Object_NextVersion('_impobj_controller3')
	if ( Mission_GetAttr('ThirdHypnoDisabled') == 0 ) and ( Object_Exists('_impobj_hypno_s3') ):
		Object_NextVersion('_impobj_hypno_s3')
		Object_PlayEffect('_impobj_hypno_s3', 'effect_hypno_end')

def OnFourthHypno(event):
	if Mission_GetAttr('Control4Destroyed') == 0:
		if Mission_GetAttr('FourthHypnoTriggeredOnce') == 0:
			Mission_SetAttr('FourthHypnoTriggeredOnce', 1)
#			play(fourth_field_hypnosis_cs, "fourth_field_hypnosis_cs")
		print "entering"
		if Mission_GetAttr('FourthHypnoDisabled') == 0:
			Mission_SetAttr('FourthHypnoDisabled', 1)
##			Object_SetPrimaryState(event.object,PCSTATE_HYPNOTISED,15)
			TriggerHypnotize(event.object,'_impobj_hypno_s4')
			Object_NextVersion('_impobj_hypno_s4')
			Object_PlayEffect('_impobj_hypno_s4', 'effect_hypno_end')
			if RPG_GAME_DIFFICULTY < 3:
				regTimer('OnHypno4Expired', 20)
			elif RPG_GAME_DIFFICULTY < 6:
				regTimer('OnHypno4Expired', 18)
			else:
				regTimer('OnHypno4Expired', 15)
			regTimer('DestroyHypno4', 14.8)

def DestroyHypno4(event):
		Object_Destroy('_impobj_hypno_s4')
		print "impobj_hypno_s4 destroyed"

def OnHypno4Expired(event):
	if Mission_GetAttr('Control4Destroyed') == 0:
		if not Object_Exists('_impobj_hypno_s4'):
			spawn('_impobj_hypno_s4', 'nazihq_hypno_sphere', 'hypnofield4_marker')
		Object_PlayEffect('_impobj_hypno_s4', 'hypnofield_start')
		regHeroMarkerEnter('hypnofield4_marker', 'OnFourthHypno')
		Mission_SetAttr('FourthHypnoDisabled', 0)

def OnControl4Destroyed(event,heroname):
	Mission_SetAttr('Control4Destroyed', 1)
	RemoveHypnotig(event)
	Object_NextVersion('_impobj_controller4')
	if ( Mission_GetAttr('FourthHypnoDisabled') == 0 ) and ( Object_Exists('_impobj_hypno_s4') ):
		Object_NextVersion('_impobj_hypno_s4')
		Object_PlayEffect('_impobj_hypno_s4', 'effect_hypno_end')
	WhySphere()

def OnFifthHypno(event):
	if Mission_GetAttr('Control5Destroyed') == 0:
		if Mission_GetAttr('FifthHypnoTriggeredOnce') == 0:
			Mission_SetAttr('FifthHypnoTriggeredOnce', 1)
		print "entering"
		if Mission_GetAttr('FifthHypnoDisabled') == 0:
			Mission_SetAttr('FifthHypnoDisabled', 1)
##			Object_SetPrimaryState(event.object,PCSTATE_HYPNOTISED,15)
			TriggerHypnotize(event.object,'_impobj_hypno_s5')
			Object_NextVersion('_impobj_hypno_s5')
			Object_PlayEffect('_impobj_hypno_s5', 'effect_hypno_end')
			if RPG_GAME_DIFFICULTY < 3:
				regTimer('OnHypno5Expired', 20)
			elif RPG_GAME_DIFFICULTY < 6:
				regTimer('OnHypno5Expired', 18)
			else:
				regTimer('OnHypno5Expired', 15)
			regTimer('DestroyHypno5', 14.8)

def DestroyHypno5(event):
		Object_Destroy('_impobj_hypno_s5')
		print "impobj_hypno_s5 destroyed"

def OnHypno5Expired(event):
	if Mission_GetAttr('Control5Destroyed') == 0:
		if not Object_Exists('_impobj_hypno_s5'):
			spawn('_impobj_hypno_s5', 'nazihq_hypno_sphere', 'hypnofield5_marker')
		Object_PlayEffect('_impobj_hypno_s5', 'hypnofield_start')
		regHeroMarkerEnter('hypnofield5_marker', 'OnFifthHypno')
		Mission_SetAttr('FifthHypnoDisabled', 0)

def OnControl5Destroyed(event,heroname):
	Mission_SetAttr('Control5Destroyed', 1)
	RemoveHypnotig(event)
	Object_NextVersion('_impobj_controller5')
	if ( Mission_GetAttr('FifthHypnoDisabled') == 0 ) and ( Object_Exists('_impobj_hypno_s5') ):
		Object_NextVersion('_impobj_hypno_s5')
		Object_PlayEffect('_impobj_hypno_s5', 'effect_hypno_end')
	WhySphere()

def OnSixthHypno(event):
	if Mission_GetAttr('Control6Destroyed') == 0:
		if Mission_GetAttr('SixthHypnoTriggeredOnce') == 0:
			Mission_SetAttr('SixthHypnoTriggeredOnce', 1)
#			play(sixth_field_hypnosis_cs, "sixth_field_hypnosis_cs")
		print "entering"
		if Mission_GetAttr('SixthHypnoDisabled') == 0:
			Mission_SetAttr('SixthHypnoDisabled', 1)
##			Object_SetPrimaryState(event.object,PCSTATE_HYPNOTISED,15)
			TriggerHypnotize(event.object,'_impobj_hypno_s6')
			Object_NextVersion('_impobj_hypno_s6')
			Object_PlayEffect('_impobj_hypno_s6', 'effect_hypno_end')
			if RPG_GAME_DIFFICULTY < 3:
				regTimer('OnHypno6Expired', 20)
			elif RPG_GAME_DIFFICULTY < 6:
				regTimer('OnHypno6Expired', 18)
			else:
				regTimer('OnHypno6Expired', 15)
			regTimer('DestroyHypno6', 14.8)

def DestroyHypno6(event):
		Object_Destroy('_impobj_hypno_s6')
		print "impobj_hypno_s6 destroyed"

def OnHypno6Expired(event):
	if Mission_GetAttr('Control6Destroyed') == 0:
		if not Object_Exists('_impobj_hypno_s6'):
			spawn('_impobj_hypno_s6', 'nazihq_hypno_sphere', 'hypnofield6_marker')
		Object_PlayEffect('_impobj_hypno_s6', 'hypnofield_start')
		regHeroMarkerEnter('hypnofield6_marker', 'OnSixthHypno')
		Mission_SetAttr('SixthHypnoDisabled', 0)

def OnControl6Destroyed(event,heroname):
	Mission_SetAttr('Control6Destroyed', 1)
	RemoveHypnotig(event)
	Object_NextVersion('_impobj_controller6')
	if ( Mission_GetAttr('SixthHypnoDisabled') == 0 ) and ( Object_Exists('_impobj_hypno_s6') ):
		Object_NextVersion('_impobj_hypno_s6')
		Object_PlayEffect('_impobj_hypno_s6', 'effect_hypno_end')
	WhySphere()

def OnSniper1Dead(event):
	playEffect('effect_entropy_spawn', Get_ObjectPos('nazi_grenadier2'))
	Object_Destroy('nazi_grenadier2', 0)
	regTimer('SpawnNazi1', 15)

def SpawnNazi1(event):
	if Mission_GetAttr('FinalCSPlaying') == 0:
		spawn('nazi_grenadier2', 'nazi_grenadier', 'portal_spawn1')
		regDeath('nazi_grenadier2', 'OnSniper1Dead')
		addAttr('NumberOfSpawns', 1)
		if Mission_GetAttr('NumberOfSpawns') == 4:
			SpawnThreshold()

def OnSniper2Dead(event):
	playEffect('effect_entropy_spawn', Get_ObjectPos('nazi_general2'))
	Object_Destroy('nazi_general2', 0)
	regTimer('SpawnNazi2', 15)

def SpawnNazi2(event):
	if Mission_GetAttr('FinalCSPlaying') == 0:
		spawn('nazi_general2', 'nazi_general', 'portal_spawn3')
		regDeath('nazi_general2', 'OnSniper2Dead')
		addAttr('NumberOfSpawns', 1)
		if Mission_GetAttr('NumberOfSpawns') == 4:
			SpawnThreshold()

def OnEye1Dead(event):
	playEffect('effect_entropy_spawn', Get_ObjectPos('eye_minor3'))
	Object_Destroy('eye_minor3', 0)
	regTimer('SpawnEye1', 15)

def SpawnEye1(event):
	if Mission_GetAttr('FinalCSPlaying') == 0:
		spawn('eye_minor3', 'eye_minor', 'portal_spawn2')
		regDeath('eye_minor3', 'OnEye1Dead')
		addAttr('NumberOfSpawns', 1)
		if Mission_GetAttr('NumberOfSpawns') == 4:
			SpawnThreshold()

def OnEye2Dead(event):
	playEffect('effect_entropy_spawn', Get_ObjectPos('eye_minor4'))
	Object_Destroy('eye_minor4', 0)
	regTimer('SpawnEye2', 15)

def SpawnEye2(event):
	if Mission_GetAttr('FinalCSPlaying') == 0:
		spawn('eye_minor4', 'eye_minor', 'portal_spawn4')
		regDeath('eye_minor4', 'OnEye2Dead')
		addAttr('NumberOfSpawns', 1)
		if Mission_GetAttr('NumberOfSpawns') == 4:
			SpawnThreshold()

def SpawnThreshold():
	if RPG_GAME_DIFFICULTY < 4:
		regTimer('AlchemissHalfDone', 30)
		regTimer('AlchemissNearlyDone', 50)
		regTimer('AlchemissDone', 60)
		play(more_time_ss, "more_time_ss")
	if RPG_GAME_DIFFICULTY == 4:
		regTimer('AlchemissHalfDone', 40)
		regTimer('AlchemissNearlyDone', 70)
		regTimer('AlchemissDone', 80)
		play(more_time_ss, "more_time_ss")
	if RPG_GAME_DIFFICULTY == 5:
		regTimer('AlchemissHalfDone', 50)
		regTimer('AlchemissNearlyDone', 90)
		regTimer('AlchemissDone', 100)
		play(more_time_ss, "more_time_ss")
	if RPG_GAME_DIFFICULTY == 6:
		regTimer('AlchemissHalfDone', 60)
		regTimer('AlchemissNearlyDone', 110)
		regTimer('AlchemissDone', 120)
		play(more_time_ss, "more_time_ss")


def AlchemissHalfDone(event):
	print "30 seconds left"
	play(alchemiss_half_done_ss, "alchemiss_half_done_ss")

def AlchemissNearlyDone(event):
	print "10 seconds left"
	play(alchemiss_nearly_done_ss, "alchemiss_nearly_done_ss")

def AlchemissDone(event):
	print "mission complete"
	play(alchemiss_done_cs, "alchemiss_done_cs")

def TeleportHeroes():
	print "teleporting"
	herolist = getAllHeroes()
	temp = 0
	for hero in herolist:
		if Object_IsAlive(hero):
			if temp == 0:
				teleport(hero, 'hero_teleport_marker1')
				temp = 1
			elif temp == 1:
				teleport(hero, 'hero_teleport_marker2')
				temp = 2
			elif temp == 2:
				teleport(hero, 'hero_teleport_marker3')
				temp = 3
			elif temp == 3:
				teleport(hero, 'hero_teleport_marker4')
				temp = 4




def OnMissionWon():
	print "blitzkrieg/won"
	
def OnMissionLost():
	print "blitzkrieg/lost"

def PickLookTimeMaster():
	a_hero = getRandomLiveHeroName()
	print a_hero
	if a_hero == 'minute_man':
		speak('minute_man', 'MISSPCH_16_MM_01')
	elif a_hero == 'eve':
		speak('eve', 'MISSPCH_16_EV_01')
	elif a_hero == 'el_diablo':
		speak('el_diablo', 'MISSPCH_16_ED_01')
	elif a_hero == 'mentor':
		speak('mentor', 'MISSPCH_16_ME_01')
	elif a_hero == 'tombstone':
		speak('tombstone', 'MISSPCH_16_TS_01')
	elif a_hero == 'liberty_lad':
		speak('liberty_lad', 'MISSPCH_16_LL_01')
	elif a_hero == 'green_genie':
		speak('green_genie', 'MISSPCH_16_GG_01')
	elif a_hero == 'quetzalcoatl':
		speak('quetzalcoatl', 'MISSPCH_16_QZ_01')
	elif a_hero == 'the_ant':
		speak('the_ant', 'MISSPCH_16_AN_01')
	elif a_hero == 'microwave':
		speak('microwave', 'MISSPCH_16_MW_01')
	elif a_hero == 'man_o_war':
		speak('man_o_war', 'MISSPCH_16_MO_01')
	elif a_hero == 'sea_urchin':
		speak('sea_urchin', 'MISSPCH_16_SU_01')
	elif a_hero == 'law':
		speak('order', 'MISSPCH_16_OR_01')
	elif a_hero == 'black_bird':
		speak('black_bird', 'MISSPCH_16_BB_01')
	elif a_hero == 'iron_ox':
		speak('iron_ox', 'MISSPCH_16_IO_01')
	elif a_hero == 'supercollider':
		speak('supercollider', 'MISSPCH_16_SC_01')
	else:
		speak('bullet', 'MISSPCH_16_BL_13')



start_cs = [
(
	"peace()",
	"see()",
	"startCS()",
	"lookAtPos((75,-827,0), zoom = -155.4, pitch = 0, heading = -45)",
	"speak('black_jack', 'MISSPCH_16_BJ_01')",
),
(
	"speak('alchemiss', 'MISSPCH_16_AL_11')",
),
(
	"speak('bullet', 'MISSPCH_16_BL_09')",
),
(
	"speak('bullet', 'MISSPCH_16_BL_01')",
),
(
	"endCS()",
	"war()",
	"Sound_PlayMusic('music_09blitz1')",
	"blind()",
	"newObjective('primary', 1, name='defeat_blitz')",
	"ff.AITurnOff()",
),
]


stop_them_ss = [
(
	"speak('nazi_gunner4', 'MISSPCH_16_N1_01')",
),
(
	"speak('bullet', 'MISSPCH_16_BL_02')",
),
(
	"blank",
),
]


weird_field_ss = [
(
	"speak('bullet', 'MISSPCH_16_BL_03')",
),
(
	"blank",
),
]

field_hypnosis_cs = [
(
	"peace()",
	"see()",
	"startCS()",
	"speak('bullet', 'MISSPCH_16_BL_04')",
),
(
	"look('_impobj_controller1', zoom = -100, heading = 0, time = 1)",
	"wait(2.0)",
),
(
	"speak('bullet', 'MISSPCH_16_BL_05')",
),
(
	"endCS()",
	"war()",
	"blind()",
	"ff.AITurnOff()",
),
]

second_field_hypnosis_ss = [
(
	"forceSpeak('nazi_rifleman1', 'MISSPCH_16_N2_01')",
),
(
	"blank",
),
]

major_eye_cs = [
(
	"peace()",
	"see()",
	"startCS()",
	"lookAtPos((31,715,0), zoom = -125, pitch = 0, heading = 0)",
	"playTransition()"
),
(
	"speak('eye_major1', 'MISSPCH_16_E2_01')",
	"Sound_PlaySound('mission_blitzkrieg')",
	"Sound_PlayMusic('music_09blitz_eye',1)",
),
(
	"ff.EyeZap()",
),
(
	"speak('bullet', 'MISSPCH_16_BL_06')",
),
(
	"speak('eye_major1', 'MISSPCH_16_E2_02')",
),
(
	"endCS()",
	"war()",
	"blind()",
	"Sound_PlayMusic('music_09blitz1')",
	"ff.AITurnOff()",
),
]

#	"spawn('alchemiss', 'alchemiss', 'alchemiss_spawn_marker')",
#	removed from below
entered_lair_cs = [
(
	"peace()",
	"see()",
	"startCS()",
	"look('time_master_marker', zoom = -100, heading = 0, time = 0)",
	"playTransition()",
	"ff.TeleportHeroes()",

),
(
	"ff.PickLookTimeMaster()",
	"Sound_PlaySound('mission_blitzkrieg')",
	"Sound_PlayMusic('music_09blitz_tm',1)",
),
(
	"forceSpeak('alchemiss', 'MISSPCH_16_AL_12')",
),
(
	"look('hero_teleport_marker3', zoom = -100, heading = 90, time = 0)",
	"forceSpeak('blitzkrieg', 'MISSPCH_16_BZ_01')",
),
(
	"forceSpeak('blitzkrieg', 'MISSPCH_16_BZ_05')",
),
(
	"forceSpeak('blitzkrieg', 'MISSPCH_16_BZ_06')",
),
(
	"ff.AITurnOff()",
	"endCS()",
	"Sound_PlayMusic('music_09blitz2')",
	"war()",
	"blind()",
),
]


more_time_ss = [
(
	"forceSpeak('alchemiss', 'MISSPCH_16_AL_02')",
),
(
	"newObjective('primary', 2, name='need_time')",
	"wait(0.1)",
),
(
	"blank",
),
]


alchemiss_half_done_ss = [
(
	"forceSpeak('alchemiss', 'MISSPCH_16_AL_03')",
),
(
	"speak('bullet', 'MISSPCH_16_BL_08')",
),
(
	"forceSpeak('alchemiss', 'MISSPCH_16_AL_04')",
),
(
	"blank",
),
]


alchemiss_nearly_done_ss = [
(
	"forceSpeak('alchemiss', 'MISSPCH_16_AL_05')",
),
(
	"blank",
),
]

alchemiss_done_cs = [
(
	"peace()",
	"see()",
	"Mission_SetAttr('FinalCSPlaying', 1)",
	"startCS()",
	"Sound_PlayMusic('music_09blitz_end1',1)",
	"forceSpeak('blitzkrieg', 'MISSPCH_16_BZ_04')",
),
(
	"forceSpeak('alchemiss', 'MISSPCH_16_AL_06')",
),
(
	"Sound_PlayMusic('music_09blitz_end2',1)",
	"forceSpeak('alchemiss', 'MISSPCH_16_AL_07')",
),
(
	"speak('bullet', 'MISSPCH_16_BL_12')",
),
(
	"endCS()",
	"war()",
	"blind()",
	"Objective_Complete('need_time')",
	"Objective_Complete('defeat_blitz')",
	"Mission_Win()",
),
]



