# symphony

from cshelper import *
from js import *
import event

def OnIntermission():
	play(intermission_cs, 'intermission_cs')

def OnPostInit():
	print 'symphony base/start'
	peace()
	RPG_SetActive(0)
	Mission_SetSunlight(0, 60, 0.5, 0, (1,1,1))
	lookAtPos((1,211,0), zoom= -200, pitch= -10, heading= -43.5)
	Object_PlayEffect('_impobj_main_screen', 'cs_screen_scan', '', FX_LOOP|FX_TRACK_OBJECT_ROT)
	Object_PlayEffect('_impobj_main_screen2', 'cs_screen_scan', '', FX_LOOP|FX_TRACK_OBJECT_ROT)

	Campaign_UnRecruit('alchemiss')
	Campaign_UnlockOrigin('alchemiss')
	Campaign_UnRecruit('el_diablo')
	Campaign_UnlockOrigin('el_diablo')
	Campaign_Recruit('mentor')
	Campaign_UnlockOrigin('mentor')
	Campaign_Recruit('minute_man')
	Campaign_UnlockOrigin('minute_man')
	Campaign_AddHero ('liberty_lad')
	Campaign_UnlockOrigin('liberty_lad')
	Campaign_Recruit('tombstone')
	Campaign_UnlockOrigin('tombstone')
	Campaign_Recruit('bullet')
	Campaign_UnlockOrigin('bullet')
	Campaign_AddHero ('green_genie')
	Campaign_UnlockOrigin('green_genie')
	Campaign_AddHero ('quetzalcoatl')
	Campaign_UnlockOrigin('quetzalcoatl')
	Campaign_Recruit('the_ant')
	Campaign_UnlockOrigin('the_ant')
	Campaign_Recruit('eve')
	Campaign_UnlockOrigin('eve')
	Campaign_AddHero ('microwave')
	Campaign_AddHero ('supercollider')
	Campaign_Recruit('black_jack')
	Campaign_UnlockOrigin('black_jack')
	Campaign_AddHero ('law')
	Campaign_UnlockOrigin('law')
	Campaign_AddHero ('order')
	Campaign_UnlockOrigin('order')
	Campaign_AddHero ('ironox')
	Campaign_AddHero ('man_o_war')
	Campaign_UnlockOrigin('man_o_war')
	Campaign_AddHero ('sea_urchin')
	Campaign_UnlockOrigin('sea_urchin')
	Campaign_Recruit('tricolour')
	Campaign_UnlockOrigin('tricolour')
	Campaign_AddHero ('blackbird')
	Campaign_Recruit('sky_king')
	Campaign_UnlockOrigin('sky_king')
	Campaign_Recruit('man_bot')
	Campaign_UnlockOrigin('man_bot')
	Campaign_AddHero ('the_bard')

	Campaign_AddMinion('thug_with_bat')
	Campaign_AddMinion('thug_with_gun')
	Campaign_AddVillain('nuclear_winter')
	Campaign_AddVillain('time_master')
	Campaign_AddMinion('ice_trooper')
	Campaign_AddMinion('ice_sergeant')
	Campaign_AddMinion('snow_man')
	Campaign_AddMinion('shurale')
	Campaign_AddVillain('red_oktober')
	Campaign_AddMinion('dark_shaman')
	Campaign_AddVillain('frozen_giant')
	Campaign_AddMinion('nazi_rifleman')
	Campaign_AddMinion('legionnaire')
	Campaign_AddVillain('fortissimo')
	Campaign_AddVillain('red_sun')
	Campaign_AddMinion('nazi_gunner')
	Campaign_AddMinion('nazi_grenadier')
	Campaign_AddMinion('killarilla_whip')
	Campaign_AddMinion('killarilla_chaingun')
	Campaign_AddMinion('nazi_general')
	Campaign_AddMinion('eye_minor')
	Campaign_AddMinion('centurion')
	Campaign_AddMinion('eye_major')
	Campaign_AddVillain('blitzkrieg')

	Mission_SetAttr('fight_phase',1)


def OnBriefing():
	play(briefing_cs, 'briefing_cs')
	print 'symphony base/briefing'

def Fight1(event):
	print "Fight1"
	if Mission_GetAttr('fight_phase') == 1:
		Trigger_Move('wraith3', 'move', Get_MarkerPos('wraith3_pos'), '', 0, 0)
		Trigger_Move('wraith2', 'move', Get_ObjectPos('man_bot'), '', 3, 0)
		Trigger_Move('wraith1', 'move', Get_ObjectPos('man_bot'), '', 3, 0)
		regTimer('Fight1a',.65)
	else:
		Fight2(event)
def Fight1a(event):
	print "Fight1a"
	if Mission_GetAttr('fight_phase') == 1:
		Trigger_Power('man_bot', 'wraith1', 'manbot Punch', '', 0)
		Trigger_Power('wraith1', 'man_bot', 'wraith warrior Disruption', '', 0)
		Trigger_Power('wraith2', 'man_bot', 'wraith warrior Disruption', '', 0)
		Trigger_Power('wraith3', 'man_bot', 'wraith warrior Binding Force', '', 0)
		regTimer('Fight1ai',2)
		regTimer('Fight1b',4)
	else:
		Fight2(event)
def Fight1ai(event):
	print "Fight1ai"
	if Mission_GetAttr('fight_phase') == 1:
		Trigger_Power('man_bot', 'wraith2', 'manbot Punch', '', 0)
		Trigger_Power('wraith1', 'man_bot', 'wraith warrior Disruption', '', 0)
		Trigger_Power('wraith2', 'man_bot', 'wraith warrior Disruption', '', 0)
	else:
		print "phase ended"
def Fight1b(event):
	print "Fight1b"
	if Mission_GetAttr('fight_phase') == 1:
		Trigger_Move('wraith2', 'move', Get_MarkerPos('wraith2_pos'), '', 0, 0)
		Trigger_Move('wraith1', 'move', Get_ObjectPos('man_bot'), '', 1, 0)
		Trigger_Move('wraith3', 'move', Get_ObjectPos('man_bot'), '', 1, 0)
		regTimer('Fight1c',.65)
	else:
		Fight2(event)
def Fight1c(event):
	print "Fight1c"
	if Mission_GetAttr('fight_phase') == 1:
		Trigger_Power('man_bot', 'wraith3', 'manbot Punch', '', 0)
		Trigger_Power('wraith3', 'man_bot', 'wraith warrior Disruption', '', 0)
		Trigger_Power('wraith1', 'man_bot', 'wraith warrior Disruption', '', 0)
		Trigger_Power('wraith2', 'man_bot', 'wraith warrior Binding Force', '', 0)
		regTimer('Fight1ci',2)
		regTimer('Fight1d',4)
	else:
		Fight2(event)
def Fight1ci(event):
	print "Fight1ci"
	if Mission_GetAttr('fight_phase') == 1:
		Trigger_Power('man_bot', 'wraith1', 'manbot Punch', '', 0)
		Trigger_Power('wraith1', 'man_bot', 'wraith warrior Disruption', '', 0)
		Trigger_Power('wraith3', 'man_bot', 'wraith warrior Disruption', '', 0)
	else:
		print "phase ended"
def Fight1d(event):
	print "Fight1d"
	if Mission_GetAttr('fight_phase') == 1:
		Trigger_Move('wraith1', 'move', Get_MarkerPos('wraith1_pos'), '', 0, 0)
		Trigger_Move('wraith3', 'move', Get_ObjectPos('man_bot'), '', 1, 0)
		Trigger_Move('wraith2', 'move', Get_ObjectPos('man_bot'), '', 1, 0)
		regTimer('Fight1e',.65)
	else:
		Fight2(event)
def Fight1e(event):
	print "Fight1e"
	if Mission_GetAttr('fight_phase') == 1:
		Trigger_Power('man_bot', 'wraith2', 'manbot Punch', '', 0)
		Trigger_Power('wraith2', 'man_bot', 'wraith warrior Disruption', '', 0)
		Trigger_Power('wraith3', 'man_bot', 'wraith warrior Disruption', '', 0)
		Trigger_Power('wraith1', 'man_bot', 'wraith warrior Binding Force', '', 0)
		regTimer('Fight1ei',2)
		regTimer('Fight1',4)
	else:
		Fight2(event)
def Fight1ei(event):
	print "Fight1ei"
	if Mission_GetAttr('fight_phase') == 1:
		Trigger_Power('man_bot', 'wraith3', 'manbot Punch', '', 0)
		Trigger_Power('wraith3', 'man_bot', 'wraith warrior Disruption', '', 0)
		Trigger_Power('wraith2', 'man_bot', 'wraith warrior Disruption', '', 0)
	else:
		print "phase ended"

def Fight2(event):
	print "fight2"
	if Mission_GetAttr('fight_phase') == 2:
		Object_SetGenericState('man_bot',OBJSTATE_DENSITY_CHANGE,0,REMOVE_STATE)
		Object_SetGenericState('alchemiss',OBJSTATE_DENSITY_CHANGE,0,REMOVE_STATE)
		Trigger_Power('man_bot', 'wraith2', 'manbot Punch1', '', 0)
		Trigger_Power('alchemiss', 'wraith1', 'alchemiss Arcane Bolt', '', 0)
		Trigger_Power('wraith1', 'man_bot', 'wraith warrior Binding Force', '', 0)
		Trigger_Power('wraith2', 'alchemiss', 'wraith warrior Disruption', '', 0)
		Trigger_Move('wraith3', 'move', Get_MarkerPos('wraith3_pos'), '', 0, 0)
		regTimer('Fight2a',4)
	else:
		Fight3(event)
def Fight2a(event):
	print "fight2a"
	if Mission_GetAttr('fight_phase') == 2:
		Object_SetGenericState('man_bot',OBJSTATE_DENSITY_CHANGE,0,REMOVE_STATE)
		Object_SetGenericState('alchemiss',OBJSTATE_DENSITY_CHANGE,0,REMOVE_STATE)
		Trigger_Power('man_bot', 'wraith3', 'manbot Punch', '', 0)
		Trigger_Power('alchemiss', 'wraith3', 'alchemiss Hex', '', 0)
		Trigger_Power('wraith1', 'alchemiss', 'wraith warrior Disruption', '', 0)
		Trigger_Move('wraith2', 'move', Get_MarkerPos('wraith2_pos'), '', 0, 0)
		Trigger_Power('wraith3', 'man_bot', 'wraith warrior Binding Force', '', 0)
		regTimer('Fight2b',4.2)
	else:
		Fight3(event)
def Fight2b(event):
	print "fight2c"
	if Mission_GetAttr('fight_phase') == 2:
		Object_SetGenericState('man_bot',OBJSTATE_DENSITY_CHANGE,0,REMOVE_STATE)
		Object_SetGenericState('alchemiss',OBJSTATE_DENSITY_CHANGE,0,REMOVE_STATE)
		Trigger_Power('man_bot', 'wraith2', 'manbot Energy Focus', '', 0)
		Trigger_Power('alchemiss', 'wraith1', 'alchemiss Arcane Bolt', '', 0)
		Trigger_Move('wraith1', 'move', Get_MarkerPos('wraith1_pos'), '', 0, 0)
		Trigger_Power('wraith2', 'alchemiss', 'wraith warrior Binding Force', '', 0)
		Trigger_Power('wraith3', 'alchemiss', 'wraith warrior Disruption', '', 0)
		regTimer('Fight2',4)
	else:
		Fight3(event)

def Phase3(event):
	Mission_SetAttr('fight_phase',3)

def Fight3(event):
	print "fight3"
	Object_SetGenericState('man_bot',OBJSTATE_DENSITY_CHANGE,0,REMOVE_STATE)
	Object_SetGenericState('alchemiss',OBJSTATE_DENSITY_CHANGE,0,REMOVE_STATE)
	Trigger_Power('man_bot', 'wraith3', 'manbot Energy Focus', 'Fight3a', 0)
	Trigger_Power('alchemiss', 'wraith2', 'alchemiss Arcane Bolt', '', 0)
	Trigger_Power('wraith1', 'alchemiss', 'wraith warrior Binding Force', '', 0)
	regTimer('Fight3a',4.5)
def Fight3a(event):
	print "fight3a"
	Object_SetGenericState('man_bot',OBJSTATE_DENSITY_CHANGE,0,REMOVE_STATE)
	Object_SetGenericState('alchemiss',OBJSTATE_DENSITY_CHANGE,0,REMOVE_STATE)
	kill('wraith3')
	Trigger_Move('wraith1', 'move', Get_MarkerPos('wraith1_pos'), '', 0, 0)
	regTimer('Fight3ai',1.5)
def Fight3ai(event):
	print "fight3a1"
	Object_SetGenericState('man_bot',OBJSTATE_DENSITY_CHANGE,0,REMOVE_STATE)
	Object_SetGenericState('alchemiss',OBJSTATE_DENSITY_CHANGE,0,REMOVE_STATE)
	Trigger_Power('man_bot', 'wraith2', 'manbot Energy Focus', 'Fight3b', 0)
	Trigger_Power('alchemiss', 'wraith1', 'alchemiss Arcane Bolt', '', 0)
	Trigger_Power('wraith2', 'alchemiss', 'wraith warrior Disruption', '', 0)
	Trigger_Power('wraith1', 'man_bot', 'wraith warrior Binding Force', '', 0)
	regTimer('Fight3b',5.5)
def Fight3b(event):
	print "fight3b"
	Object_SetGenericState('man_bot',OBJSTATE_DENSITY_CHANGE,0,REMOVE_STATE)
	Object_SetGenericState('alchemiss',OBJSTATE_DENSITY_CHANGE,0,REMOVE_STATE)
	kill('wraith2')
	Trigger_Move('wraith1', 'move', Get_ObjectPos('alchemiss'), 'Fight3c', 0, 0)
	regTimer('Fight3c',.75)
def Fight3c(event):
	print "fight3c"
	Object_SetGenericState('man_bot',OBJSTATE_DENSITY_CHANGE,0,REMOVE_STATE)
	Object_SetGenericState('alchemiss',OBJSTATE_DENSITY_CHANGE,0,REMOVE_STATE)
	Trigger_Power('man_bot', 'wraith1', 'manbot Punch', '', 0)
	Trigger_Power('alchemiss', 'wraith1', 'alchemiss Slap', '', 0)
	regTimer('Fight3d',1.65)
def Fight3d(event):
	print "fight3d"
	Object_SetGenericState('man_bot',OBJSTATE_DENSITY_CHANGE,0,REMOVE_STATE)
	Object_SetGenericState('alchemiss',OBJSTATE_DENSITY_CHANGE,0,REMOVE_STATE)
	kill('wraith1')

def AlchTurn(event):
	turnTo('alchemiss','man_bot')
def MBTurn(event):
	turnTo('alchemiss','man_bot')
	turnTo('man_bot','alchemiss')

#-----------
# data
#-----------

#intermission
intermission_cs = [
(
	"startCS()",
	"lookAtPos((-1261,-213,0), zoom = -180.2, heading = -95.5)",
	"RPG_SetActive(0)",
	"null()",
),
(
	"lookAtPos((-1629,-81,0), zoom = -209.1, heading = -79.7, time = 10)",
	"speak('narrator', 'BRFSPCH_18_NR_02', CAPTION_TOP_LEFT)", #Narrator what a small creature is ...
	"Sound_PlayMusic('music_10sym_base1')",
	"AI_Animate('man_bot', 'melee_idle', '', 0, 1)",
	"ff.Fight1(event)",
),
(
	"speak('narrator', 'BRFSPCH_18_NR_03', CAPTION_TOP_LEFT)", #Narrator what could he do besides ...  
),
(
	"speak('narrator', 'BRFSPCH_18_NR_04', CAPTION_TOP_LEFT)", #Narrator but there is one who know...  
),
(
	"Object_SetGenericState('man_bot',OBJSTATE_DENSITY_CHANGE,0,REMOVE_STATE)",
	"speak('man_bot', 'BRFSPCH_18_MB_01', CAPTION_TOP_RIGHT)", #Man-Bot must... fight... back!  t...
	"spawn('alchemiss', 'alchemiss', 'alchemiss_spawn')",
),
(
	"Object_SetGenericState('man_bot',OBJSTATE_DENSITY_CHANGE,0,REMOVE_STATE)",
	"Object_SetGenericState('alchemiss',OBJSTATE_DENSITY_CHANGE,0,REMOVE_STATE)",
	"lookAtPos((-1585,-90,0), zoom = -211.6, pitch = 0, heading =  23.8)",
	"speak('alchemiss', 'BRFSPCH_18_AL_01', CAPTION_BOTTOM_RIGHT)", #Alchemiss looks like you could use ...
	"move('alchemiss', 'alchemiss_pos1')",
),
(
	"Object_SetGenericState('man_bot',OBJSTATE_DENSITY_CHANGE,0,REMOVE_STATE)",
	"Object_SetGenericState('alchemiss',OBJSTATE_DENSITY_CHANGE,0,REMOVE_STATE)",
	"speak('man_bot', 'BRFSPCH_18_MB_02', CAPTION_TOP_LEFT)", #Man-Bot alchemiss!  what... i... ...  
	"turnTo('man_bot', 'alchemiss')",
	"Mission_SetAttr('fight_phase',2)",
),
(
	"speak('alchemiss', 'BRFSPCH_18_AL_02', CAPTION_TOP_RIGHT)", #Alchemiss save the pillow talk for ...  
),
(
	"Object_SetGenericState('man_bot',OBJSTATE_DENSITY_CHANGE,0,REMOVE_STATE)",
	"Object_SetGenericState('alchemiss',OBJSTATE_DENSITY_CHANGE,0,REMOVE_STATE)",
	"speak('man_bot', 'BRFSPCH_18_MB_03', CAPTION_TOP_LEFT)", #Man-Bot why are you here?  how di...  
),
(
	"Object_SetGenericState('man_bot',OBJSTATE_DENSITY_CHANGE,0,REMOVE_STATE)",
	"Object_SetGenericState('alchemiss',OBJSTATE_DENSITY_CHANGE,0,REMOVE_STATE)",
	"speak('alchemiss', 'BRFSPCH_18_AL_03', CAPTION_TOP_RIGHT)", #Alchemiss i had no idea how powerfu...
	"regTimer('Phase3',10)",
),
(
	"Object_SetGenericState('man_bot',OBJSTATE_DENSITY_CHANGE,0,REMOVE_STATE)",
	"Object_SetGenericState('alchemiss',OBJSTATE_DENSITY_CHANGE,0,REMOVE_STATE)",
	"speak('man_bot', 'BRFSPCH_18_MB_04', CAPTION_TOP_LEFT)", #Man-Bot you mean?  
),
(
	"Object_SetGenericState('man_bot',OBJSTATE_DENSITY_CHANGE,0,REMOVE_STATE)",
	"Object_SetGenericState('alchemiss',OBJSTATE_DENSITY_CHANGE,0,REMOVE_STATE)",
	"speak('alchemiss', 'BRFSPCH_18_AL_04', CAPTION_TOP_RIGHT)", #Alchemiss yes!  i'm here to take yo...  
),
(
	"Object_SetGenericState('man_bot',OBJSTATE_DENSITY_CHANGE,0,REMOVE_STATE)",
	"Object_SetGenericState('alchemiss',OBJSTATE_DENSITY_CHANGE,0,REMOVE_STATE)",
	"speak('man_bot', 'BRFSPCH_18_MB_05', CAPTION_TOP_LEFT)", #Man-Bot but how?  
),
(
	"Object_SetGenericState('man_bot',OBJSTATE_DENSITY_CHANGE,0,REMOVE_STATE)",
	"Object_SetGenericState('alchemiss',OBJSTATE_DENSITY_CHANGE,0,REMOVE_STATE)",
	"speak('alchemiss', 'BRFSPCH_18_AL_05', CAPTION_TOP_RIGHT)", #Alchemiss i can't say how I know, b...  
),
(
	"lookAtPos((-1547,-79,0), zoom = -242.6, pitch = 0, heading =  10.5)",
	"null()",
),
(
	"Object_SetGenericState('man_bot',OBJSTATE_DENSITY_CHANGE,0,REMOVE_STATE)",
	"Object_SetGenericState('alchemiss',OBJSTATE_DENSITY_CHANGE,0,REMOVE_STATE)",
	"speak('alchemiss', 'BRFSPCH_18_AL_06', CAPTION_TOP_RIGHT)", #Alchemiss i can change the very nat...
	"#move('alchemiss', 'alchemiss_pos1', radius = 0)",
	"js.Trigger_Move('alchemiss', 'move', Get_MarkerPos('alchemiss_pos1'), 'AlchTurn', 1, 0)",
),
(
	"Object_SetGenericState('man_bot',OBJSTATE_DENSITY_CHANGE,0,REMOVE_STATE)",
	"Object_SetGenericState('alchemiss',OBJSTATE_DENSITY_CHANGE,0,REMOVE_STATE)",
	"speak('man_bot', 'BRFSPCH_18_MB_06', CAPTION_TOP_LEFT)", #Man-Bot reality isn't a toy!  you...  
	"#move('man_bot', 'manbot_pos1', radius = 0)",
	"js.Trigger_Move('man_bot', 'move', Get_MarkerPos('manbot_pos1'), 'MBTurn', 1, 0)",
),
(
	"Object_SetGenericState('man_bot',OBJSTATE_DENSITY_CHANGE,0,REMOVE_STATE)",
	"Object_SetGenericState('alchemiss',OBJSTATE_DENSITY_CHANGE,0,REMOVE_STATE)",
	"speak('man_bot', 'BRFSPCH_18_MB_07', CAPTION_TOP_LEFT)", #Man-Bot these creatures we fight ...
	"turnTo('man_bot', 'alchemiss')",
),
(
	"speak('man_bot', 'BRFSPCH_18_MB_08', CAPTION_TOP_LEFT)", #Man-Bot who knows what kind of ha...  
),
(
	"lookAtPos((-1546,-138,0), zoom = -267.0, pitch = -5, heading =  93.4)",
	"speak('alchemiss', 'BRFSPCH_18_AL_07', CAPTION_TOP_RIGHT)", #Alchemiss weren't you listening?!  ...  
	"turnTo('alchemiss', 'man_bot')",
),
(
	"speak('alchemiss', 'BRFSPCH_18_AL_08', CAPTION_TOP_RIGHT)", #Alchemiss every time i think of you...  
),
(
	"speak('man_bot', 'BRFSPCH_18_MB_09', CAPTION_TOP_LEFT)", #Man-Bot i thought being trapped i...  
),
(
	"speak('man_bot', 'BRFSPCH_18_MB_10', CAPTION_TOP_LEFT)", #Man-Bot but i stayed here to save...  
),
(
	"speak('alchemiss', 'BRFSPCH_18_AL_09', CAPTION_TOP_RIGHT)", #Alchemiss peaches and cream!  i cam...  
	"AI_Animate('alchemiss', 'close_portal', '', 0, 0)",
	"Object_PlayEffect('alchemiss', 'csfx_alchemiss_slap', '', FX_TRACK_OBJECT_POS, 0, 'Bip01 L Hand')",
),
(
	"speak('man_bot', 'BRFSPCH_18_MB_11', CAPTION_TOP_LEFT)", #Man-Bot alchemiss!  no!  i can se...
	"moveTo('man_bot', 'alchemiss')",
),
(
	"Trigger_Power('alchemiss', 'man_bot', 'alchemiss Slap', 'onStepCB', 0)",
),
(
	"lookAtPos((-1547,-79,0), zoom = -242.6, pitch = 0, heading =  10.5)",
	"speak('alchemiss', 'BRFSPCH_18_AL_10', CAPTION_TOP_RIGHT)", #Alchemiss i'm doing this for you, d...  
	"AI_Animate('alchemiss', 'close_portal', '', 0, 0)",
	"AI_Animate('man_bot', 'fall', '', 0, 1)",
),
(
	"lookAtPos((-1546,-138,0), zoom = -267.0, heading =  93.4)",
	"speakNoCB('man_bot', 'BRFSPCH_18_MB_14')", #CAPTION_BOTTOM_LEFT Man-Bot alchemiss!  no!  
	"Object_PlayEffect('man_bot', 'effect_portal_open', 'onStepCB', FX_TRACK_OBJECT_ROT)",
	"spawn('wraith4', 'wraith_warrior', 'wraith1_pos')",
	"spawn('wraith5', 'wraith_warrior', 'wraith2_pos')",
	"spawn('wraith6', 'wraith_warrior', 'wraith3_pos')",
	"makePeaceful('wraith4')",
	"makePeaceful('wraith5')",
	"makePeaceful('wraith6')",
),
(
	"speakNoCB('man_bot', 'BRFSPCH_18_MB_15')", #Man-Bot alchemiss!
	"#Object_PlayEffect('alchemiss', 'effect_portal_open', '', FX_TRACK_OBJECT_ROT)",
	"Object_PlayEffect('man_bot', 'effect_portal_steady', 'onStepCB', FX_TRACK_OBJECT_ROT)",
	"moveTo('wraith4', 'alchemiss')",
	"moveTo('wraith5', 'alchemiss')",
	"moveTo('wraith6', 'alchemiss')",

),
(
	"Object_PlayEffect('alchemiss', 'csfx_symphony_explosion', '', FX_TRACK_OBJECT_ROT)",
	"Camera_Fade(1)",
	"wait(1)",
),
(
	"lookAtPos((1,211,0), zoom= -251.8, pitch= -15, heading= -43.5)",
	"playTransition()",	#cut back to ff base
),
(
	"Camera_UnFade(1)",
	"Sound_PlayMusic('music_10sym_base2',1)",
	"speak('tricolour', 'BRFSPCH_18_TC_01', CAPTION_TOP_RIGHT)", #Tricolour zut alors!  does everybod...  
),
(
	"lookAtPos((54,100,0), zoom = -257.7, heading =  94.1)",
	"speak('minute_man', 'BRFSPCH_18_MM_04', CAPTION_TOP_RIGHT)", #Minute Man hardly, tricolour.  the F...  
	"turnTo('minute_man', 'tricolour')",
),
(
	"speak('minute_man', 'BRFSPCH_18_MM_05', CAPTION_TOP_RIGHT)", #Minute Man the fortress is equipped ...  
),
(
	"speak('sky_king', 'BRFSPCH_18_SY_01', CAPTION_TOP_LEFT)", #Sky King hundreds of what now?  it...  
	"turnTo('sky_king', 'minute_man')",
),
(
	"speak('sky_king', 'BRFSPCH_18_SY_02', CAPTION_TOP_LEFT)", #Sky King how are we going to go ba...  
),
(
	"speak('black_jack', 'BRFSPCH_18_BJ_01', CAPTION_TOP_RIGHT)", #Black Jack speak for yourself, fly b...  
	"turnTo('black_jack', 'sky_king')",
),
(
	"lookAtPos((47,163,0), zoom = -255.9, heading =  54.7)",
	"speak('mentor', 'BRFSPCH_18_ME_03', CAPTION_TOP_LEFT)", #Mentor yes, once we defeated bli...  
	"turnTo('mentor', 'black_jack')",
),
(
	"speak('man_o_war', 'BRFSPCH_18_MO_01', CAPTION_TOP_LEFT)", #Man O' War looks like things are ret...  
),
(
	"speak('man_o_war', 'BRFSPCH_18_MO_02', CAPTION_TOP_LEFT)", #Man O' War so, lassie, do you plan o...  
),
(
	"speak('tricolour', 'BRFSPCH_18_TC_02', CAPTION_TOP_LEFT)", #Tricolour oh... are you... well...
),
(
	"lookAtPos((1,94,0), zoom= -247.2, pitch= -10, heading= -84.3)",
	"Object_StopEffect('_impobj_main_screen', 1)",
	"Object_PlayEffect('_impobj_main_screen', 'cs_screen_alert', '', FX_LOOP|FX_TRACK_OBJECT_ROT)",
	"turn('mentor', 'hero_entrance1')",
	"turn('black_jack', 'hero_entrance1')",
	"turn('sky_king', 'hero_entrance1')",
	"turn('minute_man', 'hero_entrance1')",
	"turn('tricolour', 'hero_entrance1')",
	"turn('man_o_war', 'hero_entrance1')",
	"playEffectMarker('effect_portal_open', 'manbot_pos2', fn = 'onStepCB')",
),
(
	"speak('minute_man', 'BRFSPCH_18_MM_06', CAPTION_TOP_LEFT)", #Minute Man stars and bars!  IS it?!  
	"playEffectMarker('effect_entropy_spawn', 'manbot_pos2')",
	"playEffectMarker('effect_portal_close', 'manbot_pos2')",
	"teleport('man_bot', 'manbot_pos2')",
),
(
	"speak('mentor', 'BRFSPCH_18_ME_04', CAPTION_TOP_LEFT)", #Mentor rings of rexor!
),
(
	"speak('man_o_war', 'BRFSPCH_18_MO_03', CAPTION_TOP_LEFT)", #Man O' War can it be?  laddie, is th...  
	"move('man_bot', 'manbot_pos3', radius = 0)",
),
(
	"lookAtPos((1,211,0), zoom= -251.8, pitch= 0, heading= -43.5)",
	"speak('man_bot', 'BRFSPCH_18_MB_16', CAPTION_TOP_LEFT)", #Man-Bot get away... something ter...  
),
(
	"playEffectMarker('csfx_symphony_explosion', 'Xplosion_pos')",
	"wait(1)",
),
(
	"Camera_SetWidescreen(0)",
	"Mission_Play2DCutscene('cutscene_symphony_int', 'cutscene_symphony_wav', 'onStepCB')",
),
(
	"endCS()",
	"lookAtPos((1,211,0), zoom= -200, pitch= -10, heading= -43.5)",
	"Object_StopEffect('_impobj_main_screen', 2)",
	"Object_PlayEffect('_impobj_main_screen', 'cs_screen_city', '', FX_LOOP|FX_TRACK_OBJECT_ROT)",
	"playEffectMarker('csfx_symphony_smoke', 'Xplosion_pos')",
	"AI_Animate('mentor', 'get_up_back')",
	"AI_Animate('black_jack', 'get_up_back')",
	"AI_Animate('sky_king', 'get_up_back')",
	"AI_Animate('minute_man', 'get_up_back')",
	"AI_Animate('tricolour', 'get_up_back')",
	"AI_Animate('man_o_war', 'get_up_back')",
	"AI_Animate('man_bot', 'get_up_back')",
),
]

briefing_cs = [
(
	"startCS()",
	"lookAtPos((-730,113,1), zoom= -262.7, pitch= 0, heading= -105.9)",
	"speak('narrator', 'BRFSPCH_18_NR_01', CAPTION_TOP_LEFT)", #Narrator minutes earlier...
	"turnTo('mentor', '_impobj_main_screen')",
	"turnTo('man_bot', '_impobj_main_screen')",
	"turnTo('man_o_war', '_impobj_main_screen')",
	"turnTo('minute_man', '_impobj_main_screen')",
	"turnTo('tricolour', '_impobj_main_screen')",
	"turnTo('sky_king', '_impobj_main_screen')",
	"turnTo('black_jack', '_impobj_main_screen')",
),
(
	"speak('sea_urchin', 'BRFSPCH_18_SU_01', CAPTION_BOTTOM_LEFT)", #Sea Urchin umm, mr. tombstone? have ...
),
(
	"speak('sea_urchin', 'BRFSPCH_18_SU_02', CAPTION_BOTTOM_LEFT)", #Sea Urchin hey, tomb-y! you in there...
),
(
	"turnTo('tombstone', 'sea_urchin')",
	"speak('tombstone', 'BRFSPCH_18_TS_01', CAPTION_TOP_RIGHT)", #Tombstone i am reflecting. no...i h...
),
(
	"lookAtPos((-720,48,7), zoom= -273.5, pitch= -5, heading= -176.4)",
	"speak('sea_urchin', 'BRFSPCH_18_SU_03', CAPTION_BOTTOM_LEFT)", #Sea Urchin future what? maybe they d...
),
(
	"lookAtPos((-730,113,1), zoom= -250, pitch= -10, heading= -105.9)",
	"Object_StopEffect('_impobj_main_screen2', 1)",
	"Object_PlayEffect('_impobj_main_screen2', 'cs_screen_alert', '', FX_LOOP|FX_TRACK_OBJECT_ROT)",
	"Sound_PlayMusic('music_05berlin_br1')",
	"turnTo('sea_urchin', '_impobj_main_screen2')",
	"turnTo('tombstone', '_impobj_main_screen2')",
	"wait(2)",
),
(
	"lookAtPos((-622,133,0), zoom= -256.9, pitch= 0, heading= -7.2)",
	"move('sea_urchin', 'hero_exit1')",
	"move('tombstone', 'hero_exit1')",
	"wait(2)",
),
(
	"teleport('sea_urchin', 'hero_entrance1')",
	"teleport('sea_urchin', 'hero_entrance1')",
	"null()"
),	
(
	"lookAtPos((1,94,0), zoom= -247.2, pitch= -10, heading= -84.3)",
	"moveCB('sea_urchin', 'urchin_pos1')",
	"move('tombstone', 'urchin_pos1')",
),
(	
	"speak('sea_urchin', 'BRFSPCH_18_SU_04', CAPTION_TOP_LEFT)", #Sea Urchin what's going on?!
),
(
	"speak('man_o_war', 'BRFSPCH_18_MO_04', CAPTION_TOP_RIGHT)", #man_o_war to make a long story short...
	"turnTo('man_o_war', 'sea_urchin')",
),
(
	"lookAtPos((1,211,0), zoom= -251.8, pitch= -15, heading= -43.5)",
	"Sound_PlaySound('alarm_readyroom')",
	"speak('mentor', 'BRFSPCH_18_ME_02', CAPTION_TOP_RIGHT)", #Mentor chaos is breaking out all...
	"turnTo('man_o_war', 'mentor')",
),
(
	"speak('minute_man', 'BRFSPCH_18_MM_02', CAPTION_BOTTOM_RIGHT)", #Minute Man good gravy! entropy...
),
(
	"lookAtPos((-37,179,0), zoom= -261.8, pitch= -5, heading= -110.5)",
	"speak('sea_urchin', 'BRFSPCH_18_SU_05', CAPTION_TOP_LEFT)", #Sea Urchin entropy?
),
(
	"speak('black_jack', 'BRFSPCH_18_BJ_02', CAPTION_TOP_LEFT)", #Black Jack that's right, blue gills....
	"spawn('the_ant', 'the_ant', 'hero_entrance2')",
	"turnTo('black_jack', 'sea_urchin')",
),
(
	"speak('sea_urchin', 'BRFSPCH_18_SU_06', CAPTION_TOP_LEFT)", #Sea Urchin alchemiss did what now?
	"move('the_ant', 'ant_pos1', radius = 0)",
	"turn('black_jack', 'ant_pos1')",
),
(
	"speak('the_ant', 'BRFSPCH_18_AN_01', CAPTION_BOTTOM_LEFT)", #The Ant we need to get a team to ...
),
(
	"speak('minute_man', 'BRFSPCH_18_MM_03', CAPTION_TOP_RIGHT)", #Minute Man let's move, freedom force...
),
(
	"lookAtPos((-34,144,0), zoom= -234.1, pitch= -10, heading= -97.4)",
	"move('sea_urchin', 'hero_entrance1')",
	"move('man_bot', 'hero_entrance1')",
	"move('tombstone', 'hero_entrance1')",
	"move('minute_man', 'hero_entrance1')",
	"move('black_jack', 'hero_entrance1')",
	"wait(1)",
),
(
	"move('man_o_war', 'hero_entrance1')",
	"move('mentor', 'hero_entrance1')",
	"move('tricolour', 'hero_entrance1')",
	"move('sky_king', 'hero_entrance1')",
	"wait(1)",
),	
(
	"endBriefingCS()",
),
]

