# -*- coding: cp1252 -*-
# disappear

from cshelper import *
from js import *
from random import randint
from ffx import *
import event
import sound

def OnPreRendererCreate():
	ff.RENDER_WARP = 1

def OnPrecacheObjects():
	Mission_PrecacheTemplateObj('entropy',1,0)
	Mission_PrecacheTemplateObj('wraith_warrior',0,1)
	Mission_PrecacheTemplateObj('bacchite_green',0,1)
	Mission_PrecacheTemplateObj('alien_warrior',0,1)
	Mission_PrecacheTemplateObj('mech_man',0,1)
	Mission_PrecacheTemplateObj('nazi_gunner',0,1)
	Mission_PrecacheTemplateObj('ice_queen',0,1)
	Mission_PrecacheTemplateObj('tricolour',1,0)
	Mission_PrecacheTemplateObj('the_ant',1,0)
	Mission_PrecacheTemplateObj('mentor',1,0)
	Mission_PrecacheTemplateObj('man_bot',1,0)

def OnPostInit():
	print "disappear/start"
	setMission(20)

#cheats for demo
	#ff.DEBUG_ALLPOWERS				= 1
	#god()

	#Default light settings (TEMPORARY)
	#ff.LIGHT_CULL_RADIUS_FACTOR = 0.1
	#ff.LIGHT_DIM_RADIUS_FACTOR = 0.2
	#ff.LIGHT_CONSTANT_ATTEN = 0.6
	#ff.LIGHT_LINEAR_ATTEN = 0.0
	#ff.LIGHT_QUADRATIC_ATTEN = 3.3

	Mission_SetSunlight(-137,57,1.5,0.2,(0.2,0.2,0.6))
	Mission_SetShadows(-137,57,(0.2,0.2,0.4))
	Mission_SetProjShadowBackground((1,1,1))
	Mission_SetProjShadowColor((.6,.6,.6,1))

	Mission_SetAttr('civ_monster_index',0)
	Mission_SetAttr('force_monster',0)
	Mission_SetAttr('current_monsters',0)
	Mission_SetAttr('first_tagged_played',0)
	Mission_SetAttr('wraiths_dead',0)
	Event_RegisterSink(EVENT_TEMPLATE_OBJ_DIED, 'WraithDead', 'wraith_warrior', '', 0, 0, 1)


	play(start_cs,'start_cs')
	FFX_InitMission()

def StandardWarpEffect(pos):
	ff.RENDER_WARP = 1
	Mission_SetWaveEnvelope(1, 0.35, 3, 0.35, 3, 1)
	Mission_SetWaveSinParams(1, 4, 0.04, 1)
	Mission_StartWave(1, 3, 1, pos)
	
def DelayedWarpEffect(pos, delay, offset = (0,0,0)):
	ff.warpPosHack = pos
	ff.warpOffsetHack = offset
	wait(delay, fn = 'EnhancedWarpStart')

def EnhancedWarpStart(event):
	EnhancedWarpEffect(ff.warpPosHack, ff.warpOffsetHack)
	
def EnhancedWarpEffect(pos, offset = (0,0,0)):
	ff.RENDER_WARP = 1
	Mission_SetWaveEnvelope(1, 0.35, 3, 0.35, 3, 1)
	Mission_SetWaveSinParams(3, 4, 0.04, 1)
	finalPos = (pos[0]+offset[0], pos[1]+offset[1], pos[2]+offset[2])
	Mission_StartWave(0.5, 1, 0.5, finalPos)
	
def Hole1Opened(event):
	Mission_CustomAction('send signature','','hole_1','Hole1Touched',3,0)

def Hole2Opened(event):
	SpawnPortal(2)
	addArrow('w21_arrow', 'wraith_2_1', js.ARROW_RED, delete=1)
	addArrow('w22_arrow', 'wraith_2_2', js.ARROW_RED, delete=1)
	Mission_CustomAction('send signature','','hole_2','Hole2Touched',3,0)
	teleport('entropy','green_room_entropy')

def Hole3Opened(event):
	SpawnPortal(3)
	Mission_CustomAction('send signature','','hole_3','Hole3Touched',3,0)
	teleport('entropy','green_room_entropy')

def Hole4Opened(event):
	SpawnPortal(4)
	addArrow('w41_arrow', 'wraith_4_1', js.ARROW_RED, delete=1)
	addArrow('w42_arrow', 'wraith_4_2', js.ARROW_RED, delete=1)
	Mission_CustomAction('send signature','','hole_4','Hole4Touched',3,0)
	teleport('entropy','green_room_entropy')

def Hole5Opened(event):
	SpawnPortal(5)
	addArrow('w51_arrow', 'wraith_5_1', js.ARROW_RED, delete=1)
	addArrow('w52_arrow', 'wraith_5_2', js.ARROW_RED, delete=1)
	Mission_CustomAction('send signature','','hole_5','Hole5Touched',3,0)
	teleport('entropy','green_room_entropy')

def Hole6Opened(event):
	SpawnPortal(6)
	addArrow('w61_arrow', 'wraith_6_1', js.ARROW_RED, delete=1)
	addArrow('w62_arrow', 'wraith_6_2', js.ARROW_RED, delete=1)
	addArrow('w63_arrow', 'wraith_6_3', js.ARROW_RED, delete=1)
	Mission_CustomAction('send signature','','hole_6','Hole6Touched',3,0)
	teleport('entropy','green_room_entropy')


def Hole1Touched(event,tagger):
	wd = Mission_GetAttr('wraiths_dead')
	if (Mission_GetAttr('first_tagged_played') == 0 and (wd < 2)):
		Mission_SetAttr('first_tagged_played',1)
		play(first_hole_tagged_ss,'first_hole_tagged_ss')
		removeArrow('hole_1_arrow')
	elif wd < 2:
		HoleGuarded()
	else:
		Hole1Tagged(event,tagger)
def Hole2Touched(event,tagger):
	wd = Mission_GetAttr('wraiths_dead')
	if wd < 4:
		HoleGuarded()
	else:
		Hole2Tagged(event,tagger)
def Hole3Touched(event,tagger):
	wd = Mission_GetAttr('wraiths_dead')
	if wd < 7:
		HoleGuarded()
	else:
		Hole3Tagged(event,tagger)
def Hole4Touched(event,tagger):
	wd = Mission_GetAttr('wraiths_dead')
	if wd < 9:
		HoleGuarded()
	else:
		Hole4Tagged(event,tagger)
def Hole5Touched(event,tagger):
	wd = Mission_GetAttr('wraiths_dead')
	if wd < 11:
		HoleGuarded()
	else:
		Hole5Tagged(event,tagger)
def Hole6Touched(event,tagger):
	wd = Mission_GetAttr('wraiths_dead')
	if wd < 14:
		HoleGuarded()
	else:
		Hole6Tagged(event,tagger)

def Hole1Tagged(event,tagger):
	Object_Destroy('hole_1')
	teleport('entropy','hole_2_marker')
	ClosePortal(1)
	removeArrow('hole_1_arrow')
	AI_Animate('entropy','active_defence')
	StartSpawnPortal(2, 'Hole2Opened')
	playEffectMarker('effect_entropy_spawn', 'w21_spawn_point', key = 'spawn', keyFn = 'W21Spawn')
	playEffectMarker('effect_entropy_spawn', 'w22_spawn_point', key = 'spawn', keyFn = 'W22Spawn')
	
def Hole2Tagged(event,tagger):
	Object_Destroy('hole_2')
	teleport('entropy','hole_3_marker')
	ClosePortal(2)
	removeArrow('hole_2_arrow')
	AI_Animate('entropy','active_defence')
	StartSpawnPortal(3, 'Hole3Opened')
	playEffectMarker('effect_entropy_spawn', 'w31_spawn_point', key = 'spawn', keyFn = 'W31Spawn')
	playEffectMarker('effect_entropy_spawn', 'w32_spawn_point', key = 'spawn', keyFn = 'W32Spawn')
	playEffectMarker('effect_entropy_spawn', 'w33_spawn_point', key = 'spawn', keyFn = 'W33Spawn')
	regTimer('Hole2Delay',1)

def Hole2Delay(event):
	play(second_hole_tagged_cs,'second_hole_tagged_cs')
	
def Hole3Tagged(event,tagger):
	Object_Destroy('hole_3')
	teleport('entropy','hole_4_marker')
	ClosePortal(3)
	removeArrow('hole_3_arrow')
	play(third_hole_tagged_ss,'third_hole_tagged_ss')
	AI_Animate('entropy','active_defence')
	StartSpawnPortal(4, 'Hole4Opened')
	playEffectMarker('effect_entropy_spawn', 'w41_spawn_point', key = 'spawn', keyFn = 'W41Spawn')
	playEffectMarker('effect_entropy_spawn', 'w42_spawn_point', key = 'spawn', keyFn = 'W42Spawn')
	
def Hole4Tagged(event,tagger):
	Object_Destroy('hole_4')
	teleport('entropy','hole_5_marker')
	ClosePortal(4)
	removeArrow('hole_4_arrow')
	play(fourth_hole_tagged_ss,'fourth_hole_tagged_ss')
	AI_Animate('entropy','active_defence')
	StartSpawnPortal(5, 'Hole5Opened')
	playEffectMarker('effect_entropy_spawn', 'w51_spawn_point', key = 'spawn', keyFn = 'W51Spawn')
	playEffectMarker('effect_entropy_spawn', 'w52_spawn_point', key = 'spawn', keyFn = 'W52Spawn')
	
def Hole5Tagged(event,tagger):
	Object_Destroy('hole_5')
	teleport('entropy','hole_6_marker')
	ClosePortal(5)
	removeArrow('hole_5_arrow')
	play(fifth_hole_tagged_ss,'fifth_hole_tagged_ss')
	AI_Animate('entropy','active_defence')
	StartSpawnPortal(6, 'Hole6Opened')
	playEffectMarker('effect_entropy_spawn', 'w61_spawn_point', key = 'spawn', keyFn = 'W61Spawn')
	playEffectMarker('effect_entropy_spawn', 'w62_spawn_point', key = 'spawn', keyFn = 'W62Spawn')
	playEffectMarker('effect_entropy_spawn', 'w63_spawn_point', key = 'spawn', keyFn = 'W63Spawn')
	
def Hole6Tagged(event,tagger):
	Object_Destroy('hole_6')
	ClosePortal(6)
	removeArrow('hole_6_arrow')
#	Object_SetPrimaryState(tagger,PCSTATE_STUNNED,5)
	play(final_cs, 'final_cs')


def W11Spawn(event):
	spawn('wraith_1_1','wraith_warrior','w11_spawn_point')
def W12Spawn(event):
	spawn('wraith_1_2','wraith_warrior','w12_spawn_point')
def W21Spawn(event):
	spawn('wraith_2_1','wraith_warrior','w21_spawn_point')
def W22Spawn(event):
	spawn('wraith_2_2','wraith_warrior','w22_spawn_point')
def W31Spawn(event):
	spawn('wraith_3_1','wraith_warrior','w31_spawn_point')
	addKillAllGoal('wraith_3_1',OC_CIVILIAN)
def W32Spawn(event):
	spawn('wraith_3_2','wraith_warrior','w32_spawn_point')
def W33Spawn(event):
	spawn('wraith_3_3','wraith_warrior','w33_spawn_point')
def W41Spawn(event):
	spawn('wraith_4_1','wraith_warrior','w41_spawn_point')
	addKillAllGoal('wraith_4_1',OC_CIVILIAN)
def W42Spawn(event):
	spawn('wraith_4_2','wraith_warrior','w42_spawn_point')
def W51Spawn(event):
	spawn('wraith_5_1','wraith_warrior','w51_spawn_point')
	addKillAllGoal('wraith_5_1',OC_CIVILIAN)
def W52Spawn(event):
	spawn('wraith_5_2','wraith_warrior','w52_spawn_point')
def W61Spawn(event):
	spawn('wraith_6_1','wraith_warrior','w61_spawn_point')
	addKillAllGoal('wraith_6_1',OC_CIVILIAN)
def W62Spawn(event):
	spawn('wraith_6_2','wraith_warrior','w62_spawn_point')
	addKillAllGoal('wraith_6_2',OC_CIVILIAN)
def W63Spawn(event):
	spawn('wraith_6_3','wraith_warrior','w63_spawn_point')


def WraithDead(event):
	wd = Mission_GetAttr('wraiths_dead')+1
	Mission_SetAttr('wraiths_dead',wd)
	if wd == 2:
		HoleUnGuarded()
		addArrow('hole_1_arrow', 'hole_1', js.ARROW_RED, delete=1)
	elif wd == 4:
		HoleUnGuarded()
		addArrow('hole_2_arrow', 'hole_2', js.ARROW_RED, delete=1)
	elif wd == 7:
		HoleUnGuarded()
		addArrow('hole_3_arrow', 'hole_3', js.ARROW_RED, delete=1)
	elif wd == 9:
		HoleUnGuarded()
		addArrow('hole_4_arrow', 'hole_4', js.ARROW_RED, delete=1)
	elif wd == 11:
		HoleUnGuarded()
		addArrow('hole_5_arrow', 'hole_5', js.ARROW_RED, delete=1)
	elif wd == 14:
		HoleUnGuarded()
		addArrow('hole_6_arrow', 'hole_6', js.ARROW_RED, delete=1)
		if Mission_GetAttr('current_monsters') == 0:
			Objective_Complete('save_civs')

def HoleGuarded():
	temp = randint(0,2)
	if temp == 0:
		forceSpeakNoCB('mentor', 'MISSPCH_20_ME_03')
	elif temp == 1:
		forceSpeakNoCB('mentor', 'MISSPCH_20_ME_20')
	elif temp == 2:
		forceSpeakNoCB('mentor', 'MISSPCH_20_ME_21')
	else:
		print "bad random number in HoleGuarded???"
def HoleUnGuarded():
	temp = randint(0,2)
	if temp == 0:
		forceSpeakNoCB('mentor', 'MISSPCH_20_ME_22')
	elif temp == 1:
		forceSpeakNoCB('mentor', 'MISSPCH_20_ME_23')
	elif temp == 2:
		forceSpeakNoCB('mentor', 'MISSPCH_20_ME_24')
	else:
		print "bad random number in HoleUnGuarded???"




def PrepMonsterCivs():
#	Event_RegisterSink(EVENT_TEMPLATE_OBJ_DIED, 'MonsterCiv', 'cop', '', 0, 0, 1)
#	Event_RegisterSink(EVENT_TEMPLATE_OBJ_DIED, 'MonsterCiv', 'civilian_female', '', 0, 0, 1)
#	Event_RegisterSink(EVENT_TEMPLATE_OBJ_DIED, 'MonsterCiv', 'civilian_male', '', 0, 0, 1)
	regDeath('civ1','MonsterCiv')
	regDeath('cop1','MonsterCiv')
	regDeath('cop2','MonsterCiv')
	regDeath('cop3','MonsterCiv')
	regDeath('civilian_female_1','MonsterCiv')
	regDeath('civilian_female_2','MonsterCiv')
	regDeath('civilian_female_3','MonsterCiv')
	regDeath('civilian_female_4','MonsterCiv')
	regDeath('civilian_female_5','MonsterCiv')
	regDeath('civilian_female_6','MonsterCiv')
	regDeath('civilian_male_1','MonsterCiv')
	regDeath('civilian_male_2','MonsterCiv')
	regDeath('civilian_male_3','MonsterCiv')
	regDeath('civilian_male_4','MonsterCiv')
	regDeath('civilian_male_5','MonsterCiv')
	regDeath('civilian_male_6','MonsterCiv')

def IsAWraith(killer):
	if killer == 'wraith_3_1':
		return 1
	elif killer == 'wraith_3_2':
		return 1
	elif killer == 'wraith_3_3':
		return 1
	elif killer == 'wraith_4_1':
		return 1
	elif killer == 'wraith_4_2':
		return 1
	elif killer == 'wraith_5_1':
		return 1
	elif killer == 'wraith_5_2':
		return 1
	elif killer == 'wraith_6_1':
		return 1
	elif killer == 'wraith_6_2':
		return 1
	elif killer == 'wraith_6_3':
		return 1
	else:
		return 0

def MonsterCiv(event):
	print event.string
	if IsAWraith(event.string) or Mission_GetAttr('force_monster'):
		addAttr('civ_monster_index',1)
		addAttr('current_monsters',1)
		mondex = Mission_GetAttr('civ_monster_index')
		print "monsterciv index"
		print mondex
		totalmons = Mission_GetAttr('current_monsters')
		print "current monsterciv total"
		print totalmons
		loc=Get_ObjectPos(event.object)
		print loc
		rot=Object_GetOrientation(event.object)
		Marker_Spawn('mc_spawn_' + str(int(mondex)),loc,rot[1])
		playEffect('effect_entropy_spawn', loc, rot[1], key = 'spawn', keyFn = 'MonsterCiv2')
#		Sound_PlaySound('temporalhole_opening', loc)
		Object_Destroy(event.object)
	else:
		print "not wraith-ed"

def MonsterCiv2(event):
	mondex = Mission_GetAttr('civ_monster_index')
	monster=PickAMonster()
	Object_Spawn('civ_mon_' + str(int(mondex)),monster,'mc_spawn_' + str(int(mondex)))
	regDeath('civ_mon_' + str(int(mondex)),'CivMonDead')
	addArrow('cm_arrow_' + str(int(mondex)), 'civ_mon_' + str(int(mondex)), js.ARROW_YELLOW, delete=1)


def CivMonDead(event):
	addAttr('civ_monster_index',1)
	addAttr('current_monsters',-1)
	mondex = Mission_GetAttr('civ_monster_index')
	print "monsterciv index"
	print mondex
	totalmons = Mission_GetAttr('current_monsters')
	print "current monsterciv total"
	print totalmons
	loc=Get_ObjectPos(event.object)
	print loc
	rot=Object_GetOrientation(event.object)
	Marker_Spawn('mc_spawn_' + str(int(mondex)),loc,rot[1])
	playEffect('effect_entropy_spawn', loc, rot[1], key = 'spawn', keyFn = 'CivMonDead2')
#	Sound_PlaySound('temporalhole_opening', loc)
	Object_Destroy(event.object)
	if (Mission_GetAttr('wraiths_dead') == 14) and (Mission_GetAttr('current_monsters') == 0):
		Objective_Complete('save_civs')

def CivMonDead2(event):
	mondex = Mission_GetAttr('civ_monster_index')
	civ=PickACiv()
	Object_Spawn('new_civ_' + str(int(mondex)),civ,'mc_spawn_' + str(int(mondex)))
	regDeath('new_civ_' + str(int(mondex)),'MonsterCiv')
	if civ == 'civilian_male':
		MaleThanks()
	elif civ == 'civilian_female':
		FemaleThanks()

# NOTE: if you change these, please change the precached objects too!!!
def PickAMonster():
	temp = randint(0,5)
#	temp = randint(0,4)
	print "choosing monster number"
	print temp
	if temp == 0:
		return 'bacchite_green'
#		return 'dark_shaman'
	elif temp == 1:
		return 'alien_warrior'
#		return 'eye_minor'
	elif temp == 2:
		return 'killarilla_whip'
	elif temp == 3:
		return 'mech_man'
#		return 'subterrestrial'
	elif temp == 4:
#		return 'dejavu_clone'
		return 'nazi_gunner'
	elif temp == 5:
		return 'ice_queen'

def PickACiv():
	temp = randint(0,1)
	print "choosing civ number"
	print temp
	if temp == 0:
		return 'civilian_female'
	elif temp == 1:
		return 'civilian_male'

def MaleThanks():
	temp = randint(0,2)
	print "choosing thanks line"
	print temp
	if temp == 0:
		forceSpeakNoCB('civilian_male','MISSPCH_20_M1_01', telepathy=0)
	elif temp == 1:
		forceSpeakNoCB('civilian_male','MISSPCH_20_M2_01', telepathy=0)
	elif temp == 2:
		forceSpeakNoCB('civilian_male','MISSPCH_20_M3_01', telepathy=0)
def FemaleThanks():
	temp = randint(0,2)
	print "choosing thanks line"
	print temp
	if temp == 0:
		forceSpeakNoCB('civilian_female','MISSPCH_20_F1_01', telepathy=0)
	elif temp == 1:
		forceSpeakNoCB('civilian_female','MISSPCH_20_F2_01', telepathy=0)
	elif temp == 2:
		forceSpeakNoCB('civilian_female','MISSPCH_20_F2_02', telepathy=0)



def OnMissionWon():
	print "disappear/won"

def OnMissionLost():
	print "disappear/lost"

#functions for CS
def SpawnEntropy(event):
	spawn('entropy', 'entropy', 'entropy_pos0')
	Object_SetAttr('entropy','minHealth',20)
	makePeaceful('entropy')

def EntropyLeaves(event):
	teleport('entropy','green_room_entropy')

def SpawnPortal(number):
	name = 'hole_' + `number`
	spawn(name,'portal_core', name + '_marker')
	Object_PlayEffect(name, 'effect_portal_steady', '', FX_LOOP)
#	soundHandle = Sound_CreateSound_HANDLE('temporalhole_loop')
#	Sound_PlaySound_HANDLE(soundHandle)
#	Sound_AttachSound_HANDLE(soundHandle, name)

def StartSpawnPortal(number, callback, delayedWarp = 0):
	markerName = 'hole_' + `number` + '_marker'
	playEffectMarker('effect_portal_open', markerName, fn = callback)
#	Sound_PlaySound('temporalhole_opening', Get_MarkerPos(markerName))
	if delayedWarp:
		DelayedWarpEffect(Get_MarkerPos(markerName), 0.5, (0,0,30))
	else:
		StandardWarpEffect(Get_MarkerPos(markerName))

def ClosePortal(number):
	markerName = 'hole_' + `number` + '_marker'
	playEffectMarker('effect_portal_close', markerName)
#	Sound_PlaySound('temporalhole_closing', Get_MarkerPos(markerName))
	

def SetupFinalHeroes():
	reviveHeroes()
	teleport('hero_1', 'endcs_heropos1')
	teleport('hero_2', 'endcs_heropos2')
	teleport('hero_3', 'endcs_heropos3')
	teleport('hero_4', 'endcs_heropos4')
	destroyAllByTemplate('minute_man')
	destroyAllByTemplate('sea_urchin')
	spawn('minute_man','minute_man','endcs_mmpos1')


#										 #
# cutscenes and scripted sequences below  #
#										 #

start_cs = [
(
	"see()",
	"peace()",
	"startCS()",
	"lookAtPos((45,43,0), zoom = -245, pitch = 0, heading = 15)",
	"speak('man_bot', 'MISSPCH_20_MB_06', CAPTION_TOP_LEFT)",
),
(
	"speak('the_ant', 'MISSPCH_20_AN_04', CAPTION_TOP_RIGHT)",
),
(
	"Sound_PlayMusic('music_12dis_cs1',1)",
	"speak('mentor', 'MISSPCH_20_ME_13', CAPTION_TOP_LEFT)",
),
(
	"lookAtPos((314,-732,18), zoom = -218.4, pitch = -3, heading = -112.8)",
	"ff.StartSpawnPortal(1, 'onStepCB', 1)",
),
(
	"ff.SpawnPortal(1)",
	"playEffectMarker('effect_entropy_spawn', 'entropy_pos0', fn = 'onStepCB', key = 'spawn', keyFn = 'SpawnEntropy')",
),
(
	"speak('mentor', 'MISSPCH_20_ME_14', CAPTION_TOP_LEFT)",
	"move('entropy', 'entropy_pos1', radius = 0)",
),
(
	"AI_Animate('entropy','active_defence', '', 0, 0)",
	"playEffectMarker('effect_entropy_spawn', 'w11_spawn_point', key = 'spawn', keyFn = 'W11Spawn')",
	"playEffectMarker('effect_entropy_spawn', 'w12_spawn_point', key = 'spawn', keyFn = 'W12Spawn')",
	"ff.EnhancedWarpEffect(Get_MarkerPos('hole_1_marker'), (0,0,30))",
	"wait(3)",
),
(
	"playEffectMarker('effect_entropy_spawn', 'entropy_pos0', fn = 'onStepCB', key = 'spawn', keyFn = 'EntropyLeaves')",
),
(
	"lookAtPos((45,43,0), zoom = -245, pitch = 0, heading = 15)",
	"speak('mentor', 'MISSPCH_20_ME_15', CAPTION_TOP_LEFT)",
),
(
	"speak('tricolour', 'MISSPCH_20_TC_06', CAPTION_TOP_RIGHT)",	
),
(
	"speak('the_ant', 'MISSPCH_20_AN_05', CAPTION_TOP_RIGHT)",
),
(
	"ff.Hole1Opened(1)",
	"blind()",
	"war()",
	"Sound_PlayMusic('music_03red2')",
	"newObjective('primary', 1, name='tag_holes')",
	"addArrow('hole_1_arrow', 'hole_1', js.ARROW_RED, delete=1)",
	"endCS()",
),
]


first_hole_tagged_ss = [
(
	"speak('mentor', 'MISSPCH_20_ME_03')",
),
(
	"addArrow('w11_arrow', 'wraith_1_1', js.ARROW_RED, delete=1)",
	"addArrow('w12_arrow', 'wraith_1_2', js.ARROW_RED, delete=1)",
	"speak('entropy', 'MISSPCH_20_EN_02')",
),
(
	"blank",
),
]

second_hole_tagged_cs = [
(
	"spawn('civ1','civilian_male','civ1_spawn_point')",
	"#walk('civ1','civ1_walk_marker')",
	"peace()",
	"see()",
	"Mission_SetAttr('force_monster',1)",
	"startCS()",
	"look('hole_3_marker', zoom = -50, heading = 250, time = 0)",
	"Sound_PlayMusic('music_11elem_stdead1')",
	"speak('entropy', 'MISSPCH_20_EN_03')",
),
(
	"look('w31_spawn_point', zoom = -150, heading = 280, time = 2)",
	"ff.PrepMonsterCivs()",
	"AI_Animate('wraith_3_1','melee')",
	"wait(2)",
),
(
	"kill('civ1')",
	"speak('mentor', 'MISSPCH_20_ME_19')",
),
(
	"speak('entropy', 'MISSPCH_20_EN_20')",
),
(
	"Mission_SetAttr('force_monster',0)",
	"newObjective('secondary', 1, name='save_civs')",
	"addArrow('w31_arrow', 'wraith_3_1', js.ARROW_RED, delete=1)",
	"addArrow('w32_arrow', 'wraith_3_2', js.ARROW_RED, delete=1)",
	"addArrow('w33_arrow', 'wraith_3_3', js.ARROW_RED, delete=1)",
	"endCS()",
	"blind()",
	"war()",
	"Sound_PlayMusic('music_03red2')",
),
]

third_hole_tagged_ss = [
(
	"speak('mentor', 'MISSPCH_20_ME_04')",
),
(
	"speak('entropy', 'MISSPCH_20_EN_05')",
),
(
	"blank",
),
]

fourth_hole_tagged_ss = [
(
	"speak('mentor', 'MISSPCH_20_ME_05')",
),
(
	"speak('entropy', 'MISSPCH_20_EN_06')",
),
(
	"blank",
),
]

fifth_hole_tagged_ss = [
(
	"speak('mentor', 'MISSPCH_20_ME_06')",
),
(
	"speak('entropy', 'MISSPCH_20_EN_07')",
),
(
	"blank",
),
]



final_cs = [
(
	"startCS()",
	"peace()",
	"see()",
	"Objective_Complete('tag_holes')",
	"lookAtPos((151,-310,20), zoom = -208.0, heading =  62.8)",
	"playEffectMarker('effect_entropy_spawn', 'endcs_tmpos1', key = 'spawn', keyFn = 'onStepCB')",
	"ff.EnhancedWarpEffect(Get_MarkerPos('endcs_tmpos1'))",
),
(
	"peace()",
	"Sound_PlayMusic('music_09blitz_tm')",
	"spawn('time_master','time_master','endcs_tmpos1')",
	"AI_SetEnabled('time_master',0)",
	"null()",
),
(
	"peace()",
	"lookAtPos((151,-310,182), zoom = -218.0, heading = 62.8, time = 5)",
	"wait(5)",
),
(
	"peace()",

	"speak('time_master','MISSPCH_20_TM_01', CAPTION_TOP_LEFT)", #what is this...
	"ff.SetupFinalHeroes()",
),
(
	"lookAtPos((162,-328,7), zoom = -205.7, heading = -88.6)",
	"speak('minute_man','MISSPCH_20_MM_04', CAPTION_BOTTOM_LEFT)", #you must help us defeat entropy
	"move('minute_man', 'endcs_mmpos2', radius = 0)",
),
(
	"lookAtPos((280,-330,2), zoom = -130.5, pitch = -23, heading = 50.2)",
	"speak('time_master','MISSPCH_20_TM_02', CAPTION_TOP_LEFT)", #time master answers to no man
	"spawn('sea_urchin', 'sea_urchin', 'endcs_supos1')",
	"makePeaceful('sea_urchin')",
),
(
	"lookAtPos((162,-328,7), zoom = -205.7, heading = -88.6)",
	"speak('minute_man','MISSPCH_20_MM_05', CAPTION_TOP_LEFT)", #no! our plan has backfired!
	"AI_Animate('minute_man', 'melee_idle', '', 0, 1)",
),
(
	"speak('sea_urchin','MISSPCH_20_SU_01', CAPTION_BOTTOM_LEFT)", #umm, timey?
	"move('sea_urchin', 'endcs_supos2', radius = 0)",
),
(
	"lookAtPos((101,-374,-8), zoom = -102.8, heading = -180.8)",
	"speak('time_master','MISSPCH_20_TM_03', CAPTION_BOTTOM_LEFT)", #who is this gnat...
	"turnTo('sea_urchin', 'time_master')",
),
(
	"speak('sea_urchin','MISSPCH_20_SU_02', CAPTION_TOP_RIGHT)", #you're a smart guy,
),
(
	"speak('time_master','MISSPCH_20_TM_09', CAPTION_BOTTOM_LEFT)", #this insect questions the intelligence 
),
(
	"lookAtPos((106,-396,-8), zoom = -244.2, heading = -190.9)",
	"speak('sea_urchin','MISSPCH_20_SU_03', CAPTION_BOTTOM_RIGHT)", #duh! it was a detorical question!
),
(
	"speak('time_master','MISSPCH_20_TM_10', CAPTION_TOP_LEFT)", #time master is fully aware of entropy.
),
(
	"speak('sea_urchin','MISSPCH_20_SU_04', CAPTION_BOTTOM_RIGHT)", #really? then aren't you wigging out?
),
(
	"lookAtPos((101,-374,-8), zoom = -102.8, heading = -180.8)",
	"speak('time_master','MISSPCH_20_TM_11', CAPTION_BOTTOM_LEFT)", #"wigging?"
),
(
	"speak('sea_urchin','MISSPCH_20_SU_05', CAPTION_TOP_RIGHT)", #now i don't know much about science,
),
(
	"speak('sea_urchin','MISSPCH_20_SU_06', CAPTION_TOP_RIGHT)", #...then why wouldn't a big smarty pants
),
(
	"lookAtPos((280,-330,2), zoom = -130.5, pitch = -23, heading = 50.2)",
	"speak('time_master','MISSPCH_20_TM_12', CAPTION_TOP_LEFT)", #time master will destroy you
),
(
	"speak('time_master','MISSPCH_20_TM_13', CAPTION_TOP_LEFT)", #but -- i shall postpone 
),
(
	"endCS()",
	"Mission_Win()",
),
]
