chemicals=('barrel','cub_military_crate','cub_fuel_barrels','cuban_missile','ger_barrel','ger_crate_ammo','nazihq_storage_crate','red_int_cauldron','truck_ger_ammo')

waters=('fire_tank','water_tower','ffx_icewall','ffx_icepatch','fountain','fire_hydrant',
'snow_man','ffx_icewall','pat_fire_hydrant')

lights=('streetlight','streetlight_day','streetlight_night','trafficlight',
'ger_streetlamp','ger_streetlamp_night','pat_streetlight','pat_streetlight_night','pat_park_lamp','pat_park_lamp_night','pat_trafficlight','cub_street_lamp',
'pat_neon_sign','pat_neon_signanim_a','pat_neon_signanim_b','pat_neon_signanim_c','ger_searchlight','ger_searchlight_day')

machines=('processor','processor_animated','computer','fusebox','regulator','shield_dish','shield_box','conveyor',
'nazihq_lab_machine_1','nazihq_lab_machine_2','nazihq_lab_machine_3','nazihq_lab_machine_4','nazihq_lab_machine_5','nazihq_lab_machine_6','nazihq_lab_machine_7',
'nazihq_temporal_amplifier','nazihq_hypno_sphere','blitz_shield_emitter','blitz_shield_generator','pat_fusebox')

rocks=('building_debris_0','sand_pile','boulder_door','boulder_immovable','boulder_large','boulder_med','boulder_small','boulder_large_snowy','boulder_med_snowy','boulder_small_snowy','red_int_rock_formation1','red_int_rock_formation2','red_int_rock_formation3','red_int_rock_formation4','red_int_stalagmite',
'pat_bldg_deb')

petrols=('car_1','car_2','car_3','car_1_night','car_2_night','car_3_night','mp_car')

transmutables=(
('CUSTOM_LEAD','throwable','OnIncMass'),
('CUSTOM_GLASS','throwable','OnDecMass'),
('CUSTOM_NEON','solid','OnHarmlessGas'),
('CUSTOM_CHLORINE','metal','OnAcidGas'),
('CUSTOM_MAGNESIUM',lights,'OnFlashGas'),
('CUSTOM_SODIUM',waters,'OnHeatExplode'),
('CUSTOM_URANIUM',chemicals,'OnMakeUranium'),
('CUSTOM_HYDROGEN',chemicals,'OnMakeHydrogen'),
('CUSTOM_MINERAL',rocks,'OnTurnIntoMineral'),
('CUSTOM_HYDROGEN',rocks,'OnMakeHydrogen'),
('CUSTOM_SHORTOUT',machines,'OnShortOut'),
)

#name, target object(s), function, weapon command, weapon use function
assimilations=[
('headlamp',lights,'OnHeadlamp','ffx_flash','onAssimFlash'),
('firemitts',petrols,'OnFiremitts','ffx_flamethrower','onAssimFlame'),
('waterhose','pat_fire_hydrant','OnWaterhose','ffx_water_jet','onAssimWaterhose'),
]

naturalise=[
('streetlight','pat_flora_tree_large'),
('streetlight_day','pat_flora_tree_large'),
('streetlight_night','pat_flora_tree_large'),
('trafficlight','pat_flora_tree_large'),
('ger_streetlamp','pat_flora_tree_large'),
('ger_streetlamp_night','pat_flora_tree_large'),
('pat_streetlight','pat_flora_tree_large'),
('pat_streetlight_night','pat_flora_tree_large'),
('pat_park_lamp','pat_flora_tree_large'),
('pat_park_lamp_night','pat_flora_tree_large'),
('pat_trafficlight','pat_flora_tree_large'),
('cub_street_lamp','pat_flora_tree_large'),
]

borgise=[
('streetlight','ffx_borgstack'),
('streetlight_day','ffx_borgstack'),
('streetlight_night','ffx_borgstack'),
('trafficlight','ffx_borgstack'),
('ger_streetlamp','ffx_borgstack'),
('ger_streetlamp_night','ffx_borgstack'),
('pat_streetlight','ffx_borgstack'),
('pat_streetlight_night','ffx_borgstack'),
('pat_park_lamp','ffx_borgstack'),
('pat_park_lamp_night','ffx_borgstack'),
('pat_trafficlight','ffx_borgstack'),
('cub_street_lamp','ffx_borgstack'),
]
