ENC_CUSTOM_TYPES = {
	'building rampage': 'villains fight heroes, villains and minions attack buildings',
	'chat': 'villains fight heroes, allies want to chat, allies do not fight',
	'destroy object': 'villains fight heroes, heroes destroy objects, allies fight villains, allies destroy objects',
	'disarm bomb': 'villains fight heroes, allies fight villains, disarm bomb',
	'escort': 'villains fight heroes, allies fight villains, heroes escort allies',
	'examine': 'villains fight heroes, allies fight villains, object can be examined',
	'fight': 'villains fight heroes, allies fight villains',
	'flee the scene': 'villains fight heroes, allies fight villains, villains and minions flee',
	'guard object': 'villains fight heroes, allies fight villains, villains attack object, villains start at distance, minions start at distance',
	'heist': 'villains fight heroes, allies fight villains, villains want item, villains only flee with item, item starts on ground, heroes pickup item',
	'hunt': 'villains fight heroes, allies fight villains, villains hunt heroes',
	'hurricane': 'immediate hurricane, immediate timed encounter',
	'immediate building rampage': 'villains fight heroes, villains and minions attack buildings, villains start immediately, minions start immediately, allies start immediately',
	'immediate flee the scene': 'villains fight heroes, villains and minions flee, villains start immediately, minions start immediately',
	'immediate rampage': 'villains fight heroes, allies fight villains, villains and minions rampage, villains start immediately, minions start immediately, allies start immediately',
	'interrogation': 'villains fight heroes, allies fight villains, villains can be interrogated',
	'rampage': 'villains fight heroes, allies fight villains, villains and minions rampage',
	'sabotage': 'villains fight heroes, allies fight villains, heroes sabotage object',
	'save civilian': 'villains fight heroes, villains attack innocent allies, allies thank heroes, allies do not fight',
	'snatch': 'villains fight heroes, villains start with item, villains only flee with item, heroes return item to allies, heroes pickup item',
	
	'rival factions': 'villains fight heroes, allies fight villains, rivals fight villains',
	
	'rescue frozen': 'allies frozen, villains fight heroes, allies can be freed',
	'rescue fire': 'allies can be freed, heroes rescue allies, allies cower, allies congregate, fire, villains fight heroes',
	'rescue caged': 'allies do not move, allies can be freed, allies move when freed, allies in cages, allies thank heroes, villains fight heroes',
	'one shot power trap': 'item exists, item starts on ground, item has power, item uses power on heroes, item uses power once',
	'switchable power trap': 'item exists, item starts on ground, item has power, item uses power on heroes, switches exist, item can be switched off, item is invulnerable',
}

ENC_DEPENDENCIES = {
	'disarm bomb': ['immediate countdown'],
	'heroes return item to allies': ['item exists'],
	'villains hunt heroes': ['villains start immediately', 'minions start immediately'],
	'villains only flee with item': ['villains flee', 'villains want item'],
	'villains want item': ['item exists'],
}
