#####################################################################################
#
# Module: Name
# Author: m25
# 
# Description: generate unique names
#
#
# Version 3.052
#
#####################################################################################

#print "Loading m25name.py v.3.2.0 final; branch = m25 branch 1"

from ff import *
from js import *

def GetNextObjectName(prefix=''):
	namenum = 1
	try:
		namenum = Mission_GetAttr('objectnamenum')
	except:
		namenum = 1
	done,name = 0, ''
	while not done:
		namenum = namenum + 1
		if prefix == '':
			name = 'm25obj_%i'%(int(namenum))
			if not js.Object_Exists(name): done = 1
		else:
			name = prefix + '_' + `int(namenum)`
			if not js.Object_Exists(name): done = 1
	Mission_SetAttr('objectnamenum',namenum+1)
	return name
