import cshelper
import js

from cshelper import *
from js import *
from ffx import *
from m25skirmish import *

import sk

monsters = []

def OnEnemyKilled(event):
	sk.OnEnemyKilled(event)
	total = int(Mission_GetAttr('total'))
	if (total == 0):
		wave = int(Mission_GetAttr('wave'))
		if (wave == len(monsters)):
			sk.WinMission()
		else:
			sk.ReviveHeroes()
			regTimer('SpawnNextWave', 3)

def GenerateWave():
	global monsters
	wave_data = []
	wave = int(Mission_GetAttr('wave'))
	num_enemies = randint(1,5)
	for i in range(0, 5):
		start = min(max(wave, 0), len(monsters)-1)
		end = min(max(wave+5, 0), len(monsters)-1)
		group = [monsters[randint(start, end)],1]
		print group, CountElements(group[0],monsters)
		if CountElements(group,wave_data) < CountElements(group[0],monsters):
			print 'adding ', group
			wave_data.append(group)
	return wave_data
		
def CountElements(el,lista):
	count = 0
	for e in lista:
		if e == el:
			count = count + 1
	return count	
	
def SpawnNextWave(event):
	wave = int(Mission_GetAttr('wave'))
	sk.SpawnWave(GenerateWave())
	Mission_SetAttr('wave', wave+1)

def OnPostInit():
	sk.PreSetup()
	sk.Setup()
	SpawnNextWave('')
	SetupFFXSkirmish()

def OnSelectionRequiredCheck():
	return 1
	
def OnNumEnemiesCheck():
	return 24

def OnGameTypeCheck():
	return sk.GetStandardMarkerNames()
	
def OnReceiveSelectedEnemies(enemies):
	global monsters
	sk.PreSetup()
	for enemy in enemies:
		if enemy == '---Buddies---':
			m25getset.SetMissionVar('buddies',1)
		elif enemy == '------------':
			if m25getset.GetMissionVar('buddies',default=0):
				m25getset.SetMissionVar('buddies',0)
		else:
			if m25getset.GetMissionVar('buddies',default=0):
				name = GenerateName(enemy)
				loc = m25GetSpawnLoc(m25ai.TEAM_GOODGUYS)
				Object_SpawnAt(enemy, loc, name)
				SkirmishSetUpEnemy(name)
				SkirmishSetupAI(name, m25ai.TEAM_GOODGUYS)
			else:
				monsters.append(enemy)
