import cshelper
import js

from cshelper import *
from js import *
from ffx import *

from m25ai import *
import m25missionover

from m25skirmish import *

import sk

def OnPostInit():
    FFX_InitSkirmish()
    StartAI()
    see()
    return

def StartAI():
	m25ai.InitScripts()
	all = js.Mission_GetDynamicObjects()
	team = 2
	for a in all:
		if not js.Object_GetAttr(a,'physical'):
			m25ai.AIDisable(a)
			m25ai.SetTeam(a,TEAM_NONCOMBATANT)
		elif js.Object_GetClass(a) & js.OC_CONTROLLABLE:
			m25ai.SetTeam(a,TEAM_GOODGUYS)
			m25ai.AIDisable(a)
		else:
			m25ai.SetupAI(a)
			m25ai.SetTeam(a,team)
			m25ai.SetTeamsNeutral(TEAM_NONCOMBATANT,team)
			team = team + 1
			m25ai.AddGoal_HuntEnemy(a)
			m25ai.SetBrawler(a)

def OnEnemyKilled(event):
	SkirmishModeCheckEnd('')
#   sk.OnEnemyKilled(event)
#    total = Mission_GetAttr('total')
#    if (total == 0):
#        m25missionover.SetMissionOver()
#        sk.WinMission()

def OnNoMoreBadGuys():
    if m25missionover.GetMissionOver():
        return
    m25missionover.SetMissionOver()
    sk.WinMission()

def OnReceiveSelectedEnemies(enemies):
    sk.PreSetup()
    markerList = sk.GenerateMarkerList(24)
    for enemy in enemies:
        if len(markerList)>0:
            markerNumber = markerList.pop(0)
        else:
            markerNumber = randint(1,24)
        print 'try to spawn ' + enemy
        sk.SpawnEnemy(enemy, 0, markerNumber)
                   
def OnSelectionRequiredCheck():
    return 1

def OnNumEnemiesCheck():
    return 24

def OnGameTypeCheck():
    return sk.GetStandardMarkerNames()