import cshelper
import js

from cshelper import *
from js import *
from ffx import *
from m25skirmish import *

import sk

waves_data = (
    [('darkman_blue', 1),],
    [('darkman_blue', 2),],
    [('darkman_purple', 1),],
    [('darkman_blue', 1), ('darkman_purple', 1),],
    [('darkman_blue', 1), ('darkman_purple', 1), ('ant_worker', 2),],
    [('darkman_blue', 2), ('darkman_purple', 2),],
    [('shadow', 1),],
    [('darkman_blue', 2), ('ant_soldier', 2),],
    [('darkman_blue', 3), ('darkman_purple', 2),],
    [('darkman_blue', 3), ('ant_soldier', 3),],
    [('shadow', 1), ('darkman_blue', 2), ('darkman_purple', 1),],
    [('shadow', 1), ('darkman_blue', 2), ('darkman_purple', 2),],
    [('darkman_purple', 3), ('ant_worker', 1), ('ant_soldier', 2),],
    [('shadow', 1), ('darkman_blue', 4),],
    [('darkman_purple', 5),],
    [('ant_soldier', 6),],
    [('shadow', 1), ('darkman_purple', 4),],
    [('shadow', 1), ('darkman_blue', 2), ('darkman_purple', 3),],
    [('shadow', 2), ('darkman_blue', 2), ('darkman_purple', 2),],
    [('shadow', 2), ('darkman_purple', 4),],
)


def OnEnemyKilled(event):
    doNothing=0

def OnNoMoreBadGuys():
    sk.ReviveHeroes()
    sk.AwardBonus()
    if Mission_GetAttr('wave')<len(waves_data):
        sk.StartBonus()
    wave = int(Mission_GetAttr('wave'))
    if (wave == len(waves_data)):
        sk.WinMission()
    else:
        sk.SpawnNextWaveDelay()
        return 1

def SpawnNextWave(event):
    sk.SpawnNextWave(waves_data, fx = 'effect_entropy_spawn')

def OnPostInit():
    sk.SetupRace(waves_data, fx = 'effect_entropy_spawn')
    SetupFFXSkirmish()

def OnSelectionRequiredCheck():
    return 0

def OnGameTypeCheck():
    return sk.GetStandardMarkerNames()

def OnBonusChange(event):
    sk.OnBonusChange(event)