import cshelper
import js

from cshelper import *
from js import *
from ffx import *
from m25skirmish import *

import sk

monsters = [
	'thug_with_bat',
	'thug_with_gun',
	'nazi_rifleman',
	'cop_crooked',
	'ice_trooper',
	'thug_with_grenade',
	'sukhov',
	'nazi_gunner',
	'darkman_blue',
	'fire_elemental',
	'raptor',
	'nazi_grenadier',
	'mafioso',
	'snow_man',
	'raptor_bezerk',
	'ant_soldier',
	'nazi_general',
	'raptor_boss',
	'legionnaire',
	'ice_sergeant',
	'duplicate_bat_thug',
	'dark_shaman',
	'ice_queen',
	'shurale',
	'darkman_purple',
	'duplicate_male',
	'wraith_warrior',
	'duplicate_gun_thug',
	'red_sun',
	'bacchite_green',
	'duplicate_fem',
	'centurion',
	'mech_man',
	'subterrestrial',
	'bacchite_red',
	'duplicate_cop',
	'killarilla_whip',
	'mech_man_flame',
	'killarilla_chaingun',
	'bacchite_silver',
	'alien_warrior',
	'nuclear_winter',
	'frozen_giant',
	'alien_sergeant',
	'manbull',
	'red_oktober',
	'time_master_elec',
	'eye_minor',
	'time_master_energy',
	'dominion',
	'wraith_manta',
	'time_master_radiation',
	'pin_stripe',
	'eye_major',
	'praetor',
	'shadow',
	'dejavu',
	'trex',
	'fortissimo',
	'mr_mechanical',
	'pan',
	'time_master',
	'blitzkrieg',
	'entropy',
]

def OnEnemyKilled(event):
	sk.OnEnemyKilled(event)
	total = int(Mission_GetAttr('total'))
	if (total == 0):
		sk.AwardBonus()
		wave = int(Mission_GetAttr('wave'))
		if (wave == len(monsters)):
			sk.WinMission()
		else:
			regTimer('SpawnNextWave', 3)
			sk.StartBonus()
			sk.ReviveHeroes()

def GenerateWave():
	wave_data = []
	wave = int(Mission_GetAttr('wave'))
	for i in range(0, 5):
		start = min(max(wave, 0), len(monsters)-1)
		end = min(max(wave+5, 0), len(monsters)-1)
		group = [monsters[randint(start, end)], 1]
		wave_data.append(group)
	return wave_data

def SpawnNextWave(event):
	wave = int(Mission_GetAttr('wave'))
	sk.SpawnWave(GenerateWave())
	Mission_SetAttr('wave', wave+1)

def OnPostInit():
	sk.PreSetup()
	sk.Setup()
	Mission_SetAttr('bonus_start', 10000)
	Mission_SetAttr('bonus_time', 20)
	Mission_SetAttr('bonus_loss', 2500)
	Mission_SetAttr('ignore_bonus_timer', 0)
	sk.StartBonus()
	SpawnNextWave('')
	SetupFFXSkirmish()

def OnBonusChange(event):
	sk.OnBonusChange(event)
	
def OnSelectionRequiredCheck():
	return 0

def OnGameTypeCheck():
	return sk.GetStandardMarkerNames()